<?
 include_once("MenuItem.php");     // add MenuItem class
 include_once("model/Database.php");     // add Database class
 
 class Menu {
  private $db;                                                                 // handle the DB handler. oops.
  private $settings;                                                           // used to handle the link to the Settings (settings.ini in an object representation)
  
  function __construct($settings) {                                            // the constructor function for our class 
   $this->settings=$settings;
   $this->db   = new Database($this->settings);                                // create the link to database
  }
  
  public function getTopLevelMenu($allitems) {                                          // get all top level menu elements from DB
   if (!$allitems) {
    $this->additionalfilters=" AND (`IsVisible`=1)";
   }
   $sql="
    SELECT   *
    FROM     `menu`
    WHERE    (`ParentID`=0) ".$this->additionalfilters."
    ORDER BY `ParentID`, `Order` ;
   ";
   $rows=$this->db->query($sql);
   $els = array();
   if ($rows) {
    foreach ($rows as $row) {
     $el = new MenuItem($row->ID, $row->ParentID, safetext($row->Name), str_replace('"','\"',safetext($row->Link)), $row->Order, $row->IsVisible);  // get record
     array_push($els, $el);                                                    // add the record to array
    }
   }
   
   return $els;
  }
  
  public function getChildMenu($allitems) {                                             // get all child level menu elements from DB
   if (!$allitems) {
    $this->additionalfilters=" AND (`IsVisible`=1)";
   }
   $sql="
    SELECT   *
    FROM     `menu`
    WHERE    (`ParentID`<>0) ".$this->additionalfilters."
    ORDER BY `ParentID`, `Order` ;
   ";
   
   $rows=$this->db->query($sql);
   $els = array();
   if ($rows) {
    foreach ($rows as $row) {
     $el = new MenuItem($row->ID, $row->ParentID, safetext($row->Name), str_replace('"','\"',safetext($row->Link)), $row->Order, $row->IsVisible);  // get record
     array_push($els, $el);                                                    // add the record to array
    }
   }
   
   return $els;                                                                // send array to Model
  }
  
  public function getParentID($id)  {
   $ret="";
   $sql="
    SELECT   `ParentID`
    FROM     `Menu`
    WHERE    `ID`=".$id.";
   ";
   $rows=$this->db->query($sql);
   return ($rows->ParentID);
  }
 }
?>