<?
 $templates_buffer = Array();
 class Template {                      // used to handle the View template files
  private $srctemplate;
  public  $template;
  public  $filename;
  
  function Template($filename) {       // the constructor function
   $this->load ($filename);
  }
  
  function load($filename) {             // loads the template
   $this->filename="view/templates/".$filename;
   global $templates_buffer;
   if ($templates_buffer[$this->filename]) {
    $this->template = $templates_buffer[$this->filename];
   } else {
    if (is_file($this->filename)) {
     $this->template = filestr($this->filename);
    } else {
     echo "File ".$this->filename." not found!";
     $this->template    = " ";
    }
    $templates_buffer[$this->filename] = $this->template;
   }
   $this->srctemplate = $this->template;
  }
  
  function reload() {                                                           // used to refresh the template (useful in series of multiple fills of a single template)
   $this->template = $this->srctemplate;
  }
  
  function fill($from, $to) {                                                   // used to replace the placeholders with actual data
   $this->template = str_replace($from, $to,   $this->template);                // do a replace
  }
  
  function filloptional($from, $to) {                                           // used to replace the optional placeholders with actual data
   if (strlen($this->template)<2) return;
   $from_clean = str_replace("%", "", $from);
   $opentag = "<optional ".$from_clean.">";
   $startat_L = strpos(" ".strtolower($this->template), $opentag)-1;
   $startat_R = $startat_L + strlen($opentag);
   if ($startat_L>=0) {
//    echo $startat."<br>";
    $closetag = "</optional ".$from_clean.">";
    $endat_L = strpos(" ".strtolower($this->template), $closetag)-1;
    $endat_R = $endat_L + strlen($closetag);
    if ($endat_L>$startat_L) {
/*
     echo $startat_L."<br>";
     echo $startat_R."<br>";
     echo $endat_L."<br>";
     echo $endat_R."<br><br>";
*/
     if ($to) {
      $this->template = substr($this->template, 0, $startat_L).substr($this->template, $startat_R, $endat_L-$startat_R).substr($this->template, $endat_R);
      $this->template = str_replace($from, $to,   $this->template);              // do a replace
     } else {


      $this->template = substr($this->template, 0, $startat_L).substr($this->template, $endat_R);
     }
    }
   }
//   if ($to) {
    
//   } else {
//    $this->template = str_replace($from, $to,   $this->template);               // do a replace
//   }
  }
  
  function loadloop($loopid) {                                                  // used to load the groups of placeholders
   if (strlen($this->template)<2) return;
   $startat = strpos(" ".$this->template, "<".$loopid.">")+strlen($loopid)+1;
   if ($startat>=0) {
//    echo $startat."<br>";
//    echo $startat.' - '.strlen($this->template);
    if ($startat<strlen($this->template)) { 
     $endat = strpos(" ".$this->template, "</".$loopid.">",$startat)-1;
 //    echo "</".$loopid.">"."<br>";
     if ($endat) {
 //     echo $endat."<br>";
      $this->template=substr($this->template, $startat, $endat-$startat);
      $this->srctemplate = $this->template;
 //     echo $this->template."<br>";
     } else {
      $this->template = "";
      $this->srctemplate = $this->template;
     }
    } else {
     $this->template = "";
     $this->srctemplate = $this->template;
    }
   } else {
    $this->template = "";
    $this->srctemplate = $this->template;
   }
   if (($startat==-1) || ($endat==-1)) {
    $this->template = "";
    $this->srctemplate = $this->template;
   }
//   echo "startat: ".$startat.", endat: ".$startat."<br>, this->template: ".$this->template;
  }
  
  function fillloop($loopid, $loopblock) {                                      // used to replace the groups of placeholders with actual data
   if (strlen($this->template)<2) return;
   $startat = strpos(" ".$this->template, "<".$loopid.">")-1;
   if ($startat>=0) {
//    echo $startat."<br>";
    $endat = strpos(" ".$this->template, "</".$loopid.">")+2+strlen($loopid);
    if ($endat) {
//     echo $endat."<br>";
     $this->template=substr_replace($this->template, $loopblock, $startat, $endat-$startat);
    }
   }
  }
  
  function output() {                    // used to get the results
   return $this->template;
  }
  
 }
?>
