<?
 class Database {
  private $DBH, $STH;                         // handle the database and query handlers
  private $settings;
  private $userid;
  public $debug;
  public $thres;
  
 // mysql_query("SET NAMES cp1251");                                                  //      
  
  public function __construct($settings=stdClass, $mode='pgsql') {
   $this->userid     = getsecurevariable('userid');
   $this->thres      = 0.5;
   $this->mode       = $mode;
   
//   echo_r ($settings);
   if ($settings) {
    $this->settings = $settings;
   }
   $this->debug = 0;
   $this->DBH = "";
   try {
   // $PgConn = pg_connect("host=".$PgHost." port=5432 user=".$PgUser." password=".$PgPass." dbname=".$PgDbDefault);
    if ($this->mode=='pgsql') {
     $this->DBH = new PDO("pgsql:dbname=".$settings->pgname.";host=".$settings->pghost, $settings->pguser, $settings->pgpassword);          //    
    } else {
     $this->DBH = new PDO("mysql:host=".$settings->dbhost.";dbname=".$settings->dbname, $settings->dbuser, $settings->dbpassword);          //    
    }
    
   } catch(PDOException $e) {                 //  
    if ($settings->displaydberrors!="0") {
     echo $e->getMessage()."<br>";
     addtologEx("query: Query took ".$v." sec.\n".$sql."\n".debug_print_backtrace_cf(true), 'PDO_Long_Queries.txt', 'logs');  // write to log in case of errors
     debug_print_backtrace_cf();
    }
   }
   
   if ($this->DBH) {
    $this->DBH->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
    
//    $this->STH = $this->DBH->query("Set Global max_connections=2000 ; ");
    $this->STH = $this->DBH->query("SET NAMES 'utf8' ; ");
//    $this->STH = $this->DBH->query("SET SQL_BIG_SELECTS=1 ; ");
//    $this->STH = $this->DBH->query("SET lc_time_names = 'ru_RU' ; ");
    $this->STH->closeCursor();
   }
  }
  
  public function __destruct() {
   $this->close();
//   echo "database closed.";
  }
  
  public function close() {
   $this->DBH = null;
  }
  
  public function reload() {
   $this->__destruct();
   $this->__construct($this->settings);
  }
  
  public function query($sql, $ret = array()) {                            // execute query
   if ($this->DBH) {                                       // if we connected
//    $sql = substr_replace($sql,"",(strpos($sql," ;")+2));  // filter SQL code
    $this->STH = "";
    if ($this->mode=='pgsql') {
     $sql = $this->sqlreplace($sql);
    }
    try {
     if ($this->debug) {
//      $sql = "EXPLAIN EXTENDED ".$sql;
     }
     
     $timer = microtime(true);
     $this->STH = $this->DBH->query($sql);
     
     $v = microtime(true) - $timer;
     if ($this->debug && (($this->userid<2) && ($v>0.15))) {
      echo ("SQL: ".nl2br($sql)."<br>");
      echo "Query took <b>".($v)."</b> s. <br><hr>";
     }
     if ($v>$this->thres) {
      addtologEx("query: Query took ".$v." sec.\n".$sql."\n".debug_print_backtrace_cf(true), 'PDO_Long_Queries.txt', 'logs');  // write to log in case of errors
     }
    } catch(PDOException $e) {
     if ($settings->displaydberrors!="0") {
      echo "query - Error in SQL: <br>\n".nl2br($sql)."<br>\n".$e->getMessage()."<br>";
      debug_print_backtrace_cf();
     }
     $this->addToLogPDOErrors($sql, $e->getMessage()."\n".debug_print_backtrace_cf(true));  // write to log in case of errors
    }
//    echo_r($this->STH);
    if ($this->STH) {                                // if there's a query results
     $this->STH->setFetchMode(PDO::FETCH_OBJ);       //   
     
     while($row = $this->STH->fetch()) {             //  
      $ret[] = $row;                                 // add the record to array
     }
     
     $this->STH->closeCursor();
    }
   }
   if ($this->debug) {
//    ajax_echo_r ($ret);
   }
   return $ret;         // send array to Model
  }
  
  public function query_first($sql, $ret = null) {                      // execute query
//   if ($ret === null) $ret = new stdClass;
   if ($this->DBH) {                                       // if we connected
//    $sql = substr_replace($sql,"",(strpos($sql," ;")+2));  // filter SQL code
    $this->STH = "";
    if ($this->mode=='pgsql') {
     $sql = $this->sqlreplace($sql);
    }
    try {
     if ($this->debug) {
//      $sql = "EXPLAIN EXTENDED ".$sql;
     }
     
     $timer = microtime(true);
     $this->STH = $this->DBH->query($sql);
     
     $v = microtime(true) - $timer;
     if ($this->debug && (($this->userid<2) && ($v>0.15))) {
      echo ("SQL: ".nl2br($sql)."<br>");
      echo "Query took <b>".($v)."</b> s. <br><hr>";
     }
     if ($v>$this->thres) {
      addtologEx("query_first: Query took ".$v." sec.\n".$sql."\n".debug_print_backtrace_cf(true), 'PDO_Long_Queries.txt', 'logs');  // write to log in case of errors
     }
    } catch(PDOException $e) {
     if ($settings->displaydberrors!="0") {
      echo "query_first - Error in SQL: <br>\n".nl2br($sql)."<br>\n".$e->getMessage()."<br>";
      debug_print_backtrace_cf();
     }
     $this->addToLogPDOErrors($sql, $e->getMessage()."\n".debug_print_backtrace_cf(true));  // write to log in case of errors
    }
//    echo_r($this->STH);
    if ($this->STH) {                                // if there's a query results
     $this->STH->setFetchMode(PDO::FETCH_OBJ);       //   
     $r = $this->STH->fetch();
     if ($ret) {
      if ($r) {
       $ret = (object)array_merge((array)$ret, (array)$r);
      }
     } else {
      if ($r) {
       $ret = $r;
      }
     }
     
     $this->STH->closeCursor();
    }
   }
   if ($this->debug) {
//    ajax_echo_r ($ret);
   }
   return $ret;         // send array to Model
  }
  
  public function query_assoc($sql,$keyfieldname,$ret = array()) {                            // execute query
   if ($this->DBH) {                                       // if we connected
//    $sql = substr_replace($sql,"",(strpos($sql," ;")+2));  // filter SQL code
    $this->STH = "";
    if ($this->mode=='pgsql') {
     $sql = $this->sqlreplace($sql);
    }
    try {
     if ($this->debug) {
//      $sql = "EXPLAIN EXTENDED ".$sql;
     }
     
     $timer = microtime(true);
     $this->STH = $this->DBH->query($sql);
     
     $v = microtime(true) - $timer;
     if ($this->debug && (($this->userid<2) && ($v>0.15))) {
      echo ("SQL: ".nl2br($sql)."<br>");
      echo "Query took <b>".($v)."</b> s. <br><hr>";
     }
     if ($v>$this->thres) {
      addtologEx("query_assoc: Query took ".$v." sec.\n".$sql."\n".debug_print_backtrace_cf(true), 'PDO_Long_Queries.txt', 'logs');  // write to log in case of errors
     }
    } catch(PDOException $e) {
     if ($settings->displaydberrors!="0") {
      echo "query_assoc - Error in SQL: <br>\n".nl2br($sql)."<br>\n".$e->getMessage()."<br>";
      debug_print_backtrace_cf();
     }
     $this->addToLogPDOErrors($sql, $e->getMessage()."\n".debug_print_backtrace_cf(true));  // write to log in case of errors
    }
//    echo_r($this->STH);
    if ($this->STH) {                                // if there's a query results
     $this->STH->setFetchMode(PDO::FETCH_OBJ);       //   
     
     while($row = $this->STH->fetch()) {             //  
//      $ret[$row->$keyfieldname] = $row;                                 // add the record to array
      $ret[$row->$keyfieldname] = (object) array_merge((array) $ret[$row->$keyfieldname], (array) $row);                                 // add the record to array
      
//      echo $row->ID;
     }
     
     $this->STH->closeCursor();
    }
   }
   if ($this->debug) {
//    ajax_echo_r ($ret);
   }
   return $ret;         // send array to Model
  }
  
  public function query_only_assoc($sql,$keyfieldname='') {                            // execute query
   if ($this->DBH) {                                       // if we connected
//    $sql = substr_replace($sql,"",(strpos($sql," ;")+2));  // filter SQL code
    $STH = "";
    if ($this->mode=='pgsql') {
     $sql = $this->sqlreplace($sql);
    }
    try {
     if ($this->debug) {
//      $sql = "EXPLAIN EXTENDED ".$sql;
     }
     
     $timer = microtime(true);
     $STH = $this->DBH->query($sql);
     
     $v = microtime(true) - $timer;
     if ($this->debug && (($this->userid<2) && ($v>0.15))) {
      echo ("SQL: ".nl2br($sql)."<br>");
      echo "Query took <b>".($v)."</b> s. <br><hr>";
     }
     if ($v>$this->thres) {
      addtologEx("query_assoc: Query took ".$v." sec.\n".$sql."\n".debug_print_backtrace_cf(true), 'PDO_Long_Queries.txt', 'logs');  // write to log in case of errors
     }
    } catch(PDOException $e) {
     if ($settings->displaydberrors!="0") {
      echo "query_assoc - Error in SQL: <br>\n".nl2br($sql)."<br>\n".$e->getMessage()."<br>";
      debug_print_backtrace_cf();
     }
     $this->addToLogPDOErrors($sql, $e->getMessage()."\n".debug_print_backtrace_cf(true));  // write to log in case of errors
    }
//    echo_r($this->STH);
    if ($STH) {                                // if there's a query results
     $STH->setFetchMode(PDO::FETCH_OBJ);       //   
//     $ret->STH = $STH;
     
     /*
     while($row = $this->STH->fetch()) {             //  
//      $ret[$row->$keyfieldname] = $row;                                 // add the record to array
      $ret[$row->$keyfieldname] = (object) array_merge((array) $ret[$row->$keyfieldname], (array) $row);                                 // add the record to array
      
//      echo $row->ID;
     }
     
     $this->STH->closeCursor();
     */
    }
   }
   if ($this->debug) {
//    ajax_echo_r ($ret);
   }
   return $STH;         // send array to Model
  }
  
  public function fetch($STH) {
   $row = $STH->fetch();
   return($row);
  }
  
  public function closeCursor($STH) {
   $STH->closeCursor();
   unset ($STH);
  }
  
  public function query_flat($sql, $ret = array()) {                       // execute query
   if ($this->DBH) {                                       // if we connected
//    $sql = substr_replace($sql,"",(strpos($sql," ;")+2));  // filter SQL code
    $this->STH = "";
    if ($this->mode=='pgsql') {
     $sql = $this->sqlreplace($sql);
    }
    try {
     $timer = microtime(true);
     $this->STH = $this->DBH->query($sql);
     
     $v = microtime(true) - $timer;
     if ($this->debug && (($this->userid<2) && ($v>0.15))) {
      echo ("SQL: ".nl2br($sql)."<br>");
      echo "Query took <b>".($v)."</b> s. <br><hr>";
     }
     if ($v>$this->thres) {
      addtologEx("query_flat: Query took ".$v." sec.\n".$sql."\n".debug_print_backtrace_cf(true), 'PDO_Long_Queries.txt', 'logs');  // write to log in case of errors
     }
    } catch(PDOException $e) {
     if ($settings->displaydberrors!="0") {
      echo "query_flat - Error in SQL: <br>\n".nl2br($sql)."<br>\n".$e->getMessage()."<br>";
      debug_print_backtrace_cf();
     }
     $this->addToLogPDOErrors($sql, $e->getMessage()."\n".debug_print_backtrace_cf(true));  // write to log in case of errors
    }
//    echo_r($this->STH);
    if ($this->STH) {                                // if there's a query results
     $this->STH->setFetchMode(PDO::FETCH_NUM);       //   
     
     while($row = $this->STH->fetch()) {             //  
      if ($row[1]) {
       $ret[$row[0]] = $row[1];                              // add the record to array
      } else {
       $ret[] = $row[0];                              // add the record to array
      }
     }
     
     $this->STH->closeCursor();
     return $ret;         // send array to Model
    }
   }
  }
  
  public function query_flat_assoc($sql,$keyfieldname='ID',$datafieldname='Description') {                       // execute query
   if ($this->DBH) {                                       // if we connected
//    $sql = substr_replace($sql,"",(strpos($sql," ;")+2));  // filter SQL code
    $this->STH = "";
    if ($this->mode=='pgsql') {
     $sql = $this->sqlreplace($sql);
    }
    try {
     $timer = microtime(true);
     $this->STH = $this->DBH->query($sql);  
     
     $v = microtime(true) - $timer;
     if ($this->debug && (($this->userid<2) && ($v>0.15))) {
      echo ("SQL: ".nl2br($sql)."<br>");
      echo "Query took <b>".($v)."</b> s. <br><hr>";
     }
     if ($v>$this->thres) {
      addtologEx("query_flat_assoc: Query took ".$v." sec.\n".$sql."\n".debug_print_backtrace_cf(true), 'PDO_Long_Queries.txt', 'logs');  // write to log in case of errors
     }
    } catch(PDOException $e) {
     if ($settings->displaydberrors!="0") {
      echo "query_flat_assoc - Error in SQL: <br>\n".nl2br($sql)."<br>\n".$e->getMessage()."<br>";
      debug_print_backtrace_cf();
     }
     $this->addToLogPDOErrors($sql, $e->getMessage()."\n".debug_print_backtrace_cf(true));  // write to log in case of errors
    }
//    echo_r($this->STH);
    if ($this->STH) {                                // if there's a query results
     $this->STH->setFetchMode(PDO::FETCH_OBJ);       //   
     $ret = array();                                 // initialize the results array
     
     while($row = $this->STH->fetch()) {             //  
      $ret[$row->$keyfieldname] = $row->$datafieldname;                              // add the record to array
     }
     
     $this->STH->closeCursor();
     return $ret;         // send array to Model
    }
   }
  }
  
  public function exec($sql, $mode=0) {                            // execute query
   if ($this->DBH) {                                       // if we connected
//    $this->DBH->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
    
    $pos1 = strpos($sql, "`") + 1;
    $pos2 = strpos($sql, "`", $pos1+1);
    $tn = substr($sql, $pos1, $pos2-$pos1);
    
    $ret = new stdClass();
    
    if ($mode==0) {
     $pos = strrpos($sql, ";");
     switch ($tn) {
      case ('skype_messages'):
      case ('skype_conversations'):
       $cn = "id";
      break;
      default:
       $cn = "ID";
      break;
     }
     if ($this->mode=='pgsql') {
      $sql=substr($sql, 0, $pos)." RETURNING `".$cn."`;";
     } else {
      $sql=substr($sql, 0, $pos).";";
     }
    }
    
    if ($this->mode=='pgsql') {
     $sql = $this->sqlreplace($sql);
    }
    try {
     if ($this->debug) {
//      echo ("SQL:".nl2br($sql)."<br>");
//      die();
     }
//     $ret->rowsAffected = $this->DBH->exec($sql);
     $timer = microtime(true);
     if ($this->mode=='pgsql') {
      $this->STH = $this->DBH->query($sql);
     } else {
      $ret->rowsAffected = $this->DBH->exec($sql);
     }
     
//     addtologEx (pg_result_error(
     $v = microtime(true) - $timer;
     if ($this->debug && (($this->userid<2) && ($v>0.15))) {
      echo ("SQL: ".nl2br($sql)."<br>");
      echo "Query took <b>".(microtime(true) - $timer)."</b> s. <br>";
     }
     if ($v>$this->thres) {
      addtologEx("exec: Query took ".$v." sec.\n".$sql."\n".debug_print_backtrace_cf(true), 'PDO_Long_Queries.txt', 'logs');  // write to log in case of errors
     }
     if ($this->mode=='pgsql') {
      $ret->rowsAffected = $this->STH->rowCount();
     }
     
     if ($this->mode=='pgsql') {
      if ($this->STH) {                                // if there's a query results
       $this->STH->setFetchMode(PDO::FETCH_OBJ);       //   
 //      $ret = array();                                 // initialize the results array
       $row = $this->STH->fetch();
       $ret->lastInsertID = $row->ID;
      }
 //     echo "test";
     } else {
      $ret->lastInsertID = $this->DBH->lastInsertId();
     }
     
     $v = microtime(true) - $timer;
     if ($this->debug && (($this->userid<2) && ($v>0.15))) {
      echo "Query and fetch took <b>".(microtime(true) - $timer)."</b> s. <br><hr>";
     }
    } catch(PDOException $e) {
     if ($settings->displaydberrors!="0") {
      echo "exec - Error in SQL: <br>\n".nl2br($sql)."<br>\n".$e->getMessage()."<br>";
      debug_print_backtrace_cf();
//      die();
     }
//     echo "error";
     $this->addToLogPDOErrors($sql, $e->getMessage()."\n".debug_print_backtrace_cf(true));  // write to log in case of errors
    }
    
//    $tn.="_ID_seq";
//    echo $tn."<br>";
//    $ret->lastInsertID = $this->DBH->lastInsertId('"'.$tn.'"');
//    die ($ret->lastInsertID);
    if ($mode==0) {
     return $ret;
    } else {
     return 1;
    }
   }
  }
  
  public function getRecord($table, $id, $field = "ID") {
   $sql="
    SELECT  *
    FROM    `".escape($table)."`
    WHERE   `".escape($field)."`='".escape($id)."'
    LIMIT   1
    ;
   ";
   $ret = $this->query($sql);
   return $ret[0];
//   return $this->query($sql);
  }
  
  public function getRecordEx($table, $json, $sql_orderby="") {
   foreach ($json as $k=>$v) {
    if ($sql_where) $sql_where.=" AND ";
    $sql_where .= "(`".escape($k)."`='".escape($v)."')";
   }
   
   if ($sql_where)   $sql_where   ="WHERE "   .$sql_where;
   if ($sql_orderby) $sql_orderby ="ORDER BY ".$sql_orderby;
   
   $sql="
    SELECT  *
    FROM    `".escape($table)."`
    ".$sql_where."
    ".$sqL_orderby."
    LIMIT   1
    ;
   ";
   
   $ret = $this->query_first($sql);
   return $ret;
//   return $this->query($sql);
  }
  
  public function getList($tablename) {
   $sql="
    SELECT   *
    FROM    `".escape($tablename)."`
    ORDER BY `ID`
    ;
   ";
   return $this->query_assoc($sql,'ID');
  }
  
  public function getListAssoc($tablename,$keyfieldname) {
   $sql="
    SELECT   *
    FROM     `".escape($tablename)."`
    ; 
   ";
   $listitems=$this->query_assoc($sql,$keyfieldname);
   return $listitems;
  }
  
  public function getListOrdered($tablename, $orderby) {
   $sql="
    SELECT   *
    FROM     `".escape($tablename)."`
    ORDER BY `".escape($orderby)."`
    ; 
   ";
   $listitems=$this->query($sql);
   return $listitems;
  }
  
  public function getListOrderedFiltered($tablename, $orderby, $fltname, $fltvalue) {
   $sql="
    SELECT   *
    FROM     `".escape($tablename)."`
    WHERE    `".escape($fltname)."`='".escape($fltvalue)."'
    ORDER BY `".escape($orderby)."`
    ; 
   ";
   $listitems=$this->query($sql);
   return $listitems;
  }
  
  public function getListEx($tablename,$auxfilter) {   // this is from Model
   $sql="
    SELECT   *
    FROM     `".escape($tablename)."`
    ".((escape($auxfilter))?"WHERE ".escape($auxfilter):"")."
    ; 
   ";
   $listitems=$this->query($sql);
   return $listitems;
  }
  
  public function getListEx2($tablename,$parentcolumnname="",$parentcolumnid="") {
//   addtolog("Model getListEx begin");
//   echo $parentcolumnname;
//   echo $parentcolumnid;
   if ($parentcolumnname && $parentcolumnid) {
    $auxfilter = "`".escape($parentcolumnname)."`='".escape($parentcolumnid)."'";
   }
   
   $sql="
    SELECT   *
    FROM     `".escape($tablename)."`
    ".(($auxfilter)?"WHERE ".$auxfilter:"")."
    ;
   ";
   
   return $this->query_assoc($sql,'ID');
//   $listitems=$this->query($sql);
//   addtolog("Model getListEx end");
//   return $listitems;
  }
  
  public function getListEx3($tablename, $auxfilters="") {   // this is from Model
   if ($auxfilters) {
    foreach ($auxfilters as $k=>$v) {
     $sql_where .= "`".escape($k)."`='".escape($v)."', ";
    }
    $sql_where = "WHERE ".substr($sql_set,0,strlen($sql_set)-2);
   }
   
   $sql="
    SELECT   *
    FROM     `".$tablename."`
    ".($sql_where)."
    ; 
   ";
   $listitems=$this->query($sql);
   return $listitems;
  }
  
  public function getListByParentID($tablename, $parentname, $parentid) {
   $sql="
    SELECT   `".$tablename."`.*
    FROM     `".$tablename."`
    WHERE    `".$parentname."` = '".$parentid."'
    ; 
   ";
   $listitems=$this->query($sql);
   return $listitems;
  }
  
  public function getNextID($tname) {
   $sql = "
    SELECT MAX(`ID`) AS `NextID`
    FROM   ".$tname."
    ;
   ";
   $listitems=$this->query_first($sql);
   return $listitems->NextID+1;
  }
  
  public function saveRecord($table, $data, $keyname="ID") {
//   echo "ID: ".$data->ID."<br>";
   if ($data->$keyname) {
//    echo "ID present<br>";
    foreach ($data as $k=>$v) {
     if ($k!=$keyname) {
//      if (strlen($v)==0) {
//       $sql_set .= "`".escape($k)."`=NULL, ";
//      } else {
      
      if ($v==='NULL') {
       $sql_set .= "`".escape($k)."`=NULL, ";
      } else {
       $sql_set .= "`".escape($k)."`='".escape($v)."', ";
      }
//      }
     }
    }
    $sql_set = substr($sql_set,0,strlen($sql_set)-2);
    
    $sql = "
     UPDATE `".escape($table)."`
     SET    ".$sql_set."
     WHERE  `".$keyname."` = '".escape($data->$keyname)."'
     ; 
    ";
   } else {
//    echo "No ID<br>";
    foreach ($data as $k=>$v) {
     if ($k!=$keyname) {
      $sql_insert .= "`".escape($k)."`, ";
      if (strlen($v)==0) {
       $sql_values .= "NULL, ";
      } else {
       $sql_values .= "'".escape($v)."', ";
      }
     }
    }
    $sql_insert = substr($sql_insert,0,strlen($sql_insert)-2);
    $sql_values = substr($sql_values,0,strlen($sql_values)-2);
    
    $sql="
     INSERT INTO `".$table."`
      (".$sql_insert.")
     VALUES
      (".$sql_values.") ; 
    ";
   }
   
//   echo $sql;
   $ret=$this->exec($sql);                                   // save the new GalleryID to the parent object's table
   return $ret;
  }
  
  public function saveRecordEx($table, $data) {
   if ($data->ID) {
    foreach ($data as $k=>$v) {
     if ($k!="ID") {
      if (strlen($v)) {
       $sql_set .= "`".escape($k)."`='".escape($v)."', ";
      } else {
       $sql_set .= "`".escape($k)."`=NULL, ";
      }
     }
    }
    $sql_set = substr($sql_set,0,strlen($sql_set)-2);
    
    $sql = "
     UPDATE `".escape($table)."`
     SET    ".$sql_set."
     WHERE  `ID` = '".escape($data->ID)."'
     ; 
    ";
   } else {
    foreach ($data as $k=>$v) {
     if ($k!="ID") {
      $sql_insert .= "`".escape($k)."`, ";
      $sql_values .= "'".escape($v)."', ";
     }
    }
    $sql_insert = substr($sql_insert,0,strlen($sql_insert)-2);
    $sql_values = substr($sql_values,0,strlen($sql_values)-2);
    
    $sql="
     INSERT INTO `".$table."`
      (".$sql_insert.")
     VALUES
      (".$sql_values.") ; 
    ";
   }
   
//   echo $sql;
   $ret=$this->exec($sql);                                   // save the new GalleryID to the parent object's table
   return $ret;
  }
  
  public function addToLogPDOErrors($sql, $message) {
   @mkdirr('data/logs');
   file_put_contents('data/logs/PDOErrors.txt', date("Y-m-d H:i:s")."\t".$sql."\t".$message."\n", FILE_APPEND);  // write to log in case of errors
  }
  
  public function addItem($json) {
//   $keys   = "`ServerTime`, `SessionID`";
//   $values = "NOW(), '".session_id()."'";
   
//   $json->targettable = "orders";
   foreach ($json as $k=>$v) {
    if ($k!='targettable') {
     if ($keys) $keys.=",";
     $keys.="`".escape($k)."`";
     
     if ($values) $values.=",";
     $values.="'".escape($v)."'";
    }
   }
   
   $sql="
    INSERT INTO `".$json->targettable."`
     (".$keys.")
    VALUES
     (".$values.")
    ;
   ";
   
//   echo $sql;
   
   $ret=$this->exec($sql);
   return $ret;
  }
  
  public function addRecord($table, $json) {
//   $keys   = "`ServerTime`, `SessionID`";
//   $values = "NOW(), '".session_id()."'";
   
//   $json->targettable = "orders";
   foreach ($json as $k=>$v) {
    if ($k!='targettable') {
     if ($keys) $keys.=",";
     $keys.="`".escape($k)."`";
     
     if ($values) $values.=",";
     if ($v==='NULL') {
      $values.="NULL";
     } else {
      $values.="'".escape($v)."'";
     }
    }
   }
   
   $sql="
    INSERT INTO `".escape($table)."`
     (".$keys.")
    VALUES
     (".$values.")
    ;
   ";
   
//   echo $sql;
   
   $ret=$this->exec($sql);
   return $ret;
  }
  
  public function deleteRow($tablename, $id) {
   $sql="
    DELETE FROM `".escape($tablename)."`
    WHERE
     `ID` = '".escape($id)."'
    ; 
   ";
   $ret=$this->exec($sql);
   return $ret;
  }
  
  public function deleteRows($tablename, $columnname, $id) {
   $sql="
    DELETE FROM `".escape($tablename)."`
    WHERE
     `".escape($columnname)."` = '".escape($id)."'
    ; 
   ";
   $ret=$this->exec($sql);
   return $ret;
  }
  
  public function sqlreplace($sql) {
   $sql = str_replace("&#58;", ":", $sql);
   
   // for postgre:
   $sql = str_replace(       "`", '"', $sql);
   
   
//   $sql = str_replace(   'DAY("DateBirth")', 'extract (day from DateBirth)', $sql);
   
   $sql = str_replace(   "0000-00-00", "1970-01-01", $sql);
   
   $sql = str_replace(   "YEAR(", " extract(year   from ", $sql);
   $sql = str_replace(  "MONTH(", " extract(month  from ", $sql);
   $sql = str_replace(   "WEEK(", " extract(week   from ", $sql);
   $sql = str_replace(    "DAY(", " extract(day    from ", $sql);
   $sql = str_replace(    "DOY(", " extract(doy    from ", $sql);
   $sql = str_replace(    "DOW(", " extract(dow    from ", $sql);
   $sql = str_replace(   "HOUR(", " extract(hour   from ", $sql);
   $sql = str_replace( "MINUTE(", " extract(minute from ", $sql);
   $sql = str_replace( "SECOND(", " extract(second from ", $sql);
   $sql = str_replace(   "HOUR(", " extract(hour   from ", $sql);
   $sql = str_replace(   "RAND(", " RANDOM("             , $sql);
   
//   $sql = str_replace(       "", "..."                  , $sql);
   
   $sql = str_replace(   "DATE_FORMAT(", "to_char( ", $sql);
//   $sql = str_replace(             "%Y", "YYYY"     , $sql);
//   $sql = str_replace(             "%m", "MM"       , $sql);
   $sql = str_replace(        "'%Y-%m'", "'YYYY-MM'", $sql);
   
//   $sql = utf8_encode($sql);
//   $sql = strprepare($sql);
   
   
   return $sql;
  }
  
 }
?>
