<?
 include_once("model/Model.php");          // connect to the Model part of our MVC pattern
 include_once("model/Settings.php");       // connect to the Settings 
 include_once("lessc.inc.php");            // the lesscss server-side compiler
// include_once("getxls.php");             // the MS Excel simple export class
 include_once("StringForge.1.1.php");      // the string processing class
 include_once("Template.1.92.php");             // add Template class
 include_once("Session.1.22.php");
 
 ini_set('max_execution_time', '6000');
 
 class Controller {                        // the Controller class
  public $model;                           // used to handle the link to the Model
  public $settings;                        // used to handle the link to the Settings (settings.ini in an object representation)
  public $StringForge;
  public $viewroot;
  public $themeinfo;
  public $userid;
  
  public function __construct() {          // the constructor function
   $this->settings = Settings::init();     // load settings file
   $this->sess = new SessionSaveHandler(getrootdirsrv().$this->settings->sessionsavepath);
   
   date_default_timezone_set($this->settings->timezone);       // set the default timezone. may be we need to customize it for particular user
   $this->model       = new Model($this->settings);            // instantiate the Model class
//   $this->model       = Model::getInstance($this->settings);            // instantiate the Model class
   
   $this->less        = new lessc;
   $this->StringForge = new StringForge($this->settings);
  }
  
  public function run() {                                                      // the main sub in our application
   if(!isset($_SESSION)) session_start();
   
   $qtm = microtime(true);
   
   $log .= formatmicrotime(microtime(true) - $qtm)." 00\n";
   
//   echo "Session ID: ".session_id()."<br>";
   
   $action = getvariablereq   ('action');          // get action from the request
   $data   = getvariablereq   ('data'  );          // get JSON data from the request
   $ekey   = getvariablereq   ('ekey'  );          // get JSON data from the request
   
   $theme              = getsecurevariable ('theme'          ,-1);
   if (!is_dir("view/".$theme."/")) {
    $theme=$this->settings->defaulttheme;
   }
   
   $this->viewroot="view/".$theme;
   setsecurevariable("viewroot",$this->viewroot);
   $this->imgfolder = $this->viewroot."/img";
   
//   echo $this->viewroot;
   
   if ($ekey) {
//    echo $ekey;
    $info = $this->model->findAssessment($ekey);
   }
   
//   ajax_echo_r ($info);
   
   $log .= formatmicrotime(microtime(true) - $qtm)." 05\n";
   if ($info->Assessment) {
//    ajax_echo_r ($info);
    
    $notrack   = getvariablereq   ('notrack'  );          // get JSON data from the request
    if ($notrack!='1') {
     $info->Email->SessionID = session_id();
     $info->Email->DateOpened = date("Y-m-d H:i:s");
     $ret = $this->model->addEmail($info->Email);
//     echo 'tracked';
    } else {
//     echo 'not tracked';
    }
    
    
    
    $tmp = new Template($this->viewroot, 'assessment.htt');                                      // load common parent template
    $tmp->processfcb('');
    $tmp->fill(  '%imgfolder%', $this->imgfolder                    );
    $tmp->fill(   '%viewroot%', $this->viewroot                     );
    $tmp->fill(       '%ekey%', $ekey                               );
    
//    $vars = $tmp->getVariables();
    
    $info->Assessment->Task = nl2br($info->Assessment->Task);
    
//    ajax_echo_r ($info);
    
    $data = new stdClass;
    $data->ParentName = 'emails';
    $data->ParentID = $info->Email->ID;
    $block_comments = $this->getComments($data);
    $tmp->fillloop('loop_comment', $block_comments);
    
    $AssessmentText = getsecurevariable('AssessmentText', '');
    $tmp->fill("%AssessmentText%", $AssessmentText);
    
    
    foreach ($info->Assessment as $k=>$v) {
     $tmp->fill("%Assessment_".$k."%", $v);
    }
    foreach ($info->Email as $k=>$v) {
     $tmp->fill("%Email_".$k."%", $v);
    }
    foreach ($info->Parent as $k=>$v) {
     $tmp->fill("%Parent_".$k."%", $v);
    }
    
    
    $this->processstylesheet($hue,'assessment');
    
    echo localize($tmp->output());                                               // show it
   } else {
    
    $data = str_replace('\"','"',$data);            // fix some escaped paths (if any)
    
    if ($data) {
     $json=json_decode($data);                      // parse Json data came from AJAX (if any)
    }
    
//    ajax_echo_r ($json);
    
    if (sizeof($_FILES)>0) {                        // file upload
 //    echo "Fileupload...";
     
 //    ajax_echo_r($_FILES);
     
 //    $el = new stdClass();
 //    for ($i=0; $i<sizeof($_FILES['fileupload']); $i++) {
     
     $file = $_FILES['fileupload'];
//     ajax_echo_r($file);
     
     switch ($action) {
      case ('club'):
       $id   = getvariablereq   ('id'  );          // get JSON data from the request
//       echo $id."<br>";
       $rec = $this->model->getClub($id);
//       ajax_echo_r ($rec);
       
       $subfolder = $this->getFilesFolder($rec);
//       echo $subfolder."/".$file['name'];
       mkdirr($subfolder);
       @unlink($subfolder."/".$file['name']);
       move_uploaded_file($file['tmp_name'], $subfolder."/".$file['name']);
       
       $json = new stdClass;
       $json->Filename = $file['name'];
       $json->ParentName = 'clubs';
       $json->ParentID = $rec->ID;
       $this->model->addFile($json);
       
       $files = $this->getFiles($rec);
       echo $files;
      break;
      case ('integration'):
       $timer = microtime(true);
       
       echo "max_execution_time:".ini_get('max_execution_time')."<br>";
       
       $subfolder = "data/integration";
       $fname = $subfolder."/data.xls";
       
       mkdirr ($subfolder);
       
       if ($file['tmp_name']) {
        @rename ($fname, $subfolder."/data.".date("Y.m.d.H.i.s").".xls");
        move_uploaded_file($file['tmp_name'], $fname);
       } else {
        ajax_echo_r($_REQUEST);
        $fname = "data/integration-src/".$_REQUEST['serverfile'];
        $file['name'] = $_REQUEST['serverfile'];
        $file['error']=0;
       }
       
//       ajax_echo_r ($file);
       echo "filename to process: ".$fname."<br>";
//       die();
       
       $ret = $this->model->importXls($fname, $action, $file['name']);
       ajax_echo_r ($ret);
       
       echo "integration - Time elapsed ".formatmicrotime(microtime(true) - $timer)." s. <br>";
       
      break;
      default:
       mkdirr($this->settings->temppath);
       move_uploaded_file($file['tmp_name'], $this->settings->temppath.'/'.session_id().".xls");
      break;
     }
     
     
     
 //     $el->filename = $_FILES['files']['name'][$i];
 //     $el->tmp_name = $_FILES['files']['tmp_name'][$i];
 //     $this->model->addPicture($el, $json);
 //    }
     
     if ($file['error']==0) {
      echo localize("<en>File uploaded successfully</en><ru>Файл загружен успешно</ru>");
     } else {
      echo localize("<en>Upload error</en><ru>Ошибка при загрузке файла</ru>");
     }
    } else {
 //    ajax_echo_r ($_REQUEST);
     
     
     $userid     = getsecurevariable('userid'     ,0);
     $this->userid = $userid;
 //    echo $userid;
     
 //    $hue        = getvariable       ('hue'       );
     $hue                = getsecurevariable ('hue'            ,-1);
     $SmoothAnimation    = getsecurevariable ('SmoothAnimation',-1);
     $this->user = $this->model->getUserDetails($userid);
     
 //    ajax_echo_r ($this->user);
     
     if ((int)$SmoothAnimation==-1) {                                            // if it's not stored in session
      if ($userid>-1) {                                                             // if the user is logged
       $SmoothAnimation = $this->user->SmoothAnimation;                         // get hue value from user details
      } else {                                                                   // if the user is came for the first time
       $SmoothAnimation = 0;                                                     // set the default value
      }
     }
     
//     ajax_echo_r ($this->user);
     $usr = new stdClass();
     $usr->ID = $this->user->ID;
     $go      = getvariablereq('go');
     if ( !$go || $go=='') $go=getvariablereq('admin');
     if ((!$go || $go=='') && ($this->user->LastGo)) $go=$this->user->LastGo;
     if ( !$go || $go=='') $go=getsecurevariable('go');
     if ( !$go || $go=='') $go="home";
     $usr->LastGo = $go;
//     ajax_echo_r ($usr);
//     die();
     $this->model->setUserDetails($usr);   // passing empty class makes model to just update current user's LastAccess value
     
     if (file_exists($this->viewroot."theme.php")) {
      $this->themeinfo = parse_ini_file($this->viewroot."theme.php");
     }
     $log .= formatmicrotime(microtime(true) - $qtm)." 10\n";
     
//     $user = $this->model->isUserAuth($userid);                             // check user's session and login state
     if ($action) {                                                             // start the processing of ajax commands
      if ($action!='ownlogin') {
       header("Pragma:        no-cache");
       header("Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0");
       header("Expires:       0");
      }
      
 //     echo $action;
      
      $ajax_timer = microtime(true);
      if (
       ($userid>0                           ) || 
       ($action=='dologin'                  ) || 
       ($action=='api'                      ) || 
       ($action=='ownlogin'                 ) || 
       ($action=='addVKLike'                ) || 
       ($action=='getinfo'                  ) || 
       ($action=='checkboxClick'            ) || 
       ($action=='addUserFromFL'            ) || 
       ($action=='addUserFromData'          ) || 
       ($action=='getTagsSuggest'           ) || 
       ($action=='getTags'                  ) || 
       ($action=='getSkypeMessagesLastID'   ) || 
       ($action=='getSkypeConversationsLastID') || 
       ($action=='addTag'                   ) || 
       ($action=='removeTag'                ) || 
       ($action=='addStatus'                ) || 
       ($action=='addVacancy'               ) || 
       ($action=='trackEmail'               ) || 
       ($action=='sendAssessment'           ) ||
       ($action=='saveField'                ) ||
       ($action=='getMacros'                ) ||
       ($action=='sendComment'              ) ||
       ($action=='callsassign'              ) ||
       ($action=='callsassign2'             ) ||
       ($action=='dbfix'                    ) ||
       ($action=='dbfix2'                   ) ||
       ($action=='dbfix3'                   ) ||
       ($action=='timezones'                ) ||
       ($action=='timezones2'               ) ||
       ($action=='manageDuplicates'         ) ||
       ($action=='manageLastEvents'         ) ||
       ($action=='loadCalls'                ) ||
       ($action=='customersAutoclean'       ) ||
       ($action=='recalcListIDs'            ) ||
       ($action=='vacuum'                   ) ||
       ($action=='updateWorksessions'       ) ||
       ($action=='loadrecordings'           ) ||
       ($action=='sendComment'              ) ||
       ($action=='dologout'                 ) ||
       ($action=='wirecrm_load'             ) ||
       ($action=='recalcLessonsSuggestions' ) ||
       ($action=='recalcAges'               ) 
      ) {
       $log .= formatmicrotime(microtime(true) - $qtm)." 20\n";
       switch ($action) {
        case ("savefield"):
        case ("saveField"):
         $this->model->saveField(($json));
        break;
        case ("movemenuitem"):
        case ("togglemenuitem"):
         switch ($action) {
          case ("movemenuitem"):
           $sql = "
            UPDATE `menu`
            SET    `Order`  = '".(int)$json->prevorder."'
            WHERE  (`Order` ='".(int)$json->order."') AND (`ParentID` =".(int)$json->placement.") ; 
           ";
  //          echo $sql;
           $rupd =$this->model->db->exec($sql)->rowsAffected;
  //          echo "Records affected: " . $rupd;

           $sql = "
            UPDATE `menu`
            SET    `Order`  = '".(int)$json->order."'
            WHERE  (`ID` =".(int)$json->id.") AND (`ParentID` =".(int)$json->placement.") ; 
           ";
  //          echo $sql;
           $rupd =$this->model->db->exec($sql)->rowsAffected;
  //          echo "Records affected: " . $rupd;
          break;
          case ("togglemenuitem"):
           $sql = "
            UPDATE `menu`
            SET    `IsVisible`  = '".(int)$json->isvisible."'
            WHERE  (`ID` =".(int)$json->id.") ; 
           ";
  //          echo $sql;
           $rupd =$this->model->db->exec($sql)->rowsAffected;
  //          echo "Records affected: " . $rupd;
          break;
         }
        case ("showadminmenu"):
         $tmp = new Template($this->viewroot, 'adminparent.htt');                                      // load common parent template
         $loop_table = clone $tmp;
         $loop_table->loadloop('loop_table');
         
         $menu = array();
         $menus     = $this->model->menu->getTopLevelMenu(1);
         $submenus = $this->model->menu->getChildMenu(1);
         
         for ($i=0; $i<sizeof($menus); $i++) {
          $menu[$menus[$i]->ID] = $menus[$i];
         }
         foreach ($submenus as $submenu) {
  //          $menu[$submenu->ParentID]->children[$submenu->ID]=$submenu;
          $menu[$submenu->ParentID]->children[]=$submenu;
         }
         
         $menurows = "";
         
         $tablerow = clone $tmp;
         $tablerow->loadloop('loop_table_row');
         $c = 0;
         
         for ($pi=0; $pi<sizeof($menu); $pi++) {
          $thismenu = $menus[$pi];
          $tablerow->fill("%cell_ID%"             , $thismenu->ID        );
          $tablerow->fill("%cell_ParentID%"       , $thismenu->ParentID  );
          $tablerow->fill("%cell_Name%"           , $thismenu->Name      );
          $tablerow->fill("%cell_Link%"           , $thismenu->Link      );
          $tablerow->fill("%cell_Order%"          , $thismenu->Order     );
          $tablerow->fill("%cell_IsVisible%"      , $thismenu->IsVisible );
          $tablerow->fill("%cell_IsVisible_text%" , $thismenu->IsVisible?"Hide":"Show" );
          $tablerow->fill("%c%"                   , $c%2                 );
          if ($thismenu->Order<=0)                   $tablerow->fillloop("block_move_up"   ,"");
          if ($thismenu->Order>=(sizeof($menu)-1))   $tablerow->fillloop("block_move_dpwn" ,"");
          $menurows.=$tablerow->output();
          $tablerow->reload();
          $c++;
          
          if ($thismenu->children) {
           for ($si=0; $si<sizeof($thismenu->children); $si++) {
            $thissubmenu=$thismenu->children[$si];
            $tablerow->fill("%cell_ID%"             , $thissubmenu->ID        );
            $tablerow->fill("%cell_ParentID%"       , $thissubmenu->ParentID  );
            $tablerow->fill("%cell_Name%"           , $thissubmenu->Name      );
            $tablerow->fill("%cell_Link%"           , $thissubmenu->Link      );
            $tablerow->fill("%cell_Order%"          , $thissubmenu->Order     );
            $tablerow->fill("%cell_IsVisible%"      , $thissubmenu->IsVisible );
            $tablerow->fill("%cell_IsVisible_text%" , $thissubmenu->IsVisible?"Hide":"Show" );
            $tablerow->fill("%c%"                   , $c%2                    );
            if ($thissubmenu->Order<=0)                               $tablerow->fillloop("block_move_up"   ,"");
            if ($thissubmenu->Order>=(sizeof($thismenu->children)-1)) $tablerow->fillloop("block_move_down" ,"");
            $menurows.=$tablerow->output();
            $tablerow->reload();
            $c++;
           }
          }
         }
         
         $loop_table->fillloop('loop_table_row',$menurows);
         
         ajax_echo($loop_table->output());
         
        break;
        
        
        
        
        case ("dologin"):                                             // used to login the user
         $is_auth = $this->model->userAuth($json);
         if ($is_auth) {
          setsecurevariable('userid',$is_auth->ID);
          setsecurevariable('tmpcnt',0           );
   //       $tmp = new Template($this->viewroot, 'ajax_nouser_logged.htt');   // load JS user successful login template
          ajax_echo ("##refresh##");
         } else {
          $tmp = new Template($this->viewroot, 'ajax_nouser_error.htt');      // load JS user login error template
          $tmp->fill('%imgfolder%'          , $this->imgfolder                    );
          ajax_echo($tmp->output());
         }
        break;
        case ("dologout"):                                                       // used to log out
         $this->model->logoutUser($this->userid);
         
         setsecurevariable(             "hue", "-1" );                           // set to default (abstracted)
         setsecurevariable(           "theme", $this->settings->defaulttheme );  // set to default (abstracted)
         setsecurevariable( "SmoothAnimation", "1"  );                           // enabled by default
         setsecurevariable(          "userid", "-1" );
         $userid = -1;
//         session_unset ();
         
//         echo getsecurevariable(          "userid");
         
//         unset ($_SESSION);
//         $_SESSION = array();
//         ajax_echo_r(session_id());
         session_write_close();
         
//         ajax_echo_r($_SESSION);
         ajax_echo ("##refresh##");
        break;
        case ("setUserParameter"):                                               // used to save user's setting
         setsecurevariable($json->name, $json->value);
  //        $userid = 0;
  //        ajax_echo_r($_SESSION);
         if (($json->name=='hue') || ($json->name=='theme')) {
          ajax_echo ("##refresh##");
         }
        break;
        
        case ("newpartner"):                                   // used to login the user
         $is_sent = (trim($json->name)!='') && (trim($json->email)!='') && (trim($json->comments)!='');
         if ($is_sent) {
          $is_sent = sendmail("Email from ".$json->name,"Bricks Pro partnership request: <br>\n".$json->comments);
         }
         if ($is_sent) {
          $tmp = new Template($this->viewroot, 'ajax_new_partner.htt');            // load JS success template
         } else {
          $tmp = new Template($this->viewroot, 'ajax_new_partner_error.htt');      // load JS error template
         }
         $tmp->fill('%imgfolder%'  ,$this->imgfolder );
         ajax_echo($tmp->output());
        break;
        
        case ("showgallery"):
  //        ajax_echo_r($json);
         if ($json->operation=='download') {
          $ret = $this->model->getGalleryItem($json);
         } else {
          if ($json->operation=='delete') {
           $ret = $this->model->deleteGalleryItem($json);
          }
          $gal = $this->getGallery($json);
          $ret = $gal->compiled;
         }
         ajax_echo ($ret);
        break;
        
        
        case ('postevent'):
         $ret=$this->model->addEvent($json);
  //       ajax_echo_r ($ret->rowsAffected);
         ajax_echo_r($json);
        break;
        
        case ('getnewevents'):
         $events = $this->model->getNewEvents($json);
  //       foreach ($events as $event) {
  //       }
         
         echo json_encode($events);
        break;
        
        case ('processxls'):
         $xls = $this->model->loadXls(0);
  //       echo "test: ".$xls->rowcount(0)."<br>";
  //       echo "test: ".$xls->colcount(0)."<br>";
  //       echo ($xls->dump(true,true));
         
  //       ajax_echo_r($json);
         
         setCache('settings',$json);
         
         if ($xls) {
          $data = $this->model->processXls($xls, $json);
         } else {
          $data = "";
         }
         ajax_echo_r($data);
         
        break;
        
        case ('showtable'):
         $usr = new stdClass();
         $usr->ID        = $this->user->ID;
         $usr->SessionID = session_id();
         $this->model->setUserDetails($usr);   // passing empty class makes model to just update current user's LastAccess value
         
 //echo "06 Time elapsed ".formatmicrotime(microtime(true) - $ajax_timer)." s. <br>";
         if (!$_SESSION['json']) $_SESSION['json'] = array();
//         $_SESSION['json'][$json->go] = (object)array_merge((array)$_SESSION['json'][$json->go], (array)$json);
         $_SESSION['json'][$json->go] = $json;
 //        ajax_echo_r ($_SESSION);
         
         if ($json->go=="analytics") {
 //         ajax_echo_r ($data);
//          ajax_echo_r ($json);
          
          if ($json->r_period) {
           $tmp_src = new Template($this->viewroot, 'main_'.$json->go.'_'.$json->r_viewmode.'_'.$json->r_period.'.htt');               // load common parent template
          }
//          echo $tmp_src->IsTemplate();
          if (!$json->r_period || !$tmp_src->IsTemplate()) {
           $tmp_src = new Template($this->viewroot, 'main_'.$json->go.'_'.$json->r_viewmode.'.htt');                                   // load common parent template
          }
          if (!$tmp_src->IsTemplate()) {
           $tmp_src = new Template($this->viewroot, 'main_'.$json->go.'_'.substr($json->r_viewmode, 0, strpos($json->r_viewmode, "-")).'.htt');                                   // load common parent template
          }
          $tmp_src->fill('%Caption%', str_replace(" ", "&nbsp;", $json->r_viewmode_caption));
          
          switch ($json->r_viewmode) {
           case ('db-states'):
            $table = $this->model->getAnalyticsDBStates($json);
            
            $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
            $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
            $vars = $loop_table_row->getVariables();
            
            $c = 0;
            $looptmp->fill(       "%c%", $c%2        );
            
            $totals = array();
            $lastTypeID = -1;
            $c = 0;
//            ajax_echo_r ($table);
            
            $thistable = "";
            if (sizeof($table)) {
             $thisidcolumnname = $json->tablename."_ID";
             if ($table) {
              foreach ($table as $k=>$v) {
               $loop_table_row->reload();
               $loop_table_row->fill(       "%c%", $c%2        );
               
               $loop_table_row->fill("%k%", $k);
               $loop_table_row->fill("%v%", $v);
               
               $thistable.=$loop_table_row->output();
               $c++;
              }
             }
            }
            $looptmp->fillloop('loop_table_row',$thistable);
            $tmp_src->fillloop("loop_table",$looptmp->output());
           break;
           
           case ('db-phoneslengths'):
            $table = $this->model->getAnalyticsDBPhonesLengths($json);
            
            $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
            $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
            $vars = $loop_table_row->getVariables();
            
            $c = 0;
            $looptmp->fill(       "%c%", $c%2        );
            
            $totals = array();
            $lastTypeID = -1;
            $c = 0;
//            ajax_echo_r ($table);
            
            $thistable = "";
            if (sizeof($table)) {
             $thisidcolumnname = $json->tablename."_ID";
             if ($table) {
              foreach ($table as $k=>$v) {
               $loop_table_row->reload();
               $loop_table_row->fill(       "%c%", $c%2        );
               
               $loop_table_row->fill("%k%", $k);
               $loop_table_row->fill("%v%", $v);
               
               $thistable.=$loop_table_row->output();
               $c++;
              }
             }
            }
            $looptmp->fillloop('loop_table_row',$thistable);
            $tmp_src->fillloop("loop_table",$looptmp->output());
           break;
           
           case ('db-depth'):
            $table = $this->model->getAnalyticsDBDepth($json);
            
            $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
            $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
            $vars = $loop_table_row->getVariables();
            
            $c = 0;
            $looptmp->fill(       "%c%", $c%2        );
            
            $totals = array();
            $lastTypeID = -1;
            $c = 0;
//            ajax_echo_r ($table);
            
            $thistable = "";
            if (sizeof($table)) {
             $thisidcolumnname = $json->tablename."_ID";
             if ($table) {
              foreach ($table as $k=>$v) {
               $loop_table_row->reload();
               $loop_table_row->fill(       "%c%", $c%2        );
               
               $loop_table_row->fill("%k%", $k);
               $loop_table_row->fill("%v%", $v);
               
               $thistable.=$loop_table_row->output();
               $c++;
              }
             }
            }
            $looptmp->fillloop('loop_table_row',$thistable);
            $tmp_src->fillloop("loop_table",$looptmp->output());
            
            
           break;
           
           case ('agents-activity'):
           case ('agents-pollingquestions'):
            
            switch ($json->r_viewmode) {
             case ('agents-activity'):
              
              
              $longqueriesaccess = getfromcache ('longqueriesaccess');
              
              $lqa_key = md5($data);
              if (!$longqueriesaccess) {
               $longqueriesaccess->$lqa_key = time();
              }
              
              if (time()-$longqueriesaccess->$lqa_key<600) {
               $table = getfromcache ('longqueriescache-'.$lqa_key);
              }
              
              if (!$table) {
               $longqueriesaccess->$lqa_key = time();
               setcache ('longqueriesaccess', $longqueriesaccess);
               
               echo "From database";
  //             $table = $this->model->getAnalyticsCustomersCountsByTime($json);
               $table = $this->model->getAnalyticsAgentsActivity($json);
               setcache ('longqueriescache-'.$lqa_key, $table);
              } else {
               echo "From cache (".date("Y-m-d H:i:s", $longqueriesaccess->$lqa_key).")";
              }
              
             break;
             case ('agents-pollingquestions'):
              $longqueriesaccess = getfromcache ('longqueriesaccess');
              
              $lqa_key = md5($data);
              if (!$longqueriesaccess) {
               $longqueriesaccess->$lqa_key = time();
              }
              
              if (time()-$longqueriesaccess->$lqa_key<600) {
               $table = getfromcache ('longqueriescache-'.$lqa_key);
              }
              
              if (!$table) {
               $longqueriesaccess->$lqa_key = time();
               setcache ('longqueriesaccess', $longqueriesaccess);
               
               echo "From database";
  //             $table = $this->model->getAnalyticsCustomersCountsByTime($json);
               $table = $this->model->getAnalyticsAgentsPollingQuestions($json);
               setcache ('longqueriescache-'.$lqa_key, $table);
              } else {
               echo "From cache (".date("Y-m-d H:i:s", $longqueriesaccess->$lqa_key).")";
              }
              
             break;
            }
            
//            ajax_echo_r ($table);
            
            
            $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'     ));
            $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row' ));
            $loop_groups        = new Template($this->viewroot, $tmp_src->returnloop('loop_groups'    ));
            $loop_groups2       = new Template($this->viewroot, $tmp_src->returnloop('loop_groups2'   ));
            $loop_groups3       = new Template($this->viewroot, $tmp_src->returnloop('loop_groups3'   ));
            $loop_groups4       = new Template($this->viewroot, $tmp_src->returnloop('loop_groups4'   ));
            $loop_totals        = new Template($this->viewroot, $tmp_src->returnloop('loop_totals'    ));
            
            $vars    = $loop_table_row->getVariables();
            $vars_g4 = $loop_groups4->getVariables();
            $vars_t  = $loop_totals->getVariables();
//            ajax_echo_r ($vars_g4);
            
            $c = 0;
            $looptmp->fill(       "%c%", $c%2        );
            $looptmp->fill(       "%d%", $c%2+6      );
            $looptmp->fill(       "%e%", $c%2+8      );
            $looptmp->fill(       "%f%", $c%2+10     );
            
            $totals = array();
            $lastTypeID = -1;
            $c = 0;
//            ajax_echo_r ($table);
            
            $thistable    = "";
            $thistable_g  = "";
            $thistable_g2 = "";
            $thistable_g3 = "";
            $thistable_t  = "";
            if (sizeof($table)) {
             $thisidcolumnname = $json->tablename."_ID";
             if ($table) {
              foreach ($table as $k=>$item) {
               if ($k=='dates') {
                foreach ($item as $ik=>$iv) {
                 $loop_groups->reload();
                 $loop_groups->fill('%k%', $ik);
                 $thistable_g .= $loop_groups->output();
                 
                 $loop_groups2->reload();
                 $loop_groups2->fill('%k%', $ik);
                 $thistable_g2 .= $loop_groups2->output();
                 
                 $loop_groups3->reload();
                 $loop_groups3->fill('%k%', $ik);
                 $thistable_g3 .= $loop_groups3->output();
                }
                
                foreach ($item as $ik=>$iv) {
                 $loop_totals->reload();
                 foreach ($vars_t as $vn) {
                  $loop_totals->fill("%".$vn."%", $iv->$vn);
                 }
                 $thistable_t .= $loop_totals->output();
                }
               } else {
//                ajax_echo_r ($item);
                
//                ajax_echo_r ($item);
                if ($item->Firstname && sizeof($item->Items)) {
                 $loop_table_row->reload();
  //                $loop_table_row->fill( "%TypePicture%", $block_type[$item->TypeID]);
                 $loop_table_row->fill(       "%c%", $c%2        );
                 $loop_table_row->fill(       "%d%", $c%2+6      );
                 $loop_table_row->fill(       "%e%", $c%2+8      );
                 $loop_table_row->fill(       "%f%", $c%2+10     );
                 
                 $thistable_g4 = "";
                 foreach ($item->Items as $ik=>$iv) {
 //                 ajax_echo_r ($iv);
                  $loop_groups4->reload();
                  $loop_groups4->fill(       "%d%", $c%2+6      );
                  foreach ($vars_g4 as $vn) {
                   $loop_groups4->fill("%".$vn."%", $iv->$vn);
                  }
                  $thistable_g4 .= $loop_groups4->output();
                 }
                 $loop_table_row->fillloop('loop_groups4', $thistable_g4);
                 
                 foreach ($vars as $vn) {
                  $loop_table_row->fill("%".$vn."%", $item->$vn);
                 }
                 
                 if (($item->TypeID==1) || ($item->TypeID==3) || ($item->TypeID==5)) {
                  $sum += $item->Value;
  //                 $Income += $item->Value;
                 } else {
                  $sum -= $item->Value;
  //                 $Expenditure += $item->Value;
                 }
                 $totals[$item->TypeID] += $item->Value;
                 
                 $thistable.=$loop_table_row->output();
                 $c++;
                }
               }
              }
             }
            }
            
            $looptmp->fillloop( 'loop_table_row', $thistable    );
            $looptmp->fillloop(    'loop_groups', $thistable_g  );
            $looptmp->fillloop(   'loop_groups2', $thistable_g2 );
            $looptmp->fillloop(   'loop_groups3', $thistable_g3 );
            $looptmp->fillloop(    'loop_totals', $thistable_t  );
            
            $tmp_src->fillloop("loop_table",$looptmp->output());
            
            $tmp_src->fill("%numrows%",sizeof($table[1]));
            
            $tmp_src->fillloop(       "block_no","" );
            $tmp_src->fillloop(   "block_norows","" );
            
           break;
           
           
           case ('statuses-activities'):
           case ('statuses-reasons'):
           case ('statuses-mostlikes'):
           case ('statuses-mostdislikes'):
           case ('statuses-travelledabroads'):
           case ('statuses-datingtourinterests'):
           
           case ('statuses-reasonsfornotpurchase'):
           case ('statuses-receivenotifications'):
           case ('statuses-notificationsusefuls'):
           case ('statuses-reactinanyways'):
           
           case ('statuses-primaryspendbrands'):
//            ajax_echo_r ($json);
            switch ($json->r_viewmode) {
             case ('statuses-activities-'):
              $table = $this->model->getAnalyticsStatusesActivities($json);
             break;
             case ('statuses-reasons-'):
              $table = $this->model->getAnalyticsStatusesReasons($json);
             break;
             
             case ('statuses-primaryspendbrands'):
              $table = $this->model->getAnalyticsStatusesPrimaryspendbrands($json);
             break;
             
             default:
              $table = $this->model->getAnalyticsStatuses($json);
             break;
             
             case ('statuses-mostlikes-'):
              $table = $this->model->getAnalyticsStatusesReasons($json);
             break;
             case ('statuses-mostdislikes-'):
              $table = $this->model->getAnalyticsStatusesReasons($json);
             break;
             case ('statuses-travelledabroads-'):
              $table = $this->model->getAnalyticsStatusesReasons($json);
             break;
             case ('statuses-datingtourinterests-'):
              $table = $this->model->getAnalyticsStatusesReasons($json);
             break;
            }
            
//            ajax_echo_r ($table);
            
            
            $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'     ));
            $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row' ));
            $loop_groups        = new Template($this->viewroot, $tmp_src->returnloop('loop_groups'    ));
            $loop_groups3       = new Template($this->viewroot, $tmp_src->returnloop('loop_groups3'   ));
            $loop_groups4       = new Template($this->viewroot, $tmp_src->returnloop('loop_groups4'   ));
            $loop_totals        = new Template($this->viewroot, $tmp_src->returnloop('loop_totals'    ));
            
            $vars    = $loop_table_row->getVariables();
            $vars_g4 = $loop_groups4->getVariables();
            $vars_t  = $loop_totals->getVariables();
//            ajax_echo_r ($vars_g4);
            
            $c = 0;
            $looptmp->fill(       "%c%", $c%2        );
            $looptmp->fill(       "%d%", $c%2+6      );
            $looptmp->fill(       "%e%", $c%2+8      );
            $looptmp->fill(       "%f%", $c%2+10     );
            
            $totals = array();
            $lastTypeID = -1;
            $c = 0;
//            ajax_echo_r ($table);
            
            $thistable    = "";
            $thistable_g  = "";
            $thistable_g2 = "";
            $thistable_g3 = "";
            $thistable_t  = "";
            if (sizeof($table)) {
             $thisidcolumnname = $json->tablename."_ID";
             if ($table) {
              foreach ($table as $k=>$item) {
               if ($k=='dates') {
                foreach ($item as $ik=>$iv) {
                 $loop_groups->reload();
                 $loop_groups->fill('%k%', $ik);
                 $thistable_g .= $loop_groups->output();
                 
                 $loop_groups3->reload();
                 $loop_groups3->fill('%k%', $ik);
                 $thistable_g3 .= $loop_groups3->output();
                }
                
                foreach ($item as $ik=>$iv) {
                 $loop_totals->reload();
                 foreach ($vars_t as $vn) {
                  $loop_totals->fill("%".$vn."%", $iv->$vn);
                 }
                 $thistable_t .= $loop_totals->output();
                }
               } else {
//                ajax_echo_r ($item);
                
//                ajax_echo_r ($item);
                if ($item->Description && sizeof($item->Items)) {
                 $loop_table_row->reload();
  //                $loop_table_row->fill( "%TypePicture%", $block_type[$item->TypeID]);
                 $loop_table_row->fill(       "%c%", $c%2        );
                 $loop_table_row->fill(       "%d%", $c%2+6      );
                 $loop_table_row->fill(       "%e%", $c%2+8      );
                 $loop_table_row->fill(       "%f%", $c%2+10     );
                 
                 $thistable_g4 = "";
                 foreach ($item->Items as $ik=>$iv) {
 //                 ajax_echo_r ($iv);
                  $loop_groups4->reload();
                  $loop_groups4->fill(       "%d%", $c%2+6      );
                  foreach ($vars_g4 as $vn) {
                   $loop_groups4->fill("%".$vn."%", $iv->$vn);
                  }
                  $thistable_g4 .= $loop_groups4->output();
                 }
                 $loop_table_row->fillloop('loop_groups4', $thistable_g4);
                 
                 foreach ($vars as $vn) {
                  $loop_table_row->fill("%".$vn."%", $item->$vn);
                 }
                 
                 if (($item->TypeID==1) || ($item->TypeID==3) || ($item->TypeID==5)) {
                  $sum += $item->Value;
  //                 $Income += $item->Value;
                 } else {
                  $sum -= $item->Value;
  //                 $Expenditure += $item->Value;
                 }
                 $totals[$item->TypeID] += $item->Value;
                 
                 $thistable.=$loop_table_row->output();
                 $c++;
                }
               }
              }
             }
             $tmp_src->fillloop(   "block_norows","" );
             $looptmp->fillloop( 'loop_table_row', $thistable    );
             $looptmp->fillloop(    'loop_groups', $thistable_g  );
             $looptmp->fillloop(   'loop_groups2', $thistable_g2 );
             $looptmp->fillloop(   'loop_groups3', $thistable_g3 );
             $looptmp->fillloop(    'loop_totals', $thistable_t  );
             
             $tmp_src->fillloop("loop_table",$looptmp->output());
            } else {
             $tmp_src->removeloop(   "block_norows","" );
             $tmp_src->fillloop("loop_table","");
            }
            
            
            $tmp_src->fill("%numrows%",sizeof($table[1]));
            
           break;
           
           case ('customers-countries'):
           case ('customers-timezones'):
           case ('customers-statuses'):
            switch ($json->r_viewmode) {
             case ('customers-countries'):
             case ('customers-timezones'):
              $table = $this->model->getAnalyticsCustomers($json);
             break;
             
             case ('customers-statuses'):
              $table = $this->model->getAnalyticsCustomersStatuses($json);
             break;
             
             default:
              echo "analytics - unknown viewmode: ".$json->r_viewmode;
             break;
            }
            
//            ajax_echo_r ($table);
            
            $looptmp        = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
            
            $loop_table_cat = new Template($this->viewroot, $tmp_src->returnloop('loop_table_cat'));
//             $vars_cat = $loop_table_cat->getVariables();
            
            $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
            $vars = $loop_table_row->getVariables();
            
            $lastTypeID = -1;
            $b = 0;
            $c = 0;
            
//              ajax_echo_r ($table[1]);
            $thistable = "";
            if (sizeof($table)) {
             $thisidcolumnname = $json->tablename."_ID";
             if ($table) {
              foreach ($table as $k=>$cat) {
               $loop_table_cat->reload();
               $lastTypeID = -1;
               $c = 0;
               $thistable = "";
               $sum_this = 0;
               $ids = "";
               
               $loop_table_cat->fill(      "%PlaceName%", $k      );
               
               foreach ($cat as $item) {
                if ($lastTypeID!=$item->TypeID) {
                 $lastTypeID = $item->TypeID;
                 $c = 0;
                }
                
                $loop_table_row->reload();
                if ($item->TypeID) {
                 $loop_table_row->fill("%c%",  $c%2+(($item->TypeID-1)*2));
                } else {
                 $loop_table_row->fill("%c%",  $c%2+6);
                }
                foreach ($vars as $vn) {
//                   $loop_table_row->fill("%".$vn."%", $item->$vn);
                 
//                   echo $vn."<br>";
                 switch ($vn) {
                  case ('DateAdded'):
                  case ('Status'):
                  case ('Stage'):
                  case ('FolderName'):
                   $loop_table_row->fill(  "%".$vn."%", str_replace(" ", "&nbsp;", $item->$vn));
                  break;
                  default:
                   $loop_table_row->fill(  "%".$vn."%", $item->$vn);
                  break;
                 }
                 
                 
                 
                }
                
                if (($item->TypeID==1) || ($item->TypeID==3) || ($item->TypeID==5)) {
                 $sum      += $item->Value;
                 $sum_this += $item->Value;
                 $Income += $item->Value;
                } else {
                 $sum      -= $item->Value;
                 $sum_this -= $item->Value;
                 $Expenditure += $item->Value;
                }
                
                if ($ids) $ids.=",";
                $ids.=$item->ID;
                
                $thistable.=$loop_table_row->output();
                $c++;
                $b++;
               }
               
               $loop_table_cat->fill("%ids%", $ids);
               $loop_table_cat->fill("%sum%", $c);
               $loop_table_cat->fillloop('loop_table_row', $thistable);
               $loop_table_cat_str .= $loop_table_cat->output();
              }
             }
            }
            $looptmp->fillloop('loop_table_cat',$loop_table_cat_str);
            $tmp_src->fillloop("loop_table",$looptmp->output());
            
            $tmp_src->fill( "%numrows%", $b);
            
            $tmp_src->fillloop(       "block_no","" );
            $tmp_src->fillloop(   "block_norows","" );
            
            
           break;
           
           case ('customers-countsbytime'):
           case ('customers-countsbytimerel'):
            $longqueriesaccess = getfromcache ('longqueriesaccess');
            
            $lqa_key = md5($data);
            if (!$longqueriesaccess) {
             $longqueriesaccess->$lqa_key = time();
            }
            
            if (time()-$longqueriesaccess->$lqa_key<600) {
             $table = getfromcache ('longqueriescache-'.$lqa_key);
            }
            
            if (!$table) {
             $longqueriesaccess->$lqa_key = time();
             setcache ('longqueriesaccess', $longqueriesaccess);
             
             echo "From database";
             $table = $this->model->getAnalyticsCustomersCountsByTime($json);
             setcache ('longqueriescache-'.$lqa_key, $table);
            } else {
             echo "From cache (".date("Y-m-d H:i:s", $longqueriesaccess->$lqa_key).")";
            }
            
            
            $thistable = "";
            if (sizeof($table)) {
             $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
             $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
             $vars = $loop_table_row->getVariables();
             
             $c = 0;
             $looptmp->fill(       "%c%", $c%2        );
             
             $totals = array();
             $lastTypeID = -1;
             $c = 0;
 //            ajax_echo_r ($table);
             
             $thisidcolumnname = $json->tablename."_ID";
             if ($table) {
              foreach ($table as $k=>$v) {
               $loop_table_row->reload();
               $loop_table_row->fill(       "%c%", $c%2        );
               
               foreach ($vars as $vn) {
                $loop_table_row->fill("%".$vn."%", $v->$vn);
               }
               
               $thistable.=$loop_table_row->output();
               $c++;
              }
             }
             $looptmp->fillloop('loop_table_row', $thistable);
             $tmp_src->fillloop("loop_table", $looptmp->output());
             $tmp_src->fillloop("block_norows", "");
             
            } else {
             $tmp_src->fillloop("loop_table", "");
             $tmp_src->removeloop("block_norows");
            }
            
           break;
           
           case ('customers-countsbylocaltime'):
           case ('customers-countsbylocaltimerel'):
            $longqueriesaccess = getfromcache ('longqueriesaccess');
            
            $lqa_key = md5($data);
            if (!$longqueriesaccess) {
             $longqueriesaccess->$lqa_key = time();
            }
            
            if (time()-$longqueriesaccess->$lqa_key<600) {
             $table = getfromcache ('longqueriescache-'.$lqa_key);
            }
            
            if (!$table) {
             $longqueriesaccess->$lqa_key = time();
             setcache ('longqueriesaccess', $longqueriesaccess);
             
             echo "From database";
//             $table = $this->model->getAnalyticsCustomersCountsByTime($json);
             $table = $this->model->getAnalyticsCustomersCountsByLocalTime($json);
             setcache ('longqueriescache-'.$lqa_key, $table);
            } else {
             echo "From cache (".date("Y-m-d H:i:s", $longqueriesaccess->$lqa_key).")";
            }
            
            
            $thistable = "";
            if (sizeof($table)) {
             $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
             $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
             $vars = $loop_table_row->getVariables();
             
             $c = 0;
             $looptmp->fill(       "%c%", $c%2        );
             
             $totals = array();
             $lastTypeID = -1;
             $c = 0;
 //            ajax_echo_r ($table);
             
             $thisidcolumnname = $json->tablename."_ID";
             if ($table) {
              foreach ($table as $k=>$v) {
               $loop_table_row->reload();
               $loop_table_row->fill(       "%c%", $c%2        );
               
               foreach ($vars as $vn) {
                $loop_table_row->fill("%".$vn."%", $v->$vn);
               }
               
               $thistable.=$loop_table_row->output();
               $c++;
              }
             }
             $looptmp->fillloop('loop_table_row', $thistable);
             $tmp_src->fillloop("loop_table", $looptmp->output());
             $tmp_src->fillloop("block_norows", "");
             
            } else {
             $tmp_src->fillloop("loop_table", "");
             $tmp_src->removeloop("block_norows");
            }
            
           break;
           
           case ('customers-countsbytimeadded'):
            $longqueriesaccess = getfromcache ('longqueriesaccess');
            
            $lqa_key = md5($data);
            if (!$longqueriesaccess) {
             $longqueriesaccess->$lqa_key = time();
            }
            
            if (time()-$longqueriesaccess->$lqa_key<600) {
             $table = getfromcache ('longqueriescache-'.$lqa_key);
            }
            
            if (!$table) {
             $longqueriesaccess->$lqa_key = time();
             setcache ('longqueriesaccess', $longqueriesaccess);
             
             echo "From database";
             $table = $this->model->getAnalyticsCustomersCountsByTimeAdded($json);
             setcache ('longqueriescache-'.$lqa_key, $table);
            } else {
             echo "From cache (".date("Y-m-d H:i:s", $longqueriesaccess->$lqa_key).")";
            }
            
            $thistable = "";
            if (sizeof($table)) {
             $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
             $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
             $vars = $loop_table_row->getVariables();
             
             $c = 0;
             $looptmp->fill(       "%c%", $c%2        );
             
             $totals = array();
             $lastTypeID = -1;
             $c = 0;
 //            ajax_echo_r ($table);
             
             $thisidcolumnname = $json->tablename."_ID";
             if ($table) {
              foreach ($table as $k=>$v) {
               $loop_table_row->reload();
               $loop_table_row->fill(       "%c%", $c%2        );
               
               foreach ($vars as $vn) {
                $loop_table_row->fill("%".$vn."%", $v->$vn);
               }
               
               $thistable.=$loop_table_row->output();
               $c++;
              }
             }
             $looptmp->fillloop('loop_table_row', $thistable);
             $tmp_src->fillloop("loop_table", $looptmp->output());
             $tmp_src->fillloop("block_norows", "");
             
            } else {
             $tmp_src->fillloop("loop_table", "");
             $tmp_src->removeloop("block_norows");
            }
            
           break;
           
           case ('qos-calls'):
//            $table = $this->model->getAnalyticsQOSCalls($json);
//            ajax_echo_r ($table);
            
            
            $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'     ));
            $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row' ));
            $loop_groups        = new Template($this->viewroot, $tmp_src->returnloop('loop_groups'    ));
            $loop_groups3       = new Template($this->viewroot, $tmp_src->returnloop('loop_groups3'   ));
            $loop_groups4       = new Template($this->viewroot, $tmp_src->returnloop('loop_groups4'   ));
            $loop_totals        = new Template($this->viewroot, $tmp_src->returnloop('loop_totals'    ));
            
            $vars    = $loop_table_row->getVariables();
            $vars_g4 = $loop_groups4->getVariables();
            $vars_t  = $loop_totals->getVariables();
//            ajax_echo_r ($vars_g4);
            
            $c = 0;
            $looptmp->fill(       "%c%", $c%2        );
            $looptmp->fill(       "%d%", $c%2+6      );
            $looptmp->fill(       "%e%", $c%2+8      );
            $looptmp->fill(       "%f%", $c%2+10     );
            
            $totals = array();
            $lastTypeID = -1;
            $c = 0;
//            ajax_echo_r ($table);
            
            $thistable    = "";
            $thistable_g  = "";
            $thistable_g2 = "";
            $thistable_g3 = "";
            $thistable_t  = "";
            if (sizeof($table)) {
             $thisidcolumnname = $json->tablename."_ID";
             if ($table) {
              foreach ($table as $k=>$item) {
               if ($k=='dates') {
                foreach ($item as $ik=>$iv) {
                 $loop_groups->reload();
                 $loop_groups->fill('%k%', $ik);
                 $thistable_g .= $loop_groups->output();
                 
                 $loop_groups3->reload();
                 $loop_groups3->fill('%k%', $ik);
                 $thistable_g3 .= $loop_groups3->output();
                }
                
                foreach ($item as $ik=>$iv) {
                 $loop_totals->reload();
                 foreach ($vars_t as $vn) {
                  $loop_totals->fill("%".$vn."%", $iv->$vn);
                 }
                 $thistable_t .= $loop_totals->output();
                }
               } else {
//                ajax_echo_r ($item);
                
//                ajax_echo_r ($item);
                if ($item->Description && sizeof($item->Items)) {
                 $loop_table_row->reload();
  //                $loop_table_row->fill( "%TypePicture%", $block_type[$item->TypeID]);
                 $loop_table_row->fill(       "%c%", $c%2        );
                 $loop_table_row->fill(       "%d%", $c%2+6      );
                 $loop_table_row->fill(       "%e%", $c%2+8      );
                 $loop_table_row->fill(       "%f%", $c%2+10     );
                 
                 $thistable_g4 = "";
                 foreach ($item->Items as $ik=>$iv) {
 //                 ajax_echo_r ($iv);
                  $loop_groups4->reload();
                  $loop_groups4->fill(       "%d%", $c%2+6      );
                  foreach ($vars_g4 as $vn) {
                   $loop_groups4->fill("%".$vn."%", $iv->$vn);
                  }
                  $thistable_g4 .= $loop_groups4->output();
                 }
                 $loop_table_row->fillloop('loop_groups4', $thistable_g4);
                 
                 foreach ($vars as $vn) {
                  $loop_table_row->fill("%".$vn."%", $item->$vn);
                 }
                 
                 if (($item->TypeID==1) || ($item->TypeID==3) || ($item->TypeID==5)) {
                  $sum += $item->Value;
  //                 $Income += $item->Value;
                 } else {
                  $sum -= $item->Value;
  //                 $Expenditure += $item->Value;
                 }
                 $totals[$item->TypeID] += $item->Value;
                 
                 $thistable.=$loop_table_row->output();
                 $c++;
                }
               }
              }
             }
             $tmp_src->fillloop(   "block_norows","" );
             $looptmp->fillloop( 'loop_table_row', $thistable    );
             $looptmp->fillloop(    'loop_groups', $thistable_g  );
             $looptmp->fillloop(   'loop_groups2', $thistable_g2 );
             $looptmp->fillloop(   'loop_groups3', $thistable_g3 );
             $looptmp->fillloop(    'loop_totals', $thistable_t  );
             
             $tmp_src->fillloop("loop_table",$looptmp->output());
            } else {
             $tmp_src->removeloop(   "block_norows","" );
             $tmp_src->fillloop("loop_table","");
            }
            
            
            $tmp_src->fill("%numrows%",sizeof($table[1]));
            
           break;
           
           
           
           
           
           
           
           
           case ('hh-activity'):
            if ($json->r_Weeks) {
             $ret = $this->model->getAnalyticsFullWeeks($json);
 //            ajax_echo_r ($ret);
             
             
             foreach ($ret->funnels as $fk=>$funnel) {
              $loop_table_row        = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row_'.$fk));
              $loop_table_subrow     = new Template($this->viewroot, $loop_table_row->returnloop('loop_table_subrow'));
              $loop_table_subrow_hdr = new Template($this->viewroot, $tmp_src->returnloop('loop_table_subrow_hdr_'.$fk));
              
              $c = 0;
              $tmp_src->fill(       "%c%", $c%2        );
              $tmp_src->fill(       "%d%", $c%2+6      );
              $tmp_src->fill(       "%e%", $c%2+8      );
              
              $vars = $loop_table_subrow->getVariables();
              
 //             ajax_echo_r ($funnel);
 //             ajax_echo_r (array_keys($funnel[array_keys($funnel)[0]]));
              
              $sr = "";
              
 //             foreach (array_keys($funnel[array_keys($funnel)[0]]) as $k=>$v) {
              foreach ($ret->funnels['money']['weeks'] as $k=>$v) {
               $loop_table_subrow_hdr->reload();
               $loop_table_subrow_hdr->fill("%hdr%", $k);
               $loop_table_subrow_hdr->fill("%Day%"  , $v->Day);
               $loop_table_subrow_hdr->fill("%Month%", $v->Month);
               $loop_table_subrow_hdr->fill("%Year%" , $v->Year);
               $sr.=$loop_table_subrow_hdr->output();
              }
              $tmp_src->fillloop('loop_table_subrow_hdr_'.$fk, $sr);
              
              
              $thistbl = "";
              foreach ($funnel as $k=>$v) {
               if ($k!='keys') {
                $loop_table_row->reload();
                $loop_table_row->fill(       "%c%", $c%2        );
                $loop_table_row->fill(       "%d%", $c%2+6      );
                $loop_table_row->fill(       "%e%", $c%2+8      );
                $loop_table_row->fill(     "%Cat%", $k          );
                
                $sr = "";
 //               ajax_echo_r ($funnel['keys']);
                foreach ($funnel['keys'] as $sk=>$sv) {
 //                ajax_echo_r ($sk);
                 $loop_table_subrow->reload();
                 foreach ($vars as $var) {
                  $loop_table_subrow->fill(     "%".$var."%", $v[$sk]->$var     );
                 }
                 $sr.=$loop_table_subrow->output();
                }
                $loop_table_row->fillloop('loop_table_subrow', $sr);
                
                $thistbl.=$loop_table_row->output();
                $c++;
               }
              }
              $tmp_src->fillloop('loop_table_row_'.$fk, $thistbl);
              
             }
             
            } else {
             $table = $this->model->getAnalyticsHHActivity($json);
//             $table = array(1);
             
             $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
             $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
             $vars = $loop_table_row->getVariables();
             
             $c = 0;
             $looptmp->fill(       "%c%", $c%2        );
             $looptmp->fill(       "%d%", $c%2+6      );
             $looptmp->fill(       "%e%", $c%2+8      );
             $looptmp->fill(       "%f%", $c%2+10     );
             
             /*
             $block_type = array();
             $block_type[1]     = new Template($this->viewroot, $tmp_src->returnloop('block_type1'));
             $block_type[2]     = new Template($this->viewroot, $tmp_src->returnloop('block_type2'));
             $block_type[5]     = new Template($this->viewroot, $tmp_src->returnloop('block_type5'));
             $block_type[6]     = new Template($this->viewroot, $tmp_src->returnloop('block_type6'));
             
             $block_type[1] = $block_type[1]->output();
             $block_type[2] = $block_type[2]->output();
             $block_type[5] = $block_type[5]->output();
             $block_type[6] = $block_type[6]->output();
             */
             
             $totals = array();
             $lastTypeID = -1;
             $c = 0;
 //            ajax_echo_r ($table);
             
             $thistable = "";
             if (sizeof($table)) {
              $thisidcolumnname = $json->tablename."_ID";
              if ($table) {
               foreach ($table as $item) {
                if ($lastTypeID!=$item->TypeID) {
                 $lastTypeID = $item->TypeID;
                 $c = 2;
                }
                
                $loop_table_row->reload();
//                $loop_table_row->fill( "%TypePicture%", $block_type[$item->TypeID]);
                $loop_table_row->fill(       "%c%", $c%2        );
                $loop_table_row->fill(       "%d%", $c%2+6      );
                $loop_table_row->fill(       "%e%", $c%2+8      );
                $loop_table_row->fill(       "%f%", $c%2+10     );
                foreach ($vars as $vn) {
                 $loop_table_row->fill("%".$vn."%", $item->$vn);
                }
                
                if (($item->TypeID==1) || ($item->TypeID==3) || ($item->TypeID==5)) {
                 $sum += $item->Value;
 //                 $Income += $item->Value;
                } else {
                 $sum -= $item->Value;
 //                 $Expenditure += $item->Value;
                }
                $totals[$item->TypeID] += $item->Value;
                
                $thistable.=$loop_table_row->output();
                $c++;
               }
              }
             }
             $looptmp->fillloop('loop_table_row',$thistable);
             $tmp_src->fillloop("loop_table",$looptmp->output());
             
             $tmp_src->fill("%numrows%",sizeof($table[1]));
             
             $tmp_src->fillloop(       "block_no","" );
             $tmp_src->fillloop(   "block_norows","" );
             
             $tmp_src->fillloop(    "block_type1", '');
             $tmp_src->fillloop(    "block_type2", '');
             $tmp_src->fillloop(    'block_type5', '');
             $tmp_src->fillloop(    'block_type6', '');
             
             
             
             
            }
            
            
           break;
           case ('clubs'):
            if ($json->r_Weeks) {
             $ret = $this->model->getAnalyticsClubsWeeks($json);
            } else {
             $table = $this->model->getAnalyticsClubs($json);
 //            ajax_echo_r ($table[1][0]);
             
             $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
             $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
             $vars = $loop_table_row->getVariables();
             
             
             $block_type = array();
             $block_type[1]     = new Template($this->viewroot, $tmp_src->returnloop('block_type1'));
             $block_type[2]     = new Template($this->viewroot, $tmp_src->returnloop('block_type2'));
             $block_type[5]     = new Template($this->viewroot, $tmp_src->returnloop('block_type5'));
             $block_type[6]     = new Template($this->viewroot, $tmp_src->returnloop('block_type6'));
             
             $block_type[1] = $block_type[1]->output();
             $block_type[2] = $block_type[2]->output();
             $block_type[5] = $block_type[5]->output();
             $block_type[6] = $block_type[6]->output();
             
             $lastTypeID = -1;
             $c = 0;
   //           ajax_echo_r ($table[1]);
             $thistable = "";
             if (sizeof($table[1])) {
              $thisidcolumnname = $json->tablename."_ID";
              foreach ($table[1] as $item) {
               if ($lastTypeID!=$item->TypeID) {
                $lastTypeID = $item->TypeID;
                $c = 2;
               }
               
               $loop_table_row->reload();
               $loop_table_row->fill( "%TypePicture%", $block_type[$item->TypeID]);
//               $loop_table_row->fill("%c%",  $c%2+(($item->TypeID-1)*2));
               $loop_table_row->fill("%c%",  $c%2+4);
               foreach ($vars as $vn) {
                $loop_table_row->fill("%".$vn."%", $item->$vn);
               }
               
               if (($item->TypeID==1) || ($item->TypeID==3) || ($item->TypeID==5)) {
                $sum += $item->Value;
                $Income += $item->Value;
               } else {
                $sum -= $item->Value;
                $Expenditure += $item->Value;
               }
               
               $thistable.=$loop_table_row->output();
               $c++;
              }
              $looptmp->fillloop('loop_table_row',$thistable);
              $tmp_src->fillloop("loop_table",$looptmp->output());
              
              $tmp_src->fillloop(   "block_norows","" );
             } else {
              $tmp_src->fillloop("loop_table", "123");
              $tmp_src->removeloop(   "block_norows" );
             }
             
             $tmp_src->fill("%numrows%",sizeof($table[1]));
             
             $tmp_src->fillloop(       "block_no","" );
             $tmp_src->fillloop(      "block_yes","" );
             
             $tmp_src->fillloop(    "block_type1", '');
             $tmp_src->fillloop(    "block_type2", '');
             $tmp_src->fillloop(    'block_type5', '');
             $tmp_src->fillloop(    'block_type6', '');
             
             
             
             
            }
           break;
           case ('partners'):
            if ($json->r_Weeks) {
             $ret = $this->model->getAnalyticsPartnersWeeks($json);
            } else {
             $table = $this->model->getAnalyticsPartners($json);
 //            ajax_echo_r ($table[1][0]);
             
             $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
             $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
             $vars = $loop_table_row->getVariables();
             
             
             $block_type = array();
             $block_type[1]     = new Template($this->viewroot, $tmp_src->returnloop('block_type1'));
             $block_type[2]     = new Template($this->viewroot, $tmp_src->returnloop('block_type2'));
             $block_type[5]     = new Template($this->viewroot, $tmp_src->returnloop('block_type5'));
             $block_type[6]     = new Template($this->viewroot, $tmp_src->returnloop('block_type6'));
             
             $block_type[1] = $block_type[1]->output();
             $block_type[2] = $block_type[2]->output();
             $block_type[5] = $block_type[5]->output();
             $block_type[6] = $block_type[6]->output();
             
             $lastTypeID = -1;
             $c = 0;
   //           ajax_echo_r ($table[1]);
             $thistable = "";
             if (sizeof($table)) {
              $thisidcolumnname = $json->tablename."_ID";
              if ($table[1]) {
               foreach ($table[1] as $item) {
                if ($lastTypeID!=$item->TypeID) {
                 $lastTypeID = $item->TypeID;
                 $c = 2;
                }
                
                $loop_table_row->reload();
                $loop_table_row->fill( "%TypePicture%", $block_type[$item->TypeID]);
 //               $loop_table_row->fill("%c%",  $c%2+(($item->TypeID-1)*2));
                $loop_table_row->fill("%c%",  $c%2);
                foreach ($vars as $vn) {
                 $loop_table_row->fill("%".$vn."%", $item->$vn);
                }
                
                if (($item->TypeID==1) || ($item->TypeID==3) || ($item->TypeID==5)) {
                 $sum += $item->Value;
                 $Income += $item->Value;
                } else {
                 $sum -= $item->Value;
                 $Expenditure += $item->Value;
                }
                
                $thistable.=$loop_table_row->output();
                $c++;
               }
              }
             }
             $looptmp->fillloop('loop_table_row',$thistable);
             $tmp_src->fillloop("loop_table",$looptmp->output());
             
             $tmp_src->fill("%numrows%",sizeof($table[1]));
             
             $tmp_src->fillloop(       "block_no","" );
             $tmp_src->fillloop(   "block_norows","" );
             
             $tmp_src->fillloop(    "block_type1", '');
             $tmp_src->fillloop(    "block_type2", '');
             $tmp_src->fillloop(    'block_type5', '');
             $tmp_src->fillloop(    'block_type6', '');
             
             
             
             
            }
           break;
           case ('freelancers'):
            if ($json->r_Weeks) {
             $ret = $this->model->getAnalyticsFreelancersWeeks($json);
            } else {
             $table = $this->model->getAnalyticsFreelancers($json);
 //            ajax_echo_r ($table[1][0]);
             
             $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
             $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
             $vars = $loop_table_row->getVariables();
             
             $block_type = array();
             $block_type[1]     = new Template($this->viewroot, $tmp_src->returnloop('block_type1'));
             $block_type[2]     = new Template($this->viewroot, $tmp_src->returnloop('block_type2'));
             $block_type[5]     = new Template($this->viewroot, $tmp_src->returnloop('block_type5'));
             $block_type[6]     = new Template($this->viewroot, $tmp_src->returnloop('block_type6'));
             
             $block_type[1] = $block_type[1]->output();
             $block_type[2] = $block_type[2]->output();
             $block_type[5] = $block_type[5]->output();
             $block_type[6] = $block_type[6]->output();
             
             $lastTypeID = -1;
             $c = 0;
   //           ajax_echo_r ($table[1]);
             $thistable = "";
             if (sizeof($table)) {
              $thisidcolumnname = $json->tablename."_ID";
              if ($table[1]) {
               foreach ($table[1] as $item) {
                if ($lastTypeID!=$item->TypeID) {
                 $lastTypeID = $item->TypeID;
                 $c = 2;
                }
                
                $loop_table_row->reload();
                
                $loop_table_row->fill( "%TypePicture%", $block_type[$item->TypeID]);
 //               $loop_table_row->fill("%c%",  $c%2+(($item->TypeID-1)*2));
                $loop_table_row->fill("%c%",  $c%2);
                foreach ($vars as $vn) {
                 $loop_table_row->fill("%".$vn."%", $item->$vn);
                }
                
                if (($item->TypeID==1) || ($item->TypeID==3) || ($item->TypeID==5)) {
                 $sum += $item->Value;
                 $Income += $item->Value;
                } else {
                 $sum -= $item->Value;
                 $Expenditure += $item->Value;
                }
                
                $thistable.=$loop_table_row->output();
                $c++;
               }
              }
             }
             $looptmp->fillloop('loop_table_row',$thistable);
             $tmp_src->fillloop("loop_table",$looptmp->output());
             
             $tmp_src->fill("%numrows%",sizeof($table[1]));
             
             $tmp_src->fillloop(       "block_no","" );
             $tmp_src->fillloop(   "block_norows","" );
             
             $tmp_src->fillloop(    "block_type1", '');
             $tmp_src->fillloop(    "block_type2", '');
             $tmp_src->fillloop(    'block_type5', '');
             $tmp_src->fillloop(    'block_type6', '');
             
             
             
             
            }
           break;
           case ('full'):
           case ('db-timezones'):
            switch ($json->r_viewmode) {
             case ('full'):
              $ret = $this->model->getAnalyticsFull($json);
             break;
             case ('db-timezones'):
              $ret = $this->model->getAnalyticsTimezones($json);
             break;
            }
            
//            ajax_echo_r ($ret);
//            ajax_echo_r ($tmp_src);
            
            foreach ($ret as $fk=>$funnel) {
//             echo $fk."<br>";
             $l = $tmp_src->returnloop('loop_table_row_'.$fk);
             if ($l) {
              $loop_table_row = new Template($this->viewroot, $l);
              
              $vars = $loop_table_row->getVariables();
              
  //            ajax_echo_r ($funnel);
              
              $c = 0;
              $thistbl = "";
              foreach ($funnel as $k=>$v) {
               $loop_table_row->reload();
               $loop_table_row->fill(       "%c%", $c%2        );
               $loop_table_row->fill(     "%Cat%", $k          );
               $loop_table_row->fill(     "%Cnt%", $v          );
               
               $thistbl.=$loop_table_row->output();
               $c++;
              }
              $tmp_src->fillloop('loop_table_row_'.$fk, $thistbl);
             }
            }
            
           break;
           case ('monthlych'):
            $ret = $this->model->getAnalytics2($json, "sunburst.json");
            $tmp_src->fill(   '%filename%', 'data/charts/sunburst.json'         );
            $tmp_src->fill( '%domain_max%', $ret                                );
           break;
           case ('dynamics-weeks'):
           case ('dynamics-months'):
            $ret = $this->model->getAnalytics1($json, "data.tsv");
            $tmp_src->fill( '%domain_max%', $ret                                );
           break;
           case ('yearrep'):
            $rep = $this->model->getAnalytics($json);
            $tmp_src->fill( '%domain_max%', $ret                                );
            
            ajax_echo_r ($rep);
           break;
           case ('through'):
            $rep = $this->model->getAnalyticsThrough($json);
//            $tmp_src->fill( '%domain_max%', $ret                                );
            
//            ajax_echo_r ($rep);
            
            if ($json->r_Weeks) {
             $ret = $this->model->getAnalyticsClubsWeeks($json);
            } else {
             $table = $this->model->getAnalyticsThrough($json);
 //            ajax_echo_r ($table[1][0]);
             
             $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
             $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
             $vars = $loop_table_row->getVariables();
             
             
             $block_type = array();
             $block_type[1]     = new Template($this->viewroot, $tmp_src->returnloop('block_type1'));
             $block_type[2]     = new Template($this->viewroot, $tmp_src->returnloop('block_type2'));
             $block_type[5]     = new Template($this->viewroot, $tmp_src->returnloop('block_type5'));
             $block_type[6]     = new Template($this->viewroot, $tmp_src->returnloop('block_type6'));
             
             $block_type[1] = $block_type[1]->output();
             $block_type[2] = $block_type[2]->output();
             $block_type[5] = $block_type[5]->output();
             $block_type[6] = $block_type[6]->output();
             
             $lastTypeID = -1;
             $c = 0;
   //           ajax_echo_r ($table[1]);
             $thistable = "";
             if (sizeof($table[1])) {
              $thisidcolumnname = $json->tablename."_ID";
              foreach ($table[1] as $item) {
               if ($lastTypeID!=$item->TypeID) {
                $lastTypeID = $item->TypeID;
                $c = 2;
               }
               
               $loop_table_row->reload();
               $loop_table_row->fill( "%TypePicture%", $block_type[$item->TypeID]);
//               $loop_table_row->fill("%c%",  $c%2+(($item->TypeID-1)*2));
               $loop_table_row->fill("%c%",  $c%2);
               foreach ($vars as $vn) {
                $loop_table_row->fill("%".$vn."%", $item->$vn);
               }
               
               if (($item->TypeID==1) || ($item->TypeID==3) || ($item->TypeID==5)) {
                $sum += $item->Value;
                $Income += $item->Value;
               } else {
                $sum -= $item->Value;
                $Expenditure += $item->Value;
               }
               
               $thistable.=$loop_table_row->output();
               $c++;
              }
              $looptmp->fillloop('loop_table_row',$thistable);
              $tmp_src->fillloop("loop_table",$looptmp->output());
              
              $tmp_src->fillloop(   "block_norows","" );
             } else {
              $tmp_src->fillloop("loop_table", "123");
              $tmp_src->removeloop(   "block_norows" );
             }
             
             $tmp_src->fill("%numrows%",sizeof($table[1]));
             
             $tmp_src->fillloop(       "block_no","" );
             
             $tmp_src->fillloop(    "block_type1", '');
             $tmp_src->fillloop(    "block_type2", '');
             $tmp_src->fillloop(    'block_type5', '');
             $tmp_src->fillloop(    'block_type6', '');
             
             
             
             
            }
            
           break;
           case ('hh-resumes'):
            $rep = $this->model->getAnalyticsHHResumes($json);
 //           ajax_echo_r ($rep);
            
            
            $looptmp        = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
            $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
            $vars = $loop_table_row->getVariables();
            
            $c = 0;
            
            $thistable = "";
            if (sizeof($rep)) {
             foreach ($rep as $item) {
              $loop_table_row->reload();
              foreach ($vars as $vn) {
               if ($vn!=="Children") {
                $loop_table_row->fill("%".$vn."%", $item->$vn);
               }
              }
              
              $thistable.=$loop_table_row->output();
              $c++;
             }
            }
            $looptmp->fillloop('loop_table_row',$thistable);
            $tmp_src->fillloop("loop_table",$looptmp->output());
            
            $tmp_src->fill("%numrows%",sizeof($table));
            
            
            
           break;
          }
          
          setCache('analytics_'.session_id(), $table);
          
          $tmp_src = $this->fillStricts($tmp_src);
          
          
          $tmp_src->processfcb('');
          $tmp_src->fill(  '%imgfolder%', $this->imgfolder                    );
          $tmp_src->fill(   '%viewroot%', $this->viewroot                     );
          
          ajax_echo(sup($tmp_src->output()));
          
         } else {
 //         ajax_echo_r ($json);
 //echo "07 Time elapsed ".formatmicrotime(microtime(true) - $ajax_timer)." s. <br>";
          $json->tablename = $json->go;
          
          $thisdebug = 0;
          if ($thisdebug) $mtime = microtime(true);
          switch ($json->go) {
           case ('dbrefine'):
            $table = $this->model->getDBRefine($json);
           break;
           case ('video'):
           break;
           case ('events'):
            $table = $this->model->getStatusesCustomers(0,0,1,$json); // aka getEvents
            
           break;
           case ('dashboard'):
//            ajax_echo_r ($json);
            switch ($json->r_viewmode) {
             case ('dashboard-customers'):
              
             break;
            }
            
           break;
           case ('qd'):
            $table = $this->model->getQD($json);
           break;
           case ('news'):
            $params = new stdClass;
            $params->listid=-1;
            $table = $this->model->getTasks($params);
           break;
           case ('reports'):
            $table = $this->model->getReports($json);
           break;
           case ('macros'):
            $table = $this->model->getMacros($json);
           break;
           case ('schedule'):
//            $model_calendar = new Model_Calendar;
//            $model_calendar = Model_Calendar::getInstance($this->settings);            // instantiate the Model class
            
//            $table = Model_Calendar::getCalendar($json);
            
            setsecurevariable('schedule_json', $json);
            
            $table = $this->model->getSchedule($json);
            
//            $this->exportCalendar();
 //           ajax_echo_r($table);
            
           break;
           case ('users'):
            if ($this->user->GroupID!=1) $id = $this->user->ID;
            $table[1] = $this->model->getUsers($json, $id);
//            $table[1] = $this->model->getLastCallEvents($table[1], $id);
            
           break;
           case ('people'):
            if ($this->user->GroupID!=1) $id = $this->user->ID;
            $table[1] = $this->model->getPeoples($json, $id);
           break;
           case ('system'):
            $table = $this->model->getQueue($json);
            
           break;
           case ('vkusers'):
            $timer = microtime(true);
 //           echo "timer: ".$timer."<br>";
            $table[1] = $this->model->getVKUsers($json);
            if ($table[1][0]) {
             $table[0] = array_keys((array)$table[1][0]);
            }
            if (microtime(true) - $ajax_timer > 1) echo "getVKUsers - Time elapsed ".formatmicrotime(microtime(true) - $timer)." s. <br>";
           break;
           case ('freelancers'):
 //echo "08 Time elapsed ".formatmicrotime(microtime(true) - $ajax_timer)." s. <br>";
 //           $this->model->fillFreelancers($json);
            
 //echo "09 Time elapsed ".formatmicrotime(microtime(true) - $ajax_timer)." s. <br>";
            $timer = microtime(true);
 //           echo "timer: ".$timer."<br>";
            $table[1] = $this->model->getFreelancers($json);
            if ($table[1][0]) {
             $table[0] = array_keys((array)$table[1][0]);
            }
            if (microtime(true) - $ajax_timer > 1) echo "getFreelancers - Time elapsed ".formatmicrotime(microtime(true) - $timer)." s. <br>";
           break;
           case ('vacancies'):
            $timer = microtime(true);
            $table[1] = $this->model->getVacancies($json);
            
 //           ajax_echo_r ($table[1]);
            
            if ($table[1][0]) {
             $table[0] = array_keys((array)$table[1][0]);
            }
            if (microtime(true) - $ajax_timer > 1) echo "getVacancies - Time elapsed ".formatmicrotime(microtime(true) - $timer)." s. <br>";
           break;
           
           case ('retargeting'):
            $table[1] = $this->model->getRetargetingInfo();
           break;
           case ('email'):
            $table[1] = $this->model->getEmails($json);
           break;
           case ('family'):
            $params = new stdClass;
            $params->tablename = 'bodymetrics';
            $table = $this->model->getTable($params);
            
            $table2 = $this->model->getChildren($json);
           break;
           case ('callrecordings'):
            $table = $this->model->getCallrecordings($json);
//            ajax_echo_r ($table);
           break;
           case ('skype'):
            $json->tablename = 'skype_messages';
            $table = $this->model->getSkypeMessages($json);
 //           ajax_echo_r ($json);
           break;
           case ('crm'):
//            ajax_echo_r ($json);
            
//            $tmr2 = microtime(true);
            $table = $this->model->getCrm($json);
//            echo "Time elapsed ".formatmicrotime(microtime(true) - $tmr2)." s. <br>";
            
//            ajax_echo_r ($table);
           break;
           case ('parsers'):
            $table = $this->model->getParsersInfo($json);
           break;
           case ('assessments'):
            $table = $this->model->getAssessments($json);
           break;
           case ('clubs'):
            $table = array();
            $table[1] = $this->model->getClubs($json);
            
            foreach ($table[1] as $k=>$v) {
             $table[1][$k]->files_cnt   = $this->getFilesCount($table[1][$k]);
             $data = clone $table[1][$k];
             $data->ParentName = 'clubs';
             $data->ParentID   = $table[1][$k]->ID;
             $table[1][$k]->touches_cnt = $this->getStatusesCount($data);
             $table[1][$k]->talk_cnt    = $this->getMessagesCount($data);
//             $table[1][$k]->ass_cnt     = $this->model->getBetsCount($data);
            }
            
           break;
           case ('sql'):
//            ajax_echo_r ($json);
            $start = time();
            $table = $this->model->runSQL($json);
            echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$start)."</b><br>";
            
//            ajax_echo_r ($table);
           break;
           case ('customers'):
            $table = $this->model->getCustomers($json);
           break;
           case ('calls'):
            // moved to showCallsDetails
           break;
           
           
           
           
           case ('di-members'):
            include_once('model/MSkadate.php');
            $sk = new SModel($this->settings, $this->user);
            $table = $sk->getDIMembers();
           break;
           
           
           case ('home'):
           break;
           
           default:
//            ajax_echo_r ($json);
            $table = $this->model->getTable($json);
           break;
          }
           
//          ajax_echo_r($table);
           
 //         if ($json->go=="analytics") {
 //         } else {
           
           if (gettype($table)=='array') {
            setsecurevariable('ids', $table[1]);
           }
           
           if ($json->isexport) {
            $tmp = new Template($this->viewroot, 'output_list_'.$json->go.'.htt');                                      // load common parent template
            $block_item = new Template($this->viewroot, $tmp->returnloop('block_item'));
            
            $vars = $block_item->getVariables();
            
            $thislist = "";
            if (sizeof($table[1])) {
             foreach ($table[1] as $item) {
              $block_item->reload();
              foreach ($vars as $vn) {
               $block_item->fill("%".$vn."%"           , $item->$vn     );
              }
              $thislist.=$block_item->output();
             }
            }
            
            $tmp->fillloop("block_item"           , $thislist     );
            
            $tmp->fill("%numrows%",sizeof($table[1]));
            
            $tmp->processfcb();
            $tmp->fill(  '%imgfolder%' , $this->imgfolder                    );
            $tmp->fill(   '%viewroot%' , $this->viewroot                     );
            
            ajax_echo(sup($tmp->output()));
           } else {
            if ($json->r_SQLExplain) {
             $tmp_src = new Template($this->viewroot, 'main_'.$json->go.'_explain.htt');             // load common parent template
            } else {
//             if ($json->r_viewmode) {
              $tmp_src = new Template($this->viewroot, 'main_'.$json->go.'_'.$json->r_viewmode.'.htt');             // load common parent template
//             }
             if (!$tmp_src->IsTemplate()) {
              $tmp_src = new Template($this->viewroot, 'main_'.$json->go.'.htt');                                   // load common parent template
             }
            }
            
            $tmp_src->processfcb('');
            $tmp_src->fill(  '%imgfolder%' , $this->imgfolder                    );
            $tmp_src->fill(   '%viewroot%' , $this->viewroot                     );
            
            $sum = 0;
            $Income = 0;
            $Expenditure = 0;
            
            $New = 0;
            $InProgress = 0;
            $Done = 0;
            $Approved = 0;
            
    //        ajax_echo_r ($json);
//            ajax_echo_r ($table);
            switch ($json->go) {
 //            break;
             case ('dbrefine'):
              $tmp_src->fill('%Caption%', $json->r_viewmode_caption);
              
              $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
              $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
              $vars = $loop_table_row->getVariables();
              
              
              
              
              $lastTypeID = -1;
              $c = 0;
              $ids = "";
   //           ajax_echo_r ($table[1]);
              $thistable = "";
              if (sizeof($table)) {
               $thisidcolumnname = $json->tablename."_ID";
               if ($table[1]) {
                foreach ($table[1] as $item) {
                 if ($lastTypeID!=$item->TypeID) {
                  $lastTypeID = $item->TypeID;
                  $c = 2;
                 }
                 
                 $item->DateAdded = str_replace(" ", "&nbsp;", $item->DateAdded);
                 
                 $loop_table_row->reload();
                 $loop_table_row->fill( "%TypePicture%", $block_type[$item->TypeID]);
                 $loop_table_row->fill("%c%",  $c%2  );
                 foreach ($vars as $vn) {
                  $loop_table_row->fill("%".$vn."%", $item->$vn);
                 }
                 
                 $thistable.=$loop_table_row->output();
                 $c++;
                }
               }
               $looptmp->fillloop('loop_table_row',$thistable);
               $tmp_src->fillloop(   "block_norows","" );
              } else {
               $tmp_src->removeloop(   "block_norows","" );
              }
              $tmp_src->fillloop("loop_table",$looptmp->output());
              
              $tmp_src->fill("%numrows%",sizeof($table[1]));
              
              $tmp_src->fill(          '%cnt%', $table[2]   );
              $tmp_src->fill(        '%Total%', $table[3]   );
              
             break;
             case ('video'):
             break;
             case ('calls'):
              $tmp_src->fillloop('block_top'   , '');
              $tmp_src->fillloop('loop_table'  , '');
              $tmp_src->fillloop('block_norows', '');
              
             break;
             case ('events'):
//              ajax_echo_r ($table);
              
              if ($table) {
               $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop("loop_statuses"));
               $block_record   = new Template($this->viewroot, $tmp_src->returnloop("block_record"));
               $block_event    = new Template($this->viewroot, $tmp_src->returnloop("block_event"));
      //         ajax_echo_r ($list);
               
               //$loopdata = $this->fillList($list, $loop, 0);
               
               $vars     = $loop_table_row->getVariables();
               $vars_rec = $block_record->getVariables();
               $vars_evt = $block_event->getVariables();
               
               foreach ($table as $k=>$v) {
                if ($v->ParentName) {
                 $loop_table_row->reload();
                 
                 foreach ($vars as $var) {
                  $loop_table_row->fill(       "%".$var."%" , brtonl($v->$var));
                 }
                 
                 if ($v->BadLine) {
                  $loop_table_row->removeloop('block_BadLine');
                 } else {
                  $loop_table_row->fillloop('block_BadLine'    , '');
                 }
                 
                 if ($v->DoNotCallBack) {
                  $loop_table_row->removeloop('block_DoNotCallBack');
                 } else {
                  $loop_table_row->fillloop('block_DoNotCallBack'    , '');
                 }
                 
                 if ($v->Reason) {
                  $loop_table_row->removeloop('block_Reason');
                 } else {
                  $loop_table_row->fillloop('block_Reason'    , '');
                 }
                 
                 if ($v->CallSet) {
                  $loop_table_row->removeloop('block_CallSet');
                 } else {
                  $loop_table_row->fillloop('block_CallSet'    , '');
                 }
                 
                 if ($v->MeetingSet) {
                  $loop_table_row->removeloop('block_MeetingSet');
                 } else {
                  $loop_table_row->fillloop('block_MeetingSet' , '');
                 }
                 
                 if ($v->SemiPromise) {
                  $loop_table_row->removeloop('block_SemiPromise');
                 } else {
                  $loop_table_row->fillloop('block_SemiPromise' , '');
                 }
                 
                 
                 $thistable.=$loop_table_row->output();
                }
                if ($v->PhoneNumber) {
                 $block_record->reload();
                 
                 $block_record->fill(     "%c%", $c%2     );
                 $block_record->fill(     "%dbg%", print_r($v, true)     );
                 
                 foreach ($vars_rec as $var) {
                  $block_record->fill(     "%".$var."%", $v->$var     );
                 }
                 $c++;
                 
      //             $loop_table_row->processfcb();
                 $thistable.=$block_record->output();
                }
                if ($v->Name) {
                 $block_event->reload();
                 
                 $block_event->fill(     "%c%", $c%2     );
                 $block_event->fill(     "%dbg%", print_r($v, true)     );
                 
                 foreach ($vars_evt as $var) {
                  $block_event->fill(     "%".$var."%", $v->$var     );
                 }
                 $c++;
                 
      //             $loop_table_row->processfcb();
                 $thistable.=$block_event->output();
                }
               }
               
               $tmp_src->fillloop('block_norows', '');
               $tmp_src->fillloop('block_record', '');
               $tmp_src->fillloop('block_event' , '');
              } else {
               $tmp_src->removeloop('block_norows');
               $tmp_src->fillloop('block_statuses' , '');
              }
              
              $tmp_src->fillloop('loop_statuses', $thistable);
              
             break;
             case ('parsers'):
//              ajax_echo_r($table);
              
              foreach ($table as $pk=>$parser) {
               $loop_parser        = new Template($this->viewroot, $tmp_src->returnloop('block_'.$pk));
               $loop_parser->fill('%pk%', $pk);
               
               $loop_table_row     = new Template($this->viewroot, $loop_parser->returnloop('loop_table_row'));
               $thistable = "";
               
               foreach ($parser as $k=>$v) {
                if (strlen($v)) {
                 $loop_table_row->reload();
                 
                 $loop_table_row->fill('%k%', $k);
                 $loop_table_row->fill('%v%', $v);
                 
                 $thistable.=$loop_table_row->output();
                }
               }
               
               
               $vars = $loop_parser->getVariables();
               foreach ($vars as $var) {
                $loop_parser->fill(     "%".$var."%", $parser->$var     );
               }
               
               
               
               $loop_parser->fillloop('loop_table_row',$thistable);
               
               $tmp_src->fillloop('block_'.$pk, $loop_parser->output());
               
              }
              
              /*
              
              $loop_parser        = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
              $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
              $thistable = "";
              
              foreach ($table as $k=>$v) {
               $loop_table_row->reload();
               
               $loop_table_row->fill('%k%', $k);
               $loop_table_row->fill('%v%', $v);
               
               $thistable.=$loop_table_row->output();
              }
              $tmp_src->fillloop('loop_table_row',$thistable);
              $tmp_src->fill('%pos%', substr(100 * $table->offset/$table->count, 0, 5));
              */
              
             break;
             case ('crm'):
              switch ($json->r_viewmode) {
               case ('classic'):
                $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_header'));
                $vars = $looptmp->getVariables();
                
//                ajax_echo_r ($table[0]);
                
                $thistable = "";
                if (sizeof($table[0])) {
                 foreach ($table[0] as $item) {
                  $looptmp->reload();
                  foreach ($vars as $vn) {
                   $looptmp->fill("%".$vn."%", $item->$vn);
                  }
                  
                  $thistable.=$looptmp->output();
                 }
                }
                $tmp_src->fillloop('loop_header', $thistable);
                
                
                
                
                $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_statuses'));
                $loop_table_row     = new Template($this->viewroot, $looptmp->returnloop('loop_elements'));
                $vars = $loop_table_row->getVariables();
   //             ajax_echo_r ($vars);
                
   //             ajax_echo_r (array_keys($table)[sizeof($table)-1]);
   //             echo sizeof($table);
                
                $thistable = "";
                for ($n=1; $n<=(array_keys($table)[sizeof($table)-1]); $n++) {
                 $thisrow = "";
                 if (sizeof($table[$n])) {
                  $looptmp->reload();
                  foreach ($table[$n] as $item) {
                   
                   $loop_table_row->reload();
                   foreach ($vars as $vn) {
                    $loop_table_row->fill("%".$vn."%", $item->$vn);
                   }
                   
  //                 $loop_table_row->processfcb();
                   $thisrow.=$loop_table_row->output(0);
  //                 echo (strlen($loop_table_row->output(0)))."<br>";
  //                 die (htmlspecialchars($thisrow));
                  }
                  $looptmp->fillloop('loop_elements', $thisrow);
                  $thistable.=$looptmp->output();
                 }
                }
  //              echo strlen($thistable)."<br>";
                $tmp_src->fillloop('loop_statuses', $thistable);
                $tmp_src->removeloop('loop_table');
               break;
               case ('details'):
                $block_type = array();
                $block_type['skype']     = new Template($this->viewroot, $tmp_src->returnloop('block_skype'));
                $block_type['email']     = new Template($this->viewroot, $tmp_src->returnloop('block_email'));
                $block_type['phone']     = new Template($this->viewroot, $tmp_src->returnloop('block_phone'));
                $block_type['name' ]     = new Template($this->viewroot, $tmp_src->returnloop('block_name'));
                
                foreach ($block_type as $k=>$v) {
                 $block_type[$k] = $block_type[$k]->output();
                 $tmp_src->fillloop("block_".$k,"");
                }
                
                $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_header'));
                $vars = $looptmp->getVariables();
                
//                $loop_statuses      = new Template($this->viewroot, $tmp_src->returnloop('loop_statuses'));
                $loop_table_row     = new Template($this->viewroot, $looptmp->returnloop('loop_elements'));
                $vars2 = $loop_table_row->getVariables();
                
//                ajax_echo_r ($table);
                
                $thistable = "";
                if (sizeof($table[0])) {
                 foreach ($table[0] as $n=>$item) {
                  $looptmp->reload();
                  
                  $loop_statuses_str = "";
//                  for ($n=1; $n<=(array_keys($table)[sizeof($table)-1]); $n++) {
//                  if ($n==16 || $n==18) {
                   $thisrow = "";
                   
//                   echo $n."<br>";
//                   ajax_echo_r (sizeof($table[$n])); echo "<hr>";
                   
                   if (sizeof($table[$n])) {
                    $c = 0;
                    foreach ($table[$n] as $item2) {
                     $loop_table_row->reload();
                     $loop_table_row->fill(       "%c%", 6+$c%2        );
                     
                     $block_type_this = "";
                     if ($item2->Firstname) $loop_table_row->fill( "%TypePicture_Name%", $block_type['name']);
                     if ($item2->Email)     $loop_table_row->fill( "%TypePicture_Email%", $block_type['email']);
                     if ($item2->Skype)     $loop_table_row->fill( "%TypePicture_Skype%", $block_type['skype']);
                     if ($item2->Phone)     $loop_table_row->fill( "%TypePicture_Phone%", $block_type['phone']);
                     
                     foreach ($vars2 as $vn) {
                      $loop_table_row->fill("%".$vn."%", $item2->$vn);
                     }
                     
                     $c++;
                     $thisrow.=$loop_table_row->output(0);
                    }
                    $loop_statuses_str.=$thisrow;
                   }
//                  }
                  
    //              echo strlen($thistable)."<br>";
                  $looptmp->fillloop('loop_statuses', $loop_statuses_str);
                  
                  foreach ($vars as $vn) {
                   $looptmp->fill("%".$vn."%", $item->$vn);
                  }
                  
                  $thistable.=$looptmp->output();
                 }
                }
                $tmp_src->fillloop('loop_header', $thistable);
                $tmp_src->removeloop('loop_table');
               break;
              }
             break;
             case ('assessments'):
              $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
              $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
              $vars = $loop_table_row->getVariables();
              
              $block_replies      = new Template($this->viewroot, $looptmp->returnloop('block_replies'));
              $loop_replies       = new Template($this->viewroot, $looptmp->returnloop('loop_replies'));
              
              /*
              $block_type = array();
              $block_type[1]     = new Template($this->viewroot, $tmp_src->returnloop('block_type1'));
              $block_type[2]     = new Template($this->viewroot, $tmp_src->returnloop('block_type2'));
              $block_type[5]     = new Template($this->viewroot, $tmp_src->returnloop('block_type5'));
              $block_type[6]     = new Template($this->viewroot, $tmp_src->returnloop('block_type6'));
              
              $block_type[1] = $block_type[1]->output();
              $block_type[2] = $block_type[2]->output();
              $block_type[5] = $block_type[5]->output();
              $block_type[6] = $block_type[6]->output();
              */
              
              $totals = array();
              $lastTypeID = -1;
              $c = 0;
   //           ajax_echo_r ($table[1]);
              $thistable = "";
              if (sizeof($table)) {
               $thisidcolumnname = $json->tablename."_ID";
               if ($table[1]) {
                foreach ($table[1] as $item) {
                 if ($lastTypeID!=$item->TypeID) {
                  $lastTypeID = $item->TypeID;
                  $c = 2;
                 }
                 
                 $loop_table_row->reload();
//                 $loop_table_row->fill( "%TypePicture%", $block_type[$item->TypeID]);
                 $loop_table_row->fill("%c%",  $c%2);
                 foreach ($vars as $vn) {
                  $loop_table_row->fill("%".$vn."%", $item->$vn);
                 }
                 
                 if (($item->TypeID==1) || ($item->TypeID==3) || ($item->TypeID==5)) {
                  $sum += $item->Value;
                 } else {
                  $sum -= $item->Value;
                 }
                 $totals[$item->TypeID] += $item->Value;
                 
                 $replies = "";
                 if ($item->Replies) {
                  $block_replies->reload();
                  $e = 0;
                  foreach ($item->Replies as $reply) {
//                   ajax_echo_r ($reply);
                   $loop_replies->reload();
                   
                   $loop_replies->fill("%e%",  6+$e%2);
                   foreach ($reply as $k=>$v) {
                    $loop_replies->fill("%".$k."%", $v);
                   }
                   
                   $replies .= $loop_replies->output();
                   $e++;
                  }
                  $block_replies->fillloop("loop_replies", $replies);
                  $loop_table_row->fillloop('block_replies', $block_replies->output());
                 } else {
                  $loop_table_row->fillloop('block_replies', "");
                 }
                 
                 $thistable.=$loop_table_row->output();
                 $c++;
                }
               }
               $looptmp->fillloop('loop_table_row',$thistable);
               $tmp_src->fillloop("loop_table",$looptmp->output());
               
               $tmp_src->fillloop(   "block_norows","" );
              } else {
               $tmp_src->fillloop("loop_table", "");
               $tmp_src->removeloop(   "block_norows" );
              }
              
              $tmp_src->fill("%numrows%",sizeof($table[1]));
              
              $tmp_src->fillloop(       "block_no","" );
              $tmp_src->fillloop(   "loop_comment","" );
              
              $tmp_src->fillloop(    "block_type1", '');
              $tmp_src->fillloop(    "block_type2", '');
              $tmp_src->fillloop(    'block_type5', '');
              $tmp_src->fillloop(    'block_type6', '');
             break;
             case ('family'):
              $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_child'));
              $vars = $loop_table_row->getVariables();
              
              if (sizeof($table2)) {
               foreach ($table2 as $item) {
                $loop_table_row->reload();
                $loop_table_row->fill( "%TypePicture%", $block_type[$item->TypeID]);
                $loop_table_row->fill("%c%",  $c%2+(($item->TypeID-1)*2));
                foreach ($vars as $vn) {
                 $loop_table_row->fill("%".$vn."%", $item->$vn);
                }
                $c++;
                $loop_table_row->fill("%c%",  $c%2);
                
                if ($item->DateBirth=="0000-00-00 00:00:00") {
                 $loop_table_row->fillloop('block_birth','');
                } else {
                 $loop_table_row->removeloop('block_birth');
                }
                
                $thistable.=$loop_table_row->output();
               }
              }
              
              $tmp_src->fillloop("loop_child", $thistable);
              
              
              
              
              $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
              $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
              $vars = $loop_table_row->getVariables();
              
              
              $block_type = array();
              $block_type[1]     = new Template($this->viewroot, $tmp_src->returnloop('block_type1'));
              $block_type[2]     = new Template($this->viewroot, $tmp_src->returnloop('block_type2'));
              $block_type[5]     = new Template($this->viewroot, $tmp_src->returnloop('block_type5'));
              $block_type[6]     = new Template($this->viewroot, $tmp_src->returnloop('block_type6'));
              
              $block_type[1] = $block_type[1]->output();
              $block_type[2] = $block_type[2]->output();
              $block_type[5] = $block_type[5]->output();
              $block_type[6] = $block_type[6]->output();
              
              $totals = array();
              $lastTypeID = -1;
              $c = 0;
   //           ajax_echo_r ($table[1]);
              $thistable = "";
              if (sizeof($table)) {
               $thisidcolumnname = $json->tablename."_ID";
               if ($table[1]) {
                foreach ($table[1] as $item) {
                 if ($lastTypeID!=$item->TypeID) {
                  $lastTypeID = $item->TypeID;
                  $c = 2;
                 }
                 
                 $loop_table_row->reload();
                 $loop_table_row->fill( "%TypePicture%", $block_type[$item->TypeID]);
                 $loop_table_row->fill("%c%",  $c%2+(($item->TypeID-1)*2));
                 foreach ($vars as $vn) {
                  $loop_table_row->fill("%".$vn."%", $item->$vn);
                 }
                 
                 if (($item->TypeID==1) || ($item->TypeID==3) || ($item->TypeID==5)) {
                  $sum += $item->Value;
 //                 $Income += $item->Value;
                 } else {
                  $sum -= $item->Value;
 //                 $Expenditure += $item->Value;
                 }
                 $totals[$item->TypeID] += $item->Value;
                 
                 $thistable.=$loop_table_row->output();
                 $c++;
                }
               }
              }
              $looptmp->fillloop('loop_table_row',$thistable);
              $tmp_src->fillloop("loop_table",$looptmp->output());
              
              $tmp_src->fill("%numrows%",sizeof($table[1]));
              
              $tmp_src->fillloop(       "block_no","" );
              $tmp_src->fillloop(   "block_norows","" );
              
              $tmp_src->fillloop(    "block_type1", '');
              $tmp_src->fillloop(    "block_type2", '');
              $tmp_src->fillloop(    'block_type5', '');
              $tmp_src->fillloop(    'block_type6', '');
              
             break;
             case ('smses'):
             case ('offers'):
              $loopdata = "";
              $c = 0;
              
              $thistable = "";
              if (sizeof($table[1])) {
               $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
               $cols = $loop_table_row->getVariables();
               
               $thisidcolumnname = $json->tablename."_ID";
       //          echo $thisidcolumnname."<br>";
               foreach ($table[1] as $item) {
                $loop_table_row->reload();
                $thisrow   = "";
                
                $loop_table_row->fill(        "%ID%", $item->ID);
                $loop_table_row->fill("%c%",  $c%2);
                
                $loop_table_row->fill("%id%"           , $item->ID             );
                $loop_table_row->fill("%tablename%"    , $json->tablename      );
                
                foreach ($cols as $cv) {
                 $k=$cv;
                 $v = $item->$k;
                 if ($k && ($k!='CustomerID')) {
                  if ($k==$json->tablename."_AuxInfo") {
                   if (trim($v)=="") $v=$emptyinfo;
                  }
                  
                  $loop_table_row->fill(  "%".$k."%", $v);
                 }
                }
                $loop_table_row->fillloop('loop_table_cell',$thisrow);
                $thistable.=$loop_table_row->output();
                $c++;
               }
              } else {
               $block_norows   = new Template($this->viewroot, $tmp_src->returnloop('block_norows'));
               $block_norows=$block_norows->output();
               
               $thisrow   = "";
               $thisrow.=$block_norows;
               $tmp_src->fillloop('loop_table',$thisrow);
               $tmp_src->fill("%c%",  $c%2);
              }
              
              $tmp_src->removeloop('loop_table');
              
              $tmp_src->fillloop('loop_table_row',$thistable);
              $tmp_src->fillloop(     "block_no", "");
              $tmp_src->fillloop( "block_norows", "");
              
              $tmp_src->fill("%numrows%",sizeof($table[1]));          
              
              
              
             break;
             
             case ('retargeting'):
              $json_c = getfromcache ('VKTargetImport');
 //             ajax_echo_r ($json_c);
              
              $loop = new Template($this->viewroot, $tmp_src->returnloop("loop_campaigns"));
              $list = $this->model->getVKCampaigns();
              $loopdata = $this->fillList($list, $loop, $json_c->s_campaignid);
              $tmp_src->fillloop('loop_campaigns', $loopdata);
              
              $loop = new Template($this->viewroot, $tmp_src->returnloop("loop_vktargetgroups"));
              $list = $table[1];
              $loopdata = $this->fillList($list, $loop, $json_c->vktargetgroupid, 'id');
              $tmp_src->fillloop('loop_vktargetgroups', $loopdata);
              
              $tmp_src->fillloop('block_VKTargetImport', '');
              
              
             break;
             case ('blog'):
     //           echo $id;
              if ($id) {
               $tmp_src->fillloop('block_delete', '');
              } else {
               $tmp_src->removeloop('block_delete');
              }
              
              $block_no       = new Template($this->viewroot, $tmp_src->returnloop('block_no'));
              $block_no=$block_no->output();
              
              $block_norows   = new Template($this->viewroot, $tmp_src->returnloop('block_norows'));
              $block_norows=$block_norows->output();
              
//              $checkbox_th    = new Template($this->viewroot, $tmp_src->returnloop('checkbox_th'));
//              $checkbox_td    = new Template($this->viewroot, $tmp_src->returnloop('checkbox_td'));
              
              $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
              
              $block_type = array();
              $block_type[1]     = new Template($this->viewroot, $tmp_src->returnloop('block_type1'));
              $block_type[2]     = new Template($this->viewroot, $tmp_src->returnloop('block_type2'));
              $block_type[3]     = new Template($this->viewroot, $tmp_src->returnloop('block_type3'));
              
              $block_type[1] = $block_type[1]->output();
              $block_type[2] = $block_type[2]->output();
              $block_type[3] = $block_type[3]->output();
              
              $loopdata = "";
//              $loopdata.=$checkbox_th->output();
              
              $cols = $loop_table_row->getVariables();
     //           ajax_echo_r ($cols);
              
              $emptyinfo = file_get_contents($this->viewroot.'/templates/emptyinfo.htt');
              $c = 0;
              
              $thistable = "";
              if (sizeof($table[1])) {
               $thisidcolumnname = $json->tablename."_ID";
       //          echo $thisidcolumnname."<br>";
               foreach ($table[1] as $item) {
                $loop_table_row->reload();
                $thisrow   = "";
//                $checkbox_td->reload();
//                $checkbox_td->fill('%checked%' , 'checked'            );
//                $checkbox_td->fill('%id%'      , $item->$thisidcolumnname );
//                $thisrow.=$checkbox_td->output();
                
                $loop_table_row->fill(           "%ID%", $item->ID);
                $loop_table_row->fill( "%TypePicture%", $block_type[$item->TypeID]);
     //             $loop_table_row->fill("%c%",  ($c%2) + (((date_timestamp_get(date_create($item->LastAccess)) + 3600*72)>date_timestamp_get(date_create()) )?0:2) );
                $loop_table_row->fill("%c%",  $c%2);
                
                foreach ($cols as $cv) {
                 $k=$cv;
                 $v = $item->$k;
                 if ($k && ($k!='CustomerID')) {
                  if ($k==$json->tablename."_AuxInfo") {
                   if (trim($v)=="") $v=$emptyinfo;
                  }
                  
                  $loop_table_row->fill(  "%".$k."%", (((int)$v==0) && ((string)(int)$v==$v) && ($k!='Cost'))?$block_no:($v));
                 }
                }
                $loop_table_row->fillloop('loop_table_cell',$thisrow);
                
     //             echo (date_timestamp_get(date_create($item->DateTarget))."-".date_timestamp_get(date_create())."<br>");
                
                $loop_table_row->fill("%id%"           , $item->ID             );
                $loop_table_row->fill("%tablename%"    , $json->tablename      );
                
                $thistable.=$loop_table_row->output();
                $c++;
               }
              } else {
               /*
               $thisrow   = "";
               $thisrow.=$block_norows;
               $loop_table_row->fillloop('loop_table_cell',$thisrow);
               $loop_table_row->fill("%c%",  $c%2);
               $thistable.=$loop_table_row->output();
               */
               $tmp_src->fillloop('loop_table', $block_norows);
              }
              
              $tmp_src->removeloop('loop_table');
              
              $tmp_src->fillloop('loop_table_row',$thistable);
              
              $tmp_src->fillloop(     "block_no","" );
              $tmp_src->fillloop( "block_norows","" );
              $tmp_src->fillloop(   "block_dir0","" );
              $tmp_src->fillloop(   "block_dir1","" );
              
              $tmp_src->fillloop(    "block_type1","" );
              $tmp_src->fillloop(    "block_type2","" );
              $tmp_src->fillloop(    "block_type3","" );
              
              $tmp_src->fill("%numrows%",sizeof($table[1]));
              
             break;
             case ('system'):
              $loop = new Template($this->viewroot, $tmp_src->returnloop("loop_serverfiles"));
              $list = $this->model->getServerFiles();
//              ajax_echo_r ($list);
              $loopdata = $this->fillList($list, $loop);
              $tmp_src->fillloop('loop_serverfiles', $loopdata);
              
              
              
              $queue       = getFromCache('queue');
              $manageQueue = getFromCache('manageQueuev2');
              
              if ($manageQueue->Left>$manageQueue->Added) {
               $tmp_src->removeloop('block_warning_nocusts');
               $tmp_src->fill("%diff%", $manageQueue->Total_CntUsers-$manageQueue->Total_CntAssignedUsers);
               $tmp_src->fill("%diff_q%", $manageQueue->Left-$manageQueue->Added);
              } else {
               $tmp_src->fillloop('block_warning_nocusts');
              }
              
              
//              ajax_echo_r ($manageQueue);
              
              $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_queueinfo'));
              $thistable = "";
              $vars = $loop_table_row->getVariables();
              $c = 0;
              foreach ($queue as $k=>$v) {
               $loop_table_row->reload();
               $loop_table_row->fill(     "%c%", $c%2     );
               $loop_table_row->fill(     "%i%", $c       );
               $loop_table_row->fill(     "%k%", $k       );
               $loop_table_row->fill(     "%v%", $v       );
               $c++;
               $thistable.=$loop_table_row->output();
              }
              $tmp_src->fillloop('loop_queueinfo', $thistable);
              
              
              
              $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_manageQueue'));
              $thistable = "";
              $vars = $loop_table_row->getVariables();
              $c = 0;
              foreach ($manageQueue as $k=>$v) {
               $loop_table_row->reload();
               $loop_table_row->fill(     "%c%", $c%2     );
               $loop_table_row->fill(     "%i%", $c       );
               $loop_table_row->fill(     "%k%", $k       );
               $loop_table_row->fill(     "%v%", $v       );
               $c++;
               $thistable.=$loop_table_row->output();
              }
              $tmp_src->fillloop('loop_manageQueue', $thistable);
              
              
              
              
              
              if ($table) {
               $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
               $thistable = "";
               
               $vars = $loop_table_row->getVariables();
               $c = 0;
               foreach ($table as $k=>$v) {
                if ($k!=$firstid) {
    //             echo $k."-".$firstid."-".$v->ID."<br>";
                 $loop_table_row->reload();
                 
                 $loop_table_row->fill(     "%c%", $c%2     );
                 $loop_table_row->fill(     "%i%", $c       );
                 
                 foreach ($vars as $var) {
                  $loop_table_row->fill(     "%".$var."%", $v->$var     );
                 }
                 $c++;
                 
    //             $loop_table_row->processfcb();
                 $thistable.=$loop_table_row->output();
                }
               }
               
               $loop_table     = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
               $loop_table->fillloop('loop_table_row', $thistable);
               
               $tmp_src->fillloop('loop_table', $loop_table->output());
               $tmp_src->fillloop('block_norows', "");
              } else {
               $tmp_src->fillloop('loop_table', "");
               $tmp_src->removeloop('block_norows');
              }
              
             break;
             case ('schedule'):
//              ajax_echo_r ($table);
              $lessons = $this->model->lessons;
              $nfl = $this->model->getNumFreeLessons($this->userid);
//              echo $nfl;
              $freelesson = $nfl==0;
//              echo $freelesson."<br>";
              
              if ($freelesson) {
               $tmp_src->removeloop('block_selectfreelessonnotification');
              } else {
               $tmp_src->fillloop('block_selectfreelessonnotification', '');
              }
              
              $loop_year      = new Template($this->viewroot, $tmp_src->returnloop     ('loop_year'      ));
              $loop_week      = new Template($this->viewroot, $loop_year->returnloop   ('loop_week'      ));
              $loop_weekday   = new Template($this->viewroot, $loop_week->returnloop   ('loop_weekday'   ));
              $loop_lesson    = new Template($this->viewroot, $loop_week->returnloop   ('loop_lesson'    ));
              $loop_day       = new Template($this->viewroot, $loop_lesson->returnloop ('loop_day'       ));
              $loop_meeting   = new Template($this->viewroot, $loop_day->returnloop    ('loop_meeting'   ));
              $loop_clickable = new Template($this->viewroot, $loop_day->returnloop    ('loop_clickable' ));
              
              $vars = $loop_meeting->getVariables();
              $now = time();
//              echo $now."<br>";
//              echo date("U")."<br>";
              
              $j = 0;
              
              foreach ($table as $year_k=>$year_v) {
               $loop_year->reload();
               $loop_year->fill('%Year%', $year_k);
               
               $loop_week_str = "";
               foreach ($year_v as $week_k=>$week_v) {
                $weekfmt = format($week_k, "##");
                $day_first = date('Y-m-d',strtotime($year_k.'W'.$weekfmt));
                $day_first_unix = date('U',strtotime($year_k.'W'.$weekfmt));
//                echo $day_first." ".$day_first_unix."<br>";
                $day_last = date('Y-m-d',strtotime($year_k.'W'.$weekfmt.' +6 days'));
//                echo $day_last."<br>";
                
                $loop_week->reload();
                if ($day_v) $day = date("d", strtotime($day_v['date']));
                $loop_week->fill('%Month%', $month_k);
                $loop_week->fill('%Month_str%', date("F", strtotime($year_k."-".$week_k."-01")));
                
                $loop_week->fill('%DayFirst%', $day_first );
                $loop_week->fill('%DayLast%' , $day_last  );
                
                
                $days_here = array();
                $loop_lesson_str = "";
                
//                foreach ($week_v as $lesson_k=>$lesson_v) {
                for ($i=0; $i<sizeof($lessons); $i++) {
                 $lesson_k = $lessons[$i];
                 
                 $lesson_ka = $lesson_k;
                 if (strlen($lesson_ka)<5) $lesson_ka = "0".$lesson_ka;
                 $lesson_v = $week_v[$lesson_ka];
                 
                 $loop_lesson->reload();
                 $loop_lesson->fill("%k%", $lesson_k);
                 $loop_lesson->fill("%c%", 98+$i%2  );
                 
                 $loop_day_str = "";
 //                foreach ($week_v as $day_k=>$day_v) {
                 for ($day_k=1; $day_k<8; $day_k++) {
                  $day_v = $lesson_v[$day_k];
                  $loop_day->reload();
 //                 ajax_echo_r ($day_v);
                  $day = '';
                  if ($day_v) $day = date("M d", strtotime($day_v['date']));
                  $loop_day->fill(  '%day%', $day);
                  $days_here[$day_k] = $day;
                  
                  $day = date('Y-m-d',strtotime($year_k.'W'.$weekfmt." +".($day_k-1)."days"));
                  $diff = floor(($day_first_unix+($day_k-1)*(60*60*24)-$now)/(60*60*24));
                  
                  $k = "Schedule-freeSelect";
                  if ($this->user->usergroup->$k) {
                   $date_clickable = $diff>=-1;
                  } else {
                   $date_clickable = $diff>=0;
                  }
                  
                  $loop_meeting_str = "";
                  if ($day_v['meetings']) {
                   $clickable = false;
                   foreach ($day_v['meetings'] as $meeting_k=>$meeting_v) {
                    $loop_meeting->reload();
                    
                    $loop_meeting->fill(           '%Time%', date("H:i", strtotime($meeting_v->Date)) );
                    
                    /*
                    $loop_meeting->fill(             '%ID%', $meeting_v->ID   );
                    $loop_meeting->fill(      '%Firstname%', $meeting_v->Firstname);
                    $loop_meeting->fill(       '%Lastname%', $meeting_v->Lastname);
                    $loop_meeting->fill(     '%MeetingSet%', $meeting_v->MeetingSet);
                    $loop_meeting->fill( '%ScheduleStatus%', $meeting_v->ScheduleStatus);
                    $loop_meeting->fill(          '%Place%', $meeting_v->Place);
                    */
                    
                    foreach ($vars as $vn) {
                     $loop_meeting->fill("%".$vn."%", $meeting_v->$vn);
                    }
                    
                    if ($meeting_v->MeetingSet==2) {
                     $loop_meeting->removeloop('block_MeetingSet_2');
                    } else {
                     $loop_meeting->fillloop('block_MeetingSet_2', '');
                    }
                    if ($meeting_v->MeetingSet==3) {
                     $loop_meeting->removeloop('block_MeetingSet_3');
                    } else {
                     $loop_meeting->fillloop('block_MeetingSet_3', '');
                    }
                    
                    $loop_meeting_str .= $loop_meeting->output();
                   }
                   
                   $k = "Schedule-freeSelect";
                   if ($this->user->usergroup->$k) {
                    $clickable = $date_clickable;
                   }
                   
                  } else {
                   $clickable = $date_clickable;
                  }
                  
                  if ($clickable) {
                   $loop_day->removeloop('loop_clickable' );
                   $loop_day->fillloop('loop_empty', '');
                   
                   $loop_day->fill( '%datetime%', $day." ".$lesson_k );
                   $loop_day->fill(   '%isfree%', (int)$freelesson   );
                   $loop_day->fill(        '%i%', $j                 );
                   $j++;
                  } else {
                   $loop_day->fillloop('loop_clickable', '' );
                   if ($loop_meeting_str=='') {
                    $loop_day->removeloop('loop_empty' );
                   } else {
                    $loop_day->fillloop('loop_empty', '');
                   }
                  }
                  
                  $loop_day->fill('%clickable%', $clickable);
                  $loop_day->fillloop('loop_meeting'  , $loop_meeting_str   );
                  $loop_day_str .= $loop_day->output();
                 }
                 
                 $loop_lesson->fillloop('loop_day', $loop_day_str);
                 $loop_lesson_str .= $loop_lesson->output();
                }
                
                $loop_weekday_str = "";
                foreach ($days_here as $day_here) {
                 $loop_weekday->reload();
                 $loop_weekday->fill('%day%', $day_here);
                 $loop_weekday_str.=$loop_weekday->output();
                }
                $loop_week->fillloop('loop_weekday', $loop_weekday_str);
                
                
                $loop_week->fillloop('loop_lesson', $loop_lesson_str);
                $loop_week_str .= $loop_week->output();
               }
               
               $loop_year->fillloop('loop_week', $loop_week_str);
               $loop_year_str .= $loop_year->output();
              }
              
              $tmp_src->fillloop  ('loop_year', $loop_year_str);
              $tmp_src->fillloop  ('block_loading', '');
              
              
              
 //             $loop_year
              
              
              
              
             break;
             case ('users'):
   //           echo $id;
              if ($id) {
               $tmp_src->fillloop('block_delete', '');
              } else {
               $tmp_src->removeloop('block_delete');
              }
              
              $block_no       = new Template($this->viewroot, $tmp_src->returnloop('block_no'));
              $block_no=$block_no->output();
              
              $block_norows   = new Template($this->viewroot, $tmp_src->returnloop('block_norows'));
              $block_norows=$block_norows->output();
              
//              $checkbox_th    = new Template($this->viewroot, $tmp_src->returnloop('checkbox_th'));
//              $checkbox_td    = new Template($this->viewroot, $tmp_src->returnloop('checkbox_td'));
              
              $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
              $loop_priv      = new Template($this->viewroot, $tmp_src->returnloop('loop_priv'));
              
//              $block_dir = array();
//              $block_dir[0]     = new Template($this->viewroot, $tmp_src->returnloop('block_dir0'));
//              $block_dir[1]     = new Template($this->viewroot, $tmp_src->returnloop('block_dir1'));
              
//              $block_dir[0] = $block_dir[0]->output();
//              $block_dir[1] = $block_dir[1]->output();
              
              $loopdata = "";
//              $loopdata.=$checkbox_th->output();
              
              $cols = $loop_table_row->getVariables();
   //           ajax_echo_r ($cols);
              
              $emptyinfo = file_get_contents($this->viewroot.'/templates/emptyinfo.htt');
              $c = 0;
              
//              ajax_echo_r ($table);
              
              $thistable = "";
              if (sizeof($table[1])) {
               $thisidcolumnname = $json->tablename."_ID";
       //          echo $thisidcolumnname."<br>";
               foreach ($table[1] as $item) {
                $loop_table_row->reload();
                $thisrow   = "";
//                $checkbox_td->reload();
//                $checkbox_td->fill('%checked%' , 'checked'            );
//                $checkbox_td->fill('%id%'      , $item->$thisidcolumnname );
//                $thisrow.=$checkbox_td->output();
                
                $loop_table_row->fill(           "%ID%", $item->ID);
//                $loop_table_row->fill( "%calldiretion%", $block_dir[$item->DirectionID]);
   //             $loop_table_row->fill("%c%",  ($c%2) + (((date_timestamp_get(date_create($item->LastAccess)) + 3600*72)>date_timestamp_get(date_create()) )?0:2) );
                $loop_table_row->fill("%c%",  $c%2);
                if ($item->ID==$this->userid || ($item->CompanyID!=$this->user->CompanyID && $this->user->CompanyID!=1)) {
                 $loop_table_row->fillloop('strict_User-delete_1', '');
                }
                
//                ajax_echo_r ($item);
                
                $Privileges = "";
                foreach ($item->Privileges as $priv) {
                 $loop_priv->reload();
                 
                 $loop_priv->fill(       '%Icon%', $priv->Icon        );
                 $loop_priv->fill(      '%Title%', $priv->Title       );
                 $loop_priv->fill('%Description%', $priv->Description );
                 
                 $Privileges.=$loop_priv->output();
                }
                $loop_table_row->fill(           "%Privileges%", $Privileges);
                
                foreach ($cols as $cv) {
                 $k=$cv;
                 $v = $item->$k;
                 if ($k && ($k!='CustomerID')) {
                  if ($k==$json->tablename."_AuxInfo") {
                   if (trim($v)=="") $v=$emptyinfo;
                  }
                  
                  $loop_table_row->fill(  "%".$k."%", (((int)$v==0) && ((string)(int)$v==$v) && ($k!='Cost'))?$block_no:($v));
                 }
                }
                $loop_table_row->fillloop('loop_table_cell',$thisrow);
                
   //             echo (date_timestamp_get(date_create($item->DateTarget))."-".date_timestamp_get(date_create())."<br>");
                
                $loop_table_row->fill("%id%"           , $item->ID             );
                $loop_table_row->fill("%tablename%"    , $json->tablename      );
                
                $thistable.=$loop_table_row->output();
                $c++;
               }
              } else {
               /*
               $thisrow   = "";
               $thisrow.=$block_norows;
               $loop_table_row->fillloop('loop_table_cell',$thisrow);
               $loop_table_row->fill("%c%",  $c%2);
               $thistable.=$loop_table_row->output();
               */
               $tmp_src->fillloop('loop_table', $block_norows);
              }
              
              $tmp_src->removeloop('loop_table');
              
              $tmp_src->fillloop('loop_table_row',$thistable);
              
              $tmp_src->fillloop(     "block_no","" );
              $tmp_src->fillloop(    "block_yes","" );
              $tmp_src->fillloop( "block_norows","" );
              $tmp_src->fillloop(   "block_dir0","" );
              $tmp_src->fillloop(   "block_dir1","" );
              $tmp_src->fillloop(    "loop_priv","" );
              
              
              $tmp_src->fill("%numrows%",sizeof($table[1]));          
             break;
             case ('people'):
   //           echo $id;
              if ($id) {
               $tmp_src->fillloop('block_delete', '');
              } else {
               $tmp_src->removeloop('block_delete');
              }
              
              $block_yes      = new Template($this->viewroot, $tmp_src->returnloop('block_yes'));
              $block_yes      = $block_yes->output();
              
              $block_no       = new Template($this->viewroot, $tmp_src->returnloop('block_no'));
              $block_no=$block_no->output();
              
              $block_noyes = array($block_no, $block_yes);
              
              $block_norows   = new Template($this->viewroot, $tmp_src->returnloop('block_norows'));
              $block_norows=$block_norows->output();
              
              $checkbox_th    = new Template($this->viewroot, $tmp_src->returnloop('checkbox_th'));
              $checkbox_td    = new Template($this->viewroot, $tmp_src->returnloop('checkbox_td'));
              
              $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
              
              $block_dir = array();
              $block_dir[0]     = new Template($this->viewroot, $tmp_src->returnloop('block_dir0'));
              $block_dir[1]     = new Template($this->viewroot, $tmp_src->returnloop('block_dir1'));
              
              $block_dir[0] = $block_dir[0]->output();
              $block_dir[1] = $block_dir[1]->output();
              
              $loopdata = "";
              $loopdata.=$checkbox_th->output();
              
              $cols = $loop_table_row->getVariables();
   //           ajax_echo_r ($cols);
              
              $emptyinfo = file_get_contents($this->viewroot.'/templates/emptyinfo.htt');
              $c = 0;
              
              
              $leftcontent = new Template($this->viewroot, "left_people.htt");
              $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
              $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
              
              $typepicture = array();
              $typepicture[1]  = $leftcontent->returnloop('block_typepicture_1');
              $typepicture[2]  = $leftcontent->returnloop('block_typepicture_2');
              $typepicture[3]  = $leftcontent->returnloop('block_typepicture_3');
              $typepicture[4]  = $leftcontent->returnloop('block_typepicture_4');
              $typepicture[5]  = $leftcontent->returnloop('block_typepicture_5');
              $typepicture[6]  = $leftcontent->returnloop('block_typepicture_6');
              $typepicture[7]  = $leftcontent->returnloop('block_typepicture_7');
              $typepicture[8]  = $leftcontent->returnloop('block_typepicture_8');
              $typepicture[9]  = $leftcontent->returnloop('block_typepicture_9');
              $typepicture[10] = $leftcontent->returnloop('block_typepicture_10');
              $typepicture[11] = $leftcontent->returnloop('block_typepicture_11');
              
              
              $thistable = "";
              if (sizeof($table[1])) {
               $thisidcolumnname = $json->tablename."_ID";
       //          echo $thisidcolumnname."<br>";
               foreach ($table[1] as $item) {
                $loop_table_row->reload();
                $thisrow   = "";
                $checkbox_td->reload();
                $checkbox_td->fill('%checked%' , 'checked'            );
                $checkbox_td->fill('%id%'      , $item->$thisidcolumnname );
                $thisrow.=$checkbox_td->output();
 //               ajax_echo_r ($item);
                $loop_table_row->fill(               "%ID%", $item->ID);
                $loop_table_row->fill(     "%calldiretion%", $block_dir[$item->DirectionID]);
                $loop_table_row->fill(      "%typepicture%", $typepicture[$item->Status_TypeID]);
                $loop_table_row->fill( "%PotentialPartner%", $block_noyes[$item->PotentialPartner]);
   //             $loop_table_row->fill("%c%",  ($c%2) + (((date_timestamp_get(date_create($item->LastAccess)) + 3600*72)>date_timestamp_get(date_create()) )?0:2) );
                $loop_table_row->fill("%c%",  $c%2);
                
                
                
                if ($item->Status_MeetingSet>0) {
                 $loop_table_row->removeLoop('block_MeetingSet');
                } else {
                 $loop_table_row->fillLoop('block_MeetingSet', '');
                }
                if ($item->Status_CallSet>0) {
                 $loop_table_row->removeLoop('block_CallSet');
                } else {
                 $loop_table_row->fillLoop('block_CallSet', '');
                }
                
                for ($n=0; $n<4; $n++) {
                 if ($item->Status_MeetingSet==$n) {
                  $loop_table_row->removeLoop('block_MeetingSet_'.$n);
                 } else {
                  $loop_table_row->fillLoop('block_MeetingSet_'.$n, '');
                 }
                 if ($item->Status_CallSet==$n) {
                  $loop_table_row->removeLoop('block_CallSet_'.$n);
                 } else {
                  $loop_table_row->fillLoop('block_CallSet_'.$n, '');
                 }
                }
                
                
                
                
                foreach ($cols as $cv) {
                 $k=$cv;
                 $v = $item->$k;
                 if ($k && ($k!='CustomerID')) {
                  if ($k==$json->tablename."_AuxInfo") {
                   if (trim($v)=="") $v=$emptyinfo;
                  }
                  
                  $loop_table_row->fill(  "%".$k."%", (((int)$v==0) && ((string)(int)$v==$v) && ($k!='Cost'))?$block_no:($v));
                 }
                }
                $loop_table_row->fillloop('loop_table_cell',$thisrow);
                
   //             echo (date_timestamp_get(date_create($item->DateTarget))."-".date_timestamp_get(date_create())."<br>");
                
                $loop_table_row->fill("%id%"           , $item->ID             );
                $loop_table_row->fill("%tablename%"    , $json->tablename      );
                
                $thistable.=$loop_table_row->output();
                $c++;
               }
              } else {
               /*
               $thisrow   = "";
               $thisrow.=$block_norows;
               $loop_table_row->fillloop('loop_table_cell',$thisrow);
               $loop_table_row->fill("%c%",  $c%2);
               $thistable.=$loop_table_row->output();
               */
               $tmp_src->fillloop('loop_table', $block_norows);
              }
              
              $tmp_src->removeloop('loop_table');
              
              $tmp_src->fillloop('loop_table_row',$thistable);
              
              $tmp_src->fillloop(     "block_no","" );
              $tmp_src->fillloop(    "block_yes","" );
              $tmp_src->fillloop( "block_norows","" );
              $tmp_src->fillloop(   "block_dir0","" );
              $tmp_src->fillloop(   "block_dir1","" );
              
              
              $tmp_src->fill("%numrows%",sizeof($table[1]));          
             break;
             case ('dashboard'):
              switch ($json->r_viewmode) {
               case ('dashboard-customers'):
                $cats = array(
                 'All'           =>'<en>Total&nbsp;count</en><ru>Всего&nbsp;клиентов</ru>', 
                 'WithNames'     =>'<en>With names</en><ru>С именами</ru>', 
                 'WithPhones'    =>'<en>With phones</en><ru>С телефонами</ru>', 
                 'WithEmails'    =>'<en>With emails</en><ru>С адресами email</ru>', 
                 'WithTimezones' =>'<en>With timezones</en><ru>С часовыми поясами</ru>', 
                 'Duplicates'    =>'<en>Duplicates</en><ru>Дублей</ru>', 
                 'Explored'      =>'<en>Explored</en><ru>Обработано</ru>', 
                 'NotExplored'   =>'<en>Not explored</en><ru>Не обработано</ru>', 
                 'Promises'      =>'<en>Promises</en><ru>Обещаний</ru>', 
                 'Semipromises'  =>'<en>Semipromises</en><ru>Полуобещаний</ru>', 
                 'Visits'        =>'<en>Visits</en><ru>Посетивших</ru>', 
                 'Payments'      =>'<en>Payments</en><ru>Заплативших</ru>', 
                 'Revenue'       =>'<en>Revenue</en><ru>Выручка</ru>'
                );
                
                $loop = new Template($this->viewroot, $tmp_src->returnloop('loop_bars'));
                $loopdata = "";
                foreach ($cats as $k=>$v) {
                 $loop->reload();
                 
                 $loop->fill("%k%", $k);
                 $loop->fill("%Caption%", $v);
                 
                 $loopdata .= $loop->output();
                }
                
                $tmp_src->fillloop('loop_bars', $loopdata);
                
               break;
               case ('dashboard-statuses'):
                $cats = array(
                 'All'           =>'<en>Total&nbsp;count</en><ru>Всего&nbsp;клиентов</ru>', 
                 'WithNames'     =>'<en>With names</en><ru>С именами</ru>', 
                 'WithPhones'    =>'<en>With phones</en><ru>С телефонами</ru>', 
                 'WithEmails'    =>'<en>With emails</en><ru>С адресами email</ru>', 
                 'WithTimezones' =>'<en>With timezones</en><ru>С часовыми поясами</ru>', 
                 'Duplicates'    =>'<en>Duplicates</en><ru>Дублей</ru>', 
                 'Promises'      =>'<en>Promises</en><ru>Обещаний</ru>', 
                 'Semipromises'  =>'<en>Semipromises</en><ru>Полуобещаний</ru>', 
                 'Callbacks'     =>'<en>Callbacks</en><ru>Перезвонов</ru>'
                );
                
                $loop = new Template($this->viewroot, $tmp_src->returnloop('loop_bars'));
                $loopdata = "";
                foreach ($cats as $k=>$v) {
                 $loop->reload();
                 
                 $loop->fill("%k%", $k);
                 $loop->fill("%Caption%", $v);
                 
                 $loopdata .= $loop->output();
                }
                
                $tmp_src->fillloop('loop_bars', $loopdata);
                
               break;
               case ('dashboard-performance'):
                
               break;
               
               
               case ('threads'):
 //               ajax_echo_r($t);
                
                
                $loop = new Template($this->viewroot, $tmp_src->returnloop('loop_users'));
                $vars = $loop->getVariables();
                
                $loop_tasks_1 = new Template($this->viewroot, $tmp_src->returnloop('loop_tasks_1'));
                $loop_tasks_2 = new Template($this->viewroot, $tmp_src->returnloop('loop_tasks_2'));
                
                $vars_tasks_1 = $loop_tasks_1->getVariables();
                $vars_tasks_2 = $loop_tasks_2->getVariables();
                
                $loopstr = "";
                foreach ($t as $k=>$v) {
                 $loop->reload();
                 
                 $buf = "";
                 if ($v['Tasks_1']) {
                  foreach ($v['Tasks_1'] as $ik=>$iv) {
                   $loop_tasks_1->reload();
                   foreach ($vars_tasks_1 as $vn) {
                    $loop_tasks_1->fill("%".$vn."%", $iv->$vn);
                   }
                   $buf .= $loop_tasks_1->output();
                  }
                 }
                 $loop->fillloop('loop_tasks_1', $buf);
                 
                 $buf = "";
                 if ($v['Tasks_2']) {
                  foreach ($v['Tasks_2'] as $ik=>$iv) {
                   $loop_tasks_1->reload();
                   foreach ($vars_tasks_1 as $vn) {
                    $loop_tasks_1->fill("%".$vn."%", $iv->$vn);
                   }
                   $buf .= $loop_tasks_1->output();
                  }
                 }
                 $loop->fillloop('loop_tasks_2', $buf);
                 
                 foreach ($vars as $vn) {
                  $loop->fill("%".$vn."%", $v['User']->$vn);
                 }
                 
                 $loopstr .= $loop->output();
                }
                
                
                
                $tmp_src->fillloop('loop_users', $loopstr);
               break;
               default:
                $loop = new Template($this->viewroot, $tmp_src->returnloop('loop_clubs'));
       //         ajax_echo_r($t);
                
                $Total = 0;
                
                $loopstr = "";
                foreach ($t as $item) {
   //              ajax_echo_r($item);
       //          ajax_echo_r($item->Title);
                 if ($item->ID == 'total') {
                  $t = new stdClass;
                  switch ($json->r_viewmode) {
                   case ('tasks'):
                    $t->New = $New;
                    $t->InProgress = $InProgress;
                    $t->Done = $Done;
                    $t->Approved = $Approved;
                   break;
                   case ('money'):
                    $t->Income = $Income;
                    if ($Expenditure) {
                     $t->Expenditure = $Expenditure;
                    } else {
                     $t->Expenditure = 0;
                    }
                    $t->Result = $Income - $Expenditure;
                    $t->IncomePending = $IncomePending;
                   break;
                  }
                  $t->Total = $Total;
                 } else {
                  $t = $this->model->getTasksInfo($item, $json);
                 }
                 
                 if ($Expenditure) {
                  $t->ROI = 100 * $Income/$Expenditure;
                 } else {
                  $t->ROI = 0;
                 }
   //              ajax_echo_r ($t);
                 
                 if ((int)$t->Total) {
   //               ajax_echo_r($t);
                  $loop->reload();
                  $loop->fill(              '%Title%', $item->Title   );
                  $loop->fill(              '%Total%', $t->Total      );
                  
                  switch ($json->r_viewmode) {
                   case ('tasks'):
                    $loop->fill(          '%Tasks_New%', $t->New        );
                    $loop->fill(   '%Tasks_InProgress%', $t->InProgress );
                    $loop->fill(         '%Tasks_Done%', $t->Done       );
                    $loop->fill(     '%Tasks_Approved%', $t->Approved   );
                    $loop->fill(     '%Tasks_Progress%', ($t->Done + $t->Approved));
                    
                    if ((int)$t->Total) {
                     $Tasks_New_P        = (int)(100*$t->New        /$t->Total);
                     $Tasks_InProgress_P = (int)(100*$t->InProgress /$t->Total);
                     $Tasks_Done_P       = (int)(100*$t->Done       /$t->Total);
          //           $Tasks_Approved_P   = (int)(100*$t->Approved   /$t->Total);
                    } else {
                     $Tasks_New_P        = 0;
                     $Tasks_InProgress_P = 0;
                     $Tasks_Done_P       = 0;
                    }
                    $Tasks_Approved_P   = 100 - $Tasks_New_P - $Tasks_InProgress_P - $Tasks_Done_P;
                    
                    $New += $t->New;
                    $InProgress += $t->InProgress;
                    $Done += $t->Done;
                    $Approved += $t->Approved;
                    
                    $loop->fill(        '%Tasks_New_P%', $Tasks_New_P);
                    $loop->fill( '%Tasks_InProgress_P%', $Tasks_InProgress_P);
                    $loop->fill(       '%Tasks_Done_P%', $Tasks_Done_P);
                    $loop->fill(   '%Tasks_Approved_P%', $Tasks_Approved_P);
                    $loop->fill(   '%Tasks_Progress_P%', $Tasks_Done_P + $Tasks_Approved_P);
                   break;
                   case ('money'):
                    $loop->fill(          '%Income%', $t->Income          );
                    $loop->fill(     '%Expenditure%', $t->Expenditure     );
                    $loop->fill(          '%Result%', $t->Result          );
                    $loop->fill(             '%ROI%', $t->ROI             );
                    $loop->fill(   '%IncomePending%', $t->IncomePending   );
                    
                    if ((int)$t->Total) {
                     $Income_P        = (int)(100*$t->Income        /$t->Total);
                     $Expenditure_P   = (int)(100*$t->Expenditure   /$t->Total);
                     $Result_P        = (int)(100*$t->Result        /$t->Total);
                     $ROI_P           = (int)(100*$t->ROI           /$t->Total);
                     $IncomePending_P = (int)(100*$t->IncomePending /$t->Total);
                    } else {
                     $Income_P        = 0;
                     $Expenditure_P   = 0;
                     $Result_P        = 0;
                     $ROI_P           = 0;
                     $IncomePending_P = 0;
                    }
                    $Income        += $t->Income;
                    $Expenditure   += $t->Expenditure;
                    $Result        += $t->Result;
                    $IncomePending += $t->IncomePending;
                    
                    $loop->fill(        '%Income_P%', $Income_P          );
                    $loop->fill(   '%Expenditure_P%', $Expenditure_P     );
                    $loop->fill(        '%Result_P%', $Result_P          );
                    $loop->fill(           '%ROI_P%', $ROI_P             );
                    $loop->fill( '%IncomePending_P%', $IncomePending_P   );
                   break;
                  }
                  
                  $Total += $t->Total;
                  $loopstr .= $loop->output();
                 }
                }
                
                $tmp_src->fillloop('loop_clubs', $loopstr);
               break;
              }
              
             break;
             case ('news'):
              $looptmp = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
              $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
              $vars = $loop_table_row->getVariables();
              
    //          $emptyinfo = file_get_contents($this->viewroot.'/templates/emptyinfo.htt');
              $c = 0;
              
    //          ajax_echo_r ($table);
              
              $thistable = "";
              if (sizeof($table)) {
               $thisidcolumnname = $json->tablename."_ID";
       //          echo $thisidcolumnname."<br>";
               foreach ($table as $item) {
                $loop_table_row->reload();
                foreach ($vars as $vn) {
                 if ($vn!=="Children") {
                  $loop_table_row->fill("%".$vn."%", $item->$vn);
                 }
                }
                
                $thistable.=$loop_table_row->output();
                $c++;
               }
              }
              $looptmp->fillloop('loop_table_row',$thistable);
              $tmp_src->fillloop("loop_table",$looptmp->output());
              
              $tmp_src->fill("%numrows%",sizeof($table));
              
             break;
             case ('reports'):
             case ('macros'):
 //             ajax_echo_r ($table);
              
              $looptmp        = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
              
              $loop_table_cat = new Template($this->viewroot, $tmp_src->returnloop('loop_table_cat'));
 //             $vars_cat = $loop_table_cat->getVariables();
              
              $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
              $vars = $loop_table_row->getVariables();
              
              $block_type = array();
              $block_type[1]     = new Template($this->viewroot, $tmp_src->returnloop('block_type1'));
              $block_type[2]     = new Template($this->viewroot, $tmp_src->returnloop('block_type2'));
              $block_type[5]     = new Template($this->viewroot, $tmp_src->returnloop('block_type5'));
              $block_type[6]     = new Template($this->viewroot, $tmp_src->returnloop('block_type6'));
              
              $block_type[1] = $block_type[1]->output();
              $block_type[2] = $block_type[2]->output();
              $block_type[5] = $block_type[5]->output();
              $block_type[6] = $block_type[6]->output();
              
              $lastTypeID = -1;
              $c = 0;
//              ajax_echo_r ($table[1]);
              $thistable = "";
              if (sizeof($table)) {
               $thisidcolumnname = $json->tablename."_ID";
               if ($table[1]) {
                foreach ($table[1] as $cat) {
                 $loop_table_cat->reload();
                 $lastTypeID = -1;
                 $c = 0;
                 $thistable = "";
                 $sum_this = 0;
                 $ids = "";
                 
                 $loop_table_cat->fill(      "%PlaceName%", $cat->PlaceName      );
                 $loop_table_cat->fill(      "%PlaceType%", $cat->PlaceType      );
                 $loop_table_cat->fill( "%PaymentDetails%", $cat->PaymentDetails );
                 $loop_table_cat->fill(          "%Count%", $cat->Count          );
                 
                 
                 foreach ($cat->items as $item) {
                  if ($lastTypeID!=$item->TypeID) {
                   $lastTypeID = $item->TypeID;
                   $c = 0;
                  }
                  
                  $loop_table_row->reload();
                  $loop_table_row->fill( "%TypePicture%", $block_type[$item->TypeID]);
                  if ($item->TypeID) {
                   $loop_table_row->fill("%c%",  $c%2+(($item->TypeID-1)*2));
                  } else {
                   $loop_table_row->fill("%c%",  $c%2+6);
                  }
                  foreach ($vars as $vn) {
//                   $loop_table_row->fill("%".$vn."%", $item->$vn);
                   
//                   echo $vn."<br>";
                   switch ($vn) {
                    case ('DateAdded'):
                    case ('Status'):
                    case ('Stage'):
                    case ('FolderName'):
                     $loop_table_row->fill(  "%".$vn."%", str_replace(" ", "&nbsp;", $item->$vn));
                    break;
                    default:
                     $loop_table_row->fill(  "%".$vn."%", $item->$vn);
                    break;
                   }
                   
                   
                   
                  }
                  
                  if (($item->TypeID==1) || ($item->TypeID==3) || ($item->TypeID==5)) {
                   $sum      += $item->Value;
                   $sum_this += $item->Value;
                   $Income += $item->Value;
                  } else {
                   $sum      -= $item->Value;
                   $sum_this -= $item->Value;
                   $Expenditure += $item->Value;
                  }
                  
                  if ($ids) $ids.=",";
                  $ids.=$item->ID;
                  
                  $thistable.=$loop_table_row->output();
                  $c++;
                 }
                 
                 $loop_table_cat->fill("%ids%", $ids);
                 $loop_table_cat->fill("%sum%", $sum_this);
                 $loop_table_cat->fillloop('loop_table_row', $thistable);
                 $loop_table_cat_str .= $loop_table_cat->output();
                }
               }
              }
              $looptmp->fillloop('loop_table_cat',$loop_table_cat_str);
              $tmp_src->fillloop("loop_table",$looptmp->output());
              
              $tmp_src->fill( "%numrows%",sizeof($table[1]));
              
              $tmp_src->fillloop(       "block_no","" );
              $tmp_src->fillloop(   "block_norows","" );
              
              $tmp_src->fillloop(    "block_type1", '');
              $tmp_src->fillloop(    "block_type2", '');
              $tmp_src->fillloop(    'block_type5', '');
              $tmp_src->fillloop(    'block_type6', '');
              
              
              
              
              
             break;
             case ('money'):
              $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
              $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
              $vars = $loop_table_row->getVariables();
              
              
              $block_type = array();
              $block_type[1]     = new Template($this->viewroot, $tmp_src->returnloop('block_type1'));
              $block_type[2]     = new Template($this->viewroot, $tmp_src->returnloop('block_type2'));
              $block_type[5]     = new Template($this->viewroot, $tmp_src->returnloop('block_type5'));
              $block_type[6]     = new Template($this->viewroot, $tmp_src->returnloop('block_type6'));
              
              $block_type[1] = $block_type[1]->output();
              $block_type[2] = $block_type[2]->output();
              $block_type[5] = $block_type[5]->output();
              $block_type[6] = $block_type[6]->output();
              
              $totals = array();
              $lastTypeID = -1;
              $c = 0;
              $ids = "";
   //           ajax_echo_r ($table[1]);
              $thistable = "";
              if (sizeof($table)) {
               $thisidcolumnname = $json->tablename."_ID";
               if ($table[1]) {
                foreach ($table[1] as $item) {
                 if ($lastTypeID!=$item->TypeID) {
                  $lastTypeID = $item->TypeID;
                  $c = 2;
                 }
                 
                 $item->DateAdded = str_replace(" ", "&nbsp;", $item->DateAdded);
                 
                 $loop_table_row->reload();
                 $loop_table_row->fill( "%TypePicture%", $block_type[$item->TypeID]);
                 $loop_table_row->fill("%c%",  $c%2+(($item->TypeID-1)*2));
                 foreach ($vars as $vn) {
                  $loop_table_row->fill("%".$vn."%", $item->$vn);
                 }
                 
                 if (($item->TypeID==1) || ($item->TypeID==3) || ($item->TypeID==5)) {
                  $sum += $item->Value;
 //                 $Income += $item->Value;
                 } else {
                  $sum -= $item->Value;
 //                 $Expenditure += $item->Value;
                 }
                 $totals[$item->TypeID] += $item->Value;
                 
                 if ($ids) $ids.=",";
                 $ids.=$item->ID;
                 
                 $thistable.=$loop_table_row->output();
                 $c++;
                }
               }
              }
              $looptmp->fillloop('loop_table_row',$thistable);
              $tmp_src->fillloop("loop_table",$looptmp->output());
              
              $tmp_src->fill("%numrows%",sizeof($table[1]));
              
              $tmp_src->fillloop(       "block_no","" );
              $tmp_src->fillloop(   "block_norows","" );
              
              $tmp_src->fillloop(    "block_type1", '');
              $tmp_src->fillloop(    "block_type2", '');
              $tmp_src->fillloop(    'block_type5', '');
              $tmp_src->fillloop(    'block_type6', '');
              
              
              
              
              $tmp_src->fill(          '%sum%', fmt($totals[1]-$totals[2]   ));
              $tmp_src->fill(       '%Income%', fmt($totals[1]              ));
              $tmp_src->fill(  '%Expenditure%', fmt($totals[2]              ));
              if ($totals[2]) {
               $tmp_src->fill(          '%ROI%', fmt(100*$totals[1]/$totals[2]   ));
              } else {
               $tmp_src->fill(          '%ROI%', fmt(0   ));
              }
              
              $tmp_src->fill(        '%p_sum%', fmt($totals[5]-$totals[6]   ));
              $tmp_src->fill(     '%p_Income%', fmt($totals[5]              ));
              $tmp_src->fill('%p_Expenditure%', fmt($totals[6]              ));
              if ($totals[6]) {
               $tmp_src->fill(        '%p_ROI%', fmt(100*$totals[5]/$totals[6]   ));
              } else {
               $tmp_src->fill(        '%p_ROI%', fmt(0   ));
              }
              
              $tmp_src->fill(        '%t_sum%', fmt($totals[1]-$totals[2]+$totals[5]-$totals[6]   ));
              $tmp_src->fill(     '%t_Income%', fmt($totals[1]+$totals[5]              ));
              $tmp_src->fill('%t_Expenditure%', fmt($totals[2]+$totals[6]              ));
              if (($totals[5]-$totals[6])) {
               $tmp_src->fill(        '%t_ROI%', fmt(100*($totals[1]-$totals[2])/($totals[5]-$totals[6])   ));
              } else {
               $tmp_src->fill(        '%t_ROI%', fmt(0   ));
              }
              
              
              $Income_total       = $table[2][1]->Sum + $table[2][3]->Sum;
              $Expenditure_total  = $table[2][2]->Sum + $table[2][4]->Sum;
              $sum_total          = $Income_total - $Expenditure_total;
              
              $Income_target      = $table[2][1]->Sum + $table[2][3]->Sum;
              $Expenditure_target = $table[2][2]->Sum + $table[2][4]->Sum;
              $sum_target         = $Income_target; // - $Expenditure_target;
              $percent_target     = $sum_target/30000;
              $percent_target_int = (int)$percent_target;
              
              $tmp_src->fill(          '%sum_total%', fmt($sum_total         )            );
              $tmp_src->fill(       '%Income_total%', fmt($Income_total      )            );
              $tmp_src->fill(  '%Expenditure_total%', fmt($Expenditure_total )            );
              
              
 //             ajax_echo_r ($table[2]);
              
              $tmp_src->fill(        '%Income_real%', fmt($table[2][1]->Sum  )            );
              $tmp_src->fill(   '%Expenditure_real%', fmt($table[2][2]->Sum  )            );
 //              $tmp_src->fill(     '%Income_virtual%', fmt($table[2][3]->Sum  )            );
              $Income_virtual = $table[3][0]->Sum*0.10;
              $tmp_src->fill(     '%Income_virtual%', fmt($Income_virtual    )            );
              $tmp_src->fill('%Expenditure_virtual%', fmt($table[2][4]->Sum  )            );
              
              
              $sum_real    = $table[2][1]->Sum - $table[2][2]->Sum;
 //              $sum_virtual = $table[2][4]->Sum - $table[2][3]->Sum;
              $sum_virtual = $table[2][4]->Sum - $Income_virtual;
              
              
              $tmp_src->fill(           '%sum_real%', fmt($sum_real           )           );
              $tmp_src->fill(        '%sum_virtual%', fmt($sum_virtual        )           );
              
              $tmp_src->fill(         '%sum_target%', fmt($sum_target         )           );
              $tmp_src->fill(     '%percent_target%', fmt($percent_target     )           );
              $tmp_src->fill( '%percent_target_int%', fmt($percent_target_int )           );
              
              $datetime1  = date_create('2014-12-01');
              $datetime2  = date_create(date('Y-m-d'));
              $datetime3  = date_create('2016-05-01');
              
              $interval   = date_diff($datetime1, $datetime2);
              $days_spent = $interval->format('%a');
              $months_spent = $days_spent * 12 / 365; 
              
              $interval   = date_diff($datetime1, $datetime3);
              $days_total = $interval->format('%a');
              $months_total = $interval->y*12 + $interval->m;
              
              $days_left    = $days_total   - $days_spent;
              $months_left  = $months_total - $months_spent;
              
              $sum_kpi   = 3000000 - $sum_target;
              $sumpm_kpi = $sum_kpi/$months_left;
              
              $sumpd_target = $sum_target/$days_spent;
              $sumpd_kpi    = $sum_kpi/$days_left;
              
              $tmp_src->fill(          '%sumpd_kpi%', fmt($sumpd_kpi          )           );
              $tmp_src->fill(       '%sumpd_target%', fmt($sumpd_target       )           );
              $tmp_src->fill(         '%days_spent%', fmt($days_spent         )           );
              $tmp_src->fill(         '%days_total%', fmt($days_total         )           );
              $tmp_src->fill(          '%days_left%', fmt($days_left          )           );
              $tmp_src->fill(            '%sum_kpi%', fmt($sum_kpi            )           );
              $tmp_src->fill(          '%sumpd_kpi%', fmt($sumpd_kpi          )           );
              
              $percent_days     = 100*$days_spent/$days_total;
              $percentpd_target = 100*$sumpd_target/$sumpd_kpi;
              
              $tmp_src->fill(       '%percent_days%', fmt($percent_days       )           );
              $tmp_src->fill(   '%percentpd_target%', fmt($percentpd_target   )           );
              
              $sumpm_target = $sum_target / $months_spent;
              $percentpm_target = 100*$sumpm_target/$sumpm_kpi;
              
              $tmp_src->fill(       '%sumpm_target%', fmt($sumpm_target       )           );
              $tmp_src->fill(          '%sumpm_kpi%', fmt($sumpm_kpi          )           );
              $tmp_src->fill(   '%percentpm_target%', fmt($percentpm_target   )           );
              $tmp_src->fill(       '%months_spent%', fmt($months_spent       )           );
              $tmp_src->fill(                "%ids%", $ids                                );
              
              
              
              
              
             break;
             
             case ('qd'):
             case ('email'):
             case ('events'):
             case ('users'):
             case ('customers'):
             case ('sql'):
             case ('di-members'):
 //            case ('money'):
              
              $looptmp = clone $tmp_src;
              
              $looptmp->loadloop("loop_table");
              $tmp = clone $looptmp;
                
//              ajax_echo_r ($table[2]);
              
              if (sizeof($table[1])) {
               $block_no = clone $looptmp;
               $block_no->loadloop('block_no');
               $block_no=$block_no->output();
               
               $tmp->loadloop("checkbox_th");
               $checkbox_th=clone $tmp;
               $tmp = clone $looptmp;
               
               $tmp->loadloop("checkbox_td");
               $checkbox_td=clone $tmp;
               $tmp = clone $looptmp;
               
               $loop_table_row = clone $looptmp;                                  // load common parent template
               $loop_table_cell = clone $looptmp;                                 // load common parent template
               
               $looptmp->loadloop("loop_table_header");
        //          $tmp->loadloop("loop_table");
               $loopdata = "";
               $loopdata.=$checkbox_th->output();
               
               if ($table[0]) {
                foreach ($table[0] as $k => $v ) {
                 if ($v) {
                  $looptmp->reload();
                  if ($v!='CustomerID') {
                   $looptmp->fill("%th%"       , $this->StringForge->prepare($v));
                   $loopdata.=$looptmp->output();
                  }
                 }
                }
               }
               
               $tmp->fillloop("loop_table_header"   ,$loopdata           );
               
               $loop_table_row->loadloop("loop_table_row");
               
               $loop_table_cell->loadloop("loop_table_cell");
               
               $emptyinfo = file_get_contents($this->viewroot.'/templates/emptyinfo.htt');
               $c = 0;
               
               $thistable = "";
               $thisidcolumnname = $json->tablename."_ID";
       //          echo $thisidcolumnname."<br>";
               foreach ($table[1] as $item) {
                $loop_table_row->reload();
                $thisrow   = "";
                $checkbox_td->reload();
                $checkbox_td->fill('%checked%' , 'checked'            );
                $checkbox_td->fill('%id%'      , $item->$thisidcolumnname );
                $thisrow.=$checkbox_td->output();
                foreach ($item as $k=>$v) {
                 if ($k && ($k!='CustomerID')) {
                  $loop_table_cell->reload();
                  if ($k==$json->tablename."_AuxInfo") {
                   if (trim($v)=="") $v=$emptyinfo;
                  }
       //             ajax_echo_r($item);
       //ajax_echo_r($k);
                  $loop_table_cell->fill("%celldata%"     , (((int)$v==0) && ((string)(int)$v==$v))?$block_no:($v));
                  $loop_table_cell->fill("%k%"     , $k);
                  $thisrow.=$loop_table_cell->output();
                 }
                }
                $loop_table_row->fillloop('loop_table_cell',$thisrow);
                $loop_table_row->fill("%c%",  $c%2);
                
                $loop_table_row->fill("%id%"           , $item->ID             );
                $loop_table_row->fill("%ID%"           , $item->ID             );
                $loop_table_row->fill("%tablename%"    , $json->tablename      );
                
                if (($item->TypeID==1) || ($item->TypeID==3)) {
                 $sum += $item->Value;
                 $Income += $item->Value;
                } else {
                 $sum -= $item->Value;
                 $Expenditure += $item->Value;
                }
                
                $thistable.=$loop_table_row->output();
                $c++;
               }
               $tmp->fillloop('loop_table_row',$thistable);
               $tmp->fillloop("checkbox_th","");
               $tmp->fillloop("checkbox_td","");
               $tmp_src->fillloop("block_norows","");
               
               
               $tmp_src->fillloop("loop_table",$tmp->output());
              } else {
               $block_norows = clone $looptmp;
               $block_norows->loadloop('block_norows');
               $block_norows=$block_norows->output();
               /*
               $loop_table_row->reload();
               $thisrow   = "";
               $thisrow.=$block_norows;
               $loop_table_row->fillloop('loop_table_cell',$thisrow);
               $loop_table_row->fill("%c%",  $c%2);
               */
               
               $tmp_src->fillloop("loop_table",$block_norows);
              }
              
              $tmp_src->fill(           "%numrows%" , sizeof($table[1])                   );
               
             break;
             case ('spiderman'):
              $looptmp = clone $tmp_src;
              $looptmp->loadloop('loop_item');
              $loop_item = "";
              $vars = $looptmp->getVariables();
              
              $parents[] = array();
              
     //         ajax_echo_r ($table[1]);
              if (sizeof($table[1])) {
               foreach ($table[1] as $item) {
                foreach ($vars as $vn) {
                 if ($vn!=="Children") {
                  $looptmp->fill("%".$vn."%", $item->$vn);
                 }
                }
                if (!$parents[$item->ParentID]) $parents[$item->ParentID] = new stdClass();
                $parents[$item->ParentID]->Content.=$looptmp->output();
                $parents[$item->ParentID]->ID=$item->ID;
     //           $loop_item.=$looptmp->output();
                $looptmp->reload();
               }
              }
              
     //         ajax_echo_r ($parents);
              
              foreach($parents as $parent) {
               $parent->Content = str_replace("Children_".$parent->ID."_", $parents[$parent->ID]->Content, $parent->Content);
     //          ajax_echo_r ($parent->Content);
     //          echo "<hr>";
              }
              
              foreach ($table[1] as $item) {
               $parents[0]->Content = str_replace("Children_".$item->ID."_", "", $parents[0]->Content);
              }
              $loop_item=$parents[0]->Content;
              
              $tmp_src->fillloop('loop_item', $loop_item);
             break;
             case ('clubs'):
              $leftcontent = new Template($this->viewroot, "editor_clubs.htt");
              $typepicture = array();
              $typepicture[ 1] = $leftcontent->returnloop('block_typepicture_1' );
              $typepicture[ 2] = $leftcontent->returnloop('block_typepicture_2' );
              $typepicture[ 3] = $leftcontent->returnloop('block_typepicture_3' );
              $typepicture[ 4] = $leftcontent->returnloop('block_typepicture_4' );
              $typepicture[ 5] = $leftcontent->returnloop('block_typepicture_5' );
              $typepicture[ 6] = $leftcontent->returnloop('block_typepicture_6' );
              $typepicture[ 7] = $leftcontent->returnloop('block_typepicture_7' );
              $typepicture[ 8] = $leftcontent->returnloop('block_typepicture_8' );
              $typepicture[ 9] = $leftcontent->returnloop('block_typepicture_9' );
              $typepicture[10] = $leftcontent->returnloop('block_typepicture_10');
              $typepicture[11] = $leftcontent->returnloop('block_typepicture_11');
              $typepicture[15] = $leftcontent->returnloop('block_typepicture_15');
              $typepicture[16] = $leftcontent->returnloop('block_typepicture_16');
              
              $block_no       = new Template($this->viewroot, $tmp_src->returnloop('block_no'));
              $block_no    =$block_no->output();
              
              $block_yes      = new Template($this->viewroot, $tmp_src->returnloop('block_yes'));
              $block_yes   =$block_yes->output();
              
              /*
              $checkbox_th    = new Template($this->viewroot, $tmp_src->returnloop('checkbox_th'));
              $checkbox_td    = new Template($this->viewroot, $tmp_src->returnloop('checkbox_td'));
              */
              $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
              
              $loopdata = "";
//              $loopdata.=$checkbox_th->output();
              
              $cols = $loop_table_row->getVariables();
              
/*
              $cols = array();
              $cols[] = 'ID';
              $cols[] = 'Title';
              $cols[] = 'ShortTitle';
              $cols[] = 'FolderName';
              $cols[] = 'Platform';
              $cols[] = 'DateAdded';
   //           $cols[] = 'DateEdited';
              $cols[] = 'DateFinished';
   //           $cols[] = 'AddedBy';
   //           $cols[] = 'AddedByName';
              $cols[] = 'Description';
              $cols[] = 'Cost';
              $cols[] = 'AssignedToName';
              $cols[] = 'AssignedTo';
              $cols[] = 'UseInTasks';
              $cols[] = 'NeedWorkers';
              $cols[] = 'ParentID';
*/              
              $emptyinfo = file_get_contents($this->viewroot.'/templates/emptyinfo.htt');
              $c = 0;
              
              $thistable = "";
              if (sizeof($table[1])) {
               $thisidcolumnname = $json->tablename."_ID";
       //          echo $thisidcolumnname."<br>";
               foreach ($table[1] as $item) {
                $loop_table_row->reload();
                $thisrow   = "";
//                $checkbox_td->reload();
//                $checkbox_td->fill('%checked%' , 'checked'            );
//                $checkbox_td->fill('%id%'      , $item->$thisidcolumnname );
//                $thisrow.=$checkbox_td->output();
                
                $loop_table_row->fill(          "%ID%", $item->ID);
                $loop_table_row->fill( "%UseInTasksV%", $item->UseInTasks );
                $loop_table_row->fill("%NeedWorkersV%", $item->NeedWorkers);
                
                $loop_table_row->fill("%c%",  $c%2+4);
                
                $loop_table_row->fill("%id%"           , $item->ID             );
                $loop_table_row->fill("%tablename%"    , $json->tablename      );
                
                $loop_table_row->fill("%Status_typepicture%"   , $typepicture[$item->Status_TypeID]      );
                
                
                foreach ($cols as $cv) {
                 $k=$cv;
                 $v = $item->$k;
                 if ($k && ($k!='CustomerID')) {
                  if ($k==$json->tablename."_AuxInfo") {
                   if (trim($v)=="") $v=$emptyinfo;
                  }
                  
                  switch ($k) {
                   case ('UseInTasks'):
                   case ('NeedWorkers'):
                    $loop_table_row->fill(  "%".$k."%", (((int)$v==0) && ((string)(int)$v==$v) && ($k!='Cost'))?$block_no:$block_yes);
                   break;
                   case ('Title'):
                   case ('ShortTitle'):
                   case ('Platform'):
                   case ('DateAdded'):
                   case ('Status'):
                   case ('Stage'):
                   case ('FolderName'):
                    $loop_table_row->fill(  "%".$k."%", str_replace(" ", "&nbsp;", $v));
                   break;
                   default:
                    $loop_table_row->fill(  "%".$k."%", $v);
                   break;
                  }
                 }
                }
                $loop_table_row->fillloop('loop_table_cell',$thisrow);
                
                $thistable.=$loop_table_row->output();
                $c++;
               }
               $tmp_src->fillloop('loop_table_row',$thistable);
               $tmp_src->fillloop(   'block_norows', '');
               $tmp_src->removeloop('loop_table');
              } else {
               $tmp_src->fillloop("loop_table", '');
               $tmp_src->removeloop(   'block_norows' );
               $tmp_src->fillloop('loop_table', '');
              }
              
              
              $tmp_src->fillloop(  "block_no","");
              $tmp_src->fillloop( "block_yes","");
              
              
              $tmp_src->fill("%numrows%",sizeof($table[1]));          
              
              
              
             break;
             case ('vkusers'):
 //             $timer = microtime(true);
              if ($json->r_SQLExplain) {
               $looptmp = clone $tmp_src;
               
               $looptmp->loadloop("loop_table");
               $tmp = clone $looptmp;
                 
 //              ajax_echo_r ($table[2]);
               
               if (sizeof($table[1])) {
                $block_no = clone $looptmp;
                $block_no->loadloop('block_no');
                $block_no=$block_no->output();
                
                $tmp->loadloop("checkbox_th");
                $checkbox_th=clone $tmp;
                $tmp = clone $looptmp;
                
                $tmp->loadloop("checkbox_td");
                $checkbox_td=clone $tmp;
                $tmp = clone $looptmp;
                
                $loop_table_row = clone $looptmp;                                  // load common parent template
                $loop_table_cell = clone $looptmp;                                 // load common parent template
                
                $looptmp->loadloop("loop_table_header");
         //          $tmp->loadloop("loop_table");
                $loopdata = "";
                $loopdata.=$checkbox_th->output();
                
                if ($table[0]) {
                 foreach ($table[0] as $k => $v ) {
                  if ($v) {
                   $looptmp->reload();
                   if ($v!='CustomerID') {
                    $looptmp->fill("%th%"       , $this->StringForge->prepare($v));
                    $loopdata.=$looptmp->output();
                   }
                  }
                 }
                }
                
                $tmp->fillloop("loop_table_header"   ,$loopdata           );
                
                $loop_table_row->loadloop("loop_table_row");
                
                $loop_table_cell->loadloop("loop_table_cell");
                
                $emptyinfo = file_get_contents($this->viewroot.'/templates/emptyinfo.htt');
                $c = 0;
                
                $thistable = "";
                $thisidcolumnname = $json->tablename."_ID";
        //          echo $thisidcolumnname."<br>";
                foreach ($table[1] as $item) {
                 $loop_table_row->reload();
                 $thisrow   = "";
                 $checkbox_td->reload();
                 $checkbox_td->fill('%checked%' , 'checked'            );
                 $checkbox_td->fill('%id%'      , $item->$thisidcolumnname );
                 $thisrow.=$checkbox_td->output();
                 foreach ($item as $k=>$v) {
                  if ($k && ($k!='CustomerID')) {
                   $loop_table_cell->reload();
                   if ($k==$json->tablename."_AuxInfo") {
                    if (trim($v)=="") $v=$emptyinfo;
                   }
        //             ajax_echo_r($item);
        //ajax_echo_r($k);
                   $loop_table_cell->fill("%celldata%"     , (((int)$v==0) && ((string)(int)$v==$v))?$block_no:($v));
                   $loop_table_cell->fill("%k%"     , $k);
                   $thisrow.=$loop_table_cell->output();
                  }
                 }
                 $loop_table_row->fillloop('loop_table_cell',$thisrow);
                 $loop_table_row->fill("%c%",  $c%2);
                 
                 $loop_table_row->fill("%id%"           , $item->ID             );
                 $loop_table_row->fill("%tablename%"    , $json->tablename      );
                 
                 if (($item->TypeID==1) || ($item->TypeID==3)) {
                  $sum += $item->Value;
                  $Income += $item->Value;
                 } else {
                  $sum -= $item->Value;
                  $Expenditure += $item->Value;
                 }
                 
                 $thistable.=$loop_table_row->output();
                 $c++;
                }
                $tmp->fillloop('loop_table_row',$thistable);
                $tmp->fillloop("checkbox_th","");
                $tmp->fillloop("checkbox_td","");
                $tmp_src->fillloop("block_norows","");
                
                
                $tmp_src->fillloop("loop_table",$tmp->output());
               } else {
                $block_norows = clone $looptmp;
                $block_norows->loadloop('block_norows');
                $block_norows=$block_norows->output();
                /*
                $loop_table_row->reload();
                $thisrow   = "";
                $thisrow.=$block_norows;
                $loop_table_row->fillloop('loop_table_cell',$thisrow);
                $loop_table_row->fill("%c%",  $c%2);
                */
                
                $tmp_src->fillloop("loop_table",$block_norows);
               }
               
               $tmp_src->fill(           "%numrows%" , sizeof($table[1])                   );
               
               
               
              } else {
               switch ($json->r_viewmode) {
                case ("search"):
                 $looptmp        = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
                 $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
                 $vars = $loop_table_row->getVariables();
                 
                 $block_type = array();
                 $block_type[1]     = new Template($this->viewroot, $tmp_src->returnloop('block_type1'));
                 $block_type[2]     = new Template($this->viewroot, $tmp_src->returnloop('block_type2'));
                 
                 $block_type[1] = $block_type[1]->output();
                 $block_type[2] = $block_type[2]->output();
                 
                 $lastTypeID = -1;
                 $c = 0;
      //           ajax_echo_r ($table[1]);
                 $thistable = "";
                 if (sizeof($table)) {
                  $thisidcolumnname = $json->tablename."_ID";
                  if ($table[1]) {
                   foreach ($table[1] as $item) {
                    if ($lastTypeID!=$item->TypeID) {
                     $lastTypeID = $item->TypeID;
                     $c = 1;
                    }
                    
                    $loop_table_row->reload();
                    $loop_table_row->fill( "%TypePicture%", $block_type[($item->Sex)]);
                    $loop_table_row->fill("%c%",  6+$c%2+(($item->Sex)*2)%4);
                    foreach ($vars as $vn) {
                     $loop_table_row->fill("%".$vn."%", $item->$vn);
                    }
                    
                    if (($item->TypeID==1) || ($item->TypeID==3)) {
                     $sum += $item->Value;
                     $Income += $item->Value;
                    } else {
                     $sum -= $item->Value;
                     $Expenditure += $item->Value;
                    }
                    
                    $thistable.=$loop_table_row->output();
                    $c++;
                   }
                  }
                 }
                 $looptmp->fillloop('loop_table_row',$thistable);
                 $tmp_src->fillloop("loop_table",$looptmp->output());
                 
                 $tmp_src->fill("%numrows%",sizeof($table[1]));
                 
                 $tmp_src->fillloop(       "block_no","" );
                 $tmp_src->fillloop(   "block_norows","" );
                 $tmp_src->fillloop(    "block_type1","" );
                 $tmp_src->fillloop(    "block_type2","" );
                break;
                case ('statistics'):
                case ('summary'):
                 $table = $table[1];
                 
                 $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
                 
   //              ajax_echo_r ($table[1]);
                 
                 $vars = $loop_table_row->getVariables();
                 
                 foreach ($table['stats'] as $k=>$v) {
                  $loop_table_row->reload();
                  $loop_table_row->fill(       "%c%", $c%2        );
                  $loop_table_row->fill(     "%Cat%", $k          );
                  
                  foreach ($vars as $var) {
                   $loop_table_row->fill(     "%".$var."%", $v->$var     );
                  }
                  
                  $thistable.=$loop_table_row->output();
                  $c++;
                 }
                 
                 $tmp_src->fillloop('loop_table_row',$thistable);
                 
                 $tmp_src->fillloop(   "block_norows","" );
                break;
                case ('demography'):
 //                ajax_echo_r ($table[1]);
                 $table = $table[1];
                 
                 $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
                 $loop_table     = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
                 
                 $vars = $loop_table_row->getVariables();
                 
                 foreach ($table as $tblk=>$tbl) {
                  $c = 0;
                  $thistbl = "";
                  $loop_table->reload();
                  $loop_table->fill ("%Title%", $tblk);
                  foreach ($tbl as $k=>$v) {
                   $loop_table_row->reload();
                   $loop_table_row->fill(       "%c%", $c%2        );
                   $loop_table_row->fill(     "%Cat%", $k          );
                   
                   foreach ($vars as $var) {
                    $loop_table_row->fill(     "%".$var."%", $v->$var     );
                   }
                   
                   $thistbl.=$loop_table_row->output();
                   $c++;
                  }
                  
                  $loop_table->fillloop('loop_table_row',$thistbl);
                  $thistable.=$loop_table->output();
                 }
                 $tmp_src->fillloop('loop_table',$thistable);
                 
                 $tmp_src->fillloop(   "block_norows","" );
                break;
               }
              }
              
 //             echo "Time elapsed ".formatmicrotime(microtime(true) - $timer)." s. <br>";
              
              
             break;
             
             
             
             
             
             
             
             
             case ('freelancers'):
 //echo "10 Time elapsed ".formatmicrotime(microtime(true) - $ajax_timer)." s. <br>";
 //             $timer = microtime(true);
              if ($json->r_SQLExplain) {
               $looptmp = clone $tmp_src;
               
               $looptmp->loadloop("loop_table");
               $tmp = clone $looptmp;
                 
 //              ajax_echo_r ($table[2]);
               
               if (sizeof($table[1])) {
                $block_no = clone $looptmp;
                $block_no->loadloop('block_no');
                $block_no=$block_no->output();
                
                $loop_table_row = clone $looptmp;                                  // load common parent template
                $loop_table_cell = clone $looptmp;                                 // load common parent template
                
                $looptmp->loadloop("loop_table_header");
         //          $tmp->loadloop("loop_table");
                $loopdata = "";
                $loopdata.=$checkbox_th->output();
                
                if ($table[0]) {
                 foreach ($table[0] as $k => $v ) {
                  if ($v) {
                   $looptmp->reload();
                   if ($v!='CustomerID') {
                    $looptmp->fill("%th%"       , $this->StringForge->prepare($v));
                    $loopdata.=$looptmp->output();
                   }
                  }
                 }
                }
                
                $tmp->fillloop("loop_table_header"   ,$loopdata           );
                
                $loop_table_row->loadloop("loop_table_row");
                $loop_table_cell->loadloop("loop_table_cell");
                
                $emptyinfo = file_get_contents($this->viewroot.'/templates/emptyinfo.htt');
                $c = 0;
                
                $thistable = "";
                $thisidcolumnname = $json->tablename."_ID";
        //          echo $thisidcolumnname."<br>";
                foreach ($table[1] as $item) {
                 $loop_table_row->reload();
                 $thisrow   = "";
                 $checkbox_td->reload();
                 $checkbox_td->fill('%checked%' , 'checked'            );
                 $checkbox_td->fill('%id%'      , $item->$thisidcolumnname );
                 $thisrow.=$checkbox_td->output();
                 foreach ($item as $k=>$v) {
                  if ($k && ($k!='CustomerID')) {
                   $loop_table_cell->reload();
                   if ($k==$json->tablename."_AuxInfo") {
                    if (trim($v)=="") $v=$emptyinfo;
                   }
        //             ajax_echo_r($item);
        //ajax_echo_r($k);
                   $loop_table_cell->fill("%celldata%"     , (((int)$v==0) && ((string)(int)$v==$v))?$block_no:($v));
                   $loop_table_cell->fill("%k%"     , $k);
                   $thisrow.=$loop_table_cell->output();
                  }
                 }
                 $loop_table_row->fillloop('loop_table_cell',$thisrow);
                 $loop_table_row->fill("%c%",  $c%2);
                 
                 $loop_table_row->fill("%id%"           , $item->ID             );
                 $loop_table_row->fill("%tablename%"    , $json->tablename      );
                 
                 if (($item->TypeID==1) || ($item->TypeID==3)) {
                  $sum += $item->Value;
                  $Income += $item->Value;
                 } else {
                  $sum -= $item->Value;
                  $Expenditure += $item->Value;
                 }
                 
                 $thistable.=$loop_table_row->output();
                 $c++;
                }
                $tmp->fillloop('loop_table_row',$thistable);
                $tmp->fillloop("checkbox_th","");
                $tmp->fillloop("checkbox_td","");
                $tmp_src->fillloop("block_norows","");
                
                $tmp_src->fillloop("loop_table",$tmp->output());
               } else {
                $block_norows = clone $looptmp;
                $block_norows->loadloop('block_norows');
                $block_norows=$block_norows->output();
                /*
                $loop_table_row->reload();
                $thisrow   = "";
                $thisrow.=$block_norows;
                $loop_table_row->fillloop('loop_table_cell',$thisrow);
                $loop_table_row->fill("%c%",  $c%2);
                */
                
                $tmp_src->fillloop("loop_table",$block_norows);
               }
               
               $tmp_src->fill(           "%numrows%" , sizeof($table[1])                   );
               
               
               
              } else {
 //echo "30 Time elapsed ".formatmicrotime(microtime(true) - $ajax_timer)." s. <br>";
               switch ($json->r_viewmode) {
                case ("search"):
                 $looptmp        = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
                 $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
                 $vars = $loop_table_row->getVariables();
                 
                 if ($json->r_MoreColumns) {
                  $looptmp->removeloop('block_morecolumns','');
                 } else {
                  $looptmp->fillloop('block_morecolumns','');
                 }
                 
                 $block_type = array();
                 $block_type[1]     = new Template($this->viewroot, $tmp_src->returnloop('block_type1'));
                 $block_type[2]     = new Template($this->viewroot, $tmp_src->returnloop('block_type2'));
                 
                 $block_type[1] = $block_type[1]->output();
                 $block_type[2] = $block_type[2]->output();
                 
 //echo "32 Time elapsed ".formatmicrotime(microtime(true) - $ajax_timer)." s. <br>";
                 $lastTypeID = -1;
                 $c = 0;
      //           ajax_echo_r ($table[1]);
                 $thistable = "";
                 $logins = "";
                 if (sizeof($table)) {
                  $thisidcolumnname = $json->tablename."_ID";
                  if ($table[1]) {
                   foreach ($table[1] as $item) {
                    if ($lastTypeID!=$item->TypeID) {
                     $lastTypeID = $item->TypeID;
                     $c = 1;
                    }
                    
                    $loop_table_row->reload();
                    
                    if ($json->r_MoreColumns) {
                     $loop_table_row->removeloop('block_morecolumns','');
                    } else {
                     $loop_table_row->fillloop('block_morecolumns','');
                    }
                    
                    if ($item->VKID) $item->VKID = "http://vk.com/".$item->VKID;
                    
                    $loop_table_row->fill( "%TypePicture%", $block_type[($item->Sex)]);
                    $loop_table_row->fill("%c%",  6+$c%2+(($item->Sex)*2)%4);
                    foreach ($vars as $vn) {
                     $loop_table_row->fill("%".$vn."%", $item->$vn);
                    }
                    
                    
                    if ($item->Skype) {
                     if ($logins) $logins.="|";
                     $logins .=$item->Firstname.";".$item->Skype.";".$item->Source;
                    }
                    if ($item->Email) {
                     if ($emails) $emails.="|";
                     $emails .=$item->Firstname.";".$item->Email.";".$item->Source.";".$item->ID;
                    }
                    
                    if (($item->TypeID==1) || ($item->TypeID==3)) {
                     $sum += $item->Value;
                     $Income += $item->Value;
                    } else {
                     $sum -= $item->Value;
                     $Expenditure += $item->Value;
                    }
                    
                    $thistable.=$loop_table_row->output();
                    $c++;
                   }
                  }
                 }
 //echo "38 Time elapsed ".formatmicrotime(microtime(true) - $ajax_timer)." s. <br>";
                 $looptmp->fillloop('loop_table_row',$thistable);
                 $tmp_src->fillloop("loop_table",$looptmp->output());
                 
                 $tmp_src->fill("%numrows%",sizeof($table[1]));
                 $tmp_src->fill("%Skype%", $logins);
                 $tmp_src->fill("%Email%", $emails);
                 
 //echo "39 Time elapsed ".formatmicrotime(microtime(true) - $ajax_timer)." s. <br>";
                 $tmp_src->fillloop(       "block_no","" );
                 $tmp_src->fillloop(   "block_norows","" );
                 $tmp_src->fillloop(    "block_type1","" );
                 $tmp_src->fillloop(    "block_type2","" );
 //echo "40 Time elapsed ".formatmicrotime(microtime(true) - $ajax_timer)." s. <br>";
                break;
                case ('statistics'):
                case ('summary'):
                case ('parser'):
                 $table = $table[1];
                 
                 $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
                 
   //              ajax_echo_r ($table[1]);
                 
                 $vars = $loop_table_row->getVariables();
                 
                 if ($table['stats']) {
                  foreach ($table['stats'] as $k=>$v) {
                   $loop_table_row->reload();
                   $loop_table_row->fill(       "%c%", $c%2        );
                   $loop_table_row->fill(     "%Cat%", $k          );
                   
                   foreach ($vars as $var) {
                    $loop_table_row->fill(     "%".$var."%", $v->$var     );
                   }
                   
                   $thistable.=$loop_table_row->output();
                   $c++;
                  }
                  
                  $tmp_src->removeloop(   "loop_table" );
                  $tmp_src->fillloop('loop_table_row',$thistable);
                  
                  $tmp_src->fillloop(   "block_norows","" );
                 } else {
                  $tmp_src->fillloop('loop_table', "");
                  $tmp_src->removeloop(   "block_norows" );
                 }
                break;
                case ('demography'):
 //                ajax_echo_r ($table[1]);
                 $table = $table[1];
                 
                 $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
                 $loop_table     = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
                 
                 $vars = $loop_table_row->getVariables();
                 
                 foreach ($table as $tblk=>$tbl) {
                  $c = 0;
                  $thistbl = "";
                  $loop_table->reload();
                  $loop_table->fill ("%Title%", $tblk);
                  foreach ($tbl as $k=>$v) {
                   $loop_table_row->reload();
                   $loop_table_row->fill(       "%i%", $c+1        );
                   $loop_table_row->fill(       "%c%", $c%2        );
                   $loop_table_row->fill(     "%Cat%", $k          );
                   
                   foreach ($vars as $var) {
                    $loop_table_row->fill(     "%".$var."%", $v->$var     );
                   }
                   
                   $thistbl.=$loop_table_row->output();
                   $c++;
                  }
                  
                  $loop_table->fillloop('loop_table_row',$thistbl);
                  $thistable.=$loop_table->output();
                 }
                 $tmp_src->fillloop('loop_table',$thistable);
                 
                 $tmp_src->fillloop(   "block_norows","" );
                break;
               }
              }
              
 //             echo "Time elapsed ".formatmicrotime(microtime(true) - $timer)." s. <br>";
              
 //echo "50 Time elapsed ".formatmicrotime(microtime(true) - $ajax_timer)." s. <br>";
              
             break;
             
             case ('vacancies'):
              $block_type = array();
              if ($tmp_src->returnloop('block_skype')) {
               $block_type['skype']     = new Template($this->viewroot, $tmp_src->returnloop('block_skype'));
               $block_type['email']     = new Template($this->viewroot, $tmp_src->returnloop('block_email'));
               $block_type['phone']     = new Template($this->viewroot, $tmp_src->returnloop('block_phone'));
               $block_type['name' ]     = new Template($this->viewroot, $tmp_src->returnloop('block_name'));
              }
              
              foreach ($block_type as $k=>$v) {
               $block_type[$k] = $block_type[$k]->output();
              }
              
 //             ajax_echo_r ($table);
 //             $timer = microtime(true);
              if ($json->r_SQLExplain) {
               $looptmp = clone $tmp_src;
               
               $looptmp->loadloop("loop_table");
               $tmp = clone $looptmp;
               
 //              ajax_echo_r ($table);
               
               if (sizeof($table[1])) {
                $loop_table_row = clone $looptmp;                                  // load common parent template
                $loop_table_cell = clone $looptmp;                                 // load common parent template
                
                $looptmp->loadloop("loop_table_header");
         //          $tmp->loadloop("loop_table");
                $loopdata = "";
                $loopdata.=$checkbox_th->output();
                
                if ($table[0]) {
                 foreach ($table[0] as $k => $v ) {
                  if ($v) {
                   $looptmp->reload();
                   if ($v!='CustomerID') {
                    $looptmp->fill("%th%"       , $this->StringForge->prepare($v));
                    $loopdata.=$looptmp->output();
                   }
                  }
                 }
                }
                
                $tmp->fillloop("loop_table_header"   ,$loopdata           );
                
                $loop_table_row->loadloop("loop_table_row");
                
                $loop_table_cell->loadloop("loop_table_cell");
                
                $emptyinfo = file_get_contents($this->viewroot.'/templates/emptyinfo.htt');
                $c = 0;
                
                $thistable = "";
                $thisidcolumnname = $json->tablename."_ID";
        //          echo $thisidcolumnname."<br>";
                foreach ($table[1] as $item) {
                 $loop_table_row->reload();
                 $thisrow   = "";
                 $checkbox_td->reload();
                 $checkbox_td->fill('%checked%' , 'checked'            );
                 $checkbox_td->fill('%id%'      , $item->$thisidcolumnname );
                 $thisrow.=$checkbox_td->output();
                 foreach ($item as $k=>$v) {
                  if ($k && ($k!='CustomerID')) {
                   $loop_table_cell->reload();
                   if ($k==$json->tablename."_AuxInfo") {
                    if (trim($v)=="") $v=$emptyinfo;
                   }
        //             ajax_echo_r($item);
        //ajax_echo_r($k);
                   $loop_table_cell->fill("%celldata%"     , (((int)$v==0) && ((string)(int)$v==$v))?$block_no:($v));
                   $loop_table_cell->fill("%k%"     , $k);
                   $thisrow.=$loop_table_cell->output();
                  }
                 }
                 $loop_table_row->fillloop('loop_table_cell',$thisrow);
                 $loop_table_row->fill("%c%",  $c%2);
                 
                 $loop_table_row->fill("%id%"           , $item->ID             );
                 $loop_table_row->fill("%tablename%"    , $json->tablename      );
                 
                 if (($item->TypeID==1) || ($item->TypeID==3)) {
                  $sum += $item->Value;
                  $Income += $item->Value;
                 } else {
                  $sum -= $item->Value;
                  $Expenditure += $item->Value;
                 }
                 
                 $thistable.=$loop_table_row->output();
                 $c++;
                }
                $tmp->fillloop('loop_table_row',$thistable);
                $tmp->fillloop("checkbox_th","");
                $tmp->fillloop("checkbox_td","");
                $tmp_src->fillloop("block_norows","");
                
                
                $tmp_src->fillloop("loop_table",$tmp->output());
               } else {
                $block_norows = clone $looptmp;
                $block_norows->loadloop('block_norows');
                $block_norows=$block_norows->output();
                /*
                $loop_table_row->reload();
                $thisrow   = "";
                $thisrow.=$block_norows;
                $loop_table_row->fillloop('loop_table_cell',$thisrow);
                $loop_table_row->fill("%c%",  $c%2);
                */
                
                $tmp_src->fillloop("loop_table",$block_norows);
               }
               
               $tmp_src->fill(           "%numrows%" , sizeof($table[1])                   );
               
               
               
              } else {
               switch ($json->r_viewmode) {
                case ("search"):
                case ("autorespond"):
                 $looptmp        = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
                 $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
                 $vars = $loop_table_row->getVariables();
                 
                 $lastTypeID = -1;
                 $c = 0;
 //                ajax_echo_r ($table[1]);
                 $thistable = "";
                 if (sizeof($table)) {
                  $thisidcolumnname = $json->tablename."_ID";
                  if ($table[1]) {
                   foreach ($table[1] as $item) {
                    if ($lastTypeID!=$item->TypeID) {
                     $lastTypeID = $item->TypeID;
                     $c = 1;
                    }
                    
                    $loop_table_row->reload();
                    
 //                   ajax_echo_r ($item);
                    
                    $block_type_this = "";
                    if ($item->Firstname) $block_type_this.=$block_type['name'];
                    if ($item->Email)     $block_type_this.=$block_type['email'];
                    if ($item->Skype)     $block_type_this.=$block_type['skype'];
                    if ($item->Phone)     $block_type_this.=$block_type['phone'];
                    $loop_table_row->fill( "%TypePicture%", $block_type_this);
                    $loop_table_row->fill("%c%",  6+$c%2+(($item->Sex)*2)%4);
                    foreach ($vars as $vn) {
                     if ($vn=='SalaryAvgRus' || $vn=='SalaryToRus' || $vn=='SalaryFromRus') {
                      $loop_table_row->fill("%".$vn."%", formatCost($item->$vn));
                     } else {
                      $loop_table_row->fill("%".$vn."%", $item->$vn);
                     }
                    }
                    
                    if (($item->TypeID==1) || ($item->TypeID==3)) {
                     $sum += $item->Value;
                     $Income += $item->Value;
                    } else {
                     $sum -= $item->Value;
                     $Expenditure += $item->Value;
                    }
                    
                    $thistable.=$loop_table_row->output();
                    $c++;
                   }
                  }
                 }
                 $looptmp->fillloop('loop_table_row',$thistable);
                 $tmp_src->fillloop("loop_table",$looptmp->output());
                 
                 $tmp_src->fill("%numrows%",sizeof($table[1]));
                 
                 $tmp_src->fillloop(       "block_no","" );
                 $tmp_src->fillloop(   "block_norows","" );
                 $tmp_src->fillloop(    "block_type1","" );
                 $tmp_src->fillloop(    "block_type2","" );
                break;
                case ('statistics'):
                case ('summary'):
                case ('parser'):
                 $table = $table[1];
                 
                 $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
                 
   //              ajax_echo_r ($table[1]);
                 
                 $vars = $loop_table_row->getVariables();
                 
                 if ($table['stats']) {
                  foreach ($table['stats'] as $k=>$v) {
                   $loop_table_row->reload();
                   $loop_table_row->fill(       "%c%", $c%2        );
                   $loop_table_row->fill(     "%Cat%", $k          );
                   
                   foreach ($vars as $var) {
                    $loop_table_row->fill(     "%".$var."%", $v->$var     );
                   }
                   
                   $thistable.=$loop_table_row->output();
                   $c++;
                  }
                  
                  $tmp_src->removeloop(   "loop_table" );
                  $tmp_src->fillloop('loop_table_row',$thistable);
                  
                  $tmp_src->fillloop(   "block_norows","" );
                 } else {
                  $tmp_src->fillloop('loop_table', "");
                  $tmp_src->removeloop(   "block_norows" );
                 }
                break;
                case ('demography'):
 //                ajax_echo_r ($table[1]);
                 $table = $table[1];
                 
                 $loop_table_row = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
                 $loop_table     = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
                 
                 $vars = $loop_table_row->getVariables();
                 
                 foreach ($table as $tblk=>$tbl) {
                  $c = 0;
                  $thistbl = "";
                  $loop_table->reload();
                  $loop_table->fill ("%Title%", $tblk);
                  foreach ($tbl as $k=>$v) {
                   $loop_table_row->reload();
                   $loop_table_row->fill(       "%i%", $c+1        );
                   $loop_table_row->fill(       "%c%", $c%2        );
                   $loop_table_row->fill(     "%Cat%", $k          );
                   
                   if ($v->URL) {
                    $loop_table_row->removeloop(       "block_link", ""          );
                    $loop_table_row->fillloop  (     "block_simple", ""          );
                   } else {
                    $loop_table_row->fillloop  (       "block_link", ""          );
                    $loop_table_row->removeloop(     "block_simple", ""          );
                   }
                   
                   foreach ($vars as $var) {
                    if ($var=='Cnt') {
                     $loop_table_row->fill(     "%".$var."%", formatCost($v->$var)     );
                    } else {
                     $loop_table_row->fill(     "%".$var."%",    ($v->$var)     );
                    }
                   }
                   
                   $thistbl.=$loop_table_row->output();
                   $c++;
                  }
                  
                  $loop_table->fillloop('loop_table_row',$thistbl);
                  $thistable.=$loop_table->output();
                 }
                 $tmp_src->fillloop('loop_table',$thistable);
                 
                 $tmp_src->fillloop(   "block_norows","" );
                break;
               }
              }
              
 //             echo "Time elapsed ".formatmicrotime(microtime(true) - $timer)." s. <br>";
              
              foreach ($block_type as $k=>$v) {
               $tmp_src->fillloop("block_".$k,"");
              }
              
             break;
             case ('usergroups'):
              $looptmp = clone $tmp_src;
              
              $looptmp->loadloop("loop_table");
              $tmp = clone $looptmp;
              
//              ajax_echo_r ($table);
              
              if (sizeof($table[1])) {
               $looptmp->loadloop("loop_table_header");
        //          $tmp->loadloop("loop_table");
               $loopdata = "";
               
               if ($table[0]) {
                foreach ($table[0] as $k => $v ) {
                 if ($v) {
                  $looptmp->reload();
                  if ($v!='CustomerID') {
                   $looptmp->fill("%th%"       , $this->StringForge->prepare($v));
                   $loopdata.=$looptmp->output();
                  }
                 }
                }
               }
               
               $tmp->fillloop("loop_table_header"   ,$loopdata           );
               
               $loop_table_row       = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
               $loop_table_cell      = new Template($this->viewroot, $tmp_src->returnloop('loop_table_cell'));
               $loop_table_cell_edit = new Template($this->viewroot, $tmp_src->returnloop('loop_table_cell_edit'));
               
               $emptyinfo = file_get_contents($this->viewroot.'/templates/emptyinfo.htt');
               $c = 0;
               
               $thistable = "";
               $thisidcolumnname = $json->tablename."_ID";
               foreach ($table[1] as $item) {
                $loop_table_row->reload();
                $thisrow   = "";
//                foreach ($item as $k=>$v) {
                
                foreach ($table[0] as $ik=>$iv) {
                 $k = $iv;
                 $v = $item->$k;
                 if ($k && ($k!='CustomerID')) {
                  switch ($k) {
                   case ('ID'):
//                   case ('Name'):
//                   case ('Title'):
                    $loop_table_cell->reload();
                    if ($k==$json->tablename."_AuxInfo") {
                     if (trim($v)=="") $v=$emptyinfo;
                    }
  //                  $loop_table_cell->fill("%celldata%"     , (((int)$v==0) && ((string)(int)$v==$v))?$block_no:($v));
                    $loop_table_cell->fill("%celldata%"     , $v);
                    $loop_table_cell->fill("%k%"     , $k);
                    $thisrow.=$loop_table_cell->output();
                   break;
                   default:
                    $loop_table_cell_edit->reload();
                    if ($k==$json->tablename."_AuxInfo") {
                     if (trim($v)=="") $v=$emptyinfo;
                    }
  //                  $loop_table_cell->fill("%celldata%"     , (((int)$v==0) && ((string)(int)$v==$v))?$block_no:($v));
                    $loop_table_cell_edit->fill("%celldata%"     , $v);
                    $loop_table_cell_edit->fill("%k%"     , $k);
                    $loop_table_cell_edit->fill("%ID%"    , $item->ID);
                    $thisrow.=$loop_table_cell_edit->output();
                   break;
                  }
                 }
                }
                $loop_table_row->fillloop('loop_table_cell',$thisrow);
                $loop_table_row->fill("%c%",  $c%2);
                
                $loop_table_row->fill("%id%"           , $item->ID             );
                $loop_table_row->fill("%tablename%"    , $json->tablename      );
                
                if (($item->TypeID==1) || ($item->TypeID==3)) {
                 $sum += $item->Value;
                 $Income += $item->Value;
                } else {
                 $sum -= $item->Value;
                 $Expenditure += $item->Value;
                }
                
                $thistable.=$loop_table_row->output();
                $c++;
               }
               $tmp->fillloop('loop_table_row',$thistable);
               $tmp->fillloop("checkbox_th","");
               $tmp->fillloop("checkbox_td","");
               $tmp->fillloop("loop_table_cell_edit","");
               $tmp_src->fillloop("block_norows","");
               
               
               $tmp_src->fillloop("loop_table",$tmp->output());
              } else {
               $block_norows = clone $looptmp;
               $block_norows->loadloop('block_norows');
               $block_norows=$block_norows->output();
               /*
               $loop_table_row->reload();
               $thisrow   = "";
               $thisrow.=$block_norows;
               $loop_table_row->fillloop('loop_table_cell',$thisrow);
               $loop_table_row->fill("%c%",  $c%2);
               */
               
               $tmp_src->fillloop("loop_table",$block_norows);
              }
              
              $tmp_src->fill(           "%numrows%" , sizeof($table[1])                   );
             break;
             
             case ('callrecordings'):
              $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
              $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
              $vars = $loop_table_row->getVariables();
              
              
              $totals = array();
              $lastTypeID = -1;
              $c = 0;
   //           ajax_echo_r ($table[1]);
              $thistable = "";
              if (sizeof($table)) {
               $thisidcolumnname = $json->tablename."_ID";
               if ($table[1]) {
                foreach ($table[1] as $v) {
                 if ($lastTypeID!=$v->TypeID) {
                  $lastTypeID = $v->TypeID;
                  $c = 2;
                 }
                 
                 $loop_table_row->reload();
                 $loop_table_row->fill("%c%",  $c%2);
                 
                 
                 
                 if ($v->BadLine) {
                  $loop_table_row->removeloop('block_BadLine');
                 } else {
                  $loop_table_row->fillloop('block_BadLine'    , '');
                 }
                 
                 if ($v->DoNotCallBack) {
                  $loop_table_row->removeloop('block_DoNotCallBack');
                 } else {
                  $loop_table_row->fillloop('block_DoNotCallBack'    , '');
                 }
                 
                 if ($v->Reason) {
                  $loop_table_row->removeloop('block_Reason');
                 } else {
                  $loop_table_row->fillloop('block_Reason'    , '');
                 }
                 
                 if ($v->CallSet) {
                  $loop_table_row->removeloop('block_CallSet');
                 } else {
                  $loop_table_row->fillloop('block_CallSet'    , '');
                 }
                 
                 if ($v->MeetingSet) {
                  $loop_table_row->removeloop('block_MeetingSet');
                 } else {
                  $loop_table_row->fillloop('block_MeetingSet' , '');
                 }
                 
                 if ($v->SemiPromise) {
                  $loop_table_row->removeloop('block_SemiPromise');
                 } else {
                  $loop_table_row->fillloop('block_SemiPromise' , '');
                 }
                 
                 foreach ($vars as $vn) {
                  $loop_table_row->fill("%".$vn."%", $v->$vn);
                 }
                 
                 if (($v->TypeID==1) || ($v->TypeID==3) || ($v->TypeID==5)) {
                  $sum += $v->Value;
 //                 $Income += $item->Value;
                 } else {
                  $sum -= $v->Value;
 //                 $Expenditure += $item->Value;
                 }
                 $totals[$v->TypeID] += $v->Value;
                 
                 $thistable.=$loop_table_row->output();
                 $c++;
                }
               }
               $looptmp->fillloop('loop_table_row',$thistable);
               $tmp_src->fillloop("loop_table",$looptmp->output());
               
               $tmp_src->fillloop(   "block_norows","" );
              } else {
               $tmp_src->fillloop("loop_table", "");
               $tmp_src->removeloop(   "block_norows" );
              }
              
              $tmp_src->fill("%numrows%",sizeof($table[1]));
              
              $tmp_src->fillloop(       "block_no","" );
              $tmp_src->fillloop(    "block_type1", '');
              $tmp_src->fillloop(    "block_type2", '');
              $tmp_src->fillloop(    'block_type5', '');
              $tmp_src->fillloop(    'block_type6', '');
             break;
             
             case ('home'):
              $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_cats'));
              $vars = $loop_table_row->getVariables();
              
              $cats = $this->model->getUserPrivileges($userid);
//              ajax_echo_r ($cats);
              
              if ($cats) {
               foreach ($cats as $item) {
                $loop_table_row->reload();
                foreach ($vars as $vn) {
                 $loop_table_row->fill("%".$vn."%", $item->$vn);
                }
                $thistable.=$loop_table_row->output();
                $c++;
               }
              }
              $tmp_src->fillloop('loop_cats',$thistable);
              
              $tmp_src->fill(   '%imgfolder%', $this->imgfolder                    );
              $tmp_src->fill(    '%viewroot%', $this->viewroot                     );
              
             break;
             
             default:
              $looptmp            = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
              $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
              $vars = $loop_table_row->getVariables();
              
              
              $totals = array();
              $lastTypeID = -1;
              $c = 0;
   //           ajax_echo_r ($table[1]);
              $thistable = "";
              if (sizeof($table)) {
               $thisidcolumnname = $json->tablename."_ID";
               if ($table[1]) {
                foreach ($table[1] as $item) {
                 if ($lastTypeID!=$item->TypeID) {
                  $lastTypeID = $item->TypeID;
                  $c = 2;
                 }
                 
                 $loop_table_row->reload();
                 switch ($json->go) {
                  case ('skype'):
                   $loop_table_row->fill("%c%",  $c%2+8);
                  break;
                  case ('clubs'):
                   $loop_table_row->fill("%c%",  $c%2+4);
                  break;
                  default:
                   $loop_table_row->fill("%c%",  $c%2);
                  break;
                 }
                 foreach ($vars as $vn) {
                  $loop_table_row->fill("%".$vn."%", $item->$vn);
                 }
                 
                 if (($item->TypeID==1) || ($item->TypeID==3) || ($item->TypeID==5)) {
                  $sum += $item->Value;
 //                 $Income += $item->Value;
                 } else {
                  $sum -= $item->Value;
 //                 $Expenditure += $item->Value;
                 }
                 $totals[$item->TypeID] += $item->Value;
                 
                 $thistable.=$loop_table_row->output();
                 $c++;
                }
               }
               $looptmp->fillloop('loop_table_row',$thistable);
               $tmp_src->fillloop("loop_table",$looptmp->output());
               
               $tmp_src->fillloop(   "block_norows","" );
              } else {
               $tmp_src->fillloop("loop_table", "");
               $tmp_src->removeloop(   "block_norows" );
              }
              
              $tmp_src->fill("%numrows%",sizeof($table[1]));
              
              $tmp_src->fillloop(       "block_no","" );
              
              $tmp_src->fillloop(    "block_type1", '');
              $tmp_src->fillloop(    "block_type2", '');
              $tmp_src->fillloop(    'block_type5', '');
              $tmp_src->fillloop(    'block_type6', '');
             break;
             
             
             
            }
            
            $tmp_src->fill(   '%imgfolder%', $this->imgfolder                    );
            $tmp_src->fill(    '%viewroot%', $this->viewroot                     );
            $tmp_src->fill(         '%sum%', fmt($sum         )                  );
            $tmp_src->fill(      '%Income%', fmt($Income      )                  );
            $tmp_src->fill( '%Expenditure%', fmt($Expenditure )                  );
            
            $tmp_src = $this->fillStricts($tmp_src);
            
            $ret = $tmp_src->output();
            $ret = sup($ret);
            ajax_echo(($ret));
           }
         }
        break;
        
        case ('showtasks'):
//         ajax_echo_r($json);
 //        session_write_close();
         
         if (!$_SESSION['json']) $_SESSION['json'] = array();
         $_SESSION['json'][$json->go] = $json;
         
         $tmp_src = new Template($this->viewroot, 'main_money_current.htt');
         
         $block_type = array();
         $block_type[1]     = new Template($this->viewroot, $tmp_src->returnloop('block_type1'));
         $block_type[2]     = new Template($this->viewroot, $tmp_src->returnloop('block_type2'));
         $block_type[5]     = new Template($this->viewroot, $tmp_src->returnloop('block_type5'));
         $block_type[6]     = new Template($this->viewroot, $tmp_src->returnloop('block_type6'));
         
         $block_type[1] = $block_type[1]->output();
         $block_type[2] = $block_type[2]->output();
         $block_type[5] = $block_type[5]->output();
         $block_type[6] = $block_type[6]->output();
         
         
         setsecurevariable( 'AssignedToID', $json->flt_AssignedToID );
         setsecurevariable(       'ClubID', $json->flt_ClubID       );
         setsecurevariable(   'TaskListID', $json->flt_TaskListID   );
         
         $loop = new Template($this->viewroot, 'main_tasks.htt');                                      // load common parent template
         $block_notasks  = new Template($this->viewroot, $loop->returnloop('block_notasks'));
         $loop_table_row = new Template($this->viewroot, $loop->returnloop('loop_table_row'));
         $block_money    = new Template($this->viewroot, $loop->returnloop('block_money'));
         
         $loop->loadloop("loop_task".$json->listid);
         
         $list = $this->model->getTasks($json);
//         ajax_echo_r ($list);
         $loopdata = "";
         
         $vars   = $loop->getVariables();
         $vars_m = $loop_table_row->getVariables();
//         ajax_echo_r($vars);
         
         if (sizeof($list)>0)  {
 //         $i=0;
          foreach ($list as $ik=>$iv) {
 //          ajax_echo_r ($iv->Money);
           $loop_table_row_str = "";
           $c=0;
//           ajax_echo_r ($iv);
           $iv->Cost     = (int)$iv->Cost;
           $iv->CostSell = (int)$iv->CostSell;
           
           if ($iv->Money) {
            foreach ($iv->Money as $mk=>$mv) {
             $loop_table_row->reload();
             
             $mv->Value = (int)$mv->Value;
             
             if ($lastTypeID!=$mv->TypeID) {
              $lastTypeID = $mv->TypeID;
              $c = 0;
             }
             
             $loop_table_row->fill( "%TypePicture%", $block_type[$mv->TypeID]);
             $loop_table_row->fill("%c%",  $c%2+(($mv->TypeID-1)*2));
             $c++;
             
             foreach ($vars_m as $vn) {
              $loop_table_row->fill("%".$vn."%", ($mv->$vn));
             }
             $loop_table_row_str.=$loop_table_row->output();
            }
            $block_money->reload();
            $block_money->fillloop('loop_table_row', $loop_table_row_str);
            
            $loop->fillloop('block_money', $block_money->output());
           } else {
            $loop->fillloop('block_money', "");
           }
           
           
           $loop->fill(  '%imgfolder%' , $this->imgfolder                    );
           
           if (time()>strtotime($iv->DateFinish)) {
            $loop->removeloop('block_overdue');
           } else {
            $loop->fillloop('block_overdue', '');
           }
           
           //ajax_echo_r (localize(htmlspecialchars_decode($iv->Title)));
           
           $iv->Title = localize(htmlspecialchars_decode($iv->Title));
           
 //          if (($i==0) && ($json->flt_TaskListID>0)) setsecurevariable('ShortTitle', $iv->ClubShortTitle);
           
  //         $block_comments = $this->getComments($iv->ID);
  //         $loop->fill(  '%Comments%' , $block_comments                    );
           foreach ($vars as $vn) {
 //           if ($vn=='Description') {
 //            $loop->fill("%".$vn."%", ru_translate("".$iv->$vn));
 //           } else {
             $loop->fill("%".$vn."%", localize($iv->$vn));
 //           }
           }
           
           if ($iv->StateID==1) {
            $loop->fillloop('block_paused','');
            $loop->removeloop('block_playing');
           } else {
            $loop->removeloop('block_paused');
            $loop->fillloop('block_playing','');
           }
           
           if ($iv->NeedWorkers==1) {
            $loop->removeloop('block_NeedWorkers');
           } else {
            $loop->fillloop('block_NeedWorkers','');
           }
           
           $loop->processfcb('');
           $loop->fill(  '%imgfolder%' , $this->imgfolder                    );
           $loop = $this->fillStricts($loop);
           
           $loopdata.=$loop->output();
           $loop->reload();
           
 //          $i++;
          }
         } else {
          $block_notasks = $this->fillStricts($block_notasks);
          $loopdata.=$block_notasks->output();
          //$loopdata.=$block_notasks->output();
         }
         
         
         ajax_echo(localize($loopdata));
         
         
         
         
         
         
         
         
         
  //       ajax_echo_r($buf);
         
        break;
        
        case ('generateresult'): 
  //       $block_link = new Template($this->viewroot, 'mainparent.htt');
  //       $block_link->loadloop('block_link');
         
  //       $block_link->fill('%href%', $this->model->generateOutput());
         
  //       echo localize($block_link->output());
         echo $this->model->generateOutput();
  //       echo ('test');
         
        break;
        
        case ("cleardatabase"):
         setCache('data', "");
        break;
        
        case ('clearColumn'):
         echo $this->model->clearColumn($json->id);
        break;
        
        
        
        
        case ("getrubrics"):
         $loop = new Template($this->viewroot, 'left_customers.htt');                                      // load common parent template
         $loop_all = clone $loop;
         
         $loop->loadloop("loop_rubricsdescriptions");
         
         $list = $this->model->getRubrics($json->HeaderID);
  //        ajax_echo_r ($list);
         $loopdata = "";
         if (sizeof($list)>0)  {
          $loop_all->loadloop("loop_rubricsall");
          $loopdata.=$loop_all->output();
          foreach ($list as $ik=>$iv) {
  //          echo $iv->ID;
           $loop->fill("%list_rubricsdescriptions%" ,  $iv->Description);
           $loop->fill("%id%"          ,  $iv->ID   );
           $loop->fill("%selected%"    ,  ""        );
           $loopdata.=$loop->output();
           $loop->reload();
          }
         } else {
          $loopdata.=$block_norows;
         }
         
         ajax_echo($loopdata);
        break;
        
        case ("setListID"):
         $this->model->setListID($json);
        break;
        
        case ("completeTask"):
         $this->model->completeTask($json);
        break;
        
        case ("addTask"):
         $ret = new stdClass;
         $json->AddedBy = $userid;
  //       echo $userid;
         
//         ajax_echo_r ($json);
//         die();
         
         
//         if ($json->Title=='') {
//          $ret->message = localize($this->getMessage('addtask_error_notitle'));
//         } else {
          
          
          /*
          if ((int) $json->Cost) {
           $json->Cost = str_replace(",",".",$json->Cost);
          }
          if ((int) $json->CostSell) {
           $json->CostSell = str_replace(",",".",$json->CostSell);
          }
          
          if ($json->ID) {
           $rec = $this->model->getTask($json->ID);
           $id = $json->ID;
          } else {
           $rec = new stdClass;
           $rec->Cost = 0;
           $rec->CostSell = 0;
          }
          */
          
          $id = $this->model->addTask($json);
          
          
          if ($id) {
           $ret->message = localize($this->getMessage('addmoney_success'));
          } else {
           $ret->message = localize($this->getMessage('addmoney_error_unknown'));
          }
          
          $ret->ID = $id;
//         }
         
         echo json_encode($ret);
        break;
        
        case ("deleteTask"):
         $this->model->deleteTask($json);
        break;
        
        case ("resumeTask"):
         $this->model->resumeTask($json);
        break;
        
        case ("pauseTask"):
         $this->model->pauseTask($json);
        break;
        
        case ("newTask"):
         $leftcontent = new Template($this->viewroot, "editor_tasks.htt");
         
         if ($this->user->GroupID==1) {
          $leftcontent->removeloop('block_adminonly2');
         } else {
          $leftcontent->fillloop('block_adminonly2','');
         }
         
//         ajax_echo_r ($this->user);
         
         if ($json->AssignedToID<0) $json->AssignedToID = $this->userid;
         if ($json->ClubID      <0) $json->ClubID       = $this->user->ClubID;
         
//         ajax_echo_r ($json);
         if ($json->ID) {
          $rec = $this->model->getTask($json->ID);
          $leftcontent->removeloop('block_editonly');
         } else {
          $rec = new stdClass;
          $rec->TypeID=1;
          $rec->AssignedToID =$json->AssignedToID;
          $rec->ClubID  =$json->ClubID;
          if ($json->TaskListID<0) {
           $rec->TaskListID = 2;
          } else {
           $rec->TaskListID = $json->TaskListID;
          }
          $rec->PriorityID =3;
          $leftcontent->fillloop('block_editonly', '');
         }
         
         $rec->DateStart =date("Y-m-d H:i", strtotime($rec->DateStart ));
         $rec->DateFinish=date("Y-m-d H:i", strtotime($rec->DateFinish));
         
         $leftcontent->fillloop('block_p','');
         
//         ajax_echo_r ($rec);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("block_PriorityID"));
         $list=$this->model->getList('priorities');
         $loopdata = $this->fillList($list, $loop, $rec->PriorityID);
         $leftcontent->fillloop('block_PriorityID', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("block_ParentID"));
         $list=$this->model->getStudents();
         $loopdata = $this->fillList($list, $loop, $rec->ParentID);
         $leftcontent->fillloop('block_ParentID', $loopdata);
         
         
         
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("block_AssignedToID"));
 //        $list=$this->model->getList('users');
         $list=$this->model->getUsersList($rec);
         if ($rec->AssignedToID<0) {
          $club = $this->model->getClub($rec->ClubID);
          $rec->AssignedToID = $club->AssignedToID;
          
          
//          ajax_echo_r ($list);
          /*
          foreach ($list as $item) {
           if ($item->IsHead) {
            $rec->AssignedToID=$item->ID;
            break;
           }
          }
          */
         }
         $loopdata = $this->fillList($list, $loop, $rec->AssignedToID);
         $leftcontent->fillloop('block_AssignedToID', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("block_ClubID"));
         $list=$this->model->getClubs($json);
 //        $list=$this->model->getList('clubs');
         $loopdata = $this->fillList($list, $loop, $rec->ClubID);
         $leftcontent->fillloop('block_ClubID', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("block_TypeID"));
         $list=$this->model->getList('tasktypes');
         $loopdata = $this->fillList($list, $loop, $rec->TypeID);
         $leftcontent->fillloop('block_TypeID', $loopdata);
         
         
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , brtonl($rec->$var));
          }
         }
         
         $leftcontent->processfcb('');
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         $leftcontent = $this->fillStricts($leftcontent);
         ajax_echo (localize($leftcontent->output()));
         
        break;
        
        case ("viewTask"):
         $leftcontent = new Template($this->viewroot, "viewer_tasks.htt");
         
//         ajax_echo_r ($json);
         if ($json->ID) {
          $rec = $this->model->getTaskWithSubtables($json->ID);
         } else {
          $rec = new stdClass;
         }
         
//         ajax_echo_r ($rec);
         
         
         $rec->additionalcontact_hidden = ($rec->ParentContactPhone)?"":"hidden";
         
         $rec->ParentFirstname        = str_replace(" ", "&nbsp;", $rec->ParentFirstname        );
         $rec->ParentLastname         = str_replace(" ", "&nbsp;", $rec->ParentLastname         );
         $rec->ParentContactFirstname = str_replace(" ", "&nbsp;", $rec->ParentContactFirstname );
         $rec->ParentContactLastname  = str_replace(" ", "&nbsp;", $rec->ParentContactLastname  );
         
         
         include 'model/Twilio/Capability.php';
         
         // put your Twilio API credentials here
         $accountSid = $this->settings->accountSid;
         $authToken  = $this->settings->authToken;
         // put your Twilio Application Sid here
         $appSid     = $this->settings->appSid;
         
         $capability = new Services_Twilio_Capability($accountSid, $authToken);
         $capability->allowClientOutgoing($appSid);
         
         $Token = $capability->generateToken();
         $leftcontent->fill('%Token%', $Token);
         
         
         
         
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , brtonl($rec->$var));
          }
         }
         
         $leftcontent->processfcb('');
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         $leftcontent = $this->fillStricts($leftcontent);
         ajax_echo (localize($leftcontent->output()));
         
        break;
        
        
        case ('closeClub'):
         ajax_echo_r ($json);
         $ret = $this->model->closeClub($json);
         ajax_echo_r ($ret);
        break;
        
        case ('addComment'):
         $json->UserID = $userid;
         ajax_echo_r ($json);
         $ret = $this->model->addComment($json);
         ajax_echo_r ($ret);
         
        break;
        
        case ('getComments'):
  //       ajax_echo_r($json);
  //       ajax_echo_r (htmlentities($this->getComments($json)));
         ajax_echo (($this->getComments($json)));
         
        break;
        
        case ('deleteComment'):
  //       ajax_echo_r($json);
         $ret = $this->model->deleteComment($json);
  //       ajax_echo_r($ret);
         echo $this->getComments($ret);
         
        break;
        
        case ('showComments'):
  //       ajax_echo_r($json);
  //       ajax_echo_r (htmlentities($this->getComments($json)));
         
         if ($json->DeleteID) {
          $ret = $this->model->deleteComment($json);
         }
         
         $items = $this->model->getCommentsRibbon($json);
//         ajax_echo_r ($items);
         $c = 0;
         
         $loop = new Template($this->viewroot, "main_assessments.htt");                                      // load common parent template
         
         $block_comment = new Template($this->viewroot, $loop->returnloop('loop_comment'));
         $vars = $block_comment->getVariables();
         
         $block_comments = "";
         if (sizeof($items)) {
          $e=0;
          foreach ($items as $item) {
           $block_comment->reload();
           
           $block_comment->processfcb('');
           $block_comment->fill(  '%imgfolder%' , $this->imgfolder                    );
           $block_comment->fill(   '%viewroot%' , $this->viewroot                     );
           $block_comment->fill(   '%e%' , 6+$e%2                     );
           
           $item->Comment = nl2br($item->Comment);
           
           foreach ($vars as $var) {
            $block_comment->fill(     "%".$var."%", $item->$var     );
           }
           
           $block_comments .= $block_comment->output();
           $e++;
          }
         }
         echo localize($block_comments);
         
         
//         showComments
         
         
//         ajax_echo (($this->getComments($json)));
         
        break;
        
        
        
        case ('addSpider'):
         $this->model->addSpider($json);
        break;
        
        case ('deleteSpider'):
         $this->model->deleteSpider($json);
        break;
        
        
        
        case ('loadUserPrivileges'):
         echo $this->getUserPrivileges($json);
        break;
        
        case ('addUserPrivilege'):
         $this->model->addUserPrivilege($json);
         echo $this->getUserPrivileges($json);
        break;
        
        case ('removeUserPrivilege'):
         $this->model->removeUserPrivilege($json);
         echo $this->getUserPrivileges($json);
        break;
        
        
        
        case ('api'):
         $method = getvariablereq('method');
         
         switch ($method) {
          case ('getCurrentProjects'):
           $json = new stdClass;
           $json->tablemode = 0;
           $json->isexport = 0;
           $json->go = "projects";
           $json->r_projectsview = "current";
           $json->tablename = "projects";
           $json->isapi = 1;
           
           $table = $this->model->getTable($json);
           
 //          ajax_echo_r ($table);
           
          break;
          case ('getAllProjects'):
           $json = new stdClass;
           $json->tablemode = 0;
           $json->isexport = 0;
           $json->go = "projects";
           $json->r_projectsview = "all";
           $json->tablename = "projects";
           $json->isapi = 1;
           
           $table = $this->model->getTable($json);
           
 //          ajax_echo_r ($table);
           
          break;
          
          case ('getVKUsers'):
           $json = new stdClass;
           $json->tablemode = 0;
           $json->isexport = 0;
           $json->go = "vkusers";
           $json->page = "money";
           $json->s_campaignid = 1;
           $json->r_viewmode = "search";
 //          $json->r_FromSamara = 1;
           $json->r_IsActive = 1;
           $json->r_Rand = 1;
 //          $json->r_ExcludeLiked = 1;
 //          $json->r_PotentialPartner = 1;
 //          $json->r_IsInteresting = 1;
 //          $json->r_FreeSearch = "кошак";
           
           
           $table = $this->model->getVKUsers($json);
           
 //          ajax_echo_r ($table);
           
          break;
          
          case ('setAddedToSkype'):
           if ($data) {
            $ret = $this->model->setAddedToSkype($data);
            if ($ret->rowsAffected) {
             echo "Successful";
            } else {
             echo "Freelancer not found: ".$data;
            }
           } else {
            echo "Error";
           }
           
 //          echo $data;
          break;
          
          case ('addCallState'):
//           echo $_SERVER['QUERY_STRING'];
           $json = new stdClass;
           $json->CustomerID = getvariablereq('CustomerID');
           $json->UserID     = getvariablereq('UserID');
           $json->EventID    = (int)getvariablereq('EventID');
//           $json->DateAdded  = date("Y-m-d H:i:s");
           
           $data = new stdClass;
           $data->ID = (int)getvariablereq('EventID');
           $data->Description = getvariablereq('EventStr');
           $ret = $this->model->updateCallEvent($data);
           
//           ajax_echo_r ($json);
           
           $ret = $this->model->addRecord("callstates", $json);
           if ($ret->rowsAffected) {
            echo "Successful";
           } else {
            echo "Error";
           }
          break;
          
          default:
           echo "Unknown api method: ".$method;
          break;
         }
         
         if ($table) {
          echo json_encode($table);
         }
        break;
        
        case ('addCallState'):
//           $json = new stdClass;
//           $json->CustomerID = getvariablereq('CustomerID');
         $json->UserID      = $this->userid;
//           $json->EventID     = (int)getvariablereq('EventID');
//         $json->DateAdded   = date("Y-m-d H:i:s");
         
//         ajax_echo_r ($json);
         
         switch ($json->Description) {
          case ('A connection is currently active'):
           $json->EventID = 31;
          break;
         }
         
         if ($json->EventID!='undefined') {
          $data = new stdClass;
          $data->ID = $json->EventID;
          $data->Description = $json->Description;
          $ret = $this->model->updateCallEvent($data);
//           ajax_echo_r ($json);
          unset ($json->Description);
          
          if ($json->CustomerID) {
           $ret = $this->model->addRecord("callstates", $json);
          }
         } else {
          addtologEx($json     , 'addCallState-faultyJson.txt', 'errors');
          addtologEx("\n"      , 'addCallState-faultyJson.txt', 'errors');
         }
         
         if ($ret->rowsAffected) {
          echo "Successful";
         } else {
          echo "Error";
         }
        break;
        
        case ('loadClubParticipants'):
 //        ajax_echo_r($json);
         
         echo $this->getParticipants($json);
        break;
        
        case ('addClubParticipant'):
         $this->model->addClubParticipant($json);
         echo $this->getParticipants($json);
        break;
        
        case ('addClubParticipantHead'):
         $this->model->addClubParticipantHead($json);
         echo $this->getParticipants($json);
        break;
        
        case ('removeClubParticipant'):
 //        ajax_echo_r($json);
         $this->model->removeClubParticipant($json);
         echo $this->getParticipants($json);
        break;
        
        case ('selectChange'):
 //        ajax_echo_r($json);
         $ret = new stdClass;
         $ret->debug = ajax_return_r($json);
         
         switch ($json->id) {
          case ('Newmoney_TypeID'):
           $leftcontent = new Template($this->viewroot, 'editor_users.htt');                                      // load common parent template
           
           $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_groupids"));
           $list = $this->model->getExpenditureGroups($json->value);
 //          ajax_echo_r ($list);
           $loopdata = $this->fillList($list, $loop, 0);
 //          $leftcontent->fillloop('loop_groupids', $loopdata);
           $ret->Newmoney_GroupID = localize($loopdata);
           
           
          break;
          case ('TypeID'):
           $leftcontent = new Template($this->viewroot, 'editor_money.htt');                                      // load common parent template
           
           $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_groupids"));
           $list = $this->model->getExpenditureGroups($json->value);
 //          ajax_echo_r ($list);
           $loopdata = $this->fillList($list, $loop, 0);
 //          $leftcontent->fillloop('loop_groupids', $loopdata);
           $ret->GroupID = localize($loopdata);
           
           $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_placenames"));
           $list = $this->model->getPlaceNames($json->value);
 //          ajax_echo_r ($list);
           $loopdata = $this->fillList($list, $loop, 0);
 //          $leftcontent->fillloop('loop_placenames', $loopdata);
           $ret->PlaceName = localize($loopdata);
           
           $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_placetypes"));
           $list = $this->model->getPlaceTypes($json->value);
 //          ajax_echo_r ($list);
           $loopdata = $this->fillList($list, $loop, 0);
 //          $leftcontent->fillloop('loop_placetypes', $loopdata);
           $ret->PlaceType = localize($loopdata);
          break;
          
          case ('GroupID'):
           $leftcontent = new Template($this->viewroot, 'editor_money.htt');                                      // load common parent template
           
           $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_placenames"));
           $list = $this->model->getPlaceNames(0, 0, $json->value);
 //          ajax_echo_r ($list);
           $loopdata = $this->fillList($list, $loop, 0);
 //          $leftcontent->fillloop('loop_placenames', $loopdata);
           $ret->PlaceName = localize($loopdata);
           
           $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_placetypes"));
           $list = $this->model->getPlaceTypes(0, 0, $json->value);
 //          ajax_echo_r ($list);
           $loopdata = $this->fillList($list, $loop, 0);
 //          $leftcontent->fillloop('loop_placetypes', $loopdata);
           $ret->PlaceType = localize($loopdata);
          break;
          
          case ('PlaceType'):
           $leftcontent = new Template($this->viewroot, 'editor_money.htt');                                      // load common parent template
           
           $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_placenames"));
           $list = $this->model->getPlaceNames(0, $json->value);
 //          ajax_echo_r ($list);
           $loopdata = $this->fillList($list, $loop, 0);
 //          $leftcontent->fillloop('loop_placenames', $loopdata);
           $ret->PlaceName = localize($loopdata);
          break;
          
          case ('PlaceName'):
           $leftcontent = new Template($this->viewroot, 'editor_money.htt');                                      // load common parent template
           
           $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_placetypes"));
           $list = $this->model->getPlaceTypes(0, $json->value);
 //          ajax_echo_r ($list);
           $loopdata = $this->fillList($list, $loop, 0);
 //          $leftcontent->fillloop('loop_placetypes', $loopdata);
           $ret->PlaceType = localize($loopdata);
          break;
          
          case ('ClubID'):
           $leftcontent = new Template($this->viewroot, 'editor_money.htt');                                      // load common parent template
           
           $loop   = new Template($this->viewroot, $leftcontent->returnloop("loop_tasks"));
           $loop_0 = new Template($this->viewroot, $leftcontent->returnloop("loop_tasks_0"));
           if ($json->value) {
            $params = new stdClass;
            $params->ClubID = $json->value;
           }
           $list = $this->model->getListTasks($params);
 //          ajax_echo_r ($list);
           $loopdata = $this->fillList($list, $loop, 0);
 //          $leftcontent->fillloop('loop_placetypes', $loopdata);
           $ret->TaskID = localize($loop_0->output().$loopdata);
           
           $loop   = new Template($this->viewroot, $leftcontent->returnloop("loop_users"));
           $loop_0 = new Template($this->viewroot, $leftcontent->returnloop("loop_users_0"));
           $list = $this->model->getUsersList($params);
           $loopdata = $this->fillList($list, $loop, 0);
           $ret->UserID = localize($loop_0->output().$loopdata);
           
           $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_placenames"));
           $list = $this->model->getPlaceNames(0,0,0,$json->value);
 //          ajax_echo_r ($list);
           $loopdata = $this->fillList($list, $loop, 0);
 //          $leftcontent->fillloop('loop_placenames', $loopdata);
           $ret->PlaceName = localize($loopdata);
           
           $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_placetypes"));
           $list = $this->model->getPlaceTypes(0,0,0,$json->value);
 //          ajax_echo_r ($list);
           $loopdata = $this->fillList($list, $loop, 0);
 //          $leftcontent->fillloop('loop_placetypes', $loopdata);
           $ret->PlaceType = localize($loopdata);
          break;
          
          case ('ParentName'):
           $leftcontent = new Template($this->viewroot, 'editor_assessments.htt');                                      // load common parent template
           
           $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_parents"));
           $list = $this->model->getAssessmentsParentObjects($json->value);
 //          ajax_echo_r ($list);
           $loopdata = $this->fillList($list, $loop, 0);
 //          $leftcontent->fillloop('loop_placetypes', $loopdata);
           $ret->ParentID = " ".localize($loopdata);
          break;
          
          
         }
         
 //        setcache('test', $ret);
         
         echo json_encode($ret);
        break;
        
        
        
        
        
        
        case ('newOffer'):
 //        ajax_echo_r ($json);
         if ($json->ID) {
          $rec = $this->model->getOffer($json->ID);
         } else {
          $rec = new stdClass;
          $rec->TypeID=1;
         }
 //        ajax_echo_r ($rec);
         
         $leftcontent = new Template($this->viewroot, "left_offers.htt");
         $leftcontent->loadloop('block_popupdefault','');
         
         /*
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_typeids"));
         $list = $this->model->getList('moneyrecordtypes');
 //        ajax_echo_r ($list);
 //        ajax_echo_r ($rec);
         $loopdata = $this->fillList($list, $loop, $rec->TypeID);
         $leftcontent->fillloop('loop_typeids', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_groupids"));
         $list = $this->model->getExpenditureGroups($rec->TypeID);
 //         ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, $rec->GroupID);
         $leftcontent->fillloop('loop_groupids', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_months"));
         $list = $this->model->getMonths('money','DateAdded');
         $loopdata = $this->fillList($list, $loop, 0);
         $leftcontent->fillloop('loop_months', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_clubs"));
         $list = $this->model->getClubs();
         $loopdata = $this->fillList($list, $loop, $rec->ClubID);
         $leftcontent->fillloop('loop_clubs', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_placenames"));
         $list = $this->model->getPlaceNames($rec->TypeID);
         $loopdata = $this->fillList($list, $loop, $rec->PlaceName, "PlaceName");
         $leftcontent->fillloop('loop_placenames', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_placetypes"));
         $list = $this->model->getPlaceTypes($rec->TypeID);
         $loopdata = $this->fillList($list, $loop, $rec->PlaceType, "PlaceType");
         $leftcontent->fillloop('loop_placetypes', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_accounts"));
         $list = $this->model->getListOrdered('accounts', 'ID');
         $loopdata = $this->fillList($list, $loop, $rec->AccountID);
         $leftcontent->fillloop('loop_accounts', $loopdata);
         
         $leftcontent->fillloop('block_sameRecords', '');
         
         */
         
         
 //        $leftcontent
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , $rec->$var);
          }
         }
         
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         $leftcontent->processfcb('');
         ajax_echo (localize($leftcontent->output()));
        break;
        
        case ('addOffer'):
         $ret = new stdClass;
         
         $json->UserID = $userid;
         
         if ($this->model->addOffer($json)) {
          $ret->message = $this->getMessage('addmoney_success');
          $ret->result = 1;
         } else {
          $ret->message = $this->getMessage('addmoney_error_unknown');
          $ret->result = 0;
         }
         echo json_encode($ret);
         
        break;
        
        case ('deleteOffer'):
         $this->model->deleteOffer($json);
        break;
        
        
        
        
        
        
        
        
        case ('sendSmses'):
         include_once("model/transport.php");       // connect to the Settings 
         $api = new Transport($this->settings);
         
         $json->MaxCost = 2;
         
 //        ajax_echo_r ($json);
         $smses = $this->model->getSmses($json);
         
 //        ajax_echo_r ($smses);
         
         foreach ($smses as $sms) {
          ajax_echo_r ($smses);
          $params  = array(
           "text"         => $sms->Text,
           "source"       => "Acceleration",
           "onlydelivery" => 1,
           "smsid"        => $sms->ID,
           "action"       => "check"
          );
          
          $phones  = array($sms->PhoneNumber);
          
          ajax_echo_r ($params);
 //         ajax_echo_r ($phones);
          
          $send = $api->send($params,$phones);
          
 //         ajax_echo_r ($send);
          if ($send['priceOfSending'] && ((float)$send['priceOfSending']<$json->MaxCost)) {
           
           $params  = array(
            "text"         => $sms->Text,
            "source"       => "Acceleration",
            "onlydelivery" => 1,
            "smsid"        => $sms->ID,
            "action"       => "send"
           );
           
           $send = $api->send($params,$phones);
           ajax_echo_r ($send);
           
           
           
           
          }
          
          
          if ($send['priceOfSending']) {
           $sms->Cost = $send['priceOfSending'];
           if ($params['action']=='send') {
            $sms->StatusID = $send['code'];
           }
           $ret = $this->model->addSms($sms);
          }
          
          if ($send['code'] == 1) {
       //    echo 'Отправлено '.$send['colSendAbonent'].', не отправлено';
          } else {
       //    echo $send['descr'];
          }
          
          echo "<hr>";
          
         }
         
         
        break;
        
        case ('preparePhones'):
         $users = $this->model->prepareUsersSmsAll($json);
        break;
        
        case ('newSmses'):
         setcache('newSmses', $json);
         ajax_echo_r ($json);
         
         $Campaign = $this->model->getVKCampaign($json->CampaignID);
 //        ajax_echo_r ($Campaign);
         
         $Offer = $this->model->getOffer($json->OfferID);
 //        ajax_echo_r ($Offer);
         
 //        $users = $this->model->prepareUsersSmsAll($json);
         
         $users = $this->model->getUsersSms($json);
         
         $smses = array();
         
         foreach ($users as $item) {
          $params = new stdClass;
          $params->UserID         = $userid;
          $params->CampaignID     = $json->CampaignID;
          $params->OfferID        = $json->OfferID;
          $params->ParentName     = "vk_users".$Campaign->Suffix;
          $params->ParentID       = $item->ID;
          $params->PhoneNumber    = $item->Phone1;
          $params->StatusID       = -2;  // not sent
//          $params->DateAdded      = date('Y-m-d H:i:s');
          
          
          $txt = new Template($this->viewroot, $Offer->Text);
          $vars = $txt->getVariables();
          
          foreach ($vars as $var) {
           if ($var) {
            $txt->fill(       "%".$var."%" , $item->$var);
           }
          }
          
          $params->Text           = $txt->Output();
          
 //         ajax_echo_r ($params);
          
          $ret = $this->model->addSms($params);
          
          $smses[] = $params;
         }
         
         
 //        ajax_echo_r ($users);
         
         return;
         
 //        ajax_echo_r ($json);
         if ($json->ID) {
          $rec = $this->model->newSmses($json->ID);
         } else {
          $rec = new stdClass;
          $rec->TypeID=1;
         }
 //        ajax_echo_r ($rec);
         
         $leftcontent = new Template($this->viewroot, "left_smses.htt");
         $leftcontent->loadloop('block_popupdefault','');
         
         /*
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_typeids"));
         $list = $this->model->getList('moneyrecordtypes');
 //        ajax_echo_r ($list);
 //        ajax_echo_r ($rec);
         $loopdata = $this->fillList($list, $loop, $rec->TypeID);
         $leftcontent->fillloop('loop_typeids', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_groupids"));
         $list = $this->model->getExpenditureGroups($rec->TypeID);
 //         ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, $rec->GroupID);
         $leftcontent->fillloop('loop_groupids', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_months"));
         $list = $this->model->getMonths('money','DateAdded');
         $loopdata = $this->fillList($list, $loop, 0);
         $leftcontent->fillloop('loop_months', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_clubs"));
         $list = $this->model->getClubs();
         $loopdata = $this->fillList($list, $loop, $rec->ClubID);
         $leftcontent->fillloop('loop_clubs', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_placenames"));
         $list = $this->model->getPlaceNames($rec->TypeID);
         $loopdata = $this->fillList($list, $loop, $rec->PlaceName, "PlaceName");
         $leftcontent->fillloop('loop_placenames', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_placetypes"));
         $list = $this->model->getPlaceTypes($rec->TypeID);
         $loopdata = $this->fillList($list, $loop, $rec->PlaceType, "PlaceType");
         $leftcontent->fillloop('loop_placetypes', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_accounts"));
         $list = $this->model->getListOrdered('accounts', 'ID');
         $loopdata = $this->fillList($list, $loop, $rec->AccountID);
         $leftcontent->fillloop('loop_accounts', $loopdata);
         
         $leftcontent->fillloop('block_sameRecords', '');
         
         */
         
         
 //        $leftcontent
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , $rec->$var);
          }
         }
         
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         $leftcontent->processfcb('');
         ajax_echo (localize($leftcontent->output()));
        break;
        
        
        
        
        
        case ('newMoney'):
//         ajax_echo_r ($json);
         if ($json->ID>0) {
          $rec = $this->model->getMoney($json->ID);
         } else {
          $rec = new stdClass;
          
          $keys = array('TypeID', 'GroupID', 'ClubID', 'UserID', 'Value');
          
          $rec->TypeID = 1;
          $rec->ClubID = 1;
          $rec->UserID = 1;
          
          foreach ($keys as $key) {
           if ($json->$key > 0) {
            $rec->$key = $json->$key;
           } else {
 //           $rec->$key = 1;
           }
          }
          
          if (!$rec->TypeID) $rec->TypeID = 1;
          
          if ($rec->ClubID) {
           $flt = new stdClass;
           $flt->ClubID     = $rec->ClubID;
           $flt->TypeID     = $rec->TypeID;
           $mon = $this->model->getMoneyTemplate($flt);
           if ($mon) {
            $rec->PlaceName = $mon->PlaceName;
            $rec->PlaceType = $mon->PlaceType;
            $rec->UserID    = $mon->UserID;
           }
          }
          
 //         ajax_echo_r ($rec);
 //         ajax_echo_r ($mon);
          $rec->AccountID = 2;
          
//          ajax_echo_r ($json);
          if ($json->moneyParser) {            // try to parse
           $buf = $json->moneyParser;
           $buf = unfilter($buf);
           $buf = strrevprepare($buf);
           
           $ar = preg_split('/\R/', $buf);
 //          $ar = explode('\n', $buf);
           
//           ajax_echo_r ($ar);
           
           $parser = array();
           
           foreach ($ar as $v) {
            $v = strprepare($v);
            
 //           $v = "Наименование:";
//            echo $v."<br>".strpos($v, ":")."<br>";
            
            if (strpos($v, ":")) {
             $k = trim($v);
            } elseif ($k && trim($v)) {
             $parser[$k] = trim($v);
//             echo $k.": ".$v."<br>";
             $k = '';
            }
            
            
           }
           
//           ajax_echo_r ($parser);
           
           foreach ($parser as $k=>$v) {
//            echo $k."-";
            switch (trim($k)) {
             case ("Наименование:"):
              $rec->Content = $v;
             break;
             case ("Номер телефона:"):
              $rec->Content .= " +7".trim($v);
              
              $rec->GroupID = 6;
              $rec->ClubID = 3;
              $rec->TypeID = 2;
              $rec->PlaceType = "Услуги связи";
             break;
             case ("Сумма в валюте списания:"):
             case ("Сумма платежа:"):
             case ("Сумма:"):
             case ("Комиссия:"):
              $v = str_replace( ",00", "", $v);
              $v = str_replace("руб.", "", $v);
              $v = str_replace(   " ", "", $v);
              $rec->Value = trim($v);
             break;
             case ("Счет списания:"):
              $pos1 = strpos($v, " ")+1;
              $pos2 = strpos($v, " ", $pos1);
              
              $buf = trim(substr($v, $pos1, $pos2-$pos1));
 //             echo $pos1."-".$pos2."-".$buf;
              
              switch ($buf) {
               case ("3243"):
                $rec->AccountID = 2;
               break;
              }
             break;
             case ("Номер карты получателя:"):
              $v .= " ";
              $pos1 = strpos($v, " ")+1;
              $pos2 = strpos($v, " ", $pos1);
 //             if (!$pos2) $pos2 = strlen($v);
              
              $buf = trim(substr($v, $pos1, $pos2-$pos1));
//              echo $pos1."-".$pos2."-".$buf."<br>";
              
              if ($buf) {
               if (!$search) $search = new stdClass;
               $search->cardNum = trim($buf);
              } else {
               if (!$search) $search = new stdClass;
               $search->cardNum = trim($v);
              }
              
              $rec->GroupID = 6;
              $rec->TypeID = 2;
             break;
             case ("Номер счета:"):
              if (!$search) $search = new stdClass;
              $search->cardNum = trim($v);
             break;
             case ("ФИО:"):
              $rec->Content = trim($v);
              
              $v .= " ";
              $pos1 = strpos($v, " ");
 //             $pos2 = strpos($v, " ", $pos1);
 //             if (!$pos2) $pos2 = strlen($v);
              
              $buf = trim(substr($v, 0, $pos1));
 //             echo $pos1."-".$pos2."-".$buf."<br>";
              
              if ($buf) {
               if (!$search) {
                $search = new stdClass;
                $search->Firstname = trim($buf);
               }
              }
              
             break;
             
            }
            
           }
           
//           ajax_echo_r ($search);
           
           if ($search) {
            $usr = $this->model->findUser($search);
//            ajax_echo_r ($usr);
            if ($usr) {
             $rec->UserID = $usr->ID;
             $rec->PlaceName = "Salary - ".$usr->Username;
             $rec->PlaceType = "Частное лицо";
             $rec->GroupID = 3;
             $rec->ClubID = 3;
             $rec->TypeID = 2;
            }
           }
          }
         }
         
 //        ajax_echo_r ($rec);
         
         
         $leftcontent = new Template($this->viewroot, "editor_money.htt");
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_typeids"));
         $list = $this->model->getList('moneyrecordtypes');
 //        ajax_echo_r ($list);
 //        ajax_echo_r ($rec);
         $loopdata = $this->fillList($list, $loop, $rec->TypeID);
         $leftcontent->fillloop('loop_typeids', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_valutes"));
         $list = $this->model->getCurr(true);
//         ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, $rec->TypeID);
         $leftcontent->fillloop('loop_valutes', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_users"));
         $list = $this->model->getUsersList($rec);
         $loopdata = $this->fillList($list, $loop, $rec->UserID);
         $leftcontent->fillloop('loop_users', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_groupids"));
         $list = $this->model->getExpenditureGroups($rec->TypeID);
 //         ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, $rec->GroupID);
         $leftcontent->fillloop('loop_groupids', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_tasks"));
         $list = $this->model->getListTasks($rec);
         $loopdata = $this->fillList($list, $loop, $rec->TaskID);
         $leftcontent->fillloop('loop_tasks', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_clubs"));
         $params = new stdClass;
         $params->AndID = $rec->ClubID;
         $list = $this->model->getClubs($params);
         
         if ($list[$rec->ClubID]) {
 //         echo "test123<br>";
         }
         
 //        echo $rec->ClubID;
 //        ajax_echo_r ($list);
         
         $loopdata = $this->fillList($list, $loop, $rec->ClubID);
         $leftcontent->fillloop('loop_clubs', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_placenames"));
         $list = $this->model->getPlaceNames($rec->TypeID);
         $loopdata = $this->fillList($list, $loop, $rec->PlaceName, "PlaceName");
         $leftcontent->fillloop('loop_placenames', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_placetypes"));
         $list = $this->model->getPlaceTypes($rec->TypeID);
         $loopdata = $this->fillList($list, $loop, $rec->PlaceType, "PlaceType");
         $leftcontent->fillloop('loop_placetypes', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_accounts"));
         $list = $this->model->getListOrdered('accounts', 'ID');
         $loopdata = $this->fillList($list, $loop, $rec->AccountID);
         $leftcontent->fillloop('loop_accounts', $loopdata);
         
         $leftcontent->fillloop('block_sameRecords', '');
         
         
         
 //        $leftcontent
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , $rec->$var);
          }
         }
         
         $leftcontent->removeloop(  'loop_users_0' );
         $leftcontent->removeloop(  'loop_tasks_0' );
         
         $leftcontent->processfcb('');
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         ajax_echo (localize($leftcontent->output()));
        break;
        
        case ('addMoney'):
         $ret = new stdClass;
 //        if (date_create($json->DateAdded)) {
 //         ajax_echo_r (date_create($json->DateAdded));
 //         echo "test: ".(date_format(date_create($json->DateAdded), 'Y'));
 //        }
         
 //        return 1;
         if (floatval($json->Value)<=0) {
          $ret->message = $this->getMessage('addmoney_error_novalue');
          $ret->result = 0;
         } elseif ((date_create($json->DateAdded)) && ((int)date_format(date_create($json->DateAdded), 'Y')<1985)) {
          $ret->message = $this->getMessage('addmoney_error_nodate');
          $ret->result = 0;
         } else {
          if ($json->Value) $json->Value = str_replace(" ", "", $json->Value);
          if ($this->model->addMoney($json)) {
           $ret->message = $this->getMessage('addmoney_success');
           $ret->result = 1;
          } else {
           $ret->message = $this->getMessage('addmoney_error_unknown');
           $ret->result = 0;
          }
         }
         echo json_encode($ret);
         
        break;
        
        case ('deleteMoney'):
         $this->model->deleteMoney($json);
        break;
        
        
        
        
        
        
        case ('newMetric'):
 //        ajax_echo_r ($json);
         if ($json->ID) {
          $rec = $this->model->getMetric($json->ID);
         } else {
          $rec = new stdClass;
          $rec->SubjectID = 0;
 //        ajax_echo_r ($rec);
         }
         
         $leftcontent = new Template($this->viewroot, "editor_family.htt");
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_children"));
         $list = $this->model->getList('children');
 //        ajax_echo_r ($list);
 //        ajax_echo_r ($rec);
         $loopdata = $this->fillList($list, $loop, $rec->TypeID);
         $leftcontent->fillloop('loop_children', $loopdata);
         
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , $rec->$var);
          }
         }
         
         $leftcontent->processfcb('');
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         ajax_echo (localize($leftcontent->output()));
        break;
        
        case ('addMetric'):
         $ret = new stdClass;
         
 //        echo "test";
 //        ajax_echo_r ($json);
 //        echo floatval($json->Weight);
         
         if (floatval($json->Weight)<=0) {
          $ret->message = $this->getMessage('addmoney_error_novalue');
          $ret->result = 0;
         } else {
          if ($this->model->addMetric($json)) {
           $ret->message = $this->getMessage('addmoney_success');
           $ret->result = 1;
          } else {
           $ret->message = $this->getMessage('addmoney_error_unknown');
           $ret->result = 0;
          }
         }
         echo json_encode($ret);
         
        break;
        
        case ('deleteMetric'):
         $this->model->deleteMetric($json);
        break;
        
        
        
        
        
        
        
        case ('newAssessment'):
 //        ajax_echo_r ($json);
         if ($json->ID) {
          $rec = $this->model->getAssessment($json->ID);
         } else {
          $lastAss = $this->model->getLastAssessment();
          
          $rec = new stdClass;
          $rec->ParentName = 'clubs';
          $rec->Limit = $lastAss->Limit;
          $rec->Query = $lastAss->Query;
          $rec->SendersEmail = 'main@cfteam.ru';
          $rec->ID = '';
          $rec->DateAdded = '';
          $rec->DateClosed = '';
          $rec->Task = '';
          
//          ajax_echo_r ($lastAss);
          
 //        ajax_echo_r ($rec);
         }
         
         $leftcontent = new Template($this->viewroot, "editor_assessments.htt");
         $leftcontent->fillloop('block_tagssuggest','');
         $leftcontent->fillloop('block_findWorkers','');
         $leftcontent->fillloop('block_tag','');
         
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_parents"));
         $list = $this->model->getAssessmentsParentObjects($rec->ParentName);
 //        ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, $rec->ParentID);
         $leftcontent->fillloop('loop_parents', $loopdata);
         
//         $vars = $leftcontent->getVariables();
         
         foreach ($rec as $k=>$v) {
          $leftcontent->fill(       "%".$k."%" , $v);
         }
         
         $leftcontent->processfcb('');
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         ajax_echo (localize($leftcontent->output()));
        break;
        
        case ('addAssessment'):
         $ret = new stdClass;
         
 //        echo "test";
 //        ajax_echo_r ($json);
 //        echo floatval($json->Weight);
         
         if (!$json->Query) {
          $ret->message = $this->getMessage('addassessment_error_noquery');
          $ret->result = 0;
         } else {
          $json->Query = unfilter($json->Query);
          $json->Task  = unfilter($json->Task );
          if ($this->model->addAssessment($json)) {
           $ret->message = $this->getMessage('addmoney_success');
           $ret->result = 1;
          } else {
           $ret->message = $this->getMessage('addmoney_error_unknown');
           $ret->result = 0;
          }
         }
         echo json_encode($ret);
         
        break;
        
        case ('deleteAssessment'):
         $this->model->deleteAssessment($json);
        break;
        
        
        
        
        case ('newClub'):
//         ajax_echo_r ($json);
         if ($json->ID) {
          $rec = $this->model->getClub($json->ID);
         } else {
          $rec = new stdClass;
          $rec->AssignedToID = $this->userid;
 //         $rec->ParentName = 'clubs';
         }
 //        ajax_echo_r ($rec);
         
         if ($rec->ID) {
          $rec->files_cnt   = $this->getFilesCount($rec);
          $data = clone $rec;
          $data->ParentName = 'clubs';
          $data->ParentID   = $rec->ID;
          $rec->touches_cnt = $this->getStatusesCount($data);
          $rec->talk_cnt    = $this->getMessagesCount($data);
//          $rec->ass_cnt     = $this->model->getBetsCount($data);
//          $rec = $this->model->getClubEntities($rec);
         }
         
         if ($rec->Description) $rec->Description=unfilter($rec->Description);
         
         $leftcontent = new Template($this->viewroot, "editor_clubs.htt");
         
         $keys = array('main', 'conversation', 'files', 'statuses', 'talk', 'assessment');
         if ($json->Tab=='undefined') $json->Tab = 'main';
         if (!$json->Tab)             $json->Tab = 'main';
         
         foreach ($keys as $k) {
          $leftcontent->fill('%tab_'.$k.'_Active%', ($json->Tab==$k)?'Active':'');
         }
         
         $leftcontent->fillloop('block_tag','');
         $leftcontent->fillloop('block_tagssuggest','');
         $leftcontent->fillloop('block_findWorkers','');
         
         $leftcontent->fill(  '%imgfolder%', $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%', $this->viewroot                     );
         
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("block_AssignedToID"));
         $list=$this->model->getUsersList($rec);
         $loopdata = $this->fillList($list, $loop, $rec->AssignedToID);
         $leftcontent->fillloop('block_AssignedToID', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("block_SourceID"));
         $list=$this->model->getUsersSources();
         $loopdata = $this->fillList($list, $loop, $rec->SourceID);
         $leftcontent->fillloop('block_SourceID', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("block_ParentID"));
         $list=$this->model->getClubs();
 //        $list=$this->model->getList('clubs');
         $loopdata = $this->fillList($list, $loop, $rec->ParentID);
         $leftcontent->fillloop('block_ParentID', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("block_StatusID"));
         $list=$this->model->getList('club_statuses');
 //        $list=$this->model->getList('clubs');
         $loopdata = $this->fillList($list, $loop, $rec->StatusID);
         $leftcontent->fillloop('block_StatusID', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("block_StageID"));
         $list=$this->model->getList('stages');
 //        $list=$this->model->getList('clubs');
         $loopdata = $this->fillList($list, $loop, $rec->StageID);
         $leftcontent->fillloop('block_StageID', $loopdata);
         
//         ajax_echo_r ($this->user);
         if ($this->user->IsHead) {
          $req = new stdClass;
          $req->PartnersOnly = 1;
          $req->UserID = $this->userid;
          $list=$this->model->getUsersList($req);
         } else {
          $list = array();
          $list[$this->userid] = $this->user;
         }
         $loop = new Template($this->viewroot, $leftcontent->returnloop("block_betUsers"));
//         ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, $this->userid);
         $leftcontent->fillloop('block_betUsers', $loopdata);
         
//         ajax_echo_r ($this->user);
         $Comment = getsecurevariable('Comment_clubs_'.$json->ID);
         if ($Comment=='-1') $Comment='';
         
         $leftcontent->fill(       "%User_Firstname%" , $this->user->Firstname       );
         $leftcontent->fill(       "%User_Lastname%"  , $this->user->Lastname        );
         $leftcontent->fill(       "%Comment%"        , $Comment                     );
         
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , $rec->$var);
          }
         }
         
         $leftcontent->processfcb('');
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         ajax_echo (localize($leftcontent->output()));
        break;
        
        case ('addClub'):
         $ret = new stdClass;
         
 //        echo "test";
 //        ajax_echo_r ($json);
 //        echo floatval($json->Weight);
         
         if (!$json->Address) {
          $ret->message = $this->getMessage('addclub_error_noaddress');
          $ret->result = 0;
         } else {
          $r = $this->model->addClub($json);
          if ($r->success) {
           $ret->message = $this->getMessage('addmoney_success');
           $ret->result = 1;
           $ret->ID = $r->lastInsertID;
           $ret->FolderName = $r->FolderName;
           $ret->ShortTitle = $r->ShortTitle;
          } else {
           $ret->message = $this->getMessage('addmoney_error_unknown');
           $ret->result = 0;
          }
         }
         echo json_encode($ret);
         
        break;
        
        case ('deleteClub'):
         $this->model->deleteClub($json);
        break;
        
        
        
        
        
        
        
        
        
        
        case ('setStatusVKUser'):
         ajax_echo_r ($json);
         
         $ret =  $this->model->addVKUser($json);
         
         ajax_echo_r ($ret);
         
        break;
        
        
        
        case ('newVKUser'):
 //        ajax_echo_r ($json);
         if ($json->ID) {
          $rec = $this->model->getVKUser($json);
         } else {
          $rec = new stdClass;
          $rec->TypeID=1;
         }
 //        ajax_echo_r ($rec);
         
         $leftcontent = new Template($this->viewroot, "editor_vkusers.htt");
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         
         /*
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_accounts"));
         $list = $this->model->getListOrdered('accounts', 'ID');
         $loopdata = $this->fillList($list, $loop, $rec->AccountID);
         $leftcontent->fillloop('loop_accounts', $loopdata);
         
         $leftcontent->fillloop('block_sameRecords', '');
         */
         
         $loop_table_row = new Template($this->viewroot, $leftcontent->returnloop('loop_table_row'));
         
 //              ajax_echo_r ($table[1]);
         $keys = array();
         /*
         $keys[] = 'FollowersCount';
         $keys[] = 'FriendsCount';
         $keys[] = 'AlbumsCount';
         $keys[] = 'VideosCount';
         $keys[] = 'AudiosCount';
         $keys[] = 'NotesCount';
         $keys[] = 'PhotosCount';
         $keys[] = 'SubscriptionsCount';
         $keys[] = 'PagesCount';
         */
         $keys[] = 'ActivityIndex';
         $keys[] = 'ContentIndex';
         $keys[] = 'RelationsIndex';
         
         $keys[] = 'Skype';
         $keys[] = 'Twitter';
         $keys[] = 'Instagram';
         $keys[] = 'Facebook';
         $keys[] = 'PhoneMobile';
         $keys[] = 'PhoneHome';
         $keys[] = 'Site';
         
         $keys[] = 'LastSeenTime';
         $keys[] = 'DateBirth';
         $keys[] = 'HomeTown';
         $keys[] = 'CityID';
         
         foreach ($keys as $k) {
          $v = $rec->$k;
          if ($v) {
           $loop_table_row->reload();
           $loop_table_row->fill("%c%",  $c%2);
           $loop_table_row->fill("%Cat%", $k);
           $loop_table_row->fill("%Cnt%", $v);
           
           $thistable.=$loop_table_row->output();
          }
          $c++;
         }
         
         $leftcontent->fillloop('loop_table_row',$thistable);
         
         
         
         
         
         
         $params = new stdClass;
         $params->ParentID = $json->ID;
         if (!$params->ParentID) $params->ParentID = -1;
         $params->ParentName = 'vkusers';
 //        ajax_echo_r ($params);
         $sta = $this->fillStatuses($params);
         $leftcontent->fillloop("block_statuses"      , $sta);
         
 //        ajax_echo_r ($rec);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_peoplesources"));
         $list = $this->model->getList('peoplesources');
 //        ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, $rec->SourceID);
         $leftcontent->fillloop('loop_peoplesources', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_statustypes"));
         $list = $this->model->getList('statustypes');
 //        ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, 0);
         $leftcontent->fillloop('loop_statustypes', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_clubs"));
         $list = $this->model->getClubs();
         $loopdata = $this->fillList($list, $loop, $rec->ClubID);
         $leftcontent->fillloop('loop_clubs', $loopdata);
         
         
         $leftcontent->fill(       "%Suffix%" , $json->Suffix);
         
         
         
         
         
         
         
         
         
         
         
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , brtonl($rec->$var));
          }
         }
         
         $leftcontent->processfcb('');
         
         ajax_echo (localize($leftcontent->output()));
        break;
        
        case ('addVKUser'):
         $ret = new stdClass;
         
         if ($this->model->addVKUser($json)) {
          $ret->message = $this->getMessage('addmoney_success');
          $ret->result = 1;
         } else {
          $ret->message = $this->getMessage('addmoney_error_unknown');
          $ret->result = 0;
         }
         echo json_encode($ret);
         
        break;
        
        
        
        
        
        
        
        
        
        
        case ('newFreelancer'):
 //        ajax_echo_r ($json);
         if ($json->ID) {
          $rec = $this->model->getFreelancer($json);
         } else {
          $rec = new stdClass;
          $rec->TypeID=1;
         }
 //        ajax_echo_r ($rec);
         
         $leftcontent = new Template($this->viewroot, "editor_freelancers.htt");
         $leftcontent->fillloop('block_tag','');
         $leftcontent->fillloop('block_tagssuggest','');
         
         
         /*
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_accounts"));
         $list = $this->model->getListOrdered('accounts', 'ID');
         $loopdata = $this->fillList($list, $loop, $rec->AccountID);
         $leftcontent->fillloop('loop_accounts', $loopdata);
         
         $leftcontent->fillloop('block_sameRecords', '');
         */
         
         
//         $loop_table_row = new Template($this->viewroot, $leftcontent->returnloop('loop_table_row'));
         
 //              ajax_echo_r ($table[1]);
         $keys = array();
         /*
         $keys[] = 'FollowersCount';
         $keys[] = 'FriendsCount';
         $keys[] = 'AlbumsCount';
         $keys[] = 'VideosCount';
         $keys[] = 'AudiosCount';
         $keys[] = 'NotesCount';
         $keys[] = 'PhotosCount';
         $keys[] = 'SubscriptionsCount';
         $keys[] = 'PagesCount';
         */
         $keys[] = 'ActivityIndex';
         $keys[] = 'ContentIndex';
         $keys[] = 'RelationsIndex';
         
         $keys[] = 'Skype';
         $keys[] = 'Twitter';
         $keys[] = 'Instagram';
         $keys[] = 'Facebook';
         $keys[] = 'PhoneMobile';
         $keys[] = 'PhoneHome';
         $keys[] = 'Site';
         
         $keys[] = 'LastSeenTime';
         $keys[] = 'DateBirth';
         $keys[] = 'HomeTown';
         $keys[] = 'CityID';
         
         /*
         foreach ($keys as $k) {
          $v = $rec->$k;
          if ($v) {
           $loop_table_row->reload();
           $loop_table_row->fill("%c%",  $c%2);
           $loop_table_row->fill("%Cat%", $k);
           $loop_table_row->fill("%Cnt%", $v);
           
           $thistable.=$loop_table_row->output();
          }
          $c++;
         }
         
         $leftcontent->fillloop('loop_table_row',$thistable);
         
         */
         
         
         
         
         $params = new stdClass;
         $params->ParentID = $json->ID;
         if (!$params->ParentID) $params->ParentID = -1;
         $params->ParentName = 'vkusers';
 //        ajax_echo_r ($params);
         $sta = $this->fillStatuses($params);
         $leftcontent->fillloop("block_statuses"      , $sta);
         
 //        ajax_echo_r ($rec);
         
         /*
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_peoplesources"));
         $list = $this->model->getList('peoplesources');
 //        ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, $rec->SourceID);
         $leftcontent->fillloop('loop_peoplesources', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_statustypes"));
         $list = $this->model->getList('statustypes');
 //        ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, 0);
         $leftcontent->fillloop('loop_statustypes', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_clubs"));
         $list = $this->model->getClubs();
         $loopdata = $this->fillList($list, $loop, $rec->ClubID);
         $leftcontent->fillloop('loop_clubs', $loopdata);
         */
         
         $leftcontent->fill(       "%Suffix%" , $json->Suffix);
         
         
         
         
         
         
         
         
         
         
         
         
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , brtonl($rec->$var));
          }
         }
         
         $leftcontent->processfcb('');
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         
         ajax_echo (localize($leftcontent->output()));
        break;
        
        case ('addFreelancer'):
         $ret = new stdClass;
         
 //        ajax_echo_r ($json);
         
 //        die();
         if ($this->model->addFreelancer($json)) {
          $ret->message = $this->getMessage('addmoney_success');
          $ret->result = 1;
         } else {
          $ret->message = $this->getMessage('addmoney_error_unknown');
          $ret->result = 0;
         }
         echo json_encode($ret);
        break;
        
        
        case ('getTagsSuggest'):
 //        ajax_echo_r ($json);
         $tags = $this->model->getTagsSuggest($json);
 //        ajax_echo_r ($tags);
         
         
         $leftcontent = new Template($this->viewroot, "editor_freelancers.htt");
         $leftcontent->loadloop('block_tagssuggest');
         
         $vars = $leftcontent->getVariables();
         
         foreach ($tags as $tag) {
          $leftcontent->reload();
          $leftcontent->processfcb('');
          $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
          $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
          foreach ($vars as $var) {
           if ($var) {
            $leftcontent->fill(       "%".$var."%" , brtonl($tag->$var));
           }
          }
          $tags_str .= $leftcontent->output();
         }
         
         ajax_echo (localize($tags_str));
        break;
        
        case ('getTags'):
 //        ajax_echo_r ($json);
         $tags = $this->model->getTags($json);
 //        ajax_echo_r ($tags);
         
         
         $leftcontent = new Template($this->viewroot, "editor_".$json->ParentName.".htt");
         $leftcontent->loadloop('block_tag');
         
         $vars = $leftcontent->getVariables();
         
         if ($tags) {
          foreach ($tags as $tag) {
           $leftcontent->reload();
           foreach ($vars as $var) {
            if ($var) {
             $leftcontent->fill(       "%".$var."%" , brtonl($tag->$var));
            }
           }
           $leftcontent->processfcb('');
           $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
           $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
           $tags_str .= $leftcontent->output();
          }
         }
         
         ajax_echo (localize($tags_str));
        break;
        
        case ('addTag'):
         if ($json->ParentID) {
          $ret = $this->model->addTag($json);
//          return $ret;
         } else {
          echo localize($this->getMessage('addtag_error_noparent'));;
         }
        break;
        case ('removeTag'):
         $ret = $this->model->removeTag($json);
         return $ret;
        break;
        
        case ('tagSaveValue'):
 //        ajax_echo_r ($json);
         $ret = $this->model->tagSaveValue($json);
         
         if ($ret->rowsAffected>0) echo "Tag saved";
 //        ajax_echo_r($ret);
         
        break;
        
        case ('findWorkers'):
//         ajax_echo_r ($json);
         $tags = $this->model->getTags($json);
 //        ajax_echo_r ($tags);
         
         if (sizeof($tags)) {
          $workers = $this->model->getWorkers($tags);
  //        ajax_echo_r ($workers);
          
          $leftcontent = new Template($this->viewroot, "editor_clubs.htt");
          $leftcontent->loadloop('block_findWorkers');
          
          $leftcontent->processfcb('');
          $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
          $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
          
          foreach ($workers as $item) {
           if ($item->Email) {
            $count_email++;
           }
          }
          
          $leftcontent->fill(      '%count_all%' , sizeof($workers)                    );
          $leftcontent->fill('%count_all_email%' , $count_email                        );
          
          $ids = $this->model->getEmailsFLIDs($json);
          $ids = array_flip($ids);
 //         ajax_echo_r ($ids);
          
 //         echo sizeof($workers)."-";
 //         echo sizeof($ids)."-";
          $workers = array_diff_key($workers, $ids);
 //         echo sizeof($workers)."-";
          
 //         ajax_echo_r ($workers);
          
 //         die();
          $count_email = 0;
          $ids = "";
          
          foreach ($workers as $item) {
           if ($item->Skype) {
            if ($logins) $logins.="|";
            $logins .=$item->Skype;
           }
           if ($item->Email) {
            if ($emails) $emails.="|";
            $emails .=$item->Firstname.";".$item->Email.";".$item->Source.";".$item->ID;
            $count_email++;
           }
           if ($ids) $ids.="|";
           $ids .= $item->ID;
          }
 //         die($ids);
          
          $leftcontent->fill(          '%count%' , sizeof($workers)                    );
          $leftcontent->fill(    '%count_email%' , $count_email                        );
          
          $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_findWorkers"));
          $loopdata = $this->fillList($workers, $loop, 0);
          $leftcontent->fillloop('loop_findWorkers', $loopdata);
          
          $leftcontent->fill( "%emails%", $emails  );
          $leftcontent->fill(  "%Skype%", $logins  );
          $leftcontent->fill( "%flsIDs%", $ids     );
          
          ajax_echo (localize($leftcontent->output()));
         } else {
          echo localize($this->getMessage('findWorkers_error_notags'));
         }
        break;
        
        case ('sendInvites'):
//         ajax_echo_r ($json);
         
         if (!$json->IDs) $json->IDs = 60438; // arag's FL id
         
         $ret = $this->model->sendInvites($json);
         ajax_echo_r ($ret);
        break;
        
        
        
        
        
        case ('newUser'):
         $leftcontent = new Template($this->viewroot, "editor_users.htt");
         
         $keys = array('main', 'conversation', 'activities', 'classes', 'wishes');
         if ($json->Tab=='undefined') $json->Tab = 'main';
         if (!$json->Tab)             $json->Tab = 'main';
         
         foreach ($keys as $k) {
          $leftcontent->fill('%tab_'.$k.'_Active%', ($json->Tab==$k)?'Active':'');
          $leftcontent->fill('%tab_'.$k.'_Hidden%', ($json->Tab==$k)?'':'hidden');
         }
         
         
         if ($this->user->GroupID==1) {
          $leftcontent->removeloop('block_adminonly2');
         } else {
          $leftcontent->fillloop('block_adminonly2','');
         }
         
         if ($json->ID>0) {     // -1 - common, -2 - student, -3 - teacher
          $rec = $this->model->getUser($json->ID);
          $leftcontent->fill('%hidden%', '');
         } else {
          $rec = new stdClass;
          $rec->TypeID=1;
          $leftcontent->fill('%hidden%', 'hidden');
          
          switch ($json->ID) {
           case ('-2'):  // student
            $rec->GroupID=9;
           break;
           case ('-3'):  // teacher
            $rec->GroupID=6;
           break;
          }
          
         }
         
         if ($rec->GroupID==9) {
          $leftcontent->removeloop('block_studentonly');
         } else {
          $leftcontent->fillloop('block_studentonly','');
         }
         
         
//         ajax_echo_r ($json);
         
         $leftcontent->fillloop('block_p','');
         
 //        ajax_echo_r ($rec);
         
         
         $looptmp = $leftcontent->returnloop("loop_clubs");
         if ($looptmp) {
          $loop = new Template($this->viewroot, $looptmp);
          $list = $this->model->getClubs($json);
          $loopdata = $this->fillList($list, $loop, $rec->ClubID);
          $leftcontent->fillloop('loop_clubs', $loopdata);
         }
         
         $looptmp = $leftcontent->returnloop("loop_grades");
         if ($looptmp) {
          $loop = new Template($this->viewroot, $looptmp);
          $list = $this->model->getGrades($json);
          $loopdata = $this->fillList($list, $loop, $rec->GradeID);
          $leftcontent->fillloop('loop_grades', $loopdata);
         }
         
         $looptmp = $leftcontent->returnloop("loop_programs");
         if ($looptmp) {
          $loop = new Template($this->viewroot, $looptmp);
          $list = $this->model->getPrograms($json);
          $loopdata = $this->fillList($list, $loop, $rec->ProgramID);
          $leftcontent->fillloop('loop_programs', $loopdata);
         }
         
         $looptmp = $leftcontent->returnloop("loop_knowledgelevels");
         if ($looptmp) {
          $loop = new Template($this->viewroot, $looptmp);
          $list = $this->model->getKnowledgeLevels($json);
          $loopdata = $this->fillList($list, $loop, $rec->KnowledgeLevelID);
          $leftcontent->fillloop('loop_knowledgelevels', $loopdata);
         }
         
         $looptmp = $leftcontent->returnloop("loop_teachers");
         if ($looptmp) {
          $loop = new Template($this->viewroot, $looptmp);
          $list = $this->model->getTeachers($json);
          $loopdata = $this->fillList($list, $loop, $rec->TeacherID);
          $leftcontent->fillloop('loop_teachers', $loopdata);
         }
         
         $looptmp = $leftcontent->returnloop("loop_usergroups");
         if ($looptmp) {
          $loop = new Template($this->viewroot, $looptmp);
          $list = $this->model->getList('usergroups');
          $loopdata = $this->fillList($list, $loop, $rec->GroupID);
          $leftcontent->fillloop('loop_usergroups', $loopdata);
         }
         
         $looptmp = $leftcontent->returnloop("loop_customerstatuses");
         if ($looptmp) {
          $loop = new Template($this->viewroot, $looptmp);
          $list = $this->model->getList('customerstatuses');
          $loopdata = $this->fillList($list, $loop, $rec->StatusID);
          $leftcontent->fillloop('loop_customerstatuses', $loopdata);
         }
         
         $looptmp = $leftcontent->returnloop("loop_customersources");
         if ($looptmp) {
          $loop = new Template($this->viewroot, $looptmp);
          $list = $this->model->getList('customersources');
          $loopdata = $this->fillList($list, $loop, $rec->SourceID);
          $leftcontent->fillloop('loop_customersources', $loopdata);
         }
         
         
         
         
         
         $leftcontent->processfcb('');
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , brtonl($rec->$var));
          }
         }
         
         $leftcontent = $this->fillStricts($leftcontent);
         
         ajax_echo (localize($leftcontent->output()));
        break;
        
        case ('addUser'):
         $ret = new stdClass;
         if ((($json->Email=='') || ($json->Phone=='')) && ($this->user->ID!=1)) {
          $ret->message = $this->getMessage('adduser_error_noemailphone');
          $ret->result = 0;
         } else {
 //         ajax_echo_r ($json);
          $ret->ID = $this->model->addUser($json);
          if ($ret->ID) {
           $ret->message = $this->getMessage('addmoney_success');
           $ret->result = 1;
          } else {
           $ret->message = $this->getMessage('addmoney_error_unknown');
           $ret->result = 0;
          }
         }
         echo json_encode($ret);
        break;
        
        case ('deleteUser'):
         $this->model->deleteUser($json);
        break;
        
        
        case ('updatePassword'):
         $ret = new stdClass;
         if ($json->Password=='') {
          $ret->message = $this->getMessage('updatepassword_error_nopassword');
          $ret->result = 0;
         } else {
          if ($this->model->updatePassword($json)) {
           $ret->message = $this->getMessage('updatepassword_success');
           $ret->result = 1;
          } else {
           $ret->message = $this->getMessage('addmoney_error_unknown');
           $ret->result = 0;
          }
         }
         echo json_encode($ret);
        break;
        
        
        
        case ('newBlog'):
         $leftcontent = new Template($this->viewroot, "editor_blog.htt");
         
         if ($userdetails->GroupID==1) {
          $leftcontent->removeloop('block_adminonly2');
         } else {
          $leftcontent->fillloop('block_adminonly2','');
         }
         
         if ($json->ID) {
          $rec = $this->model->getBlog($json->ID);
          $leftcontent->removeloop('block_editonly');
         } else {
          $rec = new stdClass;
          $rec->TypeID=1;
          $rec->IsEnabled=1;
          $leftcontent->fillloop('block_editonly', '');
         }
         
         $leftcontent->fillloop('block_p','');
         
         
         
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_blogtypes"));
         $list = $this->model->getList("blogtypes");
   //        ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, $rec->TypeID);
         $leftcontent->fillloop('loop_blogtypes', $loopdata);
         
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_parents"));
         $list = $this->model->getList("blog");
   //        ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, $rec->ParentID);
         $leftcontent->fillloop('loop_parents', $loopdata);
         
         
         
         
         
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , brtonl($rec->$var));
          }
         }
         
         $leftcontent->processfcb('');
         
         $k = "blogfolder";
         $path = $this->settings->$k.'/';
         $files_str = $this->getFiles($path, $json->ID, 'blog');
         $leftcontent->fill("%Files_blog%", $files_str);
         
         
         
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         ajax_echo (localize($leftcontent->output()));
        break;
        
        case ('addBlog'):   // aka saveblog
         $ret = new stdClass;
         $search  = array(" ", ":");
         if (!$json->Link) $json->Link=urlencode(strtolower(str_replace($search, "-", rus2translit($json->Title))));
         $ret->ID = $this->model->addBlog($json);
         if ($ret->ID) {
          $ret->message = $this->getMessage('addmoney_success');
          $ret->result = 1;
         } else {
          $ret->message = $this->getMessage('addmoney_error_unknown');
          $ret->result = 0;
         }
         echo json_encode($ret);
        break;
        
        case ('deleteBlog'):
         $this->model->deleteBlog($json);
        break;
        
        
        
        case ('deleteVKSource'):
         $this->model->deleteVKSource($json);
        break;
        
        
        
        case ('setMeetingSet'):
 //        ajax_echo_r ($json);
         if ($json->MeetingSet) {
          $ret = $this->model->addStatus($json);
         }
         if ($json->CallSet) {
          $ret = $this->model->addStatus($json);
         }
         
 //        ajax_echo_r ($ret);
         
         $params = new stdClass;
         $params->ParentID = $json->ParentID;
         if (!$params->ParentID) $params->ParentID = -1;
         if ($json->ParentName) {
          $params->ParentName = $json->ParentName;
         } else {
          $params->ParentName = 'people';
         }
         
 //        ajax_echo_r ($params);
         $sta = $this->fillStatuses($params);
         
         ajax_echo ($sta);
        break;
        
        case ('newPeople'):
         $leftcontent = new Template($this->viewroot, "left_people.htt");
         $leftcontent->loadloop('block_popupdefault','');
         
         if ($this->user->GroupID==1) {
          $leftcontent->removeloop('block_adminonly2');
         } else {
          $leftcontent->fillloop('block_adminonly2','');
         }
         
         if ($json->ID) {
          $rec = $this->model->getPeople($json->ID);
          $leftcontent->removeloop('block_editonly');
         } else {
          $rec = new stdClass;
          $rec->TypeID=1;
          $leftcontent->fillloop('block_editonly', '');
         }
         
         $leftcontent->fillloop('block_p','');
         
         $params = new stdClass;
         $params->ParentID = $json->ID;
         if (!$params->ParentID) $params->ParentID = -1;
         $params->ParentName = 'people';
 //        ajax_echo_r ($params);
         $sta = $this->fillStatuses($params);
         $leftcontent->fillloop("block_statuses"      , $sta);
         
 //        ajax_echo_r ($rec);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_peoplesources"));
         $list = $this->model->getList('peoplesources');
 //        ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, $rec->SourceID);
         $leftcontent->fillloop('loop_peoplesources', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_statustypes"));
         $list = $this->model->getList('statustypes');
 //        ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, 0);
         $leftcontent->fillloop('loop_statustypes', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_clubs"));
         $list = $this->model->getClubs();
         $loopdata = $this->fillList($list, $loop, $rec->ClubID);
         $leftcontent->fillloop('loop_clubs', $loopdata);
         
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , brtonl($rec->$var));
          }
         }
         
         $leftcontent->processfcb('');
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         ajax_echo (localize($leftcontent->output()));
        break;
        
        case ('addPeople'):
         $ret = new stdClass;
         if (($json->Firstname=='') && ($this->user->ID!=1)) {
          $ret->message = $this->getMessage('adduser_error_nousername');
          $ret->result = 0;
         } elseif (($json->Email=='') && ($this->user->ID!=1)) {
          $ret->message = $this->getMessage('adduser_error_noemail');
          $ret->result = 0;
         } else {
          $rslt = $this->model->addPeople($json);
          if (($rslt->rowsAffected>0) || ($rslt->lastInsertID>0)) {
           $ret->message = $this->getMessage('addmoney_success');
           $ret->result = 1;
           $ret->ID = $rslt->lastInsertID;
          } else {
           $ret->message = $this->getMessage('addmoney_error_unknown');
           $ret->result = 0;
          }
         }
         echo json_encode($ret);
        break;
        
        case ('deletePeople'):
         $this->model->deletePeople($json);
        break;
        
        case ('addStatus'):
//         ajax_echo_r ($json);
         if ($json->ParentName=='calendar') $json->ParentName="people";
         
         if ($json->ParentID) {
          if ($json->Address || $json->Comment || $json->NextStep) {
           if ($json->MeetingSet) {
//            $json->MeetingTime.= ":00";
            $json->MeetingTime = dateTimeAdaptRead($json->MeetingTime);
           }
           if ($json->CallSet) {
//            $json->CallTime.= ":00";
            $json->CallTime = dateTimeAdaptRead($json->CallTime);
           }
 //          ajax_echo_r ($json);
           $ret = $this->model->addStatus($json);
 //          ajax_echo_r ($ret);
          }
         }
         
         $statuses = $this->fillStatuses($json);
         ajax_echo($statuses);
        break;
        
        case ('addStatusCustomer'):
//         ajax_echo_r ($json);
         $allow = 1;
         if ($json->ParentID) {
          if (!$json->StatusID) {
           echo localize($this->getMessage('addStatusCustomer_noStatus'));
           $allow = 0;
          } else {
           /*
           if ((($json->StatusID>30) && ($json->StatusID<41)) && (trim($json->Reason)=='')) {
            echo localize($this->getMessage('addStatusCustomer_noReason'));
            $allow = 0;
           }
           */
          }
          
          if ($json->MeetingSet && !$json->MeetingTime) {
           echo localize($this->getMessage('addStatusCustomer_noMeetingTime'));
           $allow = 0;
          }
          
          if ($json->CallSet && !$json->CallTime) {
           echo localize($this->getMessage('addStatusCustomer_noCallTime'));
           $allow = 0;
          }
          
          if ($allow) {
           if ($json->MeetingSet) {
            $json->MeetingTime = ajaxdecode($json->MeetingTime);
//            $jsonMeetingTime = $json->MeetingTime;
            $json->MeetingTime = dateTimeAdaptRead($json->MeetingTime);
           } else {
            unset ($json->MeetingTime);
           }
           if ($json->CallSet) {
            $json->CallTime = ajaxdecode($json->CallTime);
//            $jsonCallTime = $json->CallTime;
            $json->CallTime = dateTimeAdaptRead($json->CallTime);
            
//            echo $json->CallTime;
//            die();
           } else {
            unset ($json->CallTime);
           }
//           ajax_echo_r ($json);
           if (strlen($json->SemipromiseTime)) {
            $json->SemipromiseTime = ajaxdecode($json->SemipromiseTime);
//            $jsonCallTime = $json->CallTime;
            $json->SemipromiseTime = dateTimeAdaptRead($json->SemipromiseTime);
           } else {
            unset ($json->SemipromiseTime);
           }
           
 //          ajax_echo_r ($json);
           
//           if ($this->userid==1) {
//            echo htmlspecialchars($jsonMeetingTime)."-".$json->MeetingTime."-".$jsonMeetingTime."-".strtotime($jsonMeetingTime)."<br>";
//            echo htmlspecialchars($jsonCallTime   )."-".$json->CallTime   ."-".$jsonCallTime   ."-".strtotime($jsonCallTime   )."<br>";
            
//            die ();
            $params = new stdClass;
            $params->ID = $json->ParentID;
            if ($json->MeetingTime) {
             $params->LastDatePromise = $json->MeetingTime;
            } else {
             $params->LastDatePromise = 'NULL';
            }
            if ($json->CallTime) {
             $params->LastDateCallback = $json->CallTime;
            } else {
             $params->LastDateCallback = 'NULL';
            }
            if ($json->SemiPromise) {
             $params->LastSemiPromise = $json->SemiPromise;
            } else {
             $params->LastSemiPromise = 'NULL';
            }
            
//            if ($json->MeetingTime || $json->CallTime || $json->SemiPromise) {
 //            ajax_echo_r ($params);
             addtologEx($params      , 'addStatusCustomer-common.txt', 'errors');
             if ($params->ID) {
              addtologEx($params      , 'addStatusCustomer-saveCustomer-common.txt', 'errors');
              if (!$params->ReferredToQD) unset ($params->ReferredToQD);
              $ret_c = $this->model->saveCustomer($params);
              addtologEx($ret_c      , 'addStatusCustomer-saveCustomer-common.txt', 'errors');
             }
//            }
//            die();
//           }
           
           $ret = $this->model->addStatus($json);
           if (!$ret) {
            addtologEx($json      , 'addStatusCustomer-addStatus-unsuccessful.txt', 'errors');
            addtologEx($ret       , 'addStatusCustomer-addStatus-unsuccessful.txt', 'errors');
            addtologEx("\n"       , 'addStatusCustomer-addStatus-unsuccessful.txt', 'errors');
            
            echo localize($this->getMessage('addStatusCustomer_error'));
           }
           
           
           
 //          ajax_echo_r ($ret);
          } else {
           /*
           if (!$json->Comment) {
            echo localize($this->getMessage('addStatusCustomer_noComment'));
           } elseif (!$json->NextStep) {
            echo localize($this->getMessage('addStatusCustomer_noNextStep'));
           }
           */
          }
         }
         
//         $statuses = $this->fillStatuses($json);
//         ajax_echo($statuses);
         
        break;
        
        case ('saveCustomer'):
         $excludes = array('DatePromise', 'DateFollowUp', 'DateBackOnline', 'DateBackOnlinePurchase');
         foreach ($excludes as $exclude) {
          if (strlen($json->$exclude)==0) unset ($json->$exclude);
         }
         
//         ajax_echo_r ($json);
         $ret = $this->model->saveCustomer($json);
//         ajax_echo_r ($ret);
        break;
        
        case ('addCustomer'):
         $excludes = array('DatePromise', 'DateFollowUp', 'DateBackOnline', 'DateBackOnlinePurchase');
         foreach ($excludes as $exclude) {
          if (strlen($json->$exclude)==0) unset ($json->$exclude);
         }
         
         if (!$json->AssignedToID) $json->AssignedToID="NULL";
         if (!$json->DuplicateID ) $json->DuplicateID ="NULL";
         
//         ajax_echo_r ($json);
         $ret = $this->model->saveCustomer($json);
         if ($ret->rowsAffected) {
          $ret->message = localize($this->getMessage('addmoney_success'));
         } else {
          $ret->message = localize($this->getMessage('addmoney_error_unknown'));
         }
         echo json_encode($ret);
        break;
        
        
        case ('loadStatuses'):
         $sta = $this->fillStatuses($json);
         ajax_echo(localize($sta));
        break;
        
        
        case ('loadAssessment'):
         if ($json->CostFrom) {
          $this->model->addRecord('bets', $json);
          
         }
         
         
         $leftcontent = new Template($this->viewroot, "editor_clubs.htt");
         $leftcontent->loadloop('block_assessment');
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_assessment"));
         $list = $this->model->getBets($json);
 //        ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, 0);
         $leftcontent->fillloop('loop_assessment', $loopdata);
         
         
         $leftcontent->processfcb();
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         ajax_echo(localize($leftcontent->output()));
        break;
        
        
        case ('ownlogin'):
         $key = getvariablereq('key');          // get JSON data from the request
         if ($key) {
          $go="ownlogin";
     //     echo strlen($key);
     //     $key = str_replace(".", "", $key);
          $key = substr($key, 0, 32);
     //     echo $key;
         }
         
         $login = $this->model->ownLogin($key);
//         ajax_echo_r ($login);
//         die();
         
         if ($login) {
          $tmp = new Template($this->viewroot, 'redir.htt');
          if (!$login->LastGo) $login->LastGo="home";
          $tmp->fill('%Link%', '?go='.$login->LastGo);
          
          setsecurevariable('userid',$login->ID);
          setsecurevariable('tmpcnt',0         );
          
         } else {
          $tmp = new Template($this->viewroot, 'wrong_key.htt');
         }
         
         echo localize($tmp->output());
        break;
        
        case ('sendEmail'):
         $user = $this->model->getUser($json->ID);
         
         if ($user->Email) {
          $tmp = new Template($this->viewroot, 'mail1.htt');
          $tmp->fill(  "%LoginKey%", $user->LoginKey  );
          $tmp->fill( "%Firstname%", $user->Firstname );
          $mail = localize($tmp->output());
          $is_sent = sendmail("Welcome to Fluent System", $mail, $user->Email);
         }
         
         if ($user->Email2) {
          $tmp = new Template($this->viewroot, 'mail1.htt');
          $tmp->fill(  "%LoginKey%", $user->LoginKey  );
          $tmp->fill( "%Firstname%", $user->Firstname );
          $mail = localize($tmp->output());
          $is_sent = sendmail("Welcome to Fluent System", $mail, $user->Email2);
         }
         
         echo "Emails sent: ".$is_sent."<br>";
         
        break;
        
        case ('setUserStatus'):
         if ($json->ID) {
          $sta = $this->model->setUserStatus($this->user->ID, $json->ID);
         }
         $sta = $this->model->getUserStatus($this->user->ID);
         
         $tmp = new Template($this->viewroot, 'mainparent.htt');                                       // load common parent template
         
         $tmp->loadloop('block_status_'.$sta,'');
         
         $tmp->processfcb('');
         $tmp->fill(  '%imgfolder%' , $this->imgfolder                    );
         $tmp->fill(   '%viewroot%' , $this->viewroot                     );
         ajax_echo (localize($tmp->output()));
        break;
        
        
        
        case ('VKParse'):
         setcache('vkparser', $json);
         
         $ret = $this->model->VKParse($json);
         $this->model->prepareUsersSmsAll($json);
         
         echo json_encode($ret);
        break;
        
        case ('findSameRecords'):
         if ($json->Value) $json->Value = str_replace(" ", "", $json->Value);
         
         $table = array();
         $table[1] = $this->model->findSameRecords($json);
         
         $leftcontent = new Template($this->viewroot, "editor_money.htt");
         $leftcontent = new Template($this->viewroot, $leftcontent->returnloop("block_sameRecords"));
         
         
         if (sizeof($table[1])) {
          $loop_table_row = new Template($this->viewroot, $leftcontent->returnloop("loop_table_row"));
          
          $vars = $loop_table_row->getVariables();
          
          $block_type = array();
          $block_type[1]     = new Template($this->viewroot, $leftcontent->returnloop('block_type1'));
          $block_type[2]     = new Template($this->viewroot, $leftcontent->returnloop('block_type2'));
          
          $block_type[1] = $block_type[1]->output();
          $block_type[2] = $block_type[2]->output();
          
          $lastTypeID = -1;
          $c = 0;
  //           ajax_echo_r ($table[1]);
          $thistable = "";
          
          
          $thisidcolumnname = $json->tablename."_ID";
          if ($table[1]) {
           foreach ($table[1] as $item) {
            if ($lastTypeID!=$item->TypeID) {
             $lastTypeID = $item->TypeID;
             $c = 1;
            }
            
            $loop_table_row->reload();
            $loop_table_row->fill( "%TypePicture%", $block_type[($item->TypeID-1)%2+1]);
            $loop_table_row->fill("%c%",  $c%2+(($item->TypeID-1)*2)%4);
            foreach ($vars as $vn) {
             $loop_table_row->fill("%".$vn."%", $item->$vn);
            }
            
            if (($item->TypeID==1) || ($item->TypeID==3)) {
             $sum += $item->Value;
             $Income += $item->Value;
            } else {
             $sum -= $item->Value;
             $Expenditure += $item->Value;
            }
            
            $thistable.=$loop_table_row->output();
            $c++;
           }
          }
          
          $leftcontent->fillloop('loop_table_row', $thistable);
          
          
          $leftcontent->fillloop(       "block_no","" );
          $leftcontent->fillloop(   "block_norows","" );
          $leftcontent->fillloop(    "block_type1","" );
          $leftcontent->fillloop(    "block_type2","" );
          
          $leftcontent->processfcb('');
         } else {
          $leftcontent = new Template($this->viewroot, $leftcontent->returnloop('block_norows'));
 //         $leftcontent = $leftcontent->output();
         }
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         ajax_echo (localize($leftcontent->output()));
         
         
        break;
        
        case ('loadGroups'):
         $json->GroupsTxt = brtonl($json->GroupsTxt);
         setcache('loadGroups', $json);
         
         $ret = $this->model->loadGroups($json);
         
 //        ajax_echo_r ($ret);
 //        echo htmlentities($json->GroupsTxt);
         
         $leftcontent = new Template($this->viewroot, "main_loadGroups_".$json->Step.".htt");
 //        $leftcontent = new Template($this->viewroot, $leftcontent->returnloop("block_sameRecords"));
         
         $leftcontent->fill("%numrows%",sizeof($ret));
         
         if (sizeof($ret)) {
          $loop_table_row = new Template($this->viewroot, $leftcontent->returnloop("loop_table_row"));
          
          $vars = $loop_table_row->getVariables();
          
          $block_type = array();
          $block_type[1]     = new Template($this->viewroot, $leftcontent->returnloop('block_type1'));
          $block_type[2]     = new Template($this->viewroot, $leftcontent->returnloop('block_type2'));
          
          $block_type[1] = $block_type[1]->output();
          $block_type[2] = $block_type[2]->output();
          
          $lastTypeID = -1;
          $c = 0;
 //         ajax_echo_r ($ret);
          $thistable = "";
          
          
          $thisidcolumnname = $json->tablename."_ID";
          if ($ret) {
           foreach ($ret as $item) {
            if ($lastTypeID!=$item->TypeID) {
             $lastTypeID = $item->TypeID;
             $c = 1;
            }
            
            $loop_table_row->reload();
            $loop_table_row->fill("%c%",  $c%2);
            foreach ($vars as $vn) {
             $loop_table_row->fill("%".$vn."%", $item->$vn);
            }
            
            $thistable.=$loop_table_row->output();
            $c++;
           }
          }
          
          $leftcontent->fillloop('loop_table_row', $thistable);
          
          
          $leftcontent->fillloop(       "block_no","" );
          $leftcontent->fillloop(   "block_norows","" );
          $leftcontent->fillloop(    "block_type1","" );
          $leftcontent->fillloop(    "block_type2","" );
          
          $leftcontent->processfcb('');
         } else {
          $leftcontent = new Template($this->viewroot, $leftcontent->returnloop('block_norows'));
 //         $leftcontent = $leftcontent->output();
         }
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         ajax_echo (localize($leftcontent->output()));
         
         
         
         
        break;
        
        case ('VKTargetImport'):
         if (!$json->offset) {
          $json_c = getfromcache ('VKTargetImport');
          $json->offset = $json_c->offset;
         }
 //        $json->offset=0;
         ajax_echo_r ($json);
         setcache ('VKTargetImport', $json);
         
         $json->r_viewmode = 'search';
         $json->ShowAll = 1;
         $json->IDsOnly = 1;
         $vkusers = $this->model->getVKUsers($json);
         
         if (!$json->offset) $json->offset = 0;
         
         $n=0;
         for ($i=$json->offset; $i<sizeof($vkusers); $i++) {
 //         echo "-step ".$i."<br>";
          
          $vkuser = $vkusers[$i];
          
          if ($ids) $ids.=",";
          $ids.= $vkuser->ID;
          
          if ((strlen($ids)>1024) || ($n>900) || (($i+1)==sizeof($vkusers))) {
           $json->ids = $ids;
           $ret = $this->model->VKImportTargetContacts($json);
           
           if ($ret->error) {
            echo ($ret->error->error_msg."<br>");
 //           ajax_echo_r ($ret->error);
            setcache ('VKTargetImport', $json);
            
            echo $json->offset." users added.<br>";
            
            break;
           } else {
 //           $lastn = $n;
            $json->offset+=$n;
            ajax_echo_r ($ret);
            echo "<br>";
           }
           
           echo "Offset: ".$json->offset.", n: ".$n.".<br>";
           $n = 0;
           $ids = "";
           
 //          break;
          } else {
           $n++;
           
          }
          
          
         }
         
         setcache ('VKTargetImport', $json);
         echo ("Total users: ".sizeof($vkusers)."<br>");
         echo $json->offset." users added.<br>";
         
         //echo $ids;
         
         
        break;
        
        case ('VKTargetGetIDs'):
         ajax_echo_r ($json);
         setcache ('VKTargetImport', $json);
         
         $json->r_viewmode = 'search';
         $json->ShowAll = 1;
         $json->IDsOnly = 1;
         $vkusers = $this->model->getVKUsers($json);
         
 //        ajax_echo_r ($vkusers);
         
         $data = join(",",$vkusers);
         
         $tmp = new Template($this->viewroot, 'main_retargeting.htt');                                      // load common parent template
         $tmp->loadloop('block_VKTargetImport');
         $tmp->fill('%size%', strlen($data));
         
 //        setCacheEx('retargeting', $data, 'test');
         $fname = "retargeting-".$json->s_campaignid.".txt";
         $cachefname = getCacheFName($fname, 0, 1, "test");
         
         file_put_contents($cachefname, $data);
         
         $link = getrootdir()."file.php?name=data/test/".$fname;
         
         $tmp->fill('%link%', $link);
         
         $tmp->processfcb('');
         $tmp->fill(   '%imgfolder%', $this->imgfolder                    );
         $tmp->fill(    '%viewroot%', $this->viewroot                     );
         
         ajax_echo(sup($tmp->output()));
         
         return 0;
         
         if (!$json->offset) $json->offset = 0;
         
         $n=0;
         for ($i=$json->offset; $i<sizeof($vkusers); $i++) {
 //         echo "-step ".$i."<br>";
          
          $vkuser = $vkusers[$i];
          
          if ($ids) $ids.=",";
          $ids.= $vkuser->ID;
          
          if ((strlen($ids)>1024) || ($n>900) || (($i+1)==sizeof($vkusers))) {
           $json->ids = $ids;
           $ret = $this->model->VKImportTargetContacts($json);
           
           if ($ret->error) {
            echo ($ret->error->error_msg."<br>");
 //           ajax_echo_r ($ret->error);
            setcache ('VKTargetImport', $json);
            
            echo $json->offset." users added.<br>";
            
            break;
           } else {
 //           $lastn = $n;
            $json->offset+=$n;
            ajax_echo_r ($ret);
            echo "<br>";
           }
           
           echo "Offset: ".$json->offset.", n: ".$n.".<br>";
           $n = 0;
           $ids = "";
           
 //          break;
          } else {
           $n++;
           
          }
          
          
         }
         
         setcache ('VKTargetImport', $json);
         echo ("Total users: ".sizeof($vkusers)."<br>");
         echo $json->offset." users added.<br>";
         
         //echo $ids;
         
         
        break;
        
        case ('VKUserStatusChange'):
         $ret = $this->model->VKUserStatusChange($json);
         
        break;
        
        case ('addVKLike'):
         $json = (object)$_REQUEST;
         unset ($json->action);
         
         ajax_echo_r ($json);
         $ret = $this->model->addVKLike($json);
         ajax_echo_r ($ret);
        break;
        
        
        case ('getinfo'):
 //        echo "data: ".$data."<br>";
         
 //        ajax_echo_r ($_GET);
         
         $params = new stdClass;
         $params->skype  = getvariablereq   ('skype'  );          // get JSON data from the request
         $params->vkid   = getvariablereq   ('vkid'   );          // get JSON data from the request
         $params->email  = getvariablereq   ('email'  );          // get JSON data from the request
         
         $params->Firstname   = strprepare(getvariablereq   ('Firstname'   ));          // get JSON data from the request
         $params->Location    = strprepare(getvariablereq   ('Location'    ));          // get JSON data from the request
         $params->Sex         = strprepare(getvariablereq   ('Sex'         ));          // get JSON data from the request
         $params->Phone       = strprepare(getvariablereq   ('Phone'       ));          // get JSON data from the request
         $params->Phone2      = strprepare(getvariablereq   ('Phone2'      ));          // get JSON data from the request
         $params->DateBirth   = strprepare(getvariablereq   ('DateBirth'   ));          // get JSON data from the request
         $params->Description = strprepare(getvariablereq   ('Description' ));          // get JSON data from the request
         
         $params->data   = $data;
         
         $info = $this->model->getInfo($params);
         
 //        ajax_echo_r ($info);
         
         $this->processstylesheet($hue,'apiresults');
         
         $tmp = new Template($this->viewroot, 'apiresults.htt');                                      // load common parent template
         $tmp->processfcb();
         $tmp->fill(  '%imgfolder%', $this->imgfolder                    );
         $tmp->fill(   '%viewroot%', $this->viewroot                     );
         
         
         $loop_details  = new Template($this->viewroot, $tmp->returnloop('loop_details' ));
         $loop_link     = new Template($this->viewroot, $tmp->returnloop('loop_link'    ));
         $loop_checkbox = new Template($this->viewroot, $tmp->returnloop('loop_checkbox'));
         $loop_hhstatus = new Template($this->viewroot, $tmp->returnloop('loop_hhstatus'));
         $tmp->fillloop("loop_link"               , ""     );
         $tmp->fillloop("loop_checkbox"           , ""     );
         $tmp->fillloop("loop_hhstatus"           , ""     );
         
         $loop_subitem  = new Template($this->viewroot, $tmp->returnloop('loop_subitem' ));
         $loop_item     = new Template($this->viewroot, $tmp->returnloop('loop_result'  ));
         
         $block_skills  = new Template($this->viewroot, $tmp->returnloop('block_skills' ));
         
         
 //        echo sizeof($info);
 //        ajax_echo_r ($info);
         
         $checkboxes = array('IsAcceptedInSkype', 'IsFreelancer', 'IsUsable', 'IsInteresting', 'NoEmails');
         
         $keys = array('Email', 'Site', 'PhoneMobile', 'Phone', 'Phone2', 'Skype', 'VKID', 'Location', 'Skype2', 'FBID', 'Address');
         
         $thislist = "";
         if (sizeof($info)) {
          foreach ($info as $k=>$v) {
           $loop_item->reload();
           $loop_item->fill(   "%key%", $k     );
           $loop_item->fill( "%count%", sizeof($v));
           
 //          ajax_echo_r ($k);
 //          ajax_echo_r ($v);
           $thissubitems = "";
           foreach ($v as $ik=>$iv) {
 //           ajax_echo_r ($ik);
 //           ajax_echo_r ($iv);
            $loop_subitem->reload();
            $loop_subitem->fill(  "%Title%", $ik     );
            
            $thisdetails = "";
            foreach ($iv as $dk=>$dv) {
 //            echo $k."-".$dk."<br>";
             if (($k=="hh_vacancies") && ($dk=='StatusID')) {  //  || ($dk=='Status'))
              $loop_hhstatus->reload();
              
              $loop = new Template($this->viewroot, $loop_hhstatus->returnloop("loop_statuses"));
              $list = $this->model->getList('hh_statuses');
      //        ajax_echo_r ($list);
              $loopdata = $this->fillList($list, $loop, $iv->StatusID);
              $loop_hhstatus->fillloop('loop_statuses', $loopdata);
              
              $loop_hhstatus->fill(      "%ID%", $iv->ID     );
              $loop_hhstatus->fill(    "%Name%", $dk         );
              $loop_hhstatus->fill(   "%Title%", $k          );
              
              $thisdetails.=$loop_hhstatus->output();
             } else {
              if (in_array($dk, $checkboxes)) {
               $loop_checkbox->reload();
               $loop_checkbox->fill(      "%ID%", $iv->ID     );
               $loop_checkbox->fill(   "%Title%", $k          );
               $loop_checkbox->fill(   "%Table%", $k      );
               $loop_checkbox->fill(    "%Name%", $dk     );
               $loop_checkbox->fill(   "%Value%", $dv     );
               $loop_checkbox->fill( "%Checked%", ($dv==1)?"checked":""  );
               $thisdetails.=$loop_checkbox->output();
              } else {
               if ($dv || (in_array($dk,$keys))) {
                if (strpos(strtolower_cf($dv), "http")===0) {
                 $loop_link->reload();
                 $loop_link->fill(   "%Title%", $k         );
                 $loop_link->fill(    "%Name%", $dk     );
                 $loop_link->fill(   "%Value%", $dv     );
                 $thisdetails.=$loop_link->output();
                } else {
                 $loop_details->reload();
                 $loop_details->fill(   "%Title%", $k         );
                 $loop_details->fill(    "%Name%", $dk     );
                 $loop_details->fill(   "%Value%", $dv     );
                 $thisdetails.=$loop_details->output();
                }
               }
              }
             }
            }
            $loop_subitem->fillloop('loop_details', $thisdetails);
            
            if ($k=='freelancers') {
             $loop_subitem->removeloop('block_skills');
             
             $loop_subitem->fill("%ID%", $ik);
             
             
             
            } else {
             $loop_subitem->fillloop('block_skills', "");
            }
            
            $thissubitems.=$loop_subitem->output();
           }
           
           $loop_item->fillloop('loop_subitem', $thissubitems);
           
           $thislist.=$loop_item->output();
          }
         }
         
         $tmp->fillloop("loop_result"           , $thislist     );
         
         
         if ($info['hh_vacancies']) {
          $loop = new Template($this->viewroot, $tmp->returnloop("loop_statustypes"));
          $list = $this->model->getList('statustypes');
  //        ajax_echo_r ($list);
          $loopdata = $this->fillList($list, $loop, 0);
          $tmp->fillloop('loop_statustypes', $loopdata);
          
          $tmp->fill("%ID%", $info['hh_vacancies'][array_keys($info['hh_vacancies'])[0]]->ID);
          
          $tmp->removeloop("block_status");
         } else {
          $tmp->fillloop("block_status"           , ""     );
         }
         
 //        $tmp->fill("%numrows%",sizeof($table[1]));
         
         if ($info['freelancers']) {
          $tmp->removeloop("block_adduser");
          $tmp->fill("%id%", array_keys($info['freelancers'])[0]);
         } else {
          $tmp->fillloop("block_adduser"           , ""     );
         }
         
         if (!$info['users']) {
          $tmp->removeloop("block_adduserskype");
          foreach ($params as $k=>$v) {
           $tmp->fill("%aus_".$k."%", $v);
          }
         } else {
          $tmp->fillloop("block_adduserskype"           , ""     );
         }
         
         
         echo localize($tmp->output());
         
        break;
        
        case ('checkboxClick'):
         ajax_echo_r ($json);
         
         $ret = $this->model->checkboxClick($json);
         
         ajax_echo_r ($ret);
         
        break;
        
        case ('addUserFromFL'):
         ajax_echo_r ($json);
         
         $ret = $this->model->addUserFromFL($json);
         
         ajax_echo_r ($ret);
        break;
        
        case ('addUserFromData'):
         ajax_echo_r ($json);
         
         $ret = $this->model->addUserFromData($json);
         
         ajax_echo_r ($ret);
        break;
        
        case ('fillClubFromVacancy'):
         $rec = $this->model->getVacancy($json);
         
         if ($rec) {
          $fields = array();
          $fields[] = 'Skype';
          $fields[] = 'Firstname';
          $fields[] = 'Lastname';
          $fields[] = 'Phone';
          $fields[] = 'Email';
          $fields[] = 'Email2';
          
          $ret = new stdClass;
          foreach ($fields as $field) {
           $ret->$field = $rec->$field;
          }
          
          echo json_encode($ret);
         }
        break;
        
        case ('newVacancy'):
 //        ajax_echo_r ($json);
         if ($json->ID) {
          $rec = $this->model->getVacancy($json);
         } else {
          $rec = new stdClass;
 //         $rec->TypeID=1;
         }
 //        ajax_echo_r ($rec);
         
         $leftcontent = new Template($this->viewroot, "editor_vacancies.htt");
         
         
         
         $params = new stdClass;
         $params->ParentID = $json->ID;
         if (!$params->ParentID) $params->ParentID = -1;
         $params->ParentName = 'hh_vacancies';
 //        ajax_echo_r ($params);
         $sta = $this->fillStatuses($params);
         $leftcontent->fillloop("block_statuses"      , $sta);
         
 //        ajax_echo_r ($rec);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_statustypes"));
         $list = $this->model->getList('statustypes');
 //        ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, 0);
         $leftcontent->fillloop('loop_statustypes', $loopdata);
         
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_statuses"));
         $list = $this->model->getList('hh_statuses');
 //        ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, $rec->StatusID);
         $leftcontent->fillloop('loop_statuses', $loopdata);
         
         
         
         
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , brtonl($rec->$var));
          }
         }
         
         $leftcontent->processfcb('');
         
         ajax_echo (localize($leftcontent->output()));
        break;
        
        case ('addVacancy'):
         $ret = new stdClass;
         
         if ($this->model->addVacancy($json)) {
          $ret->message = $this->getMessage('addmoney_success');
          $ret->result = 1;
         } else {
          $ret->message = $this->getMessage('addmoney_error_unknown');
          $ret->result = 0;
         }
         echo json_encode($ret);
         
        break;
        
        
        
        
        
        case ('sendFLEmails'):
//         ajax_echo_r ($_SESSION['json']['freelancers']);
         
         $_SESSION['json']['freelancers']->Subject = $json->Subject;
         $_SESSION['json']['freelancers']->Message = $json->Message;
         $_SESSION['json']['freelancers']->Test    = $json->Test;
         
         ajax_echo_r ($json);
         
         if ($json->Test) {
          $emails = array("Андрей;main@cfteam.ru;freelansim;20002");
         } else {
          $emails = explode("|", $json->emails);
         }
//         ajax_echo_r ($emails);
         
         $message = $json->Message;
         
         $json->Message = ajaxdecode($json->Message);
         echo (htmlspecialchars($json->Message));
         
 //        $message = "Приветствую, %0%!<br><br>Меня зовут Андрей. Я нашёл информацию о вас на сайте %2%.<br>Я сейчас ищу веб-разработчика, с которым можно было бы работать на постоянной или сдельной основе. Если для вас сейчас актуален вопрос поиска работы или заказов - то напишите мне пожалуйста в скайпе: arag_cf, я с удовольствием с вами познакомлюсь и мы с вами обсудим возможность сотрудничества.<br>Если же вам это предложение неинтересно - извините за беспокойство.<br><br>С уважением, Андрей Парсаданян<br>Creative Force Systems";
 //        $message = "Приветствую, %0%!<br><br>Меня зовут Максим, я являюсь Руководителем отдела интернет-маркетинга компании Syssoft. Я нашёл информацию о вас на сайте %2%.<br>Сейчас ищу Аналитика отдела интернет-маркетинга, с которым можно было бы работать на постоянной основе с гибким графиком в нашем московском офисе. Если для вас сейчас актуален вопрос поиска работы и наша вакансия интересна - то напишите мне пожалуйста в скайп makinch_ или на почту mi@syssoft.ru, и мы обсудим возможность сотрудничества.<br>Если вам это предложение неинтересно - прошу прощения за беспокойство.<br><br>С уважением, Максим Ильченко<br>Руководитель отдела интернет-маркетинга<br>+7 495 646 14 71 доб.138<br>syssoft.ru";
 //        $message = "Приветствую, %0%!<br><br>Меня зовут Андрей. Я нашёл информацию о вас на сайте %2%.<br>Я сейчас ищу программиста на Symfony для выполнения задач на проекте. Если для вас сейчас актуален вопрос поиска работы и моё предложение интересно - то напишите мне пожалуйста в скайп arag_cf, и мы обсудим возможность сотрудничества.<br>Если вам это предложение неинтересно - прошу прощения за беспокойство.<br><br>С уважением, Андрей Парсаданян<br>Руководитель Creative Force Systems";
//         $message = "Приветствую, %0%!<br><br>Меня зовут Андрей. Я нашёл ваши контакты на сайте %2%.<br>Я сейчас ищу программистов на Bitrix для выполнения задач на проекте. Если для вас сейчас актуален вопрос поиска работы и моё предложение интересно - то напишите мне пожалуйста в скайп arag_cf, и мы обсудим возможность сотрудничества.<br>Если вам это предложение неинтересно - прошу прощения за беспокойство.<br><br>С уважением, Андрей Парсаданян<br>Руководитель Creative Force Systems";
 //        $message = "Приветствую, %0%!<br><br>Меня зовут Андрей. Я нашёл информацию о вас на сайте %2%.<br>У меня есть несколько задач по изготовлению баннеров на сайт, а также макетов лендингов, поэтому сейчас ищу дизайнера на разовые заказы. Если вам будет интересно рассмотреть возможность сотрудничества - то напишите мне пожалуйста в скайп: arag_cf.<br>Если вам это предложение неинтересно - прошу прощения за беспокойство.<br><br>С уважением, Андрей Парсаданян<br>Creative Force Systems<br>+7-925-862-67-36<br>cfsystems.cf";
 //        $message = "Приветствую, %0%!<br><br>Меня зовут Андрей. Я нашёл информацию о вас на сайте %2%.<br>У меня есть задача по доработке сайта на базе CMS Joomla, поэтому сейчас ищу программиста. Если вам будет интересно рассмотреть возможность сотрудничества - то напишите мне пожалуйста в скайп: arag_cf.<br>Если вам это предложение неинтересно - прошу прощения за беспокойство.<br><br>С уважением, Андрей Парсаданян<br>Creative Force Systems<br>Тел. +7-925-862-67-36";
         
         foreach ($emails as $email) {
          $items = explode(";", $email);
          
          ajax_echo_r ($items);
          
          $msg = $message;
          foreach ($items as $k=>$v) {
           $msg = str_replace("%".$k."%", $v, $msg);
          }
          
          $msg = nl2br($msg);
          
 //         $email = "microbook@mail.ru";
 //         $email = "mi@syssoft.ru";
          $email = $items[1];
          
          die($msg);
          
//          $ret=extmail2("Приглашение на работу", $msg, $email, "Андрей Парсаданян, Creative Force Systems", "main@cfteam.ru");
 //         $ret = extmail2("Приглашение на работу", $msg, $email, "Максим Ильченко, Syssoft", "mi@syssoft.ru");
//          $ret = extmail2("Приглашение к участию в проекте", $msg, $email, "Андрей Парсаданян, Creative Force Systems", "main@cfteam.su");
          $ret = extmail2($json->Subject, $msg, $email, "Андрей Парсаданян, Creative Force Systems", "main@cfteam.su");
 //         ajax_echo_r ($ret);
 //         $ret = json_decode($ret);
          ajax_echo_r ($ret);
          echo "<br>";
 //         die($msg);
          
          if ($ret->Result) {
           $params = new stdClass;
//           $params->DateAdded      = date('Y-m-d H:i:s');
           $params->ParentName = "freelancers";
           $params->ParentID = $items[3];
           $params->Message = $msg;
           $params->UserID = 1;
           $params->Result = $ret->Result;
           
           $this->model->addRecord('emails', $params);
          }
          
          $ret = $this->model->addEvent('EmailSentToFreelancer','freelancers','ID',$items[3],$items[3]);
          ajax_echo_r ($ret);
          echo "<hr>";
          
         }
         
         
        break;
        
        case ("getSkypeMessagesLastID"):
         $ret = $this->model->getSkypeMessagesLastID($json);
         echo $ret;
        break;
        
        case ("getSkypeConversationsLastID"):
         $ret = $this->model->getSkypeConversationsLastID($json);
         echo $ret;
        break;
        
        
        case ("getInvoice"):
         $ids = explode(",", $json->ids);
         $json->ids = $ids;
 //        ajax_echo_r ($ids);
         
         $inv = $this->model->getInvoice($json);
 //        ajax_echo_r ($inv);
         
         if ($inv) {
          $o = $this->model->generateOutputEx($inv);
         }
 //        ajax_echo_r ($o);
         
         echo $o->filename_client;
         
         /*
         $leftcontent = new Template($this->viewroot, "output_getInvoice.htt");
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         
         
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , brtonl($o->$var));
          }
         }
         
         $leftcontent->processfcb('');
         
         ajax_echo (localize($leftcontent->output()));
         
         */
         
        break;
        
        case ('getvacidpfromskype'):
         $id   = getvariablereq   ('id'  );          // get JSON data from the request
         
         $ret = $this->model->getSkypeMessage($id);
         ajax_echo_r ($ret);
         
         if ($ret) {
          $hhid = $this->model->getHHID($ret);
          ajax_echo_r ($hhid);
          
          if ($hhid) {
           $vac = $this->model->assignSkypeToHHID($ret->author, $hhid);
           ajax_echo_r ($vac);
          }
         }
         
        break;
        
        case ("addTaskFromUser"):
         ajax_echo_r ($json);
         
         $params = new stdClass;
         foreach ($json as $k=>$v) {
          $params->$k = $v;
         }
         $params->AddedBy = $this->userid;
         
         $params->ParentName = "users";
         if ($json->AssignedToID==$this->userid) {
          $params->UserID = $json->AssignedToID;
          unset ($params->DateStart);
          unset ($params->DateFinish);
          unset ($params->AssignedToID);
          unset ($params->AddedBy);
          $id = $this->model->addStatus($params);
         } else {
          $id = $this->model->addTask($params);
         }
         
         
         $json->ID = $json->ParentID;
         echo $this->loadActivities($json);
         
        break;
        
        case ("addMoneyFromUser"):
//         ajax_echo_r ($json);
         
         $params = new stdClass;
         foreach ($json as $k=>$v) {
          $params->$k = $v;
         }
         $params->UserID = $this->userid;
         
         if (floatval($json->Value)<=0) {
          $json->money_message = $this->getMessage('addmoney_error_novalue');
          $json->money_result = 0;
          $json->focusField = "Newmoney_Value";
         } elseif ((date_create($json->DateAdded)) && ((int)date_format(date_create($json->DateAdded), 'Y')<1985)) {
          $json->money_message = $this->getMessage('addmoney_error_nodate');
          $json->money_result = 0;
          $json->focusField = "Newmoney_DateAdded";
         } else {
          if ($json->Value) $json->Value = str_replace(" ", "", $json->Value);
          if ($this->model->addMoney($params)) {
           $json->money_message = $this->getMessage('addmoney_success');
           $json->money_result = 1;
          } else {
           $json->money_message = $this->getMessage('addmoney_error_unknown');
           $json->money_result = 0;
          }
         }
         
         
         $json->ID = $json->StudentID;
         echo $this->loadActivities($json);
         
        break;
        
        case ("addWish"):
//         ajax_echo_r ($json);
         
         $days = 0;
         for ($n=1; $n<8; $n++) {
          $k = "NewwishDay".$n;
          $days += $json->$k;
         }
         
         $json->TimeStart  = ajaxdecode($json->TimeStart);
         $json->TimeFinish = ajaxdecode($json->TimeFinish);
         
         /*
         echo $json->DateStart."<br>";
         ajax_echo_r (date_create($json->DateStart));
         ajax_echo_r (strpos($json->DateStart, ":"));
         ajax_echo_r (strlen($json->DateStart));
         
         echo $json->DateFinish."<br>";
         ajax_echo_r (date_create($json->DateFinish));
         ajax_echo_r (strpos($json->DateFinish, ":"));
         ajax_echo_r (strlen($json->DateFinish));
         */
         
         if (!$days) {
          $json->message = $this->getMessage('addwish_error_noday');
          $json->result = 0;
          $json->focusField = "";
         } elseif (!date_create($json->TimeStart ) || !strpos($json->TimeStart , ":") || strlen($json->TimeStart )<3) {
          $json->message = $this->getMessage('addwish_error_nodatestart');
          $json->result = 0;
          $json->focusField = "Newwish_DateStart";
         } elseif (!date_create($json->TimeFinish) || !strpos($json->TimeFinish, ":") || strlen($json->TimeFinish)<3) {
          $json->message = $this->getMessage('addwish_error_nodatefinish');
          $json->result = 0;
          $json->focusField = "Newwish_DateFinish";
         } else {
          for ($n=1; $n<8; $n++) {
           $k = "NewwishDay".$n;
           if ($json->$k) {
            $params = new stdClass;
            $params->UserID = $this->userid;
            $params->StudentID   = $json->StudentID;
            $params->TimeStart   = $json->TimeStart;
            $params->TimeFinish  = $json->TimeFinish;
            $params->DayOfWeekID = $n;
            
            if ($this->model->addWish($params)) {
             $json->result ++;
            }
           }
          }
          if ($json->result) {
           $json->message = $this->getMessage('addmoney_success');
          }
          
          /*
          if ($this->model->addWish($params)) {
           $json->message = $this->getMessage('addmoney_success');
           $json->result = 1;
          } else {
           $json->message = $this->getMessage('addmoney_error_unknown');
           $json->result = 0;
          }
          */
          
         }
         
         
         $json->ID = $json->StudentID;
         $json->Newwish_DateStart  = $json->DateStart;
         $json->Newwish_DateFinish = $json->DateFinish;
         
         echo $this->loadWishes($json);
         
        break;
        
        case ("deleteWish"):
         $ret = $this->model->deleteWish($json);
        break;
        
        case ("loadSubItems"):
//         ajax_echo_r ($json);
         
         echo $this->loadSubItems($json);
         
         /*
         if ($json->tablename == "statuses") {
          $params = new stdClass;
          $params->ID = $json->ID;
          $params->tablename = "tasks";
          $params->fieldname = "StudentID";
          
          echo $this->loadSubItems($params);
         }
         */
        break;
        
        case ("loadActivities"):
//         ajax_echo_r ($json);
         
         echo $this->loadActivities($json);
        break;
        
        case ("loadWishes"):
//         ajax_echo_r ($json);
         
         echo $this->loadWishes($json);
        break;
        
        case ("loadConversation"):
         $leftcontent = new Template($this->viewroot, "editor_users.htt");
         $leftcontent->loadloop('block_conversation');
         
         $loop_chat             = new Template($this->viewroot, $leftcontent->returnloop('loop_chat'        ));
         $loop_chat_tab         = new Template($this->viewroot, $leftcontent->returnloop('loop_chat_tab'    ));
         $loop_table_row        = new Template($this->viewroot, $leftcontent->returnloop('loop_conversation'));
         
         $block_dir = array();
         $block_dir[0]     = new Template($this->viewroot, $leftcontent->returnloop('block_dir0'));
         $block_dir[1]     = new Template($this->viewroot, $leftcontent->returnloop('block_dir1'));
         $block_areq       = new Template($this->viewroot, $leftcontent->returnloop('block_areq'));
         $block_agrant     = new Template($this->viewroot, $leftcontent->returnloop('block_agrant'));
         $block_callstart  = new Template($this->viewroot, $leftcontent->returnloop('block_callstart'));
         $block_callend    = new Template($this->viewroot, $leftcontent->returnloop('block_callend'));
         $block_groupchat  = new Template($this->viewroot, $leftcontent->returnloop('block_groupchat'));
         
         $block_dir[0] = $block_dir[0]->output();
         $block_dir[1] = $block_dir[1]->output();
         $block_areq        = $block_areq->output();
         $block_agrant      = $block_agrant->output();
         $block_callstart   = $block_callstart->output();
         $block_callend     = $block_callend->output();
         $block_groupchat   = $block_groupchat->output();
         
         $vars = $loop_table_row->getVariables();
         $items = $this->model->getConversation($json);
         $i = 0;
         
         if ($items) {
          foreach ($items as $k=>$chat) {
           $loop_chat_tab->reload();
           $loop_chat_tab->fill("%k%", $k);
           $loop_chat_tab->fill("%i%", $i);
           $loop_chat_tab->fill("%tabActive%", ($i==0)?"tabActive":"tab");
           
           $loop_chat_tab_str .= $loop_chat_tab->output();
           $i++;
          }
         }
         $leftcontent->fillloop('loop_chat_tab', $loop_chat_tab_str);
         
         $i = 0;
         if ($items) {
          foreach ($items as $k=>$chat) {
           $loop_chat->reload();
           $loop_str = "";
           $loop_chat->fill("%k%", $k);
           $loop_chat->fill("%i%", $i);
           $loop_chat->fill("%hidden%", (($i==0)?"":"hidden"));
           
           
           foreach ($chat as $item) {
            $loop_table_row->reload();
            $loop_table_row->fill( "%calldiretion%", $block_dir[$item->DirectionID]);
            $loop_table_row->fill(            "%c%", $item->DirectionID);
            
            if ($item->DateTime=='2016-03-11 16:35:07') {
//             ajax_echo_r ($item);
//             echo htmlspecialchars($item->body_xml);
            }
//            echo htmlspecialchars($item->body_xml)."-".$item->type."<br>";
            $item->Message = nl2br($item->Message);
            switch ($item->type) {
             case (50):
              $item->Message = $block_areq.$item->Message;
             break;
             case (4):
              $item->Message = $block_groupchat.$item->identities;
             break;
             case (51):
              $item->Message = $block_agrant.$item->Message;
             break;
             case (30):
              $item->Message = $block_callstart;
             break;
             case (39):
              $buf = new Template($this->viewroot, $item->Message);
              $buf->loadloop('duration');
              $buf=(int)$buf->output();
              $item->Message = $block_callend.gmdate("H:i:s", $buf);
             break;
             default:
 //             $item->Message = str_replace("</quote>", "</quote>\n", $item->Message);
              $item->Message = str_replace("&lt;&lt;&lt;", "", $item->Message);
              
 //             $item->Message = htmlspecialchars($item->Message);
              $item->Message = nl2br($item->Message);
             break;
            }
            
            if ($item->Message) {
             foreach ($vars as $var) {
              if ($var) {
               $loop_table_row->fill(       "%".$var."%" , brtonl($item->$var));
              }
             }
             $loop_table_row->processfcb('');
             $loop_table_row->fill(  '%imgfolder%' , $this->imgfolder                    );
             $loop_table_row->fill(   '%viewroot%' , $this->viewroot                     );
             $loop_str .= $loop_table_row->output();
             $c++;
            }
           }
           $loop_chat->fillloop('loop_conversation', $loop_str);
           $loop_chat_str .= $loop_chat->output();
           $i++;
          }
         }
         
         $leftcontent->fillloop(   "block_dir0","" );
         $leftcontent->fillloop(   "block_dir1","" );
         $leftcontent->fillloop(   "block_areq","" );
         $leftcontent->fillloop(   "block_agrant","" );
         $leftcontent->fillloop(   "block_callstart","" );
         $leftcontent->fillloop(   "block_callend","" );
         $leftcontent->fillloop(   "block_groupchat","" );
         
         $leftcontent->fillloop('loop_chat', $loop_chat_str);
         ajax_echo (localize($leftcontent->output()));
        break;
        
        case ("loadTalk"):
         echo ($this->getMessages($json));
        break;
        
        case ('loadScheduleDebug'):
         echo $this->loadScheduleDebug($json);
        break;
        
        case ('loadEmails'):
         $leftcontent = new Template($this->viewroot, "editor_assessments.htt");
         $leftcontent->loadloop('block_emails');
         
         $loop_table_row           = new Template($this->viewroot, $leftcontent->returnloop('loop_emails'        ));
         $vars = $loop_table_row->getVariables();
         
         $json->AssID = $json->ID;
         $json->ResponseOnly = 1;
         $items = $this->model->getEmails($json);
//         ajax_echo_r ($items);
         $c = 0;
         
         foreach ($items as $item) {
          $loop_table_row->reload();
          $loop_table_row->fill( "%calldiretion%", $block_dir[$item->DirectionID]);
          
          if ($item->type==51) {
           $item->Message = $item->Message.$block_areq;
          }
          
          $loop_table_row->fill(       "%c%" , $c);
          foreach ($vars as $var) {
           if ($var) {
            $loop_table_row->fill(       "%".$var."%" , brtonl($item->$var));
           }
          }
          $loop_table_row->processfcb('');
          $loop_table_row->fill(  '%imgfolder%' , $this->imgfolder                    );
          $loop_table_row->fill(   '%viewroot%' , $this->viewroot                     );
          $loop_str .= $loop_table_row->output();
          
          $c++;
         }
         $leftcontent->fillloop('loop_emails', $loop_str);
         ajax_echo (localize($leftcontent->output()));
        break;
        
        case ('loadFiles'):
//         ajax_echo_r ($json);
         $rec = $this->model->getClub($json->ID);
//         ajax_echo_r ($rec);
         
         $files = $this->getFiles($rec);
         
         ajax_echo ($files['name']);
//         ajax_echo ($files);
        break;
        
        case ('sendAssessment'):
//         echo session_id();
//         ajax_echo_r ($json);
         
         $eml = $this->model->getEmail($json);
//         ajax_echo_r ($eml);
         
         if (($eml->Key == $json->ekey) && ($eml->SessionID == session_id())) {
          $ret = new stdClass;
          if ($json->AssessmentText=='') {
           $ret->message = $this->getMessage('addemail_error_novalue');
           $ret->result = 0;
          } else {
           $data = new stdClass;
           $data->ID = $json->ID;
           $data->AssessmentText = $json->AssessmentText;
           $data->AssessmentText = unfilter($data->AssessmentText);
           if ($this->model->addEmail($data)) {
            $ret->message = $this->getMessage('addemail_success');
            $ret->result = 1;
           } else {
            $ret->message = $this->getMessage('addmoney_error_unknown');
            $ret->result = 0;
           }
          }
          echo ($ret->message);
          
          
          
         } else {
          echo "Token/session mismatch";
         }
         
        break;
        
        case ('sendComment'):
//         echo session_id();
//         ajax_echo_r ($json);
         
         $eml = $this->model->getEmail($json);
//         ajax_echo_r ($eml);
         
         $ret = new stdClass;
         if (($eml->Key == $json->ekey) && ((!$eml->SessionID) || ($eml->SessionID == session_id()))) {
//          $ret = new stdClass;
          if ($json->AssessmentText=='') {
//           $ret->message = $this->getMessage('addemail_error_novalue');
//           $ret->result = 0;
          } else {
           $data = new stdClass;
           $data->ID = $json->ID;
           $data->Comment = $json->AssessmentText;
           $data->Comment = unfilter($data->Comment);
           
           $data->ParentName      = 'emails';
           $data->ParentID        = $data->ID;
           $data->UserID          = -1;
           $data->LastID          = $json->LastID;
           
           $this->model->addComment($data);
          }
          $block_comments = $this->getComments($data);
          $ret->message = localize($block_comments);
          
         } else {
//          echo "Token/session mismatch";
         }
         echo json_encode($ret);
        break;
        
        case ('trackEmail'):
//         addtologEx($_REQUEST, 'trackEmail.log');
         
         $key = getvariablereq('key');
//         ajax_echo_r ($key);
         $info = $this->model->findAssessment($key);
//         ajax_echo_r ($info);
         
         $data = new stdClass;
         $data->ID = $info->Email->ID;
         $data->DateRead = date("Y-m-d H:i:s");
         $ret = $this->model->addEmail($data);
//         ajax_echo_r($ret);
         
         
         /*
         header("Cache-Control: max-age=432000");
         header("Server: nginx/1.8.0");
         header("Content-Encoding: gzip");
         */
         header("Pragma: no-cache");
         header("Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0");
         header("Expires: 0");
         header("Content-Disposition: attachment; filename=1px.png");
         header("Content-Transfer-Encoding: binary");
         header("Content-Type: image/png");
         header("Content-Length: 68");
         
         echo file_get_contents("view/modern/img/1px.png");
         
         
        break;
        
        case ('autosaveAssessmentText'):
         setsecurevariable("AssessmentText",$json->AssessmentText);
        break;
        
        
        case ('exportXls'):
         echo $this->model->exportXls($json);
        break;
        
        
        case ('sendMessage'):
//         ajax_echo_r ($json);
         
         if ($json->checkOnly) {
          setsecurevariable('Comment_'.$json->ParentName.'_'.$json->ParentID, $json->Comment); 
         } else {
          setsecurevariable('Comment_'.$json->ParentName.'_'.$json->ParentID, ''); 
         }
         
         $ret = new stdClass;
         if (!$json->checkOnly && $json->Comment) {
          $data = new stdClass;
          $data->Comment = $json->Comment;
          $data->Comment = unfilter($data->Comment);
          
          $data->ParentName      = $json->ParentName;
          $data->ParentID        = $json->ParentID;
          $data->UserID          = $this->userid;
          
          $this->model->addMessage($data);
         }
         $json->LastID = (int)$json->LastID;
         $block_comments = $this->getMessages($json);
         $ret->message = localize($block_comments);
         
         echo json_encode($ret);
        break;
        
        case ('getUsers'):
         $leftcontent = new Template($this->viewroot, "editor_clubs.htt");
         
         if ($this->user->IsHead) {
          $req = new stdClass;
          $req->PartnersOnly = 1;
          $req->UserID = $this->userid;
          $list=$this->model->getUsersList($req);
         } else {
          $list = array();
          $list[$this->userid] = $this->user;
         }
         $loop = new Template($this->viewroot, $leftcontent->returnloop("block_betUsers"));
//         ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, $this->userid);
         echo localize($loopdata);
        break;
        
        
        
        
        case ('newUsergroups_Group'):
 //        ajax_echo_r ($json);
         if ($json->ID) {
//          $rec = $this->model->getVacancy($json);
         } else {
          $rec = new stdClass;
         }
 //        ajax_echo_r ($rec);
         
         $leftcontent = new Template($this->viewroot, "editor_usergroups_group.htt");
         
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , brtonl($rec->$var));
          }
         }
         
         $leftcontent->processfcb('');
         
         ajax_echo (localize($leftcontent->output()));
        break;
        
        case ('addUsergroups_Group'):
         $ret = new stdClass;
         
         if (trim($json->Title)=='') {
          $ret->message = $this->getMessage('addusergroup_error_notitle');
          $ret->result = 0;
         } elseif (trim($json->Name)=='') {
          $ret->message = $this->getMessage('addusergroup_error_noname');
          $ret->result = 0;
         } else {
          if ($this->model->addUsergroups_Group($json)) {
           $ret->message = $this->getMessage('addmoney_success');
           $ret->result = 1;
          } else {
           $ret->message = $this->getMessage('addmoney_error_unknown');
           $ret->result = 0;
          }
         }
         echo json_encode($ret);
         
        break;
        
        
        
        
        case ('newUsergroups_Right'):
 //        ajax_echo_r ($json);
         if ($json->ID) {
//          $rec = $this->model->getVacancy($json);
         } else {
          $rec = new stdClass;
         }
 //        ajax_echo_r ($rec);
         
         $leftcontent = new Template($this->viewroot, "editor_usergroups_right.htt");
         
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , brtonl($rec->$var));
          }
         }
         
         $leftcontent->processfcb('');
         
         ajax_echo (localize($leftcontent->output()));
        break;
        
        case ('addUsergroups_Right'):
         $ret = new stdClass;
         
         $k = $json->Name;
         $rec = $this->model->getAnyUsergroup();
//         echo strlen($rec->$k);
         
         if (trim($json->Name)=='') {
          $ret->message = $this->getMessage('addusergroup_error_noname');
          $ret->result = 0;
         } elseif (strlen($rec->$k)) {
          $ret->message = $this->getMessage('addusergroup_error_rightexists');
          $ret->result = 0;
         } else {
          if ($this->model->addUsergroups_Right($json)) {
           $ret->message = $this->getMessage('addmoney_success');
           $ret->result = 1;
          } else {
           $ret->message = $this->getMessage('addmoney_error_unknown');
           $ret->result = 0;
          }
         }
         echo json_encode($ret);
         
        break;
        
        case ('saveCell'):
//         ajax_echo_r ($json);
         
         $ids = explode("_", $json->id);
         
         $rec = new stdClass;
         $rec->id         = $ids[1];
         $rec->columnname = $ids[0];
         $rec->data       = $json->value;
         $rec->tablename  = $json->tablename;
         
         $this->model->saveField($rec);
         
        break;
        
        case ('setSidebarState'):
         $params = new stdClass;
         $params->tablename = "users";
         $params->columnname = "SidebarState";
         $params->data = $json->SidebarState;
         $params->id = $userid;
         
 //        ajax_echo_r ($params);
         
         $ret = $this->model->saveField($params);
 //        ajax_echo_r ($ret);
        break;
        
        case ('getMacros'):
         $params = new stdClass;
         $params->r_viewmode = getvariablereq('mode');
 //        ajax_echo_r ($params);
         $items = $this->model->getMacros($params);
//         ajax_echo_r ($items);
         
         $ret = "";
         if ($items[1]['everydayreminders']) {
          foreach ($items[1]['everydayreminders']->items as $k=>$v) {
           $ret.=$v->Firstname.";".$v->Skype.";".$v->ID."\r\n";
          }
         }
         
         echo $ret;
 //        ajax_echo_r ($ret);
        break;
        
        case ('skipCall'):
//         ajax_echo_r ($json);
         $params = new stdClass;
         $params->CustomerID = $json->ID;
         $params->UserID     = $this->userid;
         $params->EventID    = -2;
//         $params->DateAdded  = date("Y-m-d H:i:s");
         $ret = $this->model->addRecord("callstates", $params);
         
         /*
         if ($ret->rowsAffected) {
          echo "Successful";
         } else {
          echo "Error";
         }
         */
         
         $ret = $this->model->addEvent('skipCall','customers','ID',$json->ID,$json->ID);
         
         $ret = $this->model->skipCall($json);
//         ajax_echo_r ($ret);
        break;
        
        case ('nextCall'):
//         ajax_echo_r ($json);
         $params = new stdClass;
         $params->CustomerID = $json->ID;
         $params->UserID     = $this->userid;
         $params->EventID    = -3;
//         $params->DateAdded  = date("Y-m-d H:i:s");
         $ret = $this->model->addRecord("callstates", $params);
         
         /*
         if ($ret->rowsAffected) {
          echo "Successful";
         } else {
          echo "Error";
         }
         */
         
         $ret = $this->model->addEvent('nextCall','customers','ID',$json->ID,$json->ID);
         
         $ret = $this->model->skipCall($json);
//         ajax_echo_r ($ret);
        break;
        
        case ('updateCall'):
//         ajax_echo_r ($json);
         
         if ($json->sid) {
          $params = new stdClass;
          $params->DialCallSid = $json->sid;
          $params->UserID = $this->userid;
          
          $ret=$this->model->updateCall($params);
          echo $ret;
         }
         
        break;
        
        case ('showCallsDetails'):
//         ajax_echo_r ($json);
//         if ($this->userid==1) {
//          addtologEx($json, 'getCalls_pending.txt');
//         }
         
         $params = new stdClass;
         $params->silent = 1;
         $this->customersAutoclean($params);
         
         $log .= formatmicrotime(microtime(true) - $qtm)." 80\n";
         $log .= print_r ($json, true);
         
         
         include 'model/Twilio/Capability.php';
         
         // put your Twilio API credentials here
         $accountSid = $this->settings->accountSid;
         $authToken  = $this->settings->authToken;
         // put your Twilio Application Sid here
         $appSid     = $this->settings->appSid;
         
         /*
         $accountSid = 'AC5d776444a547db61084c3190db4cf6bf';
         $authToken  = '7fc7528bcf7a1fa956c4740825e7930f';
         $appSid     = 'AP25ebd1ceb9192b6e063d22f685623bad';
         */
         
         $capability = new Services_Twilio_Capability($accountSid, $authToken);
         $capability->allowClientOutgoing($appSid);
         if ($json->r_viewmode=='inbound') {
          $capability->allowClientIncoming("Arag");
//          setCache('lastuserid', $this->userid);
          
 //             ajax_echo_r ($json);
 //             echo "Inbound enabled";
         }
         $table = $this->model->getCallsv2($json);
         
         
         
         $log .= formatmicrotime(microtime(true) - $qtm)." 81\n";
         
//         ajax_echo_r ($table);
         $ret = new stdClass;
         $ret->debug = '';
         $ret->current = '';
         $tmp_src = new Template($this->viewroot, "main_calls.htt");
         
         $log .= formatmicrotime(microtime(true) - $qtm)." 83\n";
         $Token = $capability->generateToken();
         $tmp_src->fill('%Token%', $Token);
         
         $log .= formatmicrotime(microtime(true) - $qtm)." 85\n";
         if (sizeof($table)) {
          $firstid = 0; //array_keys($table)[0];
          
          $ret->CanProceed   = (int)$table[$firstid]->CanProceed;
          $ret->NeedActivity = (int)$table[$firstid]->NeedActivity;
          
          $log .= formatmicrotime(microtime(true) - $qtm)." 86\n";
//          ajax_echo_r ($table);
          $tmp_src->fill(  '%imgfolder%' , $this->imgfolder                    );
          $tmp_src->fill(   '%viewroot%' , $this->viewroot                     );
          $tmp_src->fill(      '%UserID%', $this->userid                       );
          
          $ret->debug = ''; // '-'.$json->CustomerID.'-'.$table[0]->ID.'-';
          if ($json->CustomerID != $table[$firstid]->ID) {
           $log .= formatmicrotime(microtime(true) - $qtm)." 87\n";
           if ($table[$firstid]->ID) {
//            ajax_echo_r ($json);
            
//            $leftcontent->fill(  '%Token%' , $capability->generateToken());
            
//            $table[$firstid]->Token = $capability->generateToken();
            
//            echo $table[$firstid]->Token;
            
            $block_top     = new Template($this->viewroot, $tmp_src->returnloop('block_top'));
            $thistable = "";
            
            $data = new stdClass;
            $data->ParentName = 'customers';
            $data->ParentID   = $table[$firstid]->ID;
            
            $table[$firstid]->LastMessageText = htmlspecialchars($table[$firstid]->LastMessageText);
            if (!$table[$firstid]->ReasonID              ) $table[$firstid]->ReasonID              = 20;
            if (!$table[$firstid]->MostLikeID            ) $table[$firstid]->MostLikeID            = 20;
            if (!$table[$firstid]->MostDislikeID         ) $table[$firstid]->MostDislikeID         = 20;
            if (!$table[$firstid]->TravelledAbroadID     ) $table[$firstid]->TravelledAbroadID     = 20;
            
            if (!$table[$firstid]->NotPurchasedID        ) $table[$firstid]->NotPurchasedID        = 20;
            if (!$table[$firstid]->ReceiveNotificationID ) $table[$firstid]->ReceiveNotificationID = 20;
            if (!$table[$firstid]->NotificationsUsefulID ) $table[$firstid]->NotificationsUsefulID = 20;
            if (!$table[$firstid]->ReactInAnyWayID       ) $table[$firstid]->ReactInAnyWayID       = 20;
            
            if (!$table[$firstid]->ReactInAnyWayID       ) $table[$firstid]->ReactInAnyWayID       = 20;
            if (!$table[$firstid]->SiteVersionID         ) $table[$firstid]->SiteVersionID         = 20;
            
//            ajax_echo_r ($table[$firstid]);
            
            if ($table[$firstid]->Prefixname) $table[$firstid]->Prefixname = "(".$table[$firstid]->Prefixname.")";
            
            $keys = array('main', 'contacts', 'deals', 'statuses');
            if ($json->Tab=='undefined') $json->Tab = 'main';
            if (!$json->Tab)             $json->Tab = 'main';
            
            foreach ($keys as $k) {
             $block_top->fill('%tab_'.$k.'_Active%', ($json->Tab==$k)?'Active':'');
             $block_top->fill('%tab_'.$k.'_Hidden%', ($json->Tab!=$k)?'hidden':'');
            }
            
            
            $lists  = array(
             'statusesreasons'       =>'ReasonID', 
             'mostlikes'             =>'MostLikeID', 
             'mostdislikes'          =>'MostDislikeID', 
             'travelledabroads'      =>'TravelledAbroadID', 
             
             'reasonsfornotpurchase' =>'NotPurchasedID',
             'receivenotifications'  =>'ReceiveNotificationID',
             'notificationsusefuls'  =>'NotificationsUsefulID',
             
             'reactinanyways'        =>'ReactInAnyWayID', 
             'siteversions'          =>'SiteVersionID', 
             
             'statusesstatuses'      =>'dummy', 
             'customersources'       =>'SourceID', 
             'customerstatuses'      =>'StatusID', 
             'customeremailedstates' =>'EmailedStateID', 
             'yesnodunno'            =>'MobileAppDownloadID', 
             'customerstages'        =>'StageID'
            );
            
            foreach ($lists as $k=>$v) {
             if ($block_top->returnloop("loop_".$k)) {
              $loop = new Template($this->viewroot, $block_top->returnloop("loop_".$k));
              $list = $this->model->getList($k);
              $loopdata = $this->fillList($list, $loop, $table[$firstid]->$v);
              $block_top->fillloop('loop_'.$k, $loopdata);
             }
            }
            
//            ajax_echo_r ($table[$firstid]);
            $block_top->fill(     "%hidden%", ($table[$firstid]->CanProceed)?"":"hidden"     );
            
            
            if ($table[$firstid]->ID) {
             $list = $this->model->getStatusesCustomers($table[$firstid]->ID, "customers", 0);
            } else {
             $list = array();
            }
            $block_top->fill('%touches_cnt%', sizeof($list));
            if ($list) {
             $block_statuses     = new Template($this->viewroot, $tmp_src->returnloop('block_statuses'));
             
//             ajax_echo_r ($list);
             
             $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_statuses'));
             $block_record       = new Template($this->viewroot, $tmp_src->returnloop('block_record'));
             
             $thistable = "";
             
//             $block_CallSet      = new Template($this->viewroot, $tmp_src->returnloop('block_CallSet'    ));
//             $block_MeetingSet   = new Template($this->viewroot, $tmp_src->returnloop('block_MeetingSet' ));
             
             $vars     = $loop_table_row->getVariables();
             $vars_rec =   $block_record->getVariables();
             $c = 0;
             foreach ($list as $k=>$v) {
              if ($v->ParentName) {
               $loop_table_row->reload();
               
               $loop_table_row->fill(     "%c%", $c%2     );
               $loop_table_row->fill(     "%dbg%", print_r($v, true)     );
               
               if ($v->BadLine) {
                $loop_table_row->removeloop('block_BadLine');
               } else {
                $loop_table_row->fillloop('block_BadLine'    , '');
               }
               
               if ($v->DoNotCallBack) {
                $loop_table_row->removeloop('block_DoNotCallBack');
               } else {
                $loop_table_row->fillloop('block_DoNotCallBack'    , '');
               }
               
               if ($v->Reason) {
                $loop_table_row->removeloop('block_Reason');
               } else {
                $loop_table_row->fillloop('block_Reason'    , '');
               }
               
               if ($v->CallSet) {
                $loop_table_row->removeloop('block_CallSet');
               } else {
                $loop_table_row->fillloop('block_CallSet'    , '');
               }
               
               if ($v->MeetingSet) {
                $loop_table_row->removeloop('block_MeetingSet');
               } else {
                $loop_table_row->fillloop('block_MeetingSet' , '');
               }
               
               if ($v->SemiPromise) {
                $loop_table_row->removeloop('block_SemiPromise');
               } else {
                $loop_table_row->fillloop('block_SemiPromise' , '');
               }
               
               
               
               $loop_table_row->fillloop('block_record'     , '');
               
               foreach ($vars as $var) {
                $loop_table_row->fill(     "%".$var."%", $v->$var     );
               }
               $c++;
               
  //             $loop_table_row->processfcb();
               $thistable.=$loop_table_row->output();
              }
              if ($v->PhoneNumber) {
               $block_record->reload();
               
               $block_record->fill(     "%c%", $c%2     );
               $block_record->fill(     "%dbg%", print_r($v, true)     );
               
               foreach ($vars_rec as $var) {
                $block_record->fill(     "%".$var."%", $v->$var     );
               }
               $c++;
               
  //             $loop_table_row->processfcb();
               $thistable.=$block_record->output();
              }
             }
             
             $block_statuses->fillloop  ('block_record' , '');
             $block_statuses->fillloop  ('loop_statuses', $thistable);
             $statuses = localize($block_statuses->output());
             
             $block_top->fillloop(  'block_statuses' , $statuses                     );
             $block_top->fillloop(    'block_norows' , ""                             );
            } else {
             $block_top->fillloop  (  'block_statuses' , ""                           );
             $block_top->removeloop(    'block_norows');
            }
            
            $block_top->fillloop  ('block_record', '');
            
            
            
            $vars = $block_top->getVariables();
            foreach ($vars as $var) {
             $block_top->fill(     "%".$var."%", $table[$firstid]->$var     );
            }
//            $loop_table_row->processfcb();
            
            $block_top->processfcb();
            $block_top->fill(  '%imgfolder%' , $this->imgfolder                    );
            $block_top->fill(   '%viewroot%' , $this->viewroot                     );
            $block_top->fill(      '%Token%' , $Token                              );
            
            $thistable = $block_top->output();
           } else {
            $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('block_norows'));
            $loop_table_row->fill(      '%Token%' , $Token                              );
            $thistable = $loop_table_row->output();
           }
           
//           $ret->current = "-".$table[$firstid]->ID."-"; //localize($thistable);
           $ret->current = localize($thistable);
          } else {
           $ret->debug = ''; //'-'.$json->LastCallStateID.'-'.$table[0]->LastCallStateID.'-';
           if ($json->LastCallStateID != $table[0]->LastCallStateID) {
            $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('block_callState'));
            $thistable = "";
            
            if ($table[$firstid]) {
             $loop_table_row->fill(     "%hidden%", ($table[$firstid]->CanProceed)?"":"hidden"     );
             
             $vars = $loop_table_row->getVariables();
             foreach ($vars as $var) {
              $loop_table_row->fill(     "%".$var."%", $table[$firstid]->$var     );
             }
 //            $loop_table_row->processfcb();
             $thistable = $loop_table_row->output();
            }
            
            $ret->callState = localize($thistable);
            $ret->StatusID = $table[0]->LastCallCustomerStatusID;
            
           }
           
          }
          
          $log .= formatmicrotime(microtime(true) - $qtm)." 88\n";
          $ids = "";
          foreach ($table as $k=>$v) {
           if ($k!=$firstid) {
            $ids.=$v->ID;
           }
          }
          
          // $table[$firstid]->ID
          
//          echo "ids: ".$ids."<br>";
          
          $log .= formatmicrotime(microtime(true) - $qtm)." 89\n";
          if ($json->IDs != $ids) {
           $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('loop_table_row'));
           $thistable = "";
           
           $log .= formatmicrotime(microtime(true) - $qtm)." 90\n";
           $vars = $loop_table_row->getVariables();
           $c = 0;
           foreach ($table as $k=>$v) {
            if ($k!=$firstid) {
//             echo $k."-".$firstid."-".$v->ID."<br>";
             $loop_table_row->reload();
             
             $loop_table_row->fill(     "%c%", $c%2     );
             
             foreach ($vars as $var) {
              $loop_table_row->fill(     "%".$var."%", $v->$var     );
             }
             $c++;
             
//             $loop_table_row->processfcb();
             $thistable.=$loop_table_row->output();
            }
           }
           
           $log .= formatmicrotime(microtime(true) - $qtm)." 91\n";
           $loop_table     = new Template($this->viewroot, $tmp_src->returnloop('loop_table'));
           $loop_table->fill(      '%Token%' , $Token                              );
           $loop_table->fillloop('loop_table_row', $thistable);
           
           $ret->pending = localize($loop_table->output());
           
           $log .= formatmicrotime(microtime(true) - $qtm)." 92\n";
           
          } else {
           if (!$json->IDs) {
//            $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('block_norows'));
//            $ret->pending = $loop_table_row->output();
//            $ret->pending = '';
            $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('block_norows'));
            $loop_table_row->fill(      '%Token%' , $Token                              );
            $ret->pending = $loop_table_row->output();;
           }
          }
          
         }
         $log .= formatmicrotime(microtime(true) - $qtm)." 98\n";
         
         /*
         if ($ret->pending == '') {
          $loop_table_row     = new Template($this->viewroot, $tmp_src->returnloop('block_norows'));
          $ret->pending = $loop_table_row->output();;
         }
         */
         
         /*
          $tmp_src->removeloop('loop_table', '');
          $tmp_src->fillloop('block_norows', '');
         } else {
          $tmp_src->fillloop('block_top', '');
          $tmp_src->fillloop('loop_table', '');
          $tmp_src->removeloop('block_norows');
         }
         */
         
         $ret->Token = $Token;
         
         echo json_encode($ret);
         
         $log .= formatmicrotime(microtime(true) - $qtm)." 99\n";
         if (microtime(true) - $qtm>0.3) {
          addtologEx($log, 'showCallsDetails-'.(microtime(true) - $qtm).'.txt', 'showCallsDetails');
         }
        break;
        
        
        case ('cust_deleteStatus'):
//         ajax_echo_r ($json);
         
         if ($json->StatusID) {
          $params = new stdClass;
          $params->ID = $json->StatusID;
          $ret = $this->model->deleteStatus($params);
         }
         
         $leftcontent = new Template($this->viewroot, "editor_customers.htt");
         $leftcontent->processfcb();
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         
         if ($this->user->GroupID==1) {
          $leftcontent->removeloop('block_adminonly2');
         } else {
          $leftcontent->fillloop('block_adminonly2','');
         }
         
         $loop_table_row = new Template($this->viewroot, $leftcontent->returnloop("loop_statuses"));
         $block_record   = new Template($this->viewroot, $leftcontent->returnloop("block_record"));
         $block_event    = new Template($this->viewroot, $leftcontent->returnloop("block_event"));
         $list = $this->model->getStatusesCustomers($json->ID, 'customers', 1);
//         ajax_echo_r ($list);
         
         //$loopdata = $this->fillList($list, $loop, 0);
         
         $vars     = $loop_table_row->getVariables();
         $vars_rec = $block_record->getVariables();
         $vars_evt = $block_event->getVariables();
         
         foreach ($list as $k=>$v) {
          if ($v->ParentName) {
           $loop_table_row->reload();
           
           foreach ($vars as $var) {
            $loop_table_row->fill(       "%".$var."%" , brtonl($v->$var));
           }
           
           if ($v->BadLine) {
            $loop_table_row->removeloop('block_BadLine');
           } else {
            $loop_table_row->fillloop('block_BadLine'    , '');
           }
           
           if ($v->DoNotCallBack) {
            $loop_table_row->removeloop('block_DoNotCallBack');
           } else {
            $loop_table_row->fillloop('block_DoNotCallBack'    , '');
           }
           
           if ($v->Reason) {
            $loop_table_row->removeloop('block_Reason');
           } else {
            $loop_table_row->fillloop('block_Reason'    , '');
           }
           
           if ($v->CallSet) {
            $loop_table_row->removeloop('block_CallSet');
           } else {
            $loop_table_row->fillloop('block_CallSet'    , '');
           }
           
           if ($v->MeetingSet) {
            $loop_table_row->removeloop('block_MeetingSet');
           } else {
            $loop_table_row->fillloop('block_MeetingSet' , '');
           }
           
           if ($v->SemiPromise) {
            $loop_table_row->removeloop('block_SemiPromise');
           } else {
            $loop_table_row->fillloop('block_SemiPromise' , '');
           }
           
           $thistable.=$loop_table_row->output();
          }
          if ($v->PhoneNumber) {
           $block_record->reload();
           
           $block_record->fill(     "%c%", $c%2     );
           $block_record->fill(     "%dbg%", print_r($v, true)     );
           
           foreach ($vars_rec as $var) {
            $block_record->fill(     "%".$var."%", $v->$var     );
           }
           $c++;
           
//             $loop_table_row->processfcb();
           $thistable.=$block_record->output();
          }
          if ($v->Name) {
           $block_event->reload();
           
           $block_event->fill(     "%c%", $c%2     );
           $block_event->fill(     "%dbg%", print_r($v, true)     );
           
           foreach ($vars_evt as $var) {
            $block_event->fill(     "%".$var."%", $v->$var     );
           }
           $c++;
           
           $thistable.=$block_event->output();
          }
         }
         
//         $leftcontent->fillloop('loop_statuses', $thistable);
         echo localize($thistable);
         
        break;
        
        
        case ('newCustomer'):
         $leftcontent = new Template($this->viewroot, "editor_customers.htt");
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         
         if ($this->user->GroupID==1) {
          $leftcontent->removeloop('block_adminonly2');
         } else {
          $leftcontent->fillloop('block_adminonly2','');
         }
         
         if ($json->ID) {
          $rec = $this->model->getCustomer($json->ID);
          $leftcontent->fill('%hidden%', '');
         } else {
          $rec = new stdClass;
          $rec->TypeID=1;
          $leftcontent->fill('%hidden%', 'hidden');
         }
         
//         ajax_echo_r ($rec);
         
         $loopdata = "";
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_fields"));
         foreach ($rec as $k=>$v) {
          if ($v) {
           $loop->reload();
           $loop->fill("%k%", $k);
           $loop->fill("%v%", $v);
           $loopdata.=$loop->output();
          }
         }
         $leftcontent->fillloop('loop_fields', $loopdata);
         
         
         
         $loop_table_row = new Template($this->viewroot, $leftcontent->returnloop("loop_statuses"));
         $block_record   = new Template($this->viewroot, $leftcontent->returnloop("block_record"));
         $block_event    = new Template($this->viewroot, $leftcontent->returnloop("block_event"));
         $list = $this->model->getStatusesCustomers($json->ID, 'customers', 1);
//         ajax_echo_r ($list);
         
         //$loopdata = $this->fillList($list, $loop, 0);
         
         $vars     = $loop_table_row->getVariables();
         $vars_rec = $block_record->getVariables();
         $vars_evt = $block_event->getVariables();
         
         foreach ($list as $k=>$v) {
          if ($v->ParentName) {
           $loop_table_row->reload();
           
           foreach ($vars as $var) {
            $loop_table_row->fill(       "%".$var."%" , brtonl($v->$var));
           }
           
           if ($v->BadLine) {
            $loop_table_row->removeloop('block_BadLine');
           } else {
            $loop_table_row->fillloop('block_BadLine'    , '');
           }
           
           if ($v->DoNotCallBack) {
            $loop_table_row->removeloop('block_DoNotCallBack');
           } else {
            $loop_table_row->fillloop('block_DoNotCallBack'    , '');
           }
           
           if ($v->Reason) {
            $loop_table_row->removeloop('block_Reason');
           } else {
            $loop_table_row->fillloop('block_Reason'    , '');
           }
           
           if ($v->CallSet) {
            $loop_table_row->removeloop('block_CallSet');
           } else {
            $loop_table_row->fillloop('block_CallSet'    , '');
           }
           
           if ($v->MeetingSet) {
            $loop_table_row->removeloop('block_MeetingSet');
           } else {
            $loop_table_row->fillloop('block_MeetingSet' , '');
           }
           
           if ($v->SemiPromise) {
            $loop_table_row->removeloop('block_SemiPromise');
           } else {
            $loop_table_row->fillloop('block_SemiPromise' , '');
           }
           
           
           $thistable.=$loop_table_row->output();
          }
          if ($v->PhoneNumber) {
           $block_record->reload();
           
           $block_record->fill(     "%c%", $c%2     );
           $block_record->fill(     "%dbg%", print_r($v, true)     );
           
           foreach ($vars_rec as $var) {
            $block_record->fill(     "%".$var."%", $v->$var     );
           }
           $c++;
           
//             $loop_table_row->processfcb();
           $thistable.=$block_record->output();
          }
          if ($v->Name) {
           $block_event->reload();
           
           $block_event->fill(     "%c%", $c%2     );
           $block_event->fill(     "%dbg%", print_r($v, true)     );
           
           foreach ($vars_evt as $var) {
            $block_event->fill(     "%".$var."%", $v->$var     );
           }
           $c++;
           
//             $loop_table_row->processfcb();
           $thistable.=$block_event->output();
          }
         }
         
         $leftcontent->fillloop('loop_statuses', $thistable);
         
         
         $vars = $leftcontent->getVariables();
          
         $leftcontent->fillloop('block_record', '');
         $leftcontent->fillloop('block_event' , '');
         
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , brtonl($rec->$var));
          }
         }
         
         $leftcontent->processfcb('');
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         
         $leftcontent = $this->fillStricts($leftcontent);
         
         ajax_echo (localize($leftcontent->output()));
        break;
        
        
        
        // skadate part start
        
        case ('newDIMember'):
         $leftcontent = new Template($this->viewroot, "editor_di-members.htt");
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         
         $vars     = $leftcontent->getVariables();
         
         if ($this->user->GroupID==1) {
          $leftcontent->removeloop('block_adminonly2');
         } else {
          $leftcontent->fillloop('block_adminonly2','');
         }
         
         include_once('model/MSkadate.php');
         $sk = new SModel($this->settings, $this->user);
         
         if ($json->ID>0) {
          $rec = $sk->getDIMember($json->ID);
          $leftcontent->fill('%hidden%', '');
         } else {
          $rec = new stdClass;
          $rec->parentUserId = $this->user->ID;
//          $rec->TypeID=1;
          $leftcontent->fill('%hidden%', 'hidden');
         }
         
         $rec->Avatar_Hidden = ($rec->Hash)?"":"hidden";
         
         $struct = $sk->getStruct();
         
//         ajax_echo_r ($rec);
//         ajax_echo_r ($struct);
         
         foreach ($struct->intvals as $k=>$v) {
//          echo $k."-".$v."-".$rec->Questions[$k]->intValue."<br>";
          foreach ($rec->Questions[$k]->Options as $ik=>$iv) {
//           echo $v."_".$ik."=".$iv."<br>";
           $leftcontent->fill('%'.$v."_".$ik.'%', $iv);
          }
         }
         
         foreach ($struct->textvals as $k=>$v) {
//          echo $k."-".$v."-".$rec->Questions[$k]->textValue."<br>";
          $leftcontent->fill('%'.$v.'%', $rec->Questions[$k]->textValue);
         }
         
         foreach ($struct->datevals as $k=>$v) {
//          echo $k."-".$v."-".$rec->Questions[$k]->dateValue."<br>";
          $leftcontent->fill('%'.$v.'%', dateAdaptRead($rec->Questions[$k]->dateValue));
         }
         
         /*
         $loopdata = "";
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_fields"));
         foreach ($rec as $k=>$v) {
          if ($v) {
           $loop->reload();
           $loop->fill("%k%", $k);
           $loop->fill("%v%", $v);
           $loopdata.=$loop->output();
          }
         }
         $leftcontent->fillloop('loop_fields', $loopdata);
         */
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , brtonl($rec->$var));
          }
         }
         
         
         
         
         /*
         $loop_table_row     = new Template($this->viewroot, $leftcontent->returnloop('loop_questions'));
         $vars = $loop_table_row->getVariables();
         
         $c = 0;
//            ajax_echo_r ($table);
         
         $thisidcolumnname = $json->tablename."_ID";
         if ($rec->Questions) {
          ajax_echo_r ($rec->Questions);
          
          foreach ($rec->Questions as $k=>$v) {
           $loop_table_row->reload();
           $loop_table_row->fill(       "%c%", $c%2        );
           
           foreach ($vars as $vn) {
            $loop_table_row->fill("%".$vn."%", $v->$vn);
           }
           
           $thistable.=$loop_table_row->output();
           $c++;
          }
         }
         $leftcontent->fillloop('loop_questions', $thistable);
         */
         
         
         
         $leftcontent->processfcb('');
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         
         $leftcontent = $this->fillStricts($leftcontent);
         
         ajax_echo (localize($leftcontent->output()));
        break;
        
        case ('addDIMember'):
//         ajax_echo_r ($json);
         
         include_once('model/MSkadate.php');
         $sk = new SModel($this->settings, $this->user);
         
         $struct = $sk->getStruct();
         
//         die();
         
         $ret = new stdClass;
         if (($json->username=='')) {
          $ret->message = $this->getMessage('adduser_error_nousername');
          $ret->result = 0;
         } elseif (($json->email=='') && ($this->user->ID!=1)) {
          $ret->message = $this->getMessage('adduser_error_noemail');
          $ret->result = 0;
         } else {
 //         ajax_echo_r ($json);
          $ret->ID = $sk->saveDIMember($json);
          if ($ret->ID) {
           $ret->message = $this->getMessage('addmoney_success');
           $ret->result = 1;
          } else {
           $ret->message = $this->getMessage('addmoney_error_unknown');
           $ret->result = 0;
          }
         }
         echo json_encode($ret);
         
         
        break;
        
        
        
        
        
        
        // skadate part end
        
        case ('dbRefine'):
//         ajax_echo_r ($json);
         
         $fndst = ajaxdecode($json->Mode);
         
         switch ($json->Mode) {
          case ('Reason'):
           $lists  = array('statusesreasons'=>'ReasonID');
          break;
          case ('MostLike'):
           $lists  = array('mostlikes'=>'MostLikeID');
          break;
          case ('MostDislike'):
           $lists  = array('mostdislikes'=>'MostDislikeID');
          break;
          case ('TravelledAbroad'):
           $lists  = array('travelledabroads'=>'TravelledAbroadID');
          break;
          case ('NotPurchased'):
           $lists  = array('reasonsfornotpurchase'=>'NotPurchasedID');
          break;
          
          case ('ReceiveNotification'):
           $lists  = array('receivenotifications'=>'ReceiveNotificationID');
          break;
          case ('NotificationsUseful'):
           $lists  = array('notificationsusefuls'=>'NotificationsUsefulID');
          break;
          case ('ReactInAnyWay'):
           $lists  = array('reactinanyways'=>'ReactInAnyWayID');
          break;
          case ('SiteVersion'):
           $lists  = array('siteversions'=>'SiteVersionID');
          break;
          
          
          default:
           echo "dbRefine - unknown Mode:".$json->Mode."<br>";
          break;
         }
         
         $leftcontent = new Template($this->viewroot, "editor_dbRefine_".$fndst.".htt");
         
         foreach ($lists as $k=>$v) {
          $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_".$k));
          $list = $this->model->getList($k);
          $loopdata = $this->fillList($list, $loop, 20);
          $leftcontent->fillloop('loop_'.$k, $loopdata);
         }
         
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , brtonl($json->$var));
          }
         }
         
         
         $leftcontent->processfcb('');
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         
         $leftcontent = $this->fillStricts($leftcontent);
         
         ajax_echo (localize($leftcontent->output()));
        break;
        
        case ('dbRefine_save'):
         ajax_echo_r ($json);
         $ret = $this->model->dbRefine_save($json);
//         ajax_echo_r ($ret);
         echo "Changed ".$ret->rowsAffected." statuses.";
        break;
        
        case ('dbintegrity'):
         $qtm = microtime(true);
//         ajax_echo_r ($json);
         
         switch ($json->id) {
          case ('start'):
           $ret = $this->model->checkIntegrity($json);
          break;
          case ('recover'):
           $fname = "data/cache/Full_list.xls";
           $action = "integration";
           $ret = $this->model->importXls($fname, $action);
           ajax_echo_r ($ret);
           
          break;
         }
         
         echo "Time elapsed: ".formatmicrotime(microtime(true) - $qtm)."<br>\n";
        break;
        
        case ('dbfix'):
         $this->dbfix($json);
        break;
        
        case ('dbfix2'):
         $this->dbfix2($json);
        break;
        
        case ('dbfix3'):
         $this->dbfix3($json);
        break;
        
        case ('callsassign'):
         $this->callsassign($json);
        break;
        
        case ('callsassign2'):
         $this->callsassign2($json);
        break;
        
        case ('timezones'):
         $this->timezones($json);
        break;
        
        case ('timezones2'):
         $this->timezones2($json);
        break;
        
        case ('manageDuplicates'):
         $this->manageDuplicates($json);
        break;
        
        case ('manageLastEvents'):
         $this->manageLastEvents($json);
        break;
        
        case ('loadCalls'):
         $this->loadCalls($json);
        break;
        
        case ('customersAutoclean'):
         $this->customersAutoclean($json);
        break;
        
        case ('recalcListIDs'):
         $this->recalcListIDs($json);
        break;
        
        case ('vacuum'):
         $this->vacuum($json);
        break;
        
        case ('updateWorksessions'):
         $this->updateWorksessions($json);
        break;
        
        case ('wirecrm_load'):
         $this->wirecrm_load($json);
        break;
        
        case ('randomfill'):
         $this->randomfill($json);
        break;
        
        
        case ('downloadXls'):
         $data = getFromCache('analytics_'.session_id());
         $ret = $this->model->downloadXls($json, $data);
         ajax_echo_r ($ret);
        break;
        
        case ('deleteStatus'):
         $ret = $this->model->deleteStatus($json);
         ajax_echo_r ($ret);
        break;
        
        case ('deleteEvent'):
         $ret = $this->model->deleteEvent($json);
         ajax_echo_r ($ret);
        break;
        
        
        
        
        case ('dashboard_update'):
//         ajax_echo_r ($json);
         
         switch ($json->r_viewmode) {
          case ('dashboard-customers'):
           $table = $this->model->getDashboardCustomers($json);
          break;
          case ('dashboard-statuses'):
           $table = $this->model->getDashboardStatuses($json);
          break;
          case ('dashboard-performance'):
           $table = $this->model->getDashboardPerformance($json);
          break;
         }
         
         echo json_encode($table);
        break;
        
        
        
        case ('recalcTimezone'):
//         ajax_echo_r ($json);
//         die();
         $ret = $this->timezones($json);
         $ret = $this->timezones2($json);
        break;
        
        
        case ('customersreport1'):
        case ('customersreport2'):
        case ('customersreport3'):
        case ('customersreport4'):
        case ('customersreport5p1'):
        case ('customersreport5p2'):
        case ('customersreport5p3'):
        case ('recalcListIDs'):
        case ('coldcallsstatuses'):
         $this->model->makeBigReport($action);
        break;
        
        case ('loadrecordings'):
         $timer = microtime(true);
         
         $this->model->loadRecordings($json);
         
         echo "loadrecordings - Time elapsed ".formatmicrotime(microtime(true) - $timer)." s. <br>";
         
        break;
        
        case ('selectLesson'):
//         ajax_echo_r ($json);
//         ajax_echo_r ($this->user);
         
         $k = "Ability-Teacher";
         if ($this->user->usergroup->$k) {
          $rec = new stdClass;
          $rec->TeacherID = $this->userid;
          if ($json->DateTime) {
           $rec->DateStart = $json->DateTime; //.":00";
//           echo "rec->DateStart: ".$rec->DateStart."<br>";
          }
          
 //         ajax_echo_r ($this->user);
          $k = "Strict-Club";
          if ($this->user->usergroup->$k) {
           $json->flt_ClubID = $this->user->ClubID;
 //          echo "flt_ClubID: ".$flt_ClubID."<br>";
          } else {
           $k = "Strict-Company";
           if ($this->user->usergroup->$k) {
            $json->flt_CompanyID = $this->user->CompanyID;
 //           echo "flt_CompanyID: ".$flt_CompanyID."<br>";
           }
          }
          
          $leftcontent = new Template($this->viewroot, "editor_lesson.htt");
          
          $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_students"));
          $list = $this->model->getStudents($json);
          $loopdata = $this->fillList($list, $loop, $rec->StudentID);
          $leftcontent->fillloop('loop_students', $loopdata);
          
          $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_teachers"));
          $list = $this->model->getTeachers($json);
          $loopdata = $this->fillList($list, $loop, $rec->TeacherID);
          $leftcontent->fillloop('loop_teachers', $loopdata);
          
          $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_types"));
          $list = $this->model->getList('scheduletypes');
          $loopdata = $this->fillList($list, $loop, $rec->TypeID);
          $leftcontent->fillloop('loop_types', $loopdata);
          
          $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_statuses"));
          $list = $this->model->getList('schedulestatuses');
          $loopdata = $this->fillList($list, $loop, $rec->StatusID);
          $leftcontent->fillloop('loop_statuses', $loopdata);
          
          $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_clubs"));
          $list = $this->model->getClubs($json);
          $loopdata = $this->fillList($list, $loop, $rec->ClubID);
          $leftcontent->fillloop('loop_clubs', $loopdata);
          
          $vars = $leftcontent->getVariables();
          
          foreach ($vars as $var) {
           if ($var) {
            $leftcontent->fill(       "%".$var."%" , brtonl($rec->$var));
           }
          }
          
         } else {
          $club = $this->model->getClub($this->user->ClubID);
 //         ajax_echo_r ($club);
          
          $months = getMonths();
          $DateAdapted = date("d m Y H:i", strtotime($json->DateTime));
          $date = explode(" ", $DateAdapted);
          $json->DateAdapted = (int)$date[0]." ".$months[(int)$date[1]]." ".$date[2];
          $json->TimeAdapted = $date[3];
          $json->Address = $club->Address;
          $json->Phone   = $club->Phone;
          
          $leftcontent = new Template($this->viewroot, "snippet_confirmlesson.htt");
          
          /*
          foreach ($lists as $k=>$v) {
           $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_".$k));
           $list = $this->model->getList($k);
           $loopdata = $this->fillList($list, $loop, 20);
           $leftcontent->fillloop('loop_'.$k, $loopdata);
          }
          */
          
          
          $nfl = $this->model->getNumFreeLessons($this->userid);
//          echo $nfl;
          $freelesson = $nfl==0;
          
          if ($freelesson) {
           $leftcontent->removeloop('block_IsFree');
          } else {
           $leftcontent->fillloop('block_IsFree');
          }
          
          
         }
         
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , brtonl($json->$var));
          }
         }
         
         $leftcontent->processfcb('');
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         
         $leftcontent = $this->fillStricts($leftcontent);
         
         ajax_echo (localize($leftcontent->output()));
        break;
        case ('confirmLesson'):
//         ajax_echo_r ($json);
         
//         $club = $this->model->getClub($this->user->ClubID);
         
         $teachers = $this->model->getClubParticipants($this->user->ID, true);
//         ajax_echo_r ($teachers);
         
         $params->UserID    = $this->user->ID;
         $params->StudentID = $this->user->ID;
         $params->TeacherID = array_keys($teachers)[0];
         $params->IsFree    = $json->IsFree;
         $params->DateStart = $json->DateTime;
         $params->ClubID    = $this->user->ClubID;
         
         if (!$params->TeacherID) {
          echo localize($this->getMessage('block_confirmLesson_error_noteacher'));
         } else {
 //         ajax_echo_r ($params);
          $r = $this->model->addLesson($params);
 //         ajax_echo_r ($r);
          
 //         $ret = new stdClass;
 //         $ret->result = 1;
 //         echo json_encode($ret);
          
          
          
          if ($r->lastInsertID) {
           $club = $this->model->getClub($this->user->ClubID);
  //         ajax_echo_r ($club);
           
           $months = getMonths();
           $DateAdapted = date("d m Y H:i", strtotime($json->DateTime));
           $date = explode(" ", $DateAdapted);
           $json->DateAdapted = (int)$date[0]." ".$months[(int)$date[1]]." ".$date[2];
           $json->TimeAdapted = $date[3];
           $json->Address = $club->Address;
           $json->Phone   = $club->Phone;
           
           $leftcontent = new Template($this->viewroot, "snippet_lessonconfirmed.htt");
           
           $vars = $leftcontent->getVariables();
           
           foreach ($vars as $var) {
            if ($var) {
             $leftcontent->fill(       "%".$var."%" , brtonl($json->$var));
            }
           }
           
           $leftcontent->processfcb('');
           $leftcontent->fill(  '%imgfolder%', $this->imgfolder                    );
           $leftcontent->fill(   '%viewroot%', $this->viewroot                     );
           
           $leftcontent = $this->fillStricts($leftcontent);
           
           ajax_echo (localize($leftcontent->output()));
          } else {
           echo "Error: record was not added.";
          }
         }
         
        break;
        
        case ('editLesson'):
         $rec = $this->model->getLesson($json->ID);
//         ajax_echo_r($rec);
         
//         ajax_echo_r($json);
         
         
//         ajax_echo_r ($this->user);
         $k = "Strict-Club";
         if ($this->user->usergroup->$k) {
          $json->flt_ClubID = $this->user->ClubID;
//          echo "flt_ClubID: ".$flt_ClubID."<br>";
         } else {
          $k = "Strict-Company";
          if ($this->user->usergroup->$k) {
           $json->flt_CompanyID = $this->user->CompanyID;
//           echo "flt_CompanyID: ".$flt_CompanyID."<br>";
          }
         }
         
         $leftcontent = new Template($this->viewroot, "editor_lesson.htt");
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_students"));
         $list = $this->model->getStudents($json);
         $loopdata = $this->fillList($list, $loop, $rec->StudentID);
         $leftcontent->fillloop('loop_students', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_teachers"));
         $list = $this->model->getTeachers($json);
         $loopdata = $this->fillList($list, $loop, $rec->TeacherID);
         $leftcontent->fillloop('loop_teachers', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_types"));
         $list = $this->model->getList('scheduletypes');
         $loopdata = $this->fillList($list, $loop, $rec->TypeID);
         $leftcontent->fillloop('loop_types', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_statuses"));
         $list = $this->model->getList('schedulestatuses');
         $loopdata = $this->fillList($list, $loop, $rec->StatusID);
         $leftcontent->fillloop('loop_statuses', $loopdata);
         
         $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_clubs"));
         $list = $this->model->getClubs($json);
         $loopdata = $this->fillList($list, $loop, $rec->ClubID);
         $leftcontent->fillloop('loop_clubs', $loopdata);
         
         
         
         $vars = $leftcontent->getVariables();
         
         foreach ($vars as $var) {
          if ($var) {
           $leftcontent->fill(       "%".$var."%" , $rec->$var);
          }
         }
         
         $leftcontent->processfcb('');
         $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
         
         $leftcontent = $this->fillStricts($leftcontent);
         
         ajax_echo (localize($leftcontent->output()));
        break;
        
        case ('saveLesson'):
//         ajax_echo_r ($json);
         
         if (!$json->TeacherID) {
          $ret->message = localize($this->getMessage('addLesson_error_noteacher'));
         } elseif (!$json->StudentID) {
          echo localize($this->getMessage('addLesson_error_nostudent'));
         } else {
          $r = $this->model->addLesson($json);
          
 //         ajax_echo_r ($ret);
          if ($r->rowsAffected) {
           $ret->message = localize($this->getMessage('addmoney_success'));
          } else {
           $ret->message = localize($this->getMessage('addmoney_error_unknown'));
          }
         }
         
         echo $ret->message;
        break;
        
        case ('deleteLesson'):
//         ajax_echo_r ($json);
         $this->model->deleteLesson($json);
        break;
        
        
        
        
        case ('updateCounters'):
//         ajax_echo_r ($json);
         echo $this->model->updateCounters($json);
        break;
        
        case ('vk_fastsearch'):
//         ajax_echo_r ($json);
         
         $rec = new stdClass;
         $rec->TypeID = 1;
         
         $leftcontent = new Template($this->viewroot, "editor_users.htt");
         $leftcontent->loadloop('block_vk_fastsearchresults');
         
         
         $looptmp = $leftcontent->returnloop("loop_vk_fastsearchresults");
         if ($looptmp) {
          $loop = new Template($this->viewroot, $looptmp);
          $list = $this->model->vk_fastsearch($json);
          $loopdata = $this->fillList($list, $loop, 1);
          $leftcontent->fillloop('loop_vk_fastsearchresults', $loopdata);
          $leftcontent->processfcb('');
         }
         
         $leftcontent->fill(  '%imgfolder%', $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%', $this->viewroot                     );
         
         $vars    = $leftcontent->getVariables();
         
         foreach ($vars as $vn) {
          $leftcontent->fill("%".$vn."%", $json->$vn);
         }
         
         $leftcontent->processfcb('');
         
         $leftcontent->fill(  '%imgfolder%', $this->imgfolder                    );
         $leftcontent->fill(   '%viewroot%', $this->viewroot                     );
         
         echo (localize($leftcontent->output()));
         
         
        break;
        
        case ('recalcLessonsSuggestions'):
         $json->debug = 1;
         $ret = $this->model->recalcLessonsSuggestions($json);
        break;
        
        /*
        case ('loadLessonsSuggestions'):
         $ret = $this->model->recalcLessonsSuggestions($json);
        break;
        */
        
        case ('recalcAges'):
         $ret = $this->model->recalcAges($json);
        break;
        
        
        
        case ('start2'):
         ajax_echo_r($json);
        break;
        
        default:                                                                   // for me if I miss something.
         ajax_echo ("Unknown AJAX action: ".$action);
        break;
        
       }
      } else {
       echo "You need to login again.<br>";
       echo "Session ID: ".session_id()."<br>";
      }
      $k = 'etc-debug';
      if ((microtime(true) - $ajax_timer > 0.2) && ($action!='getInvoice') && ($this->user->usergroup->$k=='1')) {
       echo "Time elapsed ".formatmicrotime(microtime(true) - $ajax_timer)." s. <br>";
      }
     } else {                                                                        // for plain HTML (not an Ajax)
      if (((int)$this->user->AccountType==1) && (isset($_GET['admin']))) {         // if the admin wants to see his admin-panel
       $tmp = new Template($this->viewroot, 'adminparent.htt');                                      // load common parent template
       $tmp_clean = clone $tmp;
       $tmp->loadloop('selectcompanymsg');
       $selectcompanymsg = $tmp->output();
       
       $tmp = clone $tmp_clean;                                                     // load common parent template
       $tmp->loadloop("adminpage".$_GET['admin']);
       
       if ($_GET['admin']==3) {
        $tmp->fillloop('loop_table', "");
       }
       
       $thispage = $tmp->output();
       $tmp = clone $tmp_clean;                                                     // load common parent template
       $tmp->fillloop("adminpages_parent"  ,  $thispage);
       
       $tmp->fillloop(  "companydetails","" );
       $tmp->fillloop(    "agentdetails","" );
       $tmp->fillloop("selectcompanymsg","" );
       
       $tmp->fill(    "%list_agents%", $selectcompanymsg                 );
       $tmp->fill(     "%justlogged%", $this->user->JustLogged          );         // fill template
       $tmp->fill(  "%numoldrecords%", -2                                );         // fill the template with actual data
 //         $tmp->fill("%imgfolder%"      , "../".$this->settings->imgfolder        );        // fill the template with actual data
       $tmp->fill(      "%tableview%", $this->imgfolder                  );         // fill the template with actual data
       $tmp->fill(      "%agentname%", $this->user->Firstname." ".$this->user->Lastname                );        // fill the template with actual data
       $tmp->fill(       "%clubname%", $this->settings->projectname    );        // fill the template with actual data
       
       for ($n=0; $n<10; $n++) {
        $tmp->fill("%".$n."%"        , ($n==(int)$_GET['admin']?"active":""));       // fill the template with actual data
       }
       
 //      $tmp->fill("%style%"          , $this->getstylesheet($hue,$this->imgfolder)        );         // fill the template with compiled less stylesheet
       $this->processstylesheet($hue,'admin');
       
       echo localize($tmp->output());                                               // show it
       
      } else {                                                                      // if the user or manager wants to see his/her GUI
       $tmp = new Template($this->viewroot, 'mainparent.htt');                                       // load common parent template
       
       if ($userid>0) {
        $id      = getvariablereq('id'     );
        $auxmode = getvariablereq('auxmode');
        
        $page    = getvariablereq('page');
        if (!$page) $page = "money";
        
        $json = $_SESSION['json'][$go];
        if (!$json) $json = new stdClass;
//        ajax_echo_r ($_SESSION['json']);
//        ajax_echo_r ($json);
        
        $tmp->fill('%SidebarState%', $this->user->SidebarState);
        
        $privileges_this = $this->model->getUserPrivileges($userid);
        $privileges_all  = $this->model->getUserPrivileges(0);
        
//        ajax_echo_r ($privileges_this);
  //      ajax_echo_r ($privileges_all);
        
        $allowed = 0;
        
        foreach ($privileges_this as $p) {
         $tmp->removeloop('block_link_'.$p->PageName);
         if ($go == $p->PageName) $allowed = 1;
        }
//        echo $allowed."-".$go."<br>";
        
        foreach ($privileges_all as $p) {
         $tmp->fillloop('block_link_'.$p->PageName, '');
        }
//        echo $allowed."-".$go."<br>";
        
        if ($go=='home') {
         $allowed = 1;
        } else {
         if (!$allowed) {
          $go = $privileges_this[array_keys($privileges_this)[0]]->PageName;
         }
        }
        
  //      ajax_echo_r ($privileges_this);
//        echo $allowed."-".$go."<br>";
        
        setsecurevariable(          "go", $go );
        
        
        
        $loop_clean = clone $tmp;
        
        
        
        $tmp_user_info = clone $loop_clean;
        $tmp_user_info->loadloop("loop_user_info");
        
        foreach ($this->user as $k=>$v) {
         if (gettype($v)!='object') {
          $tmp_user_info->fill(    "%User_".$k."%", $v    );
         }
        }
        
        $loop_user_auth=$tmp_user_info->output();
        
        $tmp->removeloop("loop_globalparent");
        $tmp->fillloop("loop_user_auth"      , $loop_user_auth );
        $tmp->fillloop("loop_user_info"      , ""              );
        
        
        
        
        
        
        
        
        
        
        
        $leftcontent = new Template($this->viewroot, 'left_'.$go.'.htt');                                      // load common parent template
        
        if ($go=='calls' || $go=='tasks') {
         $maincontent = new Template($this->viewroot, 'main_'.$go.'.htt');                                                // load common parent template
        } else {
         $maincontent = new Template($this->viewroot, 'main_loader.htt');                                                // load common parent template
        }
        
 //       $editor = new Template($this->viewroot, 'editor_'.$go.'.htt');                                                // load common parent template
        
  //      echo $userid;
        
        $leftcontent->fill(       '%today%', date("Y-m-d")                       );
        $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
        $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
        
        switch ($go) {
         case ('dashboard'):
          if (getvariablereq('r_viewmode')) $json->r_viewmode=getvariablereq('r_viewmode');
//          echo $json->r_viewmode;
          if (gettype($json->r_viewmode)=='NULL') $json->r_viewmode = 'dashboard-customers';
//          echo $json->r_viewmode;
          
          $keys = array('dashboard-customers', 'dashboard-statuses', 'dashboard-performance');
          foreach ($keys as $k) {
//           echo $json->r_viewmode."-".$k."-".($json->r_viewmode==$k)."<br>";
           $leftcontent->fill('%ds_'.$k.'%', $json->r_viewmode==$k);
          }
          
         break;
         case ('customers'):
          if (gettype($json->r_StatusID)=='NULL') $json->r_StatusID = -1;
          
          $keys = array('search', 'statistics', 'summary', 'demography', 'parser', 'autorespond');
          foreach ($keys as $k) {
//           echo $json->r_viewmode."-".$k."-".($json->r_viewmode==$k)."<br>";
           $leftcontent->fill('%vm_'.$k.'%', $json->r_viewmode==$k);
          }
          
         break;
         case ('calls'):
          $loader = new Template($this->viewroot, $tmp->returnloop('block_loader'));
          
          $maincontent->fillloop('block_top' , $loader->output());
          $maincontent->fillloop('loop_table', $loader->output());
          
          
          
//          ajax_echo_r ($json);
          $keys = array('inbound', 'outbound');
          
          if (getvariablereq('r_viewmode')) $json->r_viewmode=getvariablereq('r_viewmode');
//          echo in_array($json->r_viewmode, $keys);
          if (!in_array($json->r_viewmode, $keys)) $json->r_viewmode = 'outbound';
          
          foreach ($keys as $k) {
//           echo $json->r_viewmode."-".$k."-".($json->r_viewmode==$k)."<br>";
           $leftcontent->fill('%ca_'.$k.'%', $json->r_viewmode==$k);
          }
          
          
          
//          ajax_echo_r ($json);
          $keys = array('usual', 'cold');
          
          if (getvariablereq('r_mode')) $json->r_mode=getvariablereq('r_mode');
//          echo in_array($json->r_viewmode, $keys);
          if (!in_array($json->r_mode, $keys)) $json->r_mode = 'usual';
          
          foreach ($keys as $k) {
//           echo $json->r_viewmode."-".$k."-".($json->r_viewmode==$k)."<br>";
           $leftcontent->fill('%cad_'.$k.'%', $json->r_mode==$k);
          }
          
          
          
         break;
         case ('users'):
          $looptmp = $leftcontent->returnloop("loop_customerstatuses");
          if ($looptmp) {
           $loop = new Template($this->viewroot, $looptmp);
           $list = $this->model->getList('customerstatuses');
           $loopdata = $this->fillList($list, $loop, $json->flt_StatusID);
           $leftcontent->fillloop('loop_customerstatuses', $loopdata);
          }
          
          $looptmp = $leftcontent->returnloop("loop_teachers");
          if ($looptmp) {
           $loop = new Template($this->viewroot, $looptmp);
           $list = $this->model->getList('responsibles');
           $loopdata = $this->fillList($list, $loop, $json->flt_TeacherID);
           $leftcontent->fillloop('loop_teachers', $loopdata);
          }
          
          $looptmp = $leftcontent->returnloop("loop_ages");
          if ($looptmp) {
           $loop = new Template($this->viewroot, $looptmp);
           $list = $this->model->getList('ages');
           $loopdata = $this->fillList($list, $loop, $json->flt_Age);
           $leftcontent->fillloop('loop_ages', $loopdata);
          }
          
          $looptmp = $leftcontent->returnloop("loop_grades");
          if ($looptmp) {
           $loop = new Template($this->viewroot, $looptmp);
           $list = $this->model->getList('grades');
           $loopdata = $this->fillList($list, $loop, $json->flt_GradeID);
           $leftcontent->fillloop('loop_grades', $loopdata);
          }
          
          $looptmp = $leftcontent->returnloop("loop_programs");
          if ($looptmp) {
           $loop = new Template($this->viewroot, $looptmp);
           $list = $this->model->getList('programs');
           $loopdata = $this->fillList($list, $loop, $json->flt_ProgramID);
           $leftcontent->fillloop('loop_programs', $loopdata);
          }
          
          
          
         break;
         case ('money'):
          $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_typeids"));
          $list = $this->model->getList('moneyrecordtypes');
          $loopdata = $this->fillList($list, $loop, $json->flt_TypeID);
          $leftcontent->fillloop('loop_typeids', $loopdata);
          
          $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_groupids"));
          $list = $this->model->getExpenditureGroups(0);
          $loopdata = $this->fillList($list, $loop, $json->flt_GroupID);
          $leftcontent->fillloop('loop_groupids', $loopdata);
          
          
          $leftcontent->fillloop('block_popupdefault','');
          
         break;
         case ('reports'):
          if (gettype($json->r_viewmode)=='NULL') $json->r_viewmode = 'calls-noactivities';
          
          $keys = array('calls-noactivities', 'calls-wrongactivities', 'calls-customerswithcalls', 'calls-customers', 'calls-customers', 'statuses-customersbyreasons', 'statuses-customersbydislikes');
          foreach ($keys as $k) {
//           echo $json->r_viewmode."-".$k."-".($json->r_viewmode==$k)."<br>";
           $leftcontent->fill('%rp_'.$k.'%', $json->r_viewmode==$k);
          }
          
         break;
         case ('analytics'):
//          ajax_echo_r ($json);
          $keys = array(
           'full'                           =>'lf-general', 
           'agents-activity'                =>'lf-general', 
           'agents-pollingquestions'        =>'lf-general', 
           
           'db-timezones'                   =>'lf-database', 
           'db-depth'                       =>'lf-database', 
           'db-states'                      =>'lf-database', 
           'db-phoneslengths'                =>'lf-database', 
           
           'statuses-activities'            =>'lf-statuses', 
           'statuses-reasons'               =>'lf-statuses', 
           'statuses-mostlikes'             =>'lf-statuses', 
           'statuses-mostdislikes'          =>'lf-statuses', 
           'statuses-travelledabroads'      =>'lf-statuses', 
           'statuses-datingtourinterests'   =>'lf-statuses', 
           'statuses-primaryspendbrands'    =>'lf-statuses', 
           
           'customers-statuses'             =>'lf-customers', 
           'customers-countries'            =>'lf-customers', 
           'customers-timezones'            =>'lf-customers', 
           'customers-countsbytimeadded'    =>'lf-customers', 
           'customers-countsbytime'         =>'lf-customers', 
           'customers-countsbytimerel'      =>'lf-customers', 
           'customers-countsbylocaltime'    =>'lf-customers', 
           'customers-countsbylocaltimerel' =>'lf-customers',
           
           'qos-calls' => 'none'
          );
          
          if (getvariablereq('r_viewmode')) $json->r_viewmode=getvariablereq('r_viewmode');
//          echo getvariablereq('r_viewmode');
          
//          echo in_array($json->r_viewmode, $keys);
//          ajax_echo_r ($json);
          if (!$keys[$json->r_viewmode]) $json->r_viewmode = 'full';
          
          foreach ($keys as $k=>$v) {
//           echo $json->r_viewmode."-".$k."-".($json->r_viewmode==$k)."<br>";
           $leftcontent->fill('%vm_'.$k.'%', $json->r_viewmode==$k);
          }
          
          
          $groups = array('lf-general', 'lf-database', 'lf-statuses', 'lf-customers');
          
          foreach ($groups as $k) {
//           echo $k."-".$keys[$json->r_viewmode]."-".($keys[$json->r_viewmode]==$k)."<br>";
           $leftcontent->fill('%'.$k.'_hidden%', ($keys[$json->r_viewmode]==$k)?"shown":"hidden");
          }
          
          
          
         break;
         case ('macros'):
          if (gettype($json->r_viewmode)=='NULL') $json->r_viewmode = 'everydayreminders';
          
          $keys = array('everydayreminders');
          foreach ($keys as $k) {
//           echo $json->r_viewmode."-".$k."-".($json->r_viewmode==$k)."<br>";
           $leftcontent->fill('%ma_'.$k.'%', $json->r_viewmode==$k);
          }
          
         break;
         case ('tasks'):
          $block_item = new Template($this->viewroot, $leftcontent->returnloop('block_AssignedToID'));
          $users=$this->model->getUsersTasks();
 //         ajax_echo_r ($users);
          
          $AssignedToID = getvariable('AssignedToID');
          
          $vars = $block_item->getVariables();
          
          $thislist = "";
          if (sizeof($users)) {
           foreach ($users as $item) {
            $block_item->reload();
            $block_item->fill(  "%selected%", ($item->ID==$AssignedToID)?"selected":""     );
            foreach ($vars as $var) {
             $block_item->fill(        "%".$var."%", $item->$var           );
            }
            $thislist.=$block_item->output();
           }
          }
          
          $leftcontent->fillloop ('block_AssignedToID', $thislist);
          
          
          
          
          $ClubID = getvariable('ClubID');
 //         echo $ClubID;
          setsecurevariable('ClubID', $ClubID);
          
          $TaskListID = getvariable('TaskListID');
          setsecurevariable('TaskListID', $TaskListID);
 //         echo $TaskListID;
          
          
          $block_item = new Template($this->viewroot, $leftcontent->returnloop('block_ClubID'));
 //         $users=$this->model->getListEx('clubs', '(`DateFinished` < `DateAdded`) || (`DateFinished` IS NULL)');
          $users=$this->model->getClubs();
          
          $thislist = "";
          if (sizeof($users)) {
           foreach ($users as $item) {
 //           echo $item->ID."-".$ClubID."-".($item->ID==$ClubID)."<br>";
            $block_item->reload();
            $block_item->fill(       "%ID%" , $item->ID           );
            $block_item->fill(    "%Title%" , $item->Title        );
            $block_item->fill(  "%selected%", ($item->ID==$ClubID)?"selected":""     );
            $thislist.=$block_item->output();
           }
          }
          
          $leftcontent->fillloop ('block_ClubID', $thislist);
          
          
          
          $block_item = new Template($this->viewroot, $leftcontent->returnloop('block_TypeID'));
          $users=$this->model->getList('tasktypes');
          
          
          $thislist = "";
          if (sizeof($users)) {
           foreach ($users as $item) {
            $block_item->reload();
            $block_item->fill(       "%ID%" , $item->ID           );
            $block_item->fill(    "%Title%" , $item->Title        );
            $block_item->fill(  "%selected%", ($item->ID==$TaskListID)?"selected":""     );
            $thislist.=$block_item->output();
           }
          }
          
          $leftcontent->fillloop ('block_TypeID', $thislist);
          
          
          /*
          $block_item = new Template($this->viewroot, $leftcontent->returnloop('block_PriorityID'));
          $users=$this->model->getList('priorities');
          
          $thislist = "";
          if (sizeof($users)) {
           $c=0;
           foreach ($users as $item) {
            $block_item->reload();
            $block_item->fill(        "%ID%" , $item->ID           );
            $block_item->fill(     "%Title%" , $item->Title        );
            $block_item->fill(         "%c%" , $c==2               );
            $thislist.=$block_item->output();
            $c++;
           }
          }
  //         <en></en><ru></ru>
          $leftcontent->fillloop ('block_PriorityID', $thislist);
          
          */
          
          
          
          $loop     = clone $maincontent;
          $loop->loadloop("loop_clubs");
          
 //         $list = $this->model->getListOrdered('clubs','Title');
          $list = $this->model->getClubs();
          
          
  //        ajax_echo_r ($list);
          $loopdata = "";
          if (sizeof($list)>0)  {
           foreach ($list as $ik=>$iv) {
   //          echo $iv->ID;
            $loop->reload();
            $loop->fill( "%list_clubs%" ,  $iv->Name        );
            $loop->fill(            "%id%" ,  $iv->ID          );
            $loop->fill(      "%selected%" ,  ""               );
            $loopdata.=$loop->output();
           }
          } else {
  //         $loopdata.=$block_norows;
          }
          
          $maincontent->fillloop('loop_clubs', $loopdata);
          
          
          
          
          
          $maincontent->fillloop('block_notasks','');
          
          $maincontent->fillloop('loop_task0'       ,'');
          $maincontent->fillloop('loop_task1'       ,'');
          $maincontent->fillloop('loop_task2'       ,'');
          $maincontent->fillloop('loop_task3'       ,'');
          $maincontent->fillloop('loop_comment'     ,'');
          
         break;
         case ('clubs'):
//          ajax_echo_r ($json);
//          die (gettype($json->r_StatusID));
          if (gettype($json->r_StatusID)=='NULL') $json->r_StatusID = -1;
          
          if ($loopraw = $leftcontent->returnloop("loop_statuses")) {
           $loopraw_all = new Template($this->viewroot, $leftcontent->returnloop("loop_statuses_all"));
           $loopraw_all->fill(      "%selected%" ,  ($r_StatusID==-1)?"selected":"");
           $leftcontent->fillloop('loop_statuses_all', $loopraw_all->output());
           
           $loop = new Template($this->viewroot, $loopraw);
           $list = $this->model->getList('club_statuses');
   //        ajax_echo_r ($list);
           $r_StatusID = (getvariablereq('r_StatusID'))?getvariablereq('r_StatusID'):$json->r_StatusID;
           $loopdata = $this->fillList($list, $loop, $r_StatusID);
           $leftcontent->fillloop('loop_statuses', $loopdata);
           
           $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_dates"));
           $list = $this->model->getDates('clubs','DateAdded');
  //         ajax_echo_r ($list);
           $loopdata = $this->fillList($list, $loop, $json->r_DateAdded);
           $leftcontent->fillloop('loop_dates', $loopdata);
           
           
           $loopraw_all = new Template($this->viewroot, $leftcontent->returnloop("loop_stages_all"));
           $loopraw_all->fill(      "%selected%" ,  ($r_StatusID==-1)?"selected":"");
           $leftcontent->fillloop('loop_stages_all', $loopraw_all->output());
           
           $loop = new Template($this->viewroot, $loopraw);
           $list = $this->model->getList('stages');
   //        ajax_echo_r ($list);
           $r_StatusID = (getvariablereq('r_StageID'))?getvariablereq('r_StageID'):$json->r_StatusID;
           $loopdata = $this->fillList($list, $loop, $r_StatusID);
           $leftcontent->fillloop('loop_stages', $loopdata);
           
          }
          
         break;
         case ('system'):
 //         $json = getFromCache('loadGroups');
 //         ajax_echo_r ($json);
          
          $leftcontent->fill  (  '%GroupsTxt%', brtonl($json->GroupsTxt  ));
          $leftcontent->fill  ( '%CampaignID%', brtonl($json->CampaignID ));
          
          $maincontent->fillloop( 'loop_table_row', '');
          $maincontent->fillloop(    'block_type1', '');
          $maincontent->fillloop(    'block_type2', '');
          
         break;
         case ('vkusers'):
          $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_campaigns"));
          $list = $this->model->getVKCampaigns();
          $loopdata = $this->fillList($list, $loop, $json->s_campaignid);
          $leftcontent->fillloop('loop_campaigns', $loopdata);
          
         break;
         
         case ('crm'):
          $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_statusgroups"));
          $list = $this->model->getList('hh_statusgroups');
//          ajax_echo_r ($list);
          $loopdata = $this->fillList($list, $loop, 0);
          $leftcontent->fillloop('loop_statusgroups', $loopdata);
          
         break;
         
         
         case ('smses'):
 //         $json = getFromCache('newSmses');
          
          $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_campaigns"));
          $list = $this->model->getVKCampaigns();
          $loopdata = $this->fillList($list, $loop, $json->s_campaignid);
          $leftcontent->fillloop('loop_campaigns', $loopdata);
          
          $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_offers"));
          $list = $this->model->getList('offers');
          $loopdata = $this->fillList($list, $loop, $json->s_offerid);
          $leftcontent->fillloop('loop_offers', $loopdata);
          
 //         ajax_echo_r ($json);
          $leftcontent->fill  ( '%count%', $json->r_count );
         break;
         case ('dbrefine'):
//          ajax_echo_r ($json);
          if (!$json->r_viewmode || gettype($json->r_viewmode)=='NULL') $json->r_viewmode = 'otherreasons';
          
          /*
          $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_months"));
          $list = $this->model->getMonths('money','DateAdded');
 //         ajax_echo_r ($list);
          $loopdata = $this->fillList($list, $loop, $json->flt_Month);
          $leftcontent->fillloop('loop_months', $loopdata);
          */
          
          $keys = array('otherreasons', 'mostlikes', 'mostdislikes', 'travelledabroads', 'reasonsfornotpurchase', 'receivenotifications', 'notificationsusefuls', 'reactinanyways');
          foreach ($keys as $k) {
//           echo $json->r_viewmode."-".$k."-".($json->r_viewmode==$k)."<br>";
           $leftcontent->fill('%dbr_'.$k.'%', $json->r_viewmode==$k);
          }
         break;
         
         case ('vacancies'):
          if (gettype($json->r_StatusID)=='NULL') $json->r_StatusID = -1;
          
          $keys = array('search', 'statistics', 'summary', 'demography', 'parser', 'autorespond');
          foreach ($keys as $k) {
//           echo $json->r_viewmode."-".$k."-".($json->r_viewmode==$k)."<br>";
           $leftcontent->fill('%vm_'.$k.'%', $json->r_viewmode==$k);
          }
          
         break;
         case ('schedule'):
          $maincontent->fillloop  ('loop_year', '');
          $maincontent->removeloop('block_loading');
         break;
        }
        
        
        if ($loopraw = $leftcontent->returnloop("loop_statuses")) {
         $loop = new Template($this->viewroot, $loopraw);
         $list = $this->model->getList('statusesstatuses');
 //        ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, $rec->StatusID);
         $leftcontent->fillloop('loop_statuses', $loopdata);
        }
        
        if ($loopraw = $leftcontent->returnloop("loop_months")) {
         $loop = new Template($this->viewroot, $loopraw);
         $list = $this->model->getMonths('statuses','DateAdded');
//         ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, $json->flt_Month);
         $leftcontent->fillloop('loop_months', $loopdata);
        }
        
        if ($loopraw = $leftcontent->returnloop("loop_days")) {
         $loop = new Template($this->viewroot, $loopraw);
         $list = $this->model->getDates('statuses','DateAdded');
//         ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, $json->flt_Month);
         $leftcontent->fillloop('loop_days', $loopdata);
        }
        
        if ($loopraw = $leftcontent->returnloop("block_users")) {
         $loop = new Template($this->viewroot, $loopraw);
         $list = $this->model->getUsersList();
//         ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, $json->flt_UserID);
         $leftcontent->fillloop('block_users', $loopdata);
        }
        
        
        if ($loopraw = $leftcontent->returnloop("loop_lists")) {
         $loop = new Template($this->viewroot, $loopraw);
         $list = $this->model->getList('lists');
         $itm = new stdClass;
         $itm->ID=999;
         $itm->Description="Not cold customres";
         $list[] = $itm;
//         ajax_echo_r ($list);
         $loopdata = $this->fillList($list, $loop, $json->flt_ListID);
         $leftcontent->fillloop('loop_lists', $loopdata);
        }
        
        if ($loopraw = $leftcontent->returnloop("loop_brands")) {
         $loop = new Template($this->viewroot, $loopraw);
         $list = $this->model->getBrands();
         $loopdata = $this->fillList($list, $loop, $json->flt_BrandID);
         $leftcontent->fillloop('loop_brands', $loopdata);
        }
        
        if ($loopraw = $leftcontent->returnloop("loop_datesadded")) {
         $loop = new Template($this->viewroot, $loopraw);
         $list = $this->model->getCustomersDatesAdded();
         $loopdata = $this->fillList($list, $loop, $json->flt_BrandID);
         $leftcontent->fillloop('loop_datesadded', $loopdata);
        }
        
        
        /*
        $loopraw = $leftcontent->returnloop("loop_clubs");
        ajax_echo_r ($loopraw);
        if ($loopraw) {
         $loop = new Template($this->viewroot, $loopraw);
         $list = $this->model->getClubs();
         $loopdata = $this->fillList($list, $loop, $json->flt_ClubID);
         $leftcontent->fillloop('loop_clubs', $loopdata);
        }
        */
        
        
 //       $tmp->fill("%editor%"      , $editor->output());                                      // fill the template with actual data
        $tmp->fill("%editor%"      , "");                                      // fill the template with actual data
        
        
        
        
        
        
        
        $vars = $leftcontent->getvariables();
 //       ajax_echo_r ($vars);
 //       ajax_echo_r($json);
        
        foreach ($vars as $var) {
         if ($var) {
          $leftcontent->fill("%".$var."%", brtonl($json->$var));
         }
        }
        
        $maincontent->fillloop('loop_table', '');
        $maincontent->fillloop('block_no', '');
        $maincontent->fillloop('block_yes', '');
        $maincontent->fillloop('block_norows', '');
        
        
        
        $tmp->fill("%leftcontent%"      , $leftcontent->output());                                      // fill the template with actual data
        $tmp->fill("%maincontent%"      , $maincontent->output());                                      // fill the template with actual data
        
        /*
        $menu_toplevel_item = clone $loop_clean;                                                        // load common parent template
        $menu_toplevel_item->loadloop("loop_menu_toplevel_items");
        $toplevel_menu = $this->model->getTopLevelMenu();
        $topitems=Array();
        
        foreach ($toplevel_menu as $item) {
         $menu_toplevel_item->reload();
         $menu_toplevel_item->fill("%ID%"         , $item->ID);
         $menu_toplevel_item->fill("%Name%"       , $item->Name);
         $menu_toplevel_item->fill("%Link%"       , $item->Link);
         $menu_toplevel_items.=$menu_toplevel_item->output();
         array_push($topitems, $item->ID);
        }
        
        $child_menu = $this->model->getChildMenu();
        $lastparentid=-1;
        
        foreach ($child_menu as $item) {
         if ($lastparentid!=$item->ParentID) {
          $lastparentid=$item->ParentID;
          if (in_array($lastparentid, $topitems)) {
           $menu_items.='var tmenu'.$lastparentid.' = ms.addMenu(document.getElementById("menu'.$lastparentid.'"));';
          } else {
           $menu_items.='var tmenu'.$lastparentid.' = tmenu'.$this->model->getParentID($lastparentid).'.addMenu(menu'.$lastparentid.');';
          }
         }
         $menu_items.='var menu'.$item->ID.' = tmenu'.$lastparentid.'.addItem("'.$item->Name.'", "'.$item->Link.'", 0, 0);';
        }
        */
        
        $tmp->fillloop("loop_menu_toplevel_items"      , $menu_toplevel_items);
        $tmp->fill("%menu_items%"               , $menu_items         );
        $tmp->fill("%fromajax%"                 , 0                   );
        
        /*
        $list = $this->model->getListEx('objecttypes','`Filter`="2"');          // load list of supply tables
        
        $loop = clone $loop_clean;
        $loop->loadloop("loop_objecttypes_demand");
        $loopdata = "";
        if (sizeof($list)>0)  {
         foreach ($list as $ik=>$iv) {
  //          echo $objecttype."-".$iv->SourceTable."<br>";
          $loop->fill("%list_objecttypes_demand%" ,  $iv->Description);
          $loop->fill("%id%"                      ,  $iv->SourceTable);
          $loop->fill("%selected%"                , ($objecttype==$iv->SourceTable)?"selected":"");
          $loop->fill("%checked%"                 , ($objecttype==$iv->SourceTable)?"checked":"");
          $loopdata.=$loop->output();
          $loop->reload();
         }
        }
        $tmp->fillloop("loop_objecttypes_demand"   ,$loopdata        );         // fill the template with actual data
        */
        
  //      $inner_tmp = new Template($this->viewroot, "inner_".$go.".htt");                                       // load common parent template
        
        $json = getFromCache('settings');
  //      ajax_echo_r($json);
        
        $tmp->fill('%settings_pl_startrow_defvalue%' ,   $json->settings_pl_startrow );
        $tmp->fill('%settings_pl_startcol_defvalue%' ,   $json->settings_pl_startcol );
        $tmp->fill('%settings_pl_namescol_defvalue%' ,   $json->settings_pl_namescol );
        $tmp->fill('%settings_pl_idscol_defvalue%'   ,   $json->settings_pl_idscol   );
        $tmp->fill('%settings_pl_costscol_defvalue%' ,   $json->settings_pl_costscol );
        
        $tmp->fill('%settings_o_startrow_defvalue%'  ,   $json->settings_o_startrow  );
        $tmp->fill('%settings_o_idscol_defvalue%'    ,   $json->settings_o_idscol    );
        $tmp->fill('%settings_o_qtyscol_defvalue%'   ,   $json->settings_o_qtyscol   );
        $tmp->fill('%settings_o_costscol_defvalue%'  ,   $json->settings_o_costscol  );
        $tmp->fill('%settings_o_sumscol_defvalue%'   ,   $json->settings_o_sumscol   );
        
        $tmp->fillloop('block_split_none'       ,'');
        $tmp->fillloop('block_split_vertical'   ,'');
        $tmp->fillloop('block_split_horizontal' ,'');
        
        $tmp->fillloop('loop_table'    ,'');
        $tmp->fillloop('block_no'      ,'');
        $tmp->fillloop('block_norows'  ,'');
        $tmp->fillloop("block_limited" ,"");
        
   //     echo $this->user->JustLogged;
        $params = new stdClass();
        
        $params->tablename   = $objecttype;
        $params->OfferTypeID = "2";
        
        $tmp->fill("%justlogged%"         , $this->user->JustLogged          );        // fill template
        $tmp->fill("%tableview%"          , $this->imgfolder                  );        // fill the template with actual data
        $tmp->fill("%agentname%"          , $this->user->Firstname." ".$this->user->Lastname                );        // fill the template with actual data
        
       } else {
        $loop_user_auth=$tmp->returnloop("loop_user_auth");
        $tmp->fillloop("loop_globalparent", $loop_user_auth);
       }
       
 //      $tmp->fill("%style%"          , $this->getstylesheet($hue,$this->imgfolder)        );        // fill the template with compiled less stylesheet
       $this->processstylesheet($hue,'style');
       $tmp->fill("%theme%"              , $this->user->Theme                 );
       
       $tmp->fill('%objecttype%'         , $objecttype                         );
       $tmp->fill('%SmoothAnimation%'    , $SmoothAnimation                    );
       
       $tmp->fill('%auxmode%'            , $auxmode                            );
       
 //      if ($id) {
 //       $tmp->fill('%id%'       , $id            );
 //      } else {
 //       $tmp->fill('%id%'       , 0              );
 //      }
       
       if ((int)$this->user->AccountType!=1) {
        $tmp->fillloop("adminpanellink","");
       }
       $tmp->fillloop("block_link","");
       
       
       if (!$go) $go = "Login";
       
       $tmp->fill(  '%session_id%', session_id()                    );
       
       $tmp->fill(     "%projectname%", $this->settings->projectname    );        // fill the template with actual data
       $tmp->fill(              '%go%', $go                             );
       $tmp->fill(              '%id%', $id                             );
       $tmp->fill(            '%page%', $page                           );
       $tmp->fill(          '%userid%', $this->userid                   );
       
       $k = "Ability-Teacher";
       $tmp->fill( '%ability_teacher%', (int)$this->user->usergroup->$k      );
       
       $tmp->processfcb('');
       
       $tmp->fill(  '%imgfolder%' , $this->imgfolder                );
       $tmp->fill(   '%viewroot%' , $this->viewroot                 );
       
       $tmp = $this->fillStricts($tmp);
       
       
       
       
       
       
       
       
       $css = array();
       
       $pos_verybegin = 0;
       do {
        $pos_begin = strpos($tmp->template, '<link rel="stylesheet"', $prevpos);
        if ($pos_begin) {
         if (!$pos_verybegin) $pos_verybegin = $pos_begin;
         $pos_end   = strpos($tmp->template, '/>', $pos_begin)+2;
//         echo $pos_begin."-".$pos_end."<br>";
         $thistag = substr($tmp->template, $pos_begin, $pos_end-$pos_begin);
         $prevpos = $pos_end+1;
         
//         echo htmlspecialchars($thistag)."<br>";
         
         $pos_begin_thistag = strpos($thistag, 'href="')+6;
         if ($pos_begin_thistag) {
          $pos_end_thistag   = strpos($thistag, '"', $pos_begin_thistag);
//          echo $pos_begin_thistag."-".$pos_end_thistag."<br>";
          $thisfilename = htmlspecialchars(substr($thistag, $pos_begin_thistag, $pos_end_thistag-$pos_begin_thistag));
          $thisfilename = str_replace("file.php?name=", "", $thisfilename);
          $css[] = $thisfilename;
          
          $ftime_css  = getfilemtime($thisfilename);
          if ($ftime_css>$ftime_css_max) $ftime_css_max=$ftime_css;
         }
        }
       } while ($pos_begin);
       
//       ajax_echo_r ($css);
       
       $cssmixfilename = "mainparent.css";
       
       $ftime_css  = getfilemtime($this->viewroot."/styles/".$cssmixfilename);
       if ($ftime_css!=$ftime_css_max) {
        include_once("minify/Minify.php");
        include_once("minify/CSS.php");
        include_once("minify/Converter.php");
        
 //       use MatthiasMullie\Minify;
        
        $minifier = new CSS();
        
        foreach ($css as $file) {
         $sourcePath = getrootdirsrv().$file;
//         echo $sourcePath."<br>";
         $minifier->add($sourcePath);
        }
        
        $minifier->minify($this->viewroot."/styles/".$cssmixfilename);
        touch($this->viewroot."/styles/".$cssmixfilename,$ftime_css_max);
        
//        echo "update css<br>";
       }
       $tmp->template = str_replace(substr($tmp->template, $pos_verybegin, $pos_end-$pos_verybegin), '<link rel="stylesheet" type="text/css" href="file.php?name='.(substr($css[0], 0, strrpos($css[0], "/")+1).$cssmixfilename).'"/>', $tmp->template);
       
       
       
       
       
       
       
       
       
       $js = array();
       
       $prevpos = 0;
       $pos_verybegin = 0;
       do {
        $pos_begin = strpos($tmp->template, '<script type="text/javascript"', $prevpos);
        if ($pos_begin) {
         if (!$pos_verybegin) $pos_verybegin = $pos_begin;
         $pos_end   = strpos($tmp->template, '/script>', $pos_begin)+8;
//         echo $pos_begin."-".$pos_end."<br>";
         $thistag = substr($tmp->template, $pos_begin, $pos_end-$pos_begin);
         $prevpos = $pos_end+1;
         
//         echo htmlspecialchars($thistag)."<br>";
         
         $pos_begin_thistag = strpos($thistag, 'src="')+5;
         if ($pos_begin_thistag) {
          $pos_end_thistag   = strpos($thistag, '"', $pos_begin_thistag);
//          echo $pos_begin_thistag."-".$pos_end_thistag."<br>";
          $thisfilename = htmlspecialchars(substr($thistag, $pos_begin_thistag, $pos_end_thistag-$pos_begin_thistag));
          $thisfilename = str_replace("file.php?name=", "", $thisfilename);
          $js[] = $thisfilename;
          
          $ftime_js  = getfilemtime($thisfilename);
          if ($ftime_js>$ftime_js_max) $ftime_js_max=$ftime_js;
         }
        }
       } while ($pos_begin);
       
//       ajax_echo_r ($js);
       
       $jsmixfilename = "mainparent.js";
       
       $ftime_js  = getfilemtime("controller/js/".$jsmixfilename);
//       echo "ftime_js: ".$ftime_js."<br>";
       
       if ($ftime_js!=$ftime_js_max) {
        include_once("minify/Minify.php");
        include_once("minify/JS.php");
        include_once("minify/Converter.php");
        
        $minifier = new JS();
        
        foreach ($js as $file) {
         $sourcePath = getrootdirsrv().$file;
 //        echo $sourcePath."<br>";
         $minifier->add($sourcePath);
        }
        
        $minifier->minify("controller/js/".$jsmixfilename);
        touch("controller/js/".$jsmixfilename,$ftime_js_max);
        
//        echo "update js<br>";
       }
       $tmp->template = str_replace(substr($tmp->template, $pos_verybegin, $pos_end-$pos_verybegin), '<script type="text/javascript" async defer src="file.php?name='.(substr($js[0], 0, strrpos($js[0], "/")+1).$jsmixfilename).'"></script>', $tmp->template);
       
       
       
       
       
       echo localize($tmp->output());                                              // show it
      }
     }
    }
   }
   
   $qtm = microtime(true) - $qtm;
   
   if ($qtm>300) {
    addtologEx(time()."-".$qtm."\n".print_r($_REQUEST,true), 'queries.txt');
   }
  }
  
  function getstylesheet($hue,$viewroot,$filename) {
//   addtolog("Controller getstylesheet begin");
   $style = "";
   $stylefilename = $filename.".less";
   
   $viewroot = getrootdir().$viewroot;
//   echo $viewroot."<br>";
   
   
//   foreach ($this->settings->styles as $stylefilename) {
   $f = file_get_contents($this->viewroot."/styles/".$stylefilename);
   $f = str_replace(             "%hue%", $hue                           , $f);
   $f = str_replace( "%SmoothAnimation%", $SmoothAnimation               , $f);
   $f = str_replace(    "%previewwidth%", $this->settings->previewwidth  , $f);
   $f = str_replace(   "%previewheight%", $this->settings->previewheight , $f);
   $f = str_replace(       "%imgfolder%", $viewroot."/img"               , $f);
   $f = str_replace(        "%viewroot%", $viewroot                      , $f);
   
//   echo $viewroot."<br>";
   
   $style.=($this->less->compile($f));
//   }
//   addtolog("Controller getstylesheet end");
   return ($style);
  }
  
  function processstylesheet($hue,$filename) {
//   file_put_contents($this->viewroot."/styles/".$filename.".css",$this->getstylesheet($hue,$this->viewroot,$filename)        );         // fill the template with compiled less stylesheet
   
   $fname_css  = $this->viewroot."/styles/".$filename.".css";
   $fname_less = $this->viewroot."/styles/".$filename.".less";
   
   $ftime_css  = getfilemtime($fname_css);
   $ftime_less = getfilemtime($fname_less);
   
//   echo "ftime_css: ".$ftime_css;
//   echo "ftime_less: ".$ftime_less;
   
   if ($ftime_css!=$ftime_less) {
//    echo $ftime_css."<br>";
//    echo $ftime_less."<br>";
//    echo "update less<br>";
    file_put_contents($fname_css,$this->getstylesheet($hue,$this->viewroot,$filename));         // fill the template with compiled less stylesheet
    touch($fname_css,filemtime($fname_less));
   }
   
   
  }
  
  public function import() {                         // import functionality to get data from ISCentre
   addtolog("Controller import begin");
   include_once ("controller/DBImport.php");
   $this->dbimport = new DBImport($this->settings, $this->model);  // instantiate a class
   
   $action = getvariablereq   ('action');            // get action from the request
   $data   = getvariablereq   ('data'  );            // get JSON data from the request
   
   $data = str_replace('\"','"',$data);              // fix some escaped paths (if any)
   
   $mtime = microtime(true);
   $thisfolder = substr($_SERVER['DOCUMENT_ROOT'].$_SERVER['SCRIPT_NAME'],0,strrpos($_SERVER['DOCUMENT_ROOT'].$_SERVER['SCRIPT_NAME'] ,"/"))."data/temp/dbupdate";
   @mkdirr ($thisfolder);
   //echo $thisfolder."\n".$action."\n";
   
   switch ($action) {
    case ('update'):
     $this->dbimport->importtables($thisfolder);
     echo "Job done\n";
    break;
    default:
     if (sizeof($_FILES)>0) {
      
      $dirs = sdir($thisfolder,"*.dbu");
      
      foreach ($dirs as $dir) {
       unlink($thisfolder.'/'.$dir);
//       unlink($dir);
      }
      
      foreach ($_FILES as $file) {
       if (file_exists($thisfolder."/".$file['name'])) {
//        unlink($thisfolder."/".$file['name']);
       }
       move_uploaded_file ($file['tmp_name'],$thisfolder."/".$file['name']);
       echo "File accepted";
      }
     }
    break;
   }
   
   $fieldid = array();
   
   addtolog("Controller import end");
  }
  
  public function getComments($json) {
//   ajax_echo_r ($json);
   $Comments = $this->model->getComments($json);
//   ajax_echo_r($Comments);
   
   switch ($json->ParentName) {
    case ('emails'):
     $src = 'assessment.htt';
    break;
    default:
     $src = 'main_tasks.htt';
    break;
   }
   $loop = new Template($this->viewroot, $src);                                      // load common parent template
   
   $block_comment = new Template($this->viewroot, $loop->returnloop('loop_comment'));
   $vars = $block_comment->getVariables();
   
   $block_comments = "";
   if (sizeof($Comments)) {
    foreach ($Comments as $comment) {
     $block_comment->reload();
     
     $block_comment->processfcb('');
     $block_comment->fill(  '%imgfolder%' , $this->imgfolder                    );
     $block_comment->fill(   '%viewroot%' , $this->viewroot                     );
     
     $comment->Comment = nl2br($comment->Comment);
     foreach ($vars as $var) {
      $block_comment->fill(     "%".$var."%", $comment->$var     );
     }
     
     $block_comments .= $block_comment->output();
    }
   }
   return localize($block_comments);
  }
  
  function fillList($list, $loop, $selectedid, $key="ID") {
//   ajax_echo_r ($list);
//   echo "list: ".$list.", selectedid: ".$selectedid.", key: ".$key."<br>";
   $vars = $loop->getVariables();
   $c = 0;
   
   $loopdata = "";
   if (sizeof($list)>0)  {
    foreach ($list as $ik=>$iv) {
     $loop->reload();
//     $loop->fill(            "%ID%" ,  $iv->ID          );
     
//     if ($key) {
//      echo gettype($iv)."<br>";
      if (gettype($iv)=='integer') {
       $loop->fill(      "%selected%" ,  ($ik      ==$selectedid)?"selected":"" );
      } else {
       $loop->fill(      "%selected%" ,  ($iv->$key==$selectedid)?"selected":"" );
      }
      $loop->fill(             "%c%" ,  $c%2                                   );
      $loop->fill(             "%k%" ,  $ik                                    );
      
//     } else {
//      $loop->fill(      "%selected%" ,  ($iv->ID==$selectedid)?"selected":"");
//      echo $iv->$key."-".$selectedid."<br>";
//     }
     foreach ($vars as $var) {
      if ($var) {
       $loop->fill(       "%".$var."%" , $iv->$var);
      }
     }
     $c++;
     
     $loopdata.=$loop->output();
    }
   }
   
   return $loopdata;
  }
  
  function getParticipants($json) {
//   ajax_echo_r ($json);
   $list_participants = $this->model->getClubParticipants($json->ClubID);
//   ajax_echo_r ($list_participants);
   
   $loop_par = new Template($this->viewroot,'editor_clubs.htt');                                        // load common parent template
   $loop_par->loadloop('block_participants');
   $excludeIDs = array();
//   ajax_echo_r ($list_participants);
   $excludeIDs=array_keys($list_participants);
   if (!in_array($json->UserID, $excludeIDs)) $excludeIDs[]=$json->UserID;
   
   $list_users = $this->model->getNewUsers($excludeIDs);
   
//        ajax_echo_r($list_participants);
//        ajax_echo_r($list_users);
   
//        <block_participants>
   
//        $loop_participants = ($this->fillList($list , 'left_clubs.htt', 'loop_participants'));
//        $loop_users        = ($this->fillList($users, 'left_clubs.htt', 'loop_users'));
   
   
   $loop_participants = clone $loop_par;
   $loop_users = clone $loop_par;
   
   $loop_participants->loadloop('loop_participants');
   $loop_users->loadloop('loop_users');
   
   if ($list_participants) {
    $vars = $loop_participants->getVariables();
    $loop_participants_str = "";
    if (sizeof($loop_participants)) {
     foreach ($list_participants as $data) {
//      if ($data->Username) {
       $loop_participants->reload();
       foreach ($vars as $var) {
        if ($var) {
         $loop_participants->fill(       "%".$var."%" , $data->$var);
        }
       }
       $loop_participants_str.=$loop_participants->output();
//      }
     }
    }
   }
   
   if ($list_users) {
    $vars = $loop_users->getVariables();
    $loop_users_str = "";
    if (sizeof($list_users)) {
     foreach ($list_users as $data) {
      $loop_users->reload();
      foreach ($vars as $var) {
       if ($var) {
        $loop_users->fill(       "%".$var."%" , $data->$var);
       }
      }
      $loop_users_str.=$loop_users->output();
     }
    }
   }
   $loop_par->fillloop('loop_participants', $loop_participants_str);
   $loop_par->fillloop('loop_users', $loop_users_str);
   
   $loop_par->processfcb('');
   $loop_par->fill(  '%imgfolder%' , $this->imgfolder                    );
   $loop_par->fill(   '%viewroot%' , $this->viewroot                     );
   return localize($loop_par->output());                                               // show it
  }
  
  function getMessage($id) {
   $tmp = new Template($this->viewroot,'messages.htt');
   $tmp->loadloop("block_".$id);
   $tmp->fill('%imgfolder%', getrootdir().$this->imgfolder);
   $o = $tmp->output();
   if (!$o) $o = "getMessage: unknown id: ".$id;
   return localize($o);
  }
  
  function adaptJsonStatuses($json) {
//   ajax_echo_r ($json);
   switch ($json->ParentName) {
    case ("hh_vacancies"):
     $params = new stdClass;
     $params->ID = $json->ParentID;
     $el = $this->model->getVacancy($params);
     
     $json->Phone = $el->PhoneMobile;
     $json->Skype = $el->Skype;
     
    break;
    case ("clubs"):
//     $leftcontent->loadloop('block_status');
     $el = $this->model->getClub($json->ParentID);
     if ($el->VacancyID) {
      $params = new stdClass;
      $params->ID = $el->VacancyID;
      $el = $this->model->getVacancy($params);
//      ajax_echo_r ($el);
      if ($el->Phone) {
       $json->Phone = $el->Phone;
      } elseif ($el->Phone2) {
       $json->Phone = $el->Phone2;
      } elseif ($el->VacancyID) {
 //      ajax_echo_r ($el);
       $json->Phone = $el->Phone2;
      }
     }
     
     /*
     if ($el->VacancyID) {
      $params = new stdClass;
      $params->ID = $el->VacancyID;
      $el = $this->model->getVacancy($params);
//      ajax_echo_r ($el);
     }
     */
     $json->Skype = $el->Skype;
     
    break;
    default:
     $el = $this->model->getVacancy($json->ParentID);
     
     $json->Phone = $el->PhoneMobile;
     $json->Skype = $el->Skype;
     
    break;
   }
   
   return $json;
  }
  
  function getStatusesCount($json) {
//   ajax_echo_r ($json);
   $json = $this->adaptJsonStatuses($json);
//   ajax_echo_r ($json);
   $list = $this->model->getStatuses($json->ParentID, $json->ParentName);
   return sizeof($list);
  }
  function fillStatuses($json) {
   $json = $this->adaptJsonStatuses($json);
   
//   ajax_echo_r ($json);
   switch ($json->ParentName) {
    case ("hh_vacancies"):
     $leftcontent = new Template($this->viewroot, "editor_vacancies.htt");
    break;
    case ("clubs"):
     $leftcontent = new Template($this->viewroot, "editor_clubs.htt");
    break;
    case ("calls"):
    case ("customers"):
     $leftcontent = new Template($this->viewroot, "main_calls.htt");
    break;
    default:
     $leftcontent = new Template($this->viewroot, "left_".$json->ParentName.".htt");
    break;
   }
   
   $leftcontent->loadloop('block_status','');
   $leftcontent->processfcb('');
   $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
   $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
   
   $typepicture = array();
   $typepicture[ 1] = $leftcontent->returnloop('block_typepicture_1' );
   $typepicture[ 2] = $leftcontent->returnloop('block_typepicture_2' );
   $typepicture[ 3] = $leftcontent->returnloop('block_typepicture_3' );
   $typepicture[ 4] = $leftcontent->returnloop('block_typepicture_4' );
   $typepicture[ 5] = $leftcontent->returnloop('block_typepicture_5' );
   $typepicture[ 6] = $leftcontent->returnloop('block_typepicture_6' );
   $typepicture[ 7] = $leftcontent->returnloop('block_typepicture_7' );
   $typepicture[ 8] = $leftcontent->returnloop('block_typepicture_8' );
   $typepicture[ 9] = $leftcontent->returnloop('block_typepicture_9' );
   $typepicture[10] = $leftcontent->returnloop('block_typepicture_10');
   $typepicture[11] = $leftcontent->returnloop('block_typepicture_11');
   $typepicture[15] = $leftcontent->returnloop('block_typepicture_15');
   $typepicture[16] = $leftcontent->returnloop('block_typepicture_16');
   
//   $block_meeting   = $leftcontent->returnloop( 'block_meeting');
//   $block_call      = $leftcontent->returnloop(    'block_call');
   
   $leftcontent->removeloop('block_statuses','');
   
   
   
   
   if ($leftcontent->returnloop("loop_statustypes")) {
    $loop = new Template($this->viewroot, $leftcontent->returnloop("loop_statustypes"));
    $list = $this->model->getList('statustypes');
 //        ajax_echo_r ($list);
    $loopdata = $this->fillList($list, $loop, 0);
    $leftcontent->fillloop('loop_statustypes', $loopdata);
   }
   
   $leftcontent->processfcb();
   $leftcontent->fill(  '%imgfolder%' , $this->imgfolder                    );
   $leftcontent->fill(   '%viewroot%' , $this->viewroot                     );
//   ajax_echo(localize($leftcontent->output()));
   
   
   
   
   $loopdata = "";
   if ($loopraw = $leftcontent->returnloop("loop_statuses")) {
    $loop = new Template($this->viewroot, $loopraw);
    $list = $this->model->getStatuses($json->ParentID, $json->ParentName);
    $list = $this->model->getRecordings($json, $list);
 //   ajax_echo_r ($list);
    if ($list) {
     foreach ($list as $item) {
      $item->typepicture = $typepicture[$item->TypeID];
     }
     
     
     
     
     $vars = $loop->getVariables();
     
     if (sizeof($list)>0)  {
      foreach ($list as $ik=>$iv) {
       $loop->reload();
       
       /*
       if ($key) {
        $loop->fill(      "%selected%" ,  ($iv->$key==$selectedid)?"selected":"");
       } else {
        $loop->fill(      "%selected%" ,  ($iv->ID==$selectedid)?"selected":"");
       }
       */
       
       if ($iv->TypeID<15) {
        $loop->removeLoop('block_norecord');
        $loop->fillLoop('block_record', '');
       } else {
        $loop->fillLoop('block_norecord', '');
        $loop->removeLoop('block_record');
       }
       
       if ($iv->MeetingSet>0) {
        $loop->removeLoop('block_MeetingSet');
       } else {
        $loop->fillLoop('block_MeetingSet', '');
       }
       if ($iv->CallSet>0) {
        $loop->removeLoop('block_CallSet');
       } else {
        $loop->fillLoop('block_CallSet', '');
       }
       
       for ($n=0; $n<4; $n++) {
        if ($iv->MeetingSet==$n) {
         $loop->removeLoop('block_MeetingSet_'.$n);
        } else {
         $loop->fillLoop('block_MeetingSet_'.$n, '');
        }
        if ($iv->CallSet==$n) {
         $loop->removeLoop('block_CallSet_'.$n);
        } else {
         $loop->fillLoop('block_CallSet_'.$n, '');
        }
       }
       
  /*     
       if ($iv->MeetingSet) {
        $iv->SubIcon = $block_meeting;
       }
       if ($iv->CallSet) {
        $iv->SubIcon = $block_call;
       }
  */
       
       if ($iv->MeetingTime=="0000-00-00 00:00:00") {
        $iv->MeetingTime = "";
       }
       if ($iv->CallTime=="0000-00-00 00:00:00") {
        $iv->CallTime = "";
       }
       
       foreach ($vars as $var) {
        if ($var) {
         $loop->fill(       "%".$var."%" , $iv->$var);
        }
       }
       $loopdata.=$loop->output();
      }
     }
     $leftcontent->fillloop('block_norows', '');
    } else {
     $leftcontent->removeloop('block_norows');
    }
    
   } else {
    echo "error in htt file";
   }
   
   $leftcontent->fillloop('loop_statuses', $loopdata);
   
   $leftcontent->fillloop( 'block_typepicture_1', '');
   $leftcontent->fillloop( 'block_typepicture_2', '');
   $leftcontent->fillloop( 'block_typepicture_3', '');
   $leftcontent->fillloop( 'block_typepicture_4', '');
   $leftcontent->fillloop( 'block_typepicture_5', '');
   $leftcontent->fillloop( 'block_typepicture_6', '');
   $leftcontent->fillloop( 'block_typepicture_7', '');
   $leftcontent->fillloop( 'block_typepicture_8', '');
   $leftcontent->fillloop( 'block_typepicture_9', '');
   $leftcontent->fillloop('block_typepicture_10', '');
   $leftcontent->fillloop('block_typepicture_11', '');
   $leftcontent->fillloop('block_typepicture_15', '');
   $leftcontent->fillloop('block_typepicture_16', '');
   
   $leftcontent->fillloop(       'block_meeting', '');
   $leftcontent->fillloop(          'block_call', '');
   
   return (localize($leftcontent->output()));
  }
  
  
  function getUserPrivileges($json) {
   $list = $this->model->getUserPrivileges($json->UserID);
   
   $loop_par = new Template($this->viewroot,'editor_users.htt');                                        // load common parent template
   $loop_par->loadloop('block_p');
   
   if ($this->userid==1) {
    $loop_par->removeloop('block_removeUserPrivilege');
    $loop_par->removeloop('block_addUserPrivilege'   );
   } else {
    $loop_par->fillloop('block_removeUserPrivilege','');
    $loop_par->fillloop('block_addUserPrivilege'   ,'');
   }
   
   $loop_this = clone $loop_par;
   $loop_all  = clone $loop_par;
   
   $loop_this->loadloop('loop_this');
   $loop_all->loadloop('loop_all');
   
   $vars = $loop_this->getVariables();
   $loop = "";
   if (sizeof($list)) {
    foreach ($list as $data) {
//     if ($data->Username) {
      $loop_this->reload();
      foreach ($vars as $var) {
       if ($var) {
        $loop_this->fill(       "%".$var."%" , $data->$var);
       }
      }
      $loop.=$loop_this->output();
//     }
    }
   }
   $loop_par->fillloop('loop_this', $loop);
   
   $list_all = $this->model->getUserPrivileges();
   $vars = $loop_all->getVariables();
   $loop = "";
   if (sizeof($list_all)) {
    foreach ($list_all as $k=>$data) {
     if (!$list[$k]) {
      $loop_all->reload();
      foreach ($vars as $var) {
       if ($var) {
        $loop_all->fill(       "%".$var."%" , $data->$var);
       }
      }
      $loop.=$loop_all->output();
     }
    }
   }
   $loop_par->fillloop('loop_all', $loop);
   
   $loop_par->processfcb('');
   $loop_par->fill(  '%imgfolder%' , $this->imgfolder                    );
   $loop_par->fill(   '%viewroot%' , $this->viewroot                     );
   return localize($loop_par->output());                                               // show it
  }
  
  
  function exportCalendar() {
   $json = new stdClass;
   $json->Flat = 1;
   $list = $this->model->getCalendar($json);
   
   $tmp = new Template($this->viewroot,'cal.ict');                                        // load common parent template
   $loop_this = new Template($this->viewroot, $tmp->returnloop('loop_event'));
   
//   ajax_echo_r ($list);
   
   $vars = $loop_this->getVariables();
//   ajax_echo_r ($vars);
   $loop = "";
   if (sizeof($list)) {
    foreach ($list as $data) {
     if ($data->MeetingTime) $data->DateTarget = date("Ymd\THis", strtotime($data->MeetingTime));
     if ($data->CallTime   ) $data->DateTarget = date("Ymd\THis", strtotime($data->CallTime   ));
     $data->DateAdded = date("Ymd\THis", strtotime($data->DateAdded));
     $loop_this->reload();
     foreach ($vars as $var) {
      if ($var) {
       $loop_this->fill(       "%".$var."%" , $data->$var);
      }
     }
     $loop.=$loop_this->output();
    }
   }
   $tmp->fillloop('loop_event', $loop);
   
   $fname = "data/calendar/cal.ics";
   unlink ($fname);
   file_put_contents($fname, $tmp->output());
   
   return localize($tmp->output());                                               // show it
  }
  
  
  
  
  function fillStricts($tmp, $isEdit=1) {
//   echo htmlspecialchars($tmp->output());
   
//   ajax_echo_r ($this->user->usergroup);
//   echo $isEdit;
   if ($this->user->usergroup) {
 //   $tmp
    foreach ($this->user->usergroup as $k=>$v) {
     if ($k!='ID' && $k!='Title') {
      switch (($isEdit)?$v:2) {
       case (0):
        $tmp->removeloop('strict_'.$k.'_0');
        $tmp->fillloop  ('strict_'.$k.'_1');
        $tmp->fillloop  ('strict_'.$k.'_2');
       break;
       case (1):
        $tmp->fillloop  ('strict_'.$k.'_0');
        $tmp->removeloop('strict_'.$k.'_1');
        $tmp->fillloop  ('strict_'.$k.'_2');
       break;
       case (2):
        $tmp->fillloop  ('strict_'.$k.'_0');
        $tmp->fillloop  ('strict_'.$k.'_1');
        $tmp->removeloop('strict_'.$k.'_2');
       break;
      }
     }
    }
   }
   
   
//   echo htmlspecialchars($tmp->output());
   return $tmp;
  }
  
  
  
  
  
  
  function timezones($json = stdClass) {
   $thisEnabled = 1;
   $start = time();
   
   $mq = getFromCache('timezones');
   if (!$mq->DateLastAccess) {
    $mq = new stdClass;
    $mq->DateLastAccess = time();
    $mq->Running = 0;
    setCache('timezones',$mq);
   }
   
   $mq->Enabled = $thisEnabled;
   $res = $this->model->getSysResources();
   $thisEnabled = $res->cpu<45 || $json->ID;
   
   if ((((time()-$mq->DateLastAccess)>30) || ($mq->Running==0) || $json->Debug) && ($thisEnabled)) {
    $mq->SecondsBetweenRuns = time() - $mq->DateLastRun;
    $mq->DateLastRun = time();
    $mq->DateLastRunReadable = date("Y-m-d H:i:s", $mq->DateLastRun);
    $mq->Running = 1;
    setCache('timezones',$mq);
    
    $timer = microtime(true);
    $thisret = $this->model->timezones($json);
    
    $mq->total_code = $thisret->total_code;
    $mq->errors_nocountry_code = $thisret->errors_nocountry_code;
    $mq->changed_code = $thisret->changed_code;
    
    $mq->total = $thisret->total;
    $mq->errors_notimezone = $thisret->errors_notimezone;
    $mq->errors_unknowncountry = $thisret->errors_unknowncountry;
    
    $mq->ElapsedLastRun = formatmicrotime(microtime(true) - $timer);
    if (!$json->ID) {
     echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$timer)."</b><br>";
    }
   } else {
    if (!$thisEnabled) {
     echo "CPU is too busy to execute this script.<br>";
    } else {
//     echo "Execution of this script cancelled.<br>";
    }
   }
   
   
   $mq->LastEnabled = $thisEnabled;
   $mq->DateLastAccess = time();
   $mq->DateLastAccessReadable = date("Y-m-d H:i:s", $mq->DateLastAccess);
   
   $mq->Running = 0;
   setCache('timezones',$mq);
   
  }
  
  function timezones2($json = stdClass) {
   $thisEnabled = 1;
   $start = time();
   
   $mq = getFromCache('timezones2');
   if (!$mq->DateLastAccess) {
    $mq = new stdClass;
    $mq->DateLastAccess = time();
    $mq->Running = 0;
    setCache('timezones2',$mq);
   }
   
   $mq->Enabled = $thisEnabled;
   $res = $this->model->getSysResources();
   $thisEnabled = $res->cpu<45 || $json->ID;
   
   if ((((time()-$mq->DateLastAccess)>30) || ($mq->Running==0) || $json->Debug) && ($thisEnabled)) {
    $mq->SecondsBetweenRuns = time() - $mq->DateLastRun;
    $mq->DateLastRun = time();
    $mq->DateLastRunReadable = date("Y-m-d H:i:s", $mq->DateLastRun);
    $mq->Running = 1;
    setCache('timezones2',$mq);
    
    $timer = microtime(true);
    $thisret = $this->model->timezones2($json);
    
    $mq->total_code = $thisret->total_code;
    $mq->errors_nocountry_code = $thisret->errors_nocountry_code;
    $mq->changed_code = $thisret->changed_code;
    
    $mq->total = $thisret->total;
    $mq->errors_notimezone = $thisret->errors_notimezone;
    $mq->errors_unknowncountry = $thisret->errors_unknowncountry;
    
    $mq->ElapsedLastRun = formatmicrotime(microtime(true) - $timer);
    if (!$json->ID) {
     echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$timer)."</b><br>";
    }
   } else {
    if (!$thisEnabled) {
     echo "CPU is too busy to execute this script.<br>";
    } else {
//     echo "Execution of this script cancelled.<br>";
    }
   }
   
   
   $mq->LastEnabled = $thisEnabled;
   $mq->DateLastAccess = time();
   $mq->DateLastAccessReadable = date("Y-m-d H:i:s", $mq->DateLastAccess);
   
   $mq->Running = 0;
   setCache('timezones2',$mq);
   
  }
  
  
  
  function util() {
   $start = time();
   
   $json = new stdClass;
   $ret = $this->model->util($json);
   
   echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$start)."</b><br>";
   die();
   
   $start = time();
   
   for ($n=1; $n<1000; $n++) {
    $thisstart = microtime(true);
    
    $json = new stdClass;
    $json->Multiple = 1;
    $ret = $this->model->util($json);
    ajax_echo_r ($ret);
    echo "<b>Time elapsed during this step: ".formatmicrotime(microtime(true)-$thisstart)."</b><br>";
    
    if ((time()-$start)>100) break;
   }
   
   echo "<b>Util started ".$n." times. Time elapsed: ".formatmicrotime(microtime(true)-$start)."</b><br>";
  }
  
  
  function updateWorksessions() {
   $thisEnabled = 1;
   
   $mq = getFromCache('updateWorksessions');
   if (!$mq->DateLastAccess) {
    $mq = new stdClass;
    $mq->DateLastAccess = time();
    $mq->Running = 0;
    setCache('updateWorksessions',$mq);
   }
   $mq->Enabled = $thisEnabled;
   
   if ((((time()-$mq->DateLastAccess)>30) || ($mq->Running==0) || $json->Debug) && ($thisEnabled)) {
    $mq->SecondsBetweenRuns = time() - $mq->DateLastRun;
    $mq->DateLastRun = time();
    $mq->DateLastRunReadable = date("Y-m-d H:i:s", $mq->DateLastRun);
    $mq->Running = 1;
    setCache('updateWorksessions',$mq);
    
    $timer = microtime(true);
    $ret = $this->model->updateWorksessions($json);
    
    $mq->ElapsedLastRun = formatmicrotime(microtime(true) - $timer);
    echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$timer)."</b><br>";
   }
   
   
   $mq->LastEnabled = $thisEnabled;
   $mq->DateLastAccess = time();
   $mq->DateLastAccessReadable = date("Y-m-d H:i:s", $mq->DateLastAccess);
   
   $mq->Running = 0;
   setCache('updateWorksessions',$mq);
   
  }
  
  function wirecrm_load() {
   $thisEnabled = 1;
   $name = "wirecrm_load";
   
   $mq = getFromCache($name);
   if (!$mq->DateLastAccess) {
    $mq = new stdClass;
    $mq->DateLastAccess = time();
    $mq->Running = 0;
    setCache($name,$mq);
   }
   $mq->Enabled = $thisEnabled;
   
   if ((((time()-$mq->DateLastAccess)>30) || ($mq->Running==0) || $json->Debug) && ($thisEnabled)) {
    $mq->SecondsBetweenRuns = time() - $mq->DateLastRun;
    $mq->DateLastRun = time();
    $mq->DateLastRunReadable = date("Y-m-d H:i:s", $mq->DateLastRun);
    $mq->Running = 1;
    setCache($name,$mq);
    
    $timer = microtime(true);
    $ret = $this->model->wirecrm_load($json);
    
    $mq->ElapsedLastRun = formatmicrotime(microtime(true) - $timer);
    echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$timer)."</b><br>";
   }
   
   
   $mq->LastEnabled = $thisEnabled;
   $mq->DateLastAccess = time();
   $mq->DateLastAccessReadable = date("Y-m-d H:i:s", $mq->DateLastAccess);
   
   $mq->Running = 0;
   setCache($name,$mq);
   
  }
  
  function randomfill() {
   $thisEnabled = 1;
   $name = "randomfill";
   
   $mq = getFromCache($name);
   if (!$mq->DateLastAccess) {
    $mq = new stdClass;
    $mq->DateLastAccess = time();
    $mq->Running = 0;
    setCache($name,$mq);
   }
   $mq->Enabled = $thisEnabled;
   
   if ((((time()-$mq->DateLastAccess)>30) || ($mq->Running==0) || $json->Debug) && ($thisEnabled)) {
    $mq->SecondsBetweenRuns = time() - $mq->DateLastRun;
    $mq->DateLastRun = time();
    $mq->DateLastRunReadable = date("Y-m-d H:i:s", $mq->DateLastRun);
    $mq->Running = 1;
    setCache($name,$mq);
    
    $timer = microtime(true);
    $ret = $this->model->randomfill($json);
    
    $mq->ElapsedLastRun = formatmicrotime(microtime(true) - $timer);
    echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$timer)."</b><br>";
   }
   
   
   $mq->LastEnabled = $thisEnabled;
   $mq->DateLastAccess = time();
   $mq->DateLastAccessReadable = date("Y-m-d H:i:s", $mq->DateLastAccess);
   
   $mq->Running = 0;
   setCache($name,$mq);
   
  }
  
  
  
  
  
  function track() {
   header("Pragma: no-cache");
   header("Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0");
   header("Expires: 0");
   header("Content-Disposition: attachment; filename=1px.png");
   header("Content-Transfer-Encoding: binary");
   header("Content-Type: image/png");
   header("Content-Length: 68");
   
   echo file_get_contents("view/modern/img/1px.png");
   
   addtologEx("cookie:",  'track.log');
   addtologEx( $_COOKIE,  'track.log');
   
   addtologEx("request:", 'track.log');
   addtologEx( $_REQUEST, 'track.log');
   
   addtologEx("server:",  'track.log');
   addtologEx( $_SERVER,  'track.log');
   
  }
  
  
  function vk_service() {
   $start = time();
   $n = 0;
   
   $ret = $this->model->prepareUsersSmsAll($json);
   echo "<b>Total vacancies: ".$ret->Count.". Time elapsed: ".formatmicrotime(microtime(true)-$start)."</b><br>";
  }
  
  
  
  
  function LoadSkype() {
   $ret = $this->model->LoadSkype($json);
   
   $path = getrootdirsrv();
   $dir = 'sqlite:/'.$path.'data/skype/main.db';
   echo $dir;
   
   $dbh  = new PDO($dir) or die("cannot open the database");
   $query =  "SELECT name FROM sqlite_master WHERE type='table';";
   
   $rs = $dbh->query($query);
   foreach ($rs as $row) {
    echo $row[0]."<br>";
   }
   
   
   $query =  "SELECT * FROM Messages LIMIT 100;";
   
   $rs = $dbh->query($query);
   if ($rs) {                                // if there's a query results
    $rs->setFetchMode(PDO::FETCH_OBJ);       // выбираем режим выборки
    
    while($row = $rs->fetch()) {             // выводим результат
     ajax_echo_r ($row);
    }
   }
    
   
   
   ajax_echo_r ($ret);
  }
  
  function clean() {
//   $dir = sdir("/var/www/admin/logs", "*");
//   ajax_echo_r ($dir);
   
   
   file_put_contents ("/var/www/admin/logs/thesystem.cf.error.log", "");
   file_put_contents ("/var/www/admin/logs/phppgadmin.org.error.log", "");
//   file_put_contents ("/var/log/postgresql/postgresql-9.1-main.log", "");
//   file_put_contents ("/var/log/postgresql/postgresql-9.1-main.log.1", "");
   file_put_contents ("/var/www/admin/www/thesystem.cf/data/logs/PDOErrors.txt", "");
   
   
  }
  
  function getFilesFolder($rec) {
   $subfolder = "data/clubs/".str_replace(" ", "_", $rec->FolderName);
   return $subfolder;
  }
  function getFilesCount($rec) {
   $subfolder = $this->getFilesFolder($rec);
   $pathsrv = getrootdirsrv().$subfolder;
   $path    = getrootdir().$subfolder;
//         echo $path;
   
   mkdirr($pathsrv);
   
   $items = sdir($pathsrv, "*");
   return sizeof($items);
  }
  function getFiles($rec) {
   $subfolder = $this->getFilesFolder($rec);
   $pathsrv = getrootdirsrv().$subfolder;
   $path    = getrootdir().$subfolder;
//         echo $path;
   
   mkdirr($pathsrv);
   
   $items = sdir($pathsrv, "*");
   
   $iconpath = "http://cfteam.su/view/common/img/filetypes/";
   
   $leftcontent = new Template($this->viewroot, "editor_clubs.htt");
   $leftcontent->loadloop('block_files');
   
   if (sizeof($items)) {
//    ajax_echo_r($items);
    
    $loop_table_row           = new Template($this->viewroot, $leftcontent->returnloop('loop_files'        ));
    
    $c = 0;
    
    foreach ($items as $item) {
     $fileext  = strtolower_cf(get_file_extension($item));
     
     $loop_table_row->reload();
     $loop_table_row->fill( "%calldiretion%", $block_dir[$item->DirectionID]);
     
     if ($item->type==51) {
      $item->Message = $item->Message.$block_areq;
     }
     
     $loop_table_row->fill(        "%c%", $c);
     $loop_table_row->fill(     "%Icon%", $iconpath.$fileext.".gif");
     $loop_table_row->fill(     "%Link%", $path."/".$item);
     $loop_table_row->fill(     "%Size%", smartfilesize($pathsrv."/".$item));
     $loop_table_row->fill( "%Filename%", $item);
     
     $loop_table_row->processfcb('');
     $loop_table_row->fill(  '%imgfolder%' , $this->imgfolder                    );
     $loop_table_row->fill(   '%viewroot%' , $this->viewroot                     );
     $loop_str .= $loop_table_row->output();
     
     $c++;
    }
    $leftcontent->fillloop('block_nofiles', '');
   } else {
    $leftcontent->removeloop('block_nofiles');
   }
   
   $leftcontent->fillloop('loop_files', $loop_str);
   $files = localize($leftcontent->output());
   
   return $files;
  }
  
  
  
  function pgwrapper() {
   $ret = $this->model->pgwrapper();
   echo json_encode($ret);
  }
  
  
  function sandbox_repair() {
   $ret = $this->model->sandbox_repair();
  }
  
  
  function getMessagesCount($json) {
   $items = $this->model->getMessages($json);
   return sizeof($items);
  }
  function getMessages($json) {
//   ajax_echo_r ($json);
   
   $leftcontent = new Template($this->viewroot, "editor_clubs.htt");
   $leftcontent->loadloop('block_talk');
   
   $loop_table_row        = new Template($this->viewroot, $leftcontent->returnloop('loop_conversation'));
   
   $vars = $loop_table_row->getVariables();
   $items = $this->model->getMessages($json);
   $i = 0;
   $c = (int)$json->Count;
   if (!$c) $c=1;
   $c++;
   
//   echo $c;
//   ajax_echo_r ($items);
   
   if ($items) {
    foreach ($items as $item) {
     if ($item->Comment) {
      $loop_table_row->reload();
      $loop_table_row->fill( "%calldiretion%", $block_dir[$item->DirectionID]);
      $loop_table_row->fill(            "%c%", $c%2);
      foreach ($vars as $var) {
       if ($var) {
        if ($var=='Comment') {
         $loop_table_row->fill(       "%".$var."%" , nl2br($item->$var));
        } else {
         $loop_table_row->fill(       "%".$var."%" , brtonl($item->$var));
        }
       }
      }
      $loop_table_row->processfcb('');
      $loop_table_row->fill(  '%imgfolder%' , $this->imgfolder                    );
      $loop_table_row->fill(   '%viewroot%' , $this->viewroot                     );
      $loop_str .= $loop_table_row->output();
      $c++;
     }
    }
   }
   
   if (strlen($json->LastID)) {
    return (localize($loop_str));
   } else {
    $leftcontent->fillloop('loop_conversation', $loop_str);
 //   return htmlentities(localize($leftcontent->output()));
    return (localize($leftcontent->output()));
   }
  }
  
  
  
  
  function curr() {
   $curr = $this->model->curr();
   
  }
  
  
  function tw_record() {
   addtolog('tw_record', $_REQUEST);
  }
  
  function tw_dial() {
   $data = new stdClass;
   
   $keys = array('CallSid', 'PhoneNumber', 'DialCallStatus', 'CallStatus', 'RecordingSid', 'RecordingUrl', 'RecordingDuration', 'UserID', 'CustomerID', 'Direction', 'DialCallSid');
   
   foreach ($keys as $k) {
    if ($_REQUEST[$k]) {
     $data->$k = $_REQUEST[$k];
    }
   }
   $data->ID = $data->CallSid;
   
   
   addtologEx($_REQUEST, 'tw_dial.log');
   addtologEx(    $data, 'tw_dial.log');
   
   if ($data->ID) {
    $ret = $this->model->saveCall($data);
    addtologEx(     $ret, 'tw_dial.log');
   } else {
    addtologEx( "ID is missing, no data saved to DB.", 'tw_dial.log');
   }
  }
  
  function vacuum() {
   $thisEnabled = 1;
   
   $mq = getFromCache('vacuum');
   if (!$mq->DateLastAccess) {
    $mq = new stdClass;
    $mq->DateLastAccess = time();
    $mq->Running = 0;
    setCache('vacuum',$mq);
   }
   $mq->Enabled = $thisEnabled;
   
   if ((((time()-$mq->DateLastAccess)>30) || ($mq->Running==0) || $json->Debug) && ($thisEnabled)) {
    $mq->SecondsBetweenRuns = time() - $mq->DateLastRun;
    $mq->DateLastRun = time();
    $mq->DateLastRunReadable = date("Y-m-d H:i:s", $mq->DateLastRun);
    $mq->Running = 1;
    setCache('vacuum',$mq);
    
    $timer = microtime(true);
    $this->model->vacuum();
    
    $mq->ElapsedLastRun = formatmicrotime(microtime(true) - $timer);
    echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$timer)."</b><br>";
   } else {
    if (!$thisEnabled) {
     echo "CPU is too busy to execute this script.<br>";
    } else {
//     echo "Execution of this script cancelled.<br>";
    }
   }
   
   
   $mq->LastEnabled = $thisEnabled;
   $mq->DateLastAccess = time();
   $mq->DateLastAccessReadable = date("Y-m-d H:i:s", $mq->DateLastAccess);
   $mq->Running = 0;
   setCache('vacuum',$mq);
  }
  
  function manageDuplicates() {
   $thisEnabled = 1;
   
   $mq = getFromCache('manageDuplicates');
   if (!$mq->DateLastAccess) {
    $mq = new stdClass;
    $mq->DateLastAccess = time();
    $mq->Running = 0;
    setCache('manageDuplicates',$mq);
   }
   
   $mq->Enabled = $thisEnabled;
   $res = $this->model->getSysResources();
   $thisEnabled = $res->cpu<45;
   
   if ((((time()-$mq->DateLastAccess)>30) || ($mq->Running==0) || $json->Debug) && ($thisEnabled)) {
    $mq->SecondsBetweenRuns = time() - $mq->DateLastRun;
    $mq->DateLastRun = time();
    $mq->DateLastRunReadable = date("Y-m-d H:i:s", $mq->DateLastRun);
    $mq->Running = 1;
    setCache('manageDuplicates',$mq);
    
    $timer = microtime(true);
    $this->model->manageDuplicates();
    
    $mq->ElapsedLastRun = formatmicrotime(microtime(true) - $timer);
    echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$timer)."</b><br>";
   } else {
    if (!$thisEnabled) {
     echo "CPU is too busy to execute this script.<br>";
    } else {
//     echo "Execution of this script cancelled.<br>";
    }
   }
   
   $mq->LastEnabled = $thisEnabled;
   $mq->DateLastAccess = time();
   $mq->DateLastAccessReadable = date("Y-m-d H:i:s", $mq->DateLastAccess);
   $mq->Running = 0;
   setCache('manageDuplicates',$mq);
  }
  
  function manageLastEvents() {
   $thisEnabled = 1;
   
   $mq = getFromCache('manageLastEvents');
   if (!$mq->DateLastAccess) {
    $mq = new stdClass;
    $mq->DateLastAccess = time();
    $mq->Running = 0;
    setCache('manageLastEvents',$mq);
   }
   
   $mq->Enabled = $thisEnabled;
   $res = $this->model->getSysResources();
   $thisEnabled = $res->cpu<45;
   
   if ((((time()-$mq->DateLastAccess)>30) || ($mq->Running==0) || $json->Debug) && ($thisEnabled)) {
    $mq->SecondsBetweenRuns = time() - $mq->DateLastRun;
    $mq->DateLastRun = time();
    $mq->DateLastRunReadable = date("Y-m-d H:i:s", $mq->DateLastRun);
    $mq->Running = 1;
    setCache('manageLastEvents',$mq);
    
    $timer = microtime(true);
    $this->model->manageLastEvents();
    
    $mq->ElapsedLastRun = formatmicrotime(microtime(true) - $timer);
    echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$timer)."</b><br>";
   } else {
    if (!$thisEnabled) {
     echo "CPU is too busy to execute this script.<br>";
    } else {
//     echo "Execution of this script cancelled.<br>";
    }
   }
   
   $mq->LastEnabled = $thisEnabled;
   $mq->DateLastAccess = time();
   $mq->DateLastAccessReadable = date("Y-m-d H:i:s", $mq->DateLastAccess);
   $mq->Running = 0;
   setCache('manageLastEvents',$mq);
  }
  
  function loadCalls() {
   $thisEnabled = 1;
   
   $mq = getFromCache('loadCalls');
   if (!$mq->DateLastAccess) {
    $mq = new stdClass;
    $mq->DateLastAccess = time();
    $mq->Running = 0;
    setCache('loadCalls',$mq);
   }
   
   $mq->Enabled = $thisEnabled;
   $res = $this->model->getSysResources();
   $thisEnabled = $res->cpu<45;
   
   if ((((time()-$mq->DateLastAccess)>30) || ($mq->Running==0) || $json->Debug) && ($thisEnabled)) {
    $mq->SecondsBetweenRuns = time() - $mq->DateLastRun;
    $mq->DateLastRun = time();
    $mq->DateLastRunReadable = date("Y-m-d H:i:s", $mq->DateLastRun);
    $mq->Running = 1;
    setCache('loadCalls',$mq);
    
    $timer = microtime(true);
    $ret = $this->model->loadCalls();
    
    $ret->processed = $mq->processed;
    $ret->updated   = $mq->updated;
    $ret->total     = $mq->total;
    
    $mq->ElapsedLastRun = formatmicrotime(microtime(true) - $timer);
    echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$timer)."</b><br>";
   } else {
    if (!$thisEnabled) {
     echo "CPU is too busy to execute this script.<br>";
    } else {
//     echo "Execution of this script cancelled.<br>";
    }
   }
   
   $mq->LastEnabled = $thisEnabled;
   $mq->DateLastAccess = time();
   $mq->DateLastAccessReadable = date("Y-m-d H:i:s", $mq->DateLastAccess);
   $mq->Running = 0;
   setCache('loadCalls',$mq);
  }
  
  
  function dbfix($json) {
   $thisEnabled = 1;
   
   $mq = getFromCache('dbfix');
   if (!$mq->DateLastAccess) {
    $mq = new stdClass;
    $mq->DateLastAccess = time();
    $mq->Running = 0;
    setCache('dbfix',$mq);
   }
   
   $mq->Enabled = $thisEnabled;
   $res = $this->model->getSysResources();
   $thisEnabled = $res->cpu<45;
   
   if ((((time()-$mq->DateLastAccess)>30) || ($mq->Running==0) || $json->Debug) && ($thisEnabled)) {
    $mq->SecondsBetweenRuns = time() - $mq->DateLastRun;
    $mq->DateLastRun = time();
    $mq->DateLastRunReadable = date("Y-m-d H:i:s", $mq->DateLastRun);
    $mq->Running = 1;
    setCache('dbfix',$mq);
    
    $timer = microtime(true);
    $this->model->dbfix($json);
    
    $mq->ElapsedLastRun = formatmicrotime(microtime(true) - $timer);
    echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$timer)."</b><br>";
   } else {
    if (!$thisEnabled) {
     echo "CPU is too busy to execute this script.<br>";
    } else {
//     echo "Execution of this script cancelled.<br>";
    }
   }
   
   $mq->LastEnabled = $thisEnabled;
   $mq->DateLastAccess = time();
   $mq->DateLastAccessReadable = date("Y-m-d H:i:s", $mq->DateLastAccess);
   $mq->Running = 0;
   setCache('dbfix',$mq);
  }
  
  function dbfix2($json) {
   $thisEnabled = 1;
   
   $mq = getFromCache('dbfix2');
   if (!$mq->DateLastAccess) {
    $mq = new stdClass;
    $mq->DateLastAccess = time();
    $mq->Running = 0;
    setCache('dbfix2',$mq);
   }
   
   $mq->Enabled = $thisEnabled;
   $res = $this->model->getSysResources();
   $thisEnabled = $res->cpu<45;
   
   if ((((time()-$mq->DateLastAccess)>30) || ($mq->Running==0) || $json->Debug) && ($thisEnabled)) {
    $mq->SecondsBetweenRuns = time() - $mq->DateLastRun;
    $mq->DateLastRun = time();
    $mq->DateLastRunReadable = date("Y-m-d H:i:s", $mq->DateLastRun);
    $mq->Running = 1;
    setCache('dbfix2',$mq);
    
    $timer = microtime(true);
    $this->model->dbfix2($json);
    
    $mq->ElapsedLastRun = formatmicrotime(microtime(true) - $timer);
    echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$timer)."</b><br>";
   } else {
    if (!$thisEnabled) {
     echo "CPU is too busy to execute this script.<br>";
    } else {
//     echo "Execution of this script cancelled.<br>";
    }
   }
   
   
   $mq->LastEnabled = $thisEnabled;
   $mq->DateLastAccess = time();
   $mq->DateLastAccessReadable = date("Y-m-d H:i:s", $mq->DateLastAccess);
   $mq->Running = 0;
   setCache('dbfix2',$mq);
  }
  
  function dbfix3($json) {
   $thisEnabled = 1;
   
   $mq = getFromCache('dbfix3');
   if (!$mq->DateLastAccess) {
    $mq = new stdClass;
    $mq->DateLastAccess = time();
    $mq->Running = 0;
    setCache('dbfix3',$mq);
   }
   
   $mq->Enabled = $thisEnabled;
   $res = $this->model->getSysResources();
   $thisEnabled = $res->cpu<45;
   
   if ((((time()-$mq->DateLastAccess)>30) || ($mq->Running==0) || $json->Debug) && ($thisEnabled)) {
    $mq->SecondsBetweenRuns = time() - $mq->DateLastRun;
    $mq->DateLastRun = time();
    $mq->DateLastRunReadable = date("Y-m-d H:i:s", $mq->DateLastRun);
    $mq->Running = 1;
    setCache('dbfix3',$mq);
    
    $timer = microtime(true);
    $this->model->dbfix3($json);
    
    $mq->ElapsedLastRun = formatmicrotime(microtime(true) - $timer);
    echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$timer)."</b><br>";
   } else {
    if (!$thisEnabled) {
     echo "CPU is too busy to execute this script.<br>";
    } else {
//     echo "Execution of this script cancelled.<br>";
    }
   }
   
   $mq->LastEnabled = $thisEnabled;
   $mq->DateLastAccess = time();
   $mq->DateLastAccessReadable = date("Y-m-d H:i:s", $mq->DateLastAccess);
   $mq->Running = 0;
   setCache('dbfix3',$mq);
  }
  
  function callsassign($json) {
   $thisEnabled = 1;
   
   $mq = getFromCache('callsassign');
   if (!$mq->DateLastAccess) {
    $mq = new stdClass;
    $mq->DateLastAccess = time();
    $mq->Running = 0;
    setCache('callsassign',$mq);
   }
   
   $mq->Enabled = $thisEnabled;
   $res = $this->model->getSysResources();
   $thisEnabled = $res->cpu<45;
   
   if ((((time()-$mq->DateLastAccess)>30) || ($mq->Running==0) || $json->Debug) && ($thisEnabled)) {
    $mq->SecondsBetweenRuns = time() - $mq->DateLastRun;
    $mq->DateLastRun = time();
    $mq->DateLastRunReadable = date("Y-m-d H:i:s", $mq->DateLastRun);
    $mq->Running = 1;
    setCache('callsassign',$mq);
    
    $timer = microtime(true);
    $this->model->callsassign($json);
    
    $mq->ElapsedLastRun = formatmicrotime(microtime(true) - $timer);
    echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$timer)."</b><br>";
   } else {
    if (!$thisEnabled) {
     echo "CPU is too busy to execute this script.<br>";
    } else {
//     echo "Execution of this script cancelled.<br>";
    }
   }
   
   $mq->LastEnabled = $thisEnabled;
   $mq->DateLastAccess = time();
   $mq->DateLastAccessReadable = date("Y-m-d H:i:s", $mq->DateLastAccess);
   $mq->Running = 0;
   setCache('callsassign',$mq);
  }
  
  function callsassign2($json) {
   $thisEnabled = 1;
   
   $mq = getFromCache('callsassign2');
   if (!$mq->DateLastAccess) {
    $mq = new stdClass;
    $mq->DateLastAccess = time();
    $mq->Running = 0;
    setCache('callsassign2',$mq);
   }
   
   $mq->Enabled = $thisEnabled;
   $res = $this->model->getSysResources();
   $thisEnabled = $res->cpu<45;
   
   if ((((time()-$mq->DateLastAccess)>30) || ($mq->Running==0) || $json->Debug) && ($thisEnabled)) {
    $mq->SecondsBetweenRuns = time() - $mq->DateLastRun;
    $mq->DateLastRun = time();
    $mq->DateLastRunReadable = date("Y-m-d H:i:s", $mq->DateLastRun);
    $mq->Running = 1;
    setCache('callsassign2',$mq);
    
    $timer = microtime(true);
    $this->model->callsassign($json);
    
    $mq->ElapsedLastRun = formatmicrotime(microtime(true) - $timer);
    echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$timer)."</b><br>";
   } else {
    if (!$thisEnabled) {
     echo "CPU is too busy to execute this script.<br>";
    } else {
//     echo "Execution of this script cancelled.<br>";
    }
   }
   
   $mq->LastEnabled = $thisEnabled;
   $mq->DateLastAccess = time();
   $mq->DateLastAccessReadable = date("Y-m-d H:i:s", $mq->DateLastAccess);
   $mq->Running = 0;
   setCache('callsassign2',$mq);
  }
  
  function customersAutoclean($json = stdClass) {
   $thisEnabled = 1;
   
   $mq = getFromCache('customersAutoclean');
   if (!$mq->DateLastAccess) {
    $mq = new stdClass;
    $mq->DateLastAccess = time();
    $mq->Running = 0;
    setCache('customersAutoclean',$mq);
   }
   $mq->Enabled = $thisEnabled;
   
//   $res = $this->model->getSysResources();
//   $thisEnabled = $res->cpu<45;
   
   if ((((time()-$mq->DateLastAccess)>30) || ($mq->Running==0) || $json->Debug) && ($thisEnabled)) {
    $mq->SecondsBetweenRuns = time() - $mq->DateLastRun;
    $mq->DateLastRun = time();
    $mq->DateLastRunReadable = date("Y-m-d H:i:s", $mq->DateLastRun);
    $mq->Running = 1;
    setCache('customersAutoclean',$mq);
    
    $timer = microtime(true);
    $thisret = $this->model->customersAutoclean($json);
    
    $mq->ElapsedLastRun = formatmicrotime(microtime(true) - $timer);
    if (!$json->silent) {
     echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$timer)."</b><br>";
    }
   } else {
    if (!$thisEnabled) {
     echo "CPU is too busy to execute this script.<br>";
    } else {
//     echo "Execution of this script cancelled.<br>";
    }
   }
   
   $mq->LastEnabled = $thisEnabled;
   $mq->DateLastAccess = time();
   $mq->DateLastAccessReadable = date("Y-m-d H:i:s", $mq->DateLastAccess);
   $mq->Running = 0;
   setCache('customersAutoclean',$mq);
  }
  
  function manageQueueDebug($json=stdClass) {
   $json = new stdClass;
   $json->Debug = 1;
   
   $timer = microtime(true);
   
   $r_CustomerID = getvariablereq('r_CustomerID');
   if ($r_CustomerID) $json->r_CustomerID = $r_CustomerID;
   
   
   
   
   $q = $this->model->manageQueuev2($json);
   
   ajax_echo_r ($q);
   
   
   echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$timer)."</b><br>";
   
   die();
   
  }
  
  
  function recalcListIDs($json = stdClass) {
   $thisEnabled = 1;
   
   $mq = getFromCache('recalcListIDs');
   if (!$mq->DateLastAccess) {
    $mq = new stdClass;
    $mq->DateLastAccess = time();
    $mq->Running = 0;
    setCache('recalcListIDs',$mq);
   }
   
   $mq->Enabled = $thisEnabled;
   $res = $this->model->getSysResources();
   $thisEnabled = $res->cpu<45;
   
   if ((((time()-$mq->DateLastAccess)>30) || ($mq->Running==0) || $json->Debug) && ($thisEnabled)) {
    $mq->SecondsBetweenRuns = time() - $mq->DateLastRun;
    $mq->DateLastRun = time();
    $mq->DateLastRunReadable = date("Y-m-d H:i:s", $mq->DateLastRun);
    $mq->Running = 1;
    setCache('recalcListIDs',$mq);
    
    $timer = microtime(true);
    $thisret = $this->model->recalcListIDs($json);
    
    $mq->ElapsedLastRun = formatmicrotime(microtime(true) - $timer);
    echo "<b>Time elapsed: ".formatmicrotime(microtime(true)-$timer)."</b><br>";
   } else {
    if (!$thisEnabled) {
     echo "CPU is too busy to execute this script.<br>";
    } else {
//     echo "Execution of this script cancelled.<br>";
    }
   }
   
   $mq->LastEnabled = $thisEnabled;
   $mq->DateLastAccess = time();
   $mq->DateLastAccessReadable = date("Y-m-d H:i:s", $mq->DateLastAccess);
   $mq->Running = 0;
   setCache('recalcListIDs',$mq);
  }
  
  
  
  function loadSubItems($json) {
   $leftcontent = new Template($this->viewroot, "editor_users.htt");
   $leftcontent->loadloop('block_'.$json->tablename);
   
   $loop_table_row        = new Template($this->viewroot, $leftcontent->returnloop('loop_'.$json->tablename));
   
   
   $looptmp = $leftcontent->returnloop("loop_tasktypes");
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $list = $this->model->getList('tasktypes');
    $loopdata = $this->fillList($list, $loop, 1);
    $leftcontent->fillloop('loop_tasktypes', $loopdata);
    $leftcontent->processfcb('');
   }
   
   $looptmp = $leftcontent->returnloop("loop_teachers");
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $list = $this->model->getTeachers($json);
    $loopdata = $this->fillList($list, $loop, $rec->TeacherID);
    $leftcontent->fillloop('loop_teachers', $loopdata);
   }
   
   
   /*
   $block_dir = array();
   $block_dir[0]     = new Template($this->viewroot, $leftcontent->returnloop('block_dir0'));
   $block_dir[1]     = new Template($this->viewroot, $leftcontent->returnloop('block_dir1'));
   $block_areq       = new Template($this->viewroot, $leftcontent->returnloop('block_areq'));
   $block_agrant     = new Template($this->viewroot, $leftcontent->returnloop('block_agrant'));
   $block_callstart  = new Template($this->viewroot, $leftcontent->returnloop('block_callstart'));
   $block_callend    = new Template($this->viewroot, $leftcontent->returnloop('block_callend'));
   $block_groupchat  = new Template($this->viewroot, $leftcontent->returnloop('block_groupchat'));
   
   $block_dir[0] = $block_dir[0]->output();
   $block_dir[1] = $block_dir[1]->output();
   $block_areq        = $block_areq->output();
   $block_agrant      = $block_agrant->output();
   $block_callstart   = $block_callstart->output();
   $block_callend     = $block_callend->output();
   $block_groupchat   = $block_groupchat->output();
   */
   
   $vars = $loop_table_row->getVariables();
   $items = $this->model->getSubitems($json);
   $i = 0;
   
//         ajax_echo_r ($items);
   
   if ($items) {
    foreach ($items as $item) {
     $loop_table_row->reload();
     $loop_table_row->fill( "%calldiretion%", $block_dir[$item->DirectionID]);
     $loop_table_row->fill(            "%c%", $item->DirectionID+$c%2);
     
     foreach ($vars as $var) {
      if ($var) {
       $loop_table_row->fill(       "%".$var."%" , brtonl($item->$var));
      }
     }
     
     $loop_table_row->processfcb('');
     $loop_table_row->fill(  '%imgfolder%' , $this->imgfolder                    );
     $loop_table_row->fill(   '%viewroot%' , $this->viewroot                     );
     $loop_str .= $loop_table_row->output();
     $c++;
    }
    
   }
   
   $leftcontent->fillloop('loop_'.$json->tablename, $loop_str);
   
   
   $leftcontent->fill(  '%imgfolder%', $this->imgfolder                    );
   $leftcontent->fill(   '%viewroot%', $this->viewroot                     );
   
   $vars    = $leftcontent->getVariables();
   
   $json->Newtask_AssignedToID = $this->userid;
   $json->Newtask_Title        = "";
   $json->Newtask_DateStart    = ""; //date("Y-m-d H:i:s");
   $json->Newtask_DateFinish   = ""; //date("Y-m-d H:i:s");
   
   foreach ($vars as $vn) {
    $leftcontent->fill("%".$vn."%", $json->$vn);
   }
   
   return (localize($leftcontent->output()));
  }
  function loadActivities($json) {
   $rec = new stdClass;
   $rec->TypeID = 1;
   
   $leftcontent = new Template($this->viewroot, "editor_users.htt");
   $leftcontent->loadloop('block_activities');
   
   if ($json->money_message) {
    $leftcontent->fillloop('block_money_message', $json->money_message);
   } else {
    $leftcontent->fillloop('block_money_message', "");
   }
   
   if ($json->task_message) {
    $leftcontent->fillloop('block_task_message', $json->task_message);
   } else {
    $leftcontent->fillloop('block_task_message', "");
   }
   
   $leftcontent->fill('%focusField%', $json->focusField);
   
   
   
   $loop_table_row_activity        = new Template($this->viewroot, $leftcontent->returnloop('loop_activities' ));
   $loop_table_row_schedule        = new Template($this->viewroot, $leftcontent->returnloop('loop_schedule'   ));
   $loop_table_row_task            = new Template($this->viewroot, $leftcontent->returnloop('loop_tasks'      ));
   $loop_table_row_money           = new Template($this->viewroot, $leftcontent->returnloop('loop_money'      ));
   
   
   $looptmp = $leftcontent->returnloop("loop_tasktypes");
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $list = $this->model->getList('tasktypes');
    $loopdata = $this->fillList($list, $loop, 1);
    $leftcontent->fillloop('loop_tasktypes', $loopdata);
    $leftcontent->processfcb('');
   }
   
   $looptmp = $leftcontent->returnloop("loop_teachers");
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $list = $this->model->getTeachers($json);
    $loopdata = $this->fillList($list, $loop, $rec->TeacherID);
    $leftcontent->fillloop('loop_teachers', $loopdata);
   }
   
   
   
   
   $looptmp = $leftcontent->returnloop("loop_typeids");
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $list = $this->model->getList('moneyrecordtypes');
    $loopdata = $this->fillList($list, $loop, $rec->TypeID);
    $leftcontent->fillloop('loop_typeids', $loopdata);
   }
   
   $looptmp = $leftcontent->returnloop("loop_valutes");
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $list = $this->model->getCurr(true);
    $loopdata = $this->fillList($list, $loop, 1);
    $leftcontent->fillloop('loop_valutes', $loopdata);
   }
   
   $looptmp = $leftcontent->returnloop("loop_users");
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $list = $this->model->getUsersList($rec);
    $loopdata = $this->fillList($list, $loop, $rec->UserID);
    $leftcontent->fillloop('loop_users', $loopdata);
   }
   
//   ajax_echo_r ($rec);
   
   $looptmp = $leftcontent->returnloop("loop_groupids");
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $list = $this->model->getExpenditureGroups($rec->TypeID);
    $loopdata = $this->fillList($list, $loop, $rec->GroupID);
    $leftcontent->fillloop('loop_groupids', $loopdata);
   }
   
   $looptmp = $leftcontent->returnloop("loop_clubs");
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $params = new stdClass;
    $params->AndID = $rec->ClubID;
    $list = $this->model->getClubs($params);
    $loopdata = $this->fillList($list, $loop, $rec->ClubID);
    $leftcontent->fillloop('loop_clubs', $loopdata);
   }
   
   $looptmp = $leftcontent->returnloop("loop_accounts");
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $list = $this->model->getListOrdered('accounts', 'ID');
    $loopdata = $this->fillList($list, $loop, $rec->AccountID);
    $leftcontent->fillloop('loop_accounts', $loopdata);
   }
   
   /*
   $block_dir = array();
   $block_dir[0]     = new Template($this->viewroot, $leftcontent->returnloop('block_dir0'));
   $block_dir[1]     = new Template($this->viewroot, $leftcontent->returnloop('block_dir1'));
   
   $block_dir[0] = $block_dir[0]->output();
   $block_dir[1] = $block_dir[1]->output();
   */
   
   $block_type = array();
   $block_type[1]     = new Template($this->viewroot, $leftcontent->returnloop('block_type1'));
   $block_type[2]     = new Template($this->viewroot, $leftcontent->returnloop('block_type2'));
//   $block_type[5]     = new Template($this->viewroot, $leftcontent->returnloop('block_type5'));
//   $block_type[6]     = new Template($this->viewroot, $leftcontent->returnloop('block_type6'));
   
   $block_type[1] = $block_type[1]->output();
   $block_type[2] = $block_type[2]->output();
//   $block_type[5] = $block_type[5]->output();
//   $block_type[6] = $block_type[6]->output();
   
   $leftcontent->fillloop(    "block_type1", '');
   $leftcontent->fillloop(    "block_type2", '');
//   $leftcontent->fillloop(    'block_type5', '');
//   $leftcontent->fillloop(    'block_type6', '');
   
   /*
   $block_areq       = new Template($this->viewroot, $leftcontent->returnloop('block_areq'));
   $block_agrant     = new Template($this->viewroot, $leftcontent->returnloop('block_agrant'));
   $block_callstart  = new Template($this->viewroot, $leftcontent->returnloop('block_callstart'));
   $block_callend    = new Template($this->viewroot, $leftcontent->returnloop('block_callend'));
   $block_groupchat  = new Template($this->viewroot, $leftcontent->returnloop('block_groupchat'));
   
   $block_areq        = $block_areq->output();
   $block_agrant      = $block_agrant->output();
   $block_callstart   = $block_callstart->output();
   $block_callend     = $block_callend->output();
   $block_groupchat   = $block_groupchat->output();
   */
   
   $vars_activity = $loop_table_row_activity->getVariables();
   $vars_schedule = $loop_table_row_schedule->getVariables();
   $vars_task     = $loop_table_row_task->getVariables();
   $vars_money    = $loop_table_row_money->getVariables();
   
   $items = $this->model->getActivities($json);
   $i = 0;
   
//         ajax_echo_r ($items);
   
   if ($items) {
    foreach ($items as $item) {
     switch ($item->Source) {
      case("statuses"):
       $loop_table_row_activity->reload();
       $loop_table_row_activity->fill( "%calldiretion%", $block_dir[$item->DirectionID]);
       $loop_table_row_activity->fill(            "%c%", $item->DirectionID+$c%2);
       
       $loop_table_row_activity->processfcb('');
       $loop_table_row_activity->fill(  '%imgfolder%' , $this->imgfolder                    );
       $loop_table_row_activity->fill(   '%viewroot%' , $this->viewroot                     );
       
       foreach ($vars_activity as $var) {
        if ($var) {
         $loop_table_row_activity->fill(       "%".$var."%" , brtonl($item->$var));
        }
       }
       
       $loop_str .= $loop_table_row_activity->output();
      break;
      case("schedule"):
       $loop_table_row_schedule->reload();
       $loop_table_row_schedule->fill( "%calldiretion%", $block_dir[$item->DirectionID]);
       $loop_table_row_schedule->fill(            "%c%", $item->DirectionID+$c%2);
       
       $loop_table_row_schedule->processfcb('');
       $loop_table_row_schedule->fill(  '%imgfolder%' , $this->imgfolder                    );
       $loop_table_row_schedule->fill(   '%viewroot%' , $this->viewroot                     );
       
       foreach ($vars_schedule as $var) {
        if ($var) {
         $loop_table_row_schedule->fill(       "%".$var."%" , brtonl($item->$var));
        }
       }
       
       $loop_str .= $loop_table_row_schedule->output();
      break;
      case("tasks"):
       $loop_table_row_task->reload();
       $loop_table_row_task->fill( "%calldiretion%", $block_dir[$item->DirectionID]);
       $loop_table_row_task->fill(            "%c%", $item->DirectionID+$c%2);
       
       $loop_table_row_task->processfcb('');
       $loop_table_row_task->fill(  '%imgfolder%' , $this->imgfolder                    );
       $loop_table_row_task->fill(   '%viewroot%' , $this->viewroot                     );
       
       foreach ($vars_task as $var) {
        if ($var) {
         $loop_table_row_task->fill(       "%".$var."%" , brtonl($item->$var));
        }
       }
       
       $loop_str .= $loop_table_row_task->output();
      break;
      case("money"):
//       ajax_echo_r ($item);
       
       $loop_table_row_money->reload();
       $loop_table_row_money->fill( "%TypePicture%", $block_type[$item->TypeID]);
//       $loop_table_row_money->fill( "%calldiretion%", $block_dir[$item->DirectionID]);
       $loop_table_row_money->fill(            "%c%", $item->DirectionID+$c%2);
       
       $loop_table_row_money->processfcb('');
       $loop_table_row_money->fill(  '%imgfolder%' , $this->imgfolder                    );
       $loop_table_row_money->fill(   '%viewroot%' , $this->viewroot                     );
       
       foreach ($vars_money as $var) {
        if ($var) {
         $loop_table_row_money->fill(       "%".$var."%" , brtonl($item->$var));
        }
       }
       
       $loop_str .= $loop_table_row_money->output();
      break;
      
     }
     $c++;
    }
    
   }
   
   $leftcontent->fillloop('loop_activities', $loop_str);
   $leftcontent->fillloop('loop_schedule'  , "");
   $leftcontent->fillloop('loop_tasks'     , "");
   $leftcontent->fillloop('loop_money'     , "");
   
   
   $leftcontent->fill(  '%imgfolder%', $this->imgfolder                    );
   $leftcontent->fill(   '%viewroot%', $this->viewroot                     );
   
   $vars    = $leftcontent->getVariables();
   
   $json->Newtask_AssignedToID = $this->userid;
   $json->Newtask_Title        = "";
   $json->Newtask_DateStart    = ""; //date("Y-m-d H:i:s");
   $json->Newtask_DateFinish   = ""; //date("Y-m-d H:i:s");
   
   foreach ($vars as $vn) {
    $leftcontent->fill("%".$vn."%", $json->$vn);
   }
   
   return (localize($leftcontent->output()));
  }
  
  function loadWishes($json) {
   $rec = new stdClass;
   $rec->TypeID = 1;
   
   $leftcontent = new Template($this->viewroot, "editor_users.htt");
   $leftcontent->loadloop('block_wishes');
   
   if ($json->message) {
    $leftcontent->fillloop('block_message', $json->message);
   } else {
    $leftcontent->fillloop('block_message', "");
   }
   
   $leftcontent->fill('%focusField%', $json->focusField);
   
   
   
   $loop_table_row_wish        = new Template($this->viewroot, $leftcontent->returnloop('loop_wishes'      ));
   $loop_table_row_lessons     = new Template($this->viewroot, $leftcontent->returnloop('loop_lessons'     ));
   $loop_table_row_suggestions = new Template($this->viewroot, $leftcontent->returnloop('loop_suggestions' ));
   
   
   $looptmp = $leftcontent->returnloop("loop_tasktypes");
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $list = $this->model->getList('tasktypes');
    $loopdata = $this->fillList($list, $loop, 1);
    $leftcontent->fillloop('loop_tasktypes', $loopdata);
    $leftcontent->processfcb('');
   }
   
   $looptmp = $leftcontent->returnloop("loop_teachers");
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $list = $this->model->getTeachers($json);
    $loopdata = $this->fillList($list, $loop, $rec->TeacherID);
    $leftcontent->fillloop('loop_teachers', $loopdata);
   }
   
   
   
   
   $looptmp = $leftcontent->returnloop("loop_typeids");
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $list = $this->model->getList('moneyrecordtypes');
    $loopdata = $this->fillList($list, $loop, $rec->TypeID);
    $leftcontent->fillloop('loop_typeids', $loopdata);
   }
   
   $looptmp = $leftcontent->returnloop("loop_valutes");
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $list = $this->model->getCurr(true);
    $loopdata = $this->fillList($list, $loop, 1);
    $leftcontent->fillloop('loop_valutes', $loopdata);
   }
   
   $looptmp = $leftcontent->returnloop("loop_users");
   $users = $this->model->getUsersList($rec);
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $loopdata = $this->fillList($users, $loop, $rec->UserID);
    $leftcontent->fillloop('loop_users', $loopdata);
   }
   
//   ajax_echo_r ($rec);
   
   $looptmp = $leftcontent->returnloop("loop_groupids");
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $list = $this->model->getExpenditureGroups($rec->TypeID);
    $loopdata = $this->fillList($list, $loop, $rec->GroupID);
    $leftcontent->fillloop('loop_groupids', $loopdata);
   }
   
   $looptmp = $leftcontent->returnloop("loop_clubs");
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $params = new stdClass;
    $params->AndID = $rec->ClubID;
    $list = $this->model->getClubs($params);
    $loopdata = $this->fillList($list, $loop, $rec->ClubID);
    $leftcontent->fillloop('loop_clubs', $loopdata);
   }
   
   $looptmp = $leftcontent->returnloop("loop_accounts");
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $list = $this->model->getListOrdered('accounts', 'ID');
    $loopdata = $this->fillList($list, $loop, $rec->AccountID);
    $leftcontent->fillloop('loop_accounts', $loopdata);
   }
   
   /*
   $block_dir = array();
   $block_dir[0]     = new Template($this->viewroot, $leftcontent->returnloop('block_dir0'));
   $block_dir[1]     = new Template($this->viewroot, $leftcontent->returnloop('block_dir1'));
   
   $block_dir[0] = $block_dir[0]->output();
   $block_dir[1] = $block_dir[1]->output();
   */
   
   
//   $block_type = array();
//   $block_type[1]     = new Template($this->viewroot, $leftcontent->returnloop('block_type1'));
//   $block_type[2]     = new Template($this->viewroot, $leftcontent->returnloop('block_type2'));
//   $block_type[5]     = new Template($this->viewroot, $leftcontent->returnloop('block_type5'));
//   $block_type[6]     = new Template($this->viewroot, $leftcontent->returnloop('block_type6'));
   
//   $block_type[1] = $block_type[1]->output();
//   $block_type[2] = $block_type[2]->output();
//   $block_type[5] = $block_type[5]->output();
//   $block_type[6] = $block_type[6]->output();
   
//   $leftcontent->fillloop(    "block_type1", '');
//   $leftcontent->fillloop(    "block_type2", '');
//   $leftcontent->fillloop(    'block_type5', '');
//   $leftcontent->fillloop(    'block_type6', '');
   
   /*
   $block_areq       = new Template($this->viewroot, $leftcontent->returnloop('block_areq'));
   $block_agrant     = new Template($this->viewroot, $leftcontent->returnloop('block_agrant'));
   $block_callstart  = new Template($this->viewroot, $leftcontent->returnloop('block_callstart'));
   $block_callend    = new Template($this->viewroot, $leftcontent->returnloop('block_callend'));
   $block_groupchat  = new Template($this->viewroot, $leftcontent->returnloop('block_groupchat'));
   
   $block_areq        = $block_areq->output();
   $block_agrant      = $block_agrant->output();
   $block_callstart   = $block_callstart->output();
   $block_callend     = $block_callend->output();
   $block_groupchat   = $block_groupchat->output();
   */
   
   $vars_wish        = $loop_table_row_wish->getVariables();
   $vars_lessons     = $loop_table_row_lessons->getVariables();
   $vars_suggestions = $loop_table_row_suggestions->getVariables();
   
   $items = $this->model->getWishes($json);
   $i = 0;
   
//   ajax_echo_r ($items);
   
   $days = getDayNames();
   
   if ($items) {
    foreach ($items as $item) {
     $item->DayName = $days[$item->DayOfWeekID];
     $item->DayIsWeekend = $item->DayOfWeekID>5;
     
     $loop_table_row_wish->reload();
//     $loop_table_row_wish->fill( "%calldiretion%", $block_dir[$item->DirectionID]);
     $loop_table_row_wish->fill(            "%c%", $item->DayIsWeekend*2+$c%2);
     $lessons = "";
     
     foreach ($item->Lessons as $kl=>$vl) {
      $loop_table_row_lessons->reload();
      $loop_table_row_lessons->fill("%Time%", $kl);
      
      $suggestions = "";
      
//      ajax_echo_r ($vl);
      $i=1;
      foreach ($vl as $k=>$v) {
       $loop_table_row_suggestions->reload();
       
       if ($i<sizeof($vl)) $loop_table_row_suggestions->fill(       "%comma%" , ",");
       foreach ($vars_suggestions as $var) {
        if ($var) {
         $loop_table_row_suggestions->fill(       "%".$var."%" , brtonl($users[$k]->$var));
        }
       }
       
       $i++;
       $suggestions .= $loop_table_row_suggestions->output();
      }
      $loop_table_row_lessons->fillloop('loop_suggestions', $suggestions);
      
      $lessons.=$loop_table_row_lessons->output();
     }
     $loop_table_row_wish->fillloop('loop_lessons', $lessons);
     
     
     $loop_table_row_wish->processfcb('');
     $loop_table_row_wish->fill(  '%imgfolder%' , $this->imgfolder                    );
     $loop_table_row_wish->fill(   '%viewroot%' , $this->viewroot                     );
     
     foreach ($vars_wish as $var) {
      if ($var) {
       $loop_table_row_wish->fill(       "%".$var."%" , brtonl($item->$var));
      }
     }
     
     $loop_str .= $loop_table_row_wish->output();
     $c++;
    }
    
   }
   
   $leftcontent->fillloop('loop_wishes'    , $loop_str);
   
   $leftcontent->fill(  '%imgfolder%', $this->imgfolder                    );
   $leftcontent->fill(   '%viewroot%', $this->viewroot                     );
   
   
   $vars    = $leftcontent->getVariables();
   
   $json->Newtask_AssignedToID = $this->userid;
   $json->Newtask_Title        = "";
   $json->Newtask_DateStart    = ""; //date("Y-m-d H:i:s");
   $json->Newtask_DateFinish   = ""; //date("Y-m-d H:i:s");
   
   foreach ($vars as $vn) {
    $leftcontent->fill("%".$vn."%", $json->$vn);
   }
   
   $leftcontent->processfcb('');
   
   $leftcontent->fill(  '%imgfolder%', $this->imgfolder                    );
   $leftcontent->fill(   '%viewroot%', $this->viewroot                     );
   
   return (localize($leftcontent->output()));
  }
  
  function loadScheduleDebug($json) {
   $rec = new stdClass;
   $rec->TypeID = 1;
   
   $leftcontent = new Template($this->viewroot, "left_schedule.htt");
   $leftcontent->loadloop('block_scheduledebug');
   
   
   $looptmp = $leftcontent->returnloop("loop_scheduledebug");
   if ($looptmp) {
    $loop = new Template($this->viewroot, $looptmp);
    $list = $this->model->getUsersMissingInSchedule();
    $loopdata = $this->fillList($list, $loop, 1);
    $leftcontent->fillloop('loop_scheduledebug', $loopdata);
    $leftcontent->processfcb('');
   }
   
   /*
   $vars_wish = $loop_table_row_wish->getVariables();
   
   $items = $this->model->getWishes($json);
   $i = 0;
   
//   ajax_echo_r ($items);
   
   $days = getDayNames();
   $loop_table_row_wish        = new Template($this->viewroot, $leftcontent->returnloop('loop_wishes' ));
   
   if ($items) {
    foreach ($items as $item) {
     $item->DayName = $days[$item->DayOfWeekID];
     $item->DayIsWeekend = $item->DayOfWeekID>5;
     
     $loop_table_row_wish->reload();
//     $loop_table_row_wish->fill( "%calldiretion%", $block_dir[$item->DirectionID]);
     $loop_table_row_wish->fill(            "%c%", $item->DayIsWeekend*2+$c%2);
     
     $loop_table_row_wish->processfcb('');
     $loop_table_row_wish->fill(  '%imgfolder%' , $this->imgfolder                    );
     $loop_table_row_wish->fill(   '%viewroot%' , $this->viewroot                     );
     
     foreach ($vars_wish as $var) {
      if ($var) {
       $loop_table_row_wish->fill(       "%".$var."%" , brtonl($item->$var));
      }
     }
     
     $loop_str .= $loop_table_row_wish->output();
     $c++;
    }
    
   }
   
   $leftcontent->fillloop('loop_wishes'    , $loop_str);
   */
   
   $leftcontent->fill(  '%imgfolder%', $this->imgfolder                    );
   $leftcontent->fill(   '%viewroot%', $this->viewroot                     );
   
   $vars    = $leftcontent->getVariables();
   
   foreach ($vars as $vn) {
    $leftcontent->fill("%".$vn."%", $json->$vn);
   }
   
   $leftcontent->processfcb('');
   
   $leftcontent->fill(  '%imgfolder%', $this->imgfolder                    );
   $leftcontent->fill(   '%viewroot%', $this->viewroot                     );
   
   return (localize($leftcontent->output()));
  }
  
 }
 
?>